﻿define("BoletoBarcodePlugin.controller$BoletoCheckBarcodePlugin", ["exports", "OutSystems/ClientRuntime/Main", "BoletoBarcodePlugin.model", "BoletoBarcodePlugin.controller", "CommonPlugin.controller", "CommonPlugin.model", "BoletoBarcodePlugin.controller$BoletoCheckBarcodePlugin.GetWebAPIJS", "BoletoBarcodePlugin.controller$BoletoCheckBarcodePlugin.IsPluginAvailableJSJS", "BoletoBarcodePlugin.controller$BoletoCheckBarcodePlugin.AddCSSJS", "CommonPlugin.controller$IsCordovaDefined", "BoletoBarcodePlugin.referencesHealth", "BoletoBarcodePlugin.referencesHealth$CommonPlugin", "CommonPlugin.model$ErrorRec"], function (exports, OutSystems, BoletoBarcodePluginModel, BoletoBarcodePluginController, CommonPluginController, CommonPluginModel, BoletoBarcodePlugin_controller_BoletoCheckBarcodePlugin_GetWebAPIJS, BoletoBarcodePlugin_controller_BoletoCheckBarcodePlugin_IsPluginAvailableJSJS, BoletoBarcodePlugin_controller_BoletoCheckBarcodePlugin_AddCSSJS) {
var OS = OutSystems.Internal;
BoletoBarcodePluginController.default.boletoCheckBarcodePlugin$Action = function (callContext) {
callContext = controller.callContext(callContext);
var allExceptionsVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var isCordovaDefinedVar = new OS.DataTypes.VariableHolder();
var getWebAPIJSResult = new OS.DataTypes.VariableHolder();
var isPluginAvailableJSJSResult = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BoletoBarcodePlugin.BoletoCheckBarcodePlugin$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: IsCordovaDefined
isCordovaDefinedVar.value = CommonPluginController.default.isCordovaDefined$Action(callContext);

return OS.Flow.executeSequence(function () {
if((isCordovaDefinedVar.value.isLoadedOut)) {
// Checks if the barcode scanner plugin is loaded and ready to be used.
isPluginAvailableJSJSResult.value = controller.safeExecuteJSNode(BoletoBarcodePlugin_controller_BoletoCheckBarcodePlugin_IsPluginAvailableJSJS, "IsPluginAvailableJS", "BoletoCheckBarcodePlugin", {
IsAvailable: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("BoletoBarcodePlugin.BoletoCheckBarcodePlugin$isPluginAvailableJSJSResult"))();
jsNodeResult.isAvailableOut = OS.DataConversion.JSNodeParamConverter.from($parameters.IsAvailable, OS.Types.Boolean);
return jsNodeResult;
}, {}, {});
if((isPluginAvailableJSJSResult.value.isAvailableOut)) {
// IsAvailable = IsPluginAvailableJS.IsAvailable
outVars.value.isAvailableOut = isPluginAvailableJSJSResult.value.isAvailableOut;
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
} else {
// Error.ErrorCode = 2
outVars.value.errorOut.errorCodeAttr = "2";
// Error.ErrorMessage = "Barcode Plugin is unavailable"
outVars.value.errorOut.errorMessageAttr = "Barcode Plugin is unavailable";
// IsAvailable = False
outVars.value.isAvailableOut = false;
}

} else {
getWebAPIJSResult.value = controller.safeExecuteJSNode(BoletoBarcodePlugin_controller_BoletoCheckBarcodePlugin_GetWebAPIJS, "GetWebAPI", "BoletoCheckBarcodePlugin", {
IsSupported: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("BoletoBarcodePlugin.BoletoCheckBarcodePlugin$getWebAPIJSResult"))();
jsNodeResult.isSupportedOut = OS.DataConversion.JSNodeParamConverter.from($parameters.IsSupported, OS.Types.Boolean);
return jsNodeResult;
}, {}, {});
// Is PWA?
return OS.Flow.executeSequence(function () {
if((getWebAPIJSResult.value.isSupportedOut)) {
controller.safeExecuteJSNode(BoletoBarcodePlugin_controller_BoletoCheckBarcodePlugin_AddCSSJS, "AddCSS", "BoletoCheckBarcodePlugin", null, function ($parameters) {
}, {}, {});
// Execute Action: AddOSBarcodePlugin
return OS.SystemActions.requireScript(OS.Navigation.VersionedURL.getVersionedUrl("scripts/BoletoBarcodePlugin.OSBarcodePlugin.js"), callContext).then(function () {
// IsAvailable = True
outVars.value.isAvailableOut = true;
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
// IsPWA = True
outVars.value.isPWAOut = true;
});
} else {
// Error.ErrorCode = 1
outVars.value.errorOut.errorCodeAttr = "1";
// Error.ErrorMessage = "Cordova is not available"
outVars.value.errorOut.errorMessageAttr = "Cordova is not available";
// IsAvailable = False
outVars.value.isAvailableOut = false;
}

});
}

});
}).catch(function (ex) {
OS.Logger.trace("BoletoCheckBarcodePlugin.BoletoCheckBarcodePlugin", OS.Exceptions.getMessage(ex), ex.name);
// Handle Error: AllExceptions
if(!(OS.Exceptions.isSystem(ex))) {
OS.Logger.error(null, ex);
allExceptionsVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
return OS.Flow.executeAsyncFlow(function () {
// IsAvailable = False
outVars.value.isAvailableOut = false;
// Error.ErrorCode = -1
outVars.value.errorOut.errorCodeAttr = (-1).toString();
// Error.ErrorMessage = AllExceptions.ExceptionMessage
outVars.value.errorOut.errorMessageAttr = allExceptionsVar.value.exceptionMessageAttr;
return OS.Flow.returnAsync(outVars.value);

});
}

throw ex;
}).then(function () {
return outVars.value;
});
};
var controller = BoletoBarcodePluginController.default;
BoletoBarcodePluginController.default.constructor.registerVariableGroupType("BoletoBarcodePlugin.BoletoCheckBarcodePlugin$getWebAPIJSResult", [{
name: "IsSupported",
attrName: "isSupportedOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
BoletoBarcodePluginController.default.constructor.registerVariableGroupType("BoletoBarcodePlugin.BoletoCheckBarcodePlugin$isPluginAvailableJSJSResult", [{
name: "IsAvailable",
attrName: "isAvailableOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
BoletoBarcodePluginController.default.constructor.registerVariableGroupType("BoletoBarcodePlugin.BoletoCheckBarcodePlugin$outVars", [{
name: "IsAvailable",
attrName: "isAvailableOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "IsPWA",
attrName: "isPWAOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}]);
BoletoBarcodePluginController.default.clientActionProxies.boletoCheckBarcodePlugin$Action = function () {
return controller.executeActionInsideJSNode(BoletoBarcodePluginController.default.boletoCheckBarcodePlugin$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
IsAvailable: OS.DataConversion.JSNodeParamConverter.to(actionResults.isAvailableOut, OS.Types.Boolean),
IsPWA: OS.DataConversion.JSNodeParamConverter.to(actionResults.isPWAOut, OS.Types.Boolean),
Error: actionResults.errorOut
};
});
};
});
define("BoletoBarcodePlugin.controller$BoletoCheckBarcodePlugin.GetWebAPIJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
$parameters.IsSupported = navigator.mediaDevices !== undefined
};
});
define("BoletoBarcodePlugin.controller$BoletoCheckBarcodePlugin.IsPluginAvailableJSJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
$parameters.IsAvailable = !!cordova.plugins && !!cordova.plugins.OSBarcodeScanner;
};
});
define("BoletoBarcodePlugin.controller$BoletoCheckBarcodePlugin.AddCSSJS", [], function () {
return function ($actions, $roles, $public) {
const allcss = [...document.styleSheets]
let hasCss = allcss.filter(item => item.title == "barcode-plugin-css").length > 0;
if(!hasCss) {
    let sheet = document.createElement('style');
    sheet.title = 'barcode-plugin-css';
    sheet.innerHTML = '.interface-wrapper{height:100%;overflow:hidden;width:100%}.overlay{z-index:6}.overlay,.scanline-canvas{height:100%;position:absolute;width:100%}.scanline-canvas{z-index:7}.scanner-wrapper{height:100%;overflow:hidden;position:absolute;width:100%}.scanner-video{position:absolute;width:100%;z-index:4}.close-button{float:left;font-weight:700;margin-left:40px;margin-top:22px;text-align:left}.close-button,.torch{color:#fff;font-size:large;position:absolute;vertical-align:top;z-index:10}.torch{float:right;right:40px;text-align:right;top:19px}.scanner-instructions{color:#fff;margin-top:103px;position:absolute;text-align:center;width:100%;z-index:8}.instructions-landscape{margin-top:22px}.scanner-button-wrapper{align-items:flex-end;display:flex;height:100%;justify-content:center;position:absolute;width:100%;z-index:8}.barcode-dropdown-container{margin-top:22px;position:absolute;text-align:center;width:100%;z-index:9}.scanner-button{align-items:center;display:flex;gap:8px;margin-bottom:68px;z-index:7}.camera-button,.scanner-button{backdrop-filter:blur(7px);background:hsla(0,0%,100%,.25);border:none;border-radius:100px;color:#fff;font-size:16px;font-weight:500;height:48px;line-height:24px;padding:0 16px}.clicked{background-color:rgba(16,104,235,.25)}.scanner-button-wrapper-landscape{justify-content:right}.scanner-button-landscape{margin-bottom:10px;margin-right:28px}.barcode-camera-dropdown{border:none;color:#fff;display:none;position:absolute;width:100%;z-index:10}.barcode-camera-dropdown-item{backdrop-filter:blur(7px);background:hsla(0,0%,100%,.45);padding:5px}';
    document.getElementsByTagName('head')[0].appendChild(sheet);
}
};
});

define("BoletoBarcodePlugin.controller$BoletoScanBarcode", ["exports", "OutSystems/ClientRuntime/Main", "BoletoBarcodePlugin.model", "BoletoBarcodePlugin.controller", "CommonPlugin.model", "BoletoBarcodePlugin.controller$BoletoScanBarcode.RunWebScannerJS", "BoletoBarcodePlugin.controller$BoletoScanBarcode.RunCodeScannerJS", "CommonPlugin.model$ErrorRec", "BoletoBarcodePlugin.referencesHealth", "BoletoBarcodePlugin.referencesHealth$CommonPlugin", "BoletoBarcodePlugin.controller$BoletoCheckBarcodePlugin", "BoletoBarcodePlugin.model$ScannerResultRec"], function (exports, OutSystems, BoletoBarcodePluginModel, BoletoBarcodePluginController, CommonPluginModel, BoletoBarcodePlugin_controller_BoletoScanBarcode_RunWebScannerJS, BoletoBarcodePlugin_controller_BoletoScanBarcode_RunCodeScannerJS) {
var OS = OutSystems.Internal;
BoletoBarcodePluginController.default.boletoScanBarcode$Action = function (scanInstructionsIn, cameraDirectionIn, scanOrientationIn, scanLineIn, scanButtonIn, scanButtonTextIn, showCameraSelectionIn, hintIn, scannerFPSIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BoletoBarcodePlugin.BoletoScanBarcode$vars"))());
vars.value.scanInstructionsInLocal = scanInstructionsIn;
vars.value.cameraDirectionInLocal = cameraDirectionIn;
vars.value.scanOrientationInLocal = scanOrientationIn;
vars.value.scanLineInLocal = scanLineIn;
vars.value.scanButtonInLocal = scanButtonIn;
vars.value.scanButtonTextInLocal = scanButtonTextIn;
vars.value.showCameraSelectionInLocal = showCameraSelectionIn;
vars.value.hintInLocal = hintIn;
vars.value.scannerFPSInLocal = scannerFPSIn;
var allExceptionsVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var boletoCheckBarcodePluginVar = new OS.DataTypes.VariableHolder();
var runWebScannerJSResult = new OS.DataTypes.VariableHolder();
var runCodeScannerJSResult = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BoletoBarcodePlugin.BoletoScanBarcode$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: BoletoCheckBarcodePlugin
return BoletoBarcodePluginController.default.boletoCheckBarcodePlugin$Action(callContext).then(function (value) {
boletoCheckBarcodePluginVar.value = value;
}).then(function () {
// Is Barcode available?
return OS.Flow.executeSequence(function () {
if((boletoCheckBarcodePluginVar.value.isAvailableOut)) {
if(((vars.value.cameraDirectionInLocal === OS.BuiltinFunctions.nullIdentifier()))) {
// CameraDirection = BackCamera
vars.value.cameraDirectionInLocal = BoletoBarcodePluginModel.staticEntities.cameraDirection.backCamera;
}

if(((vars.value.scanOrientationInLocal === OS.BuiltinFunctions.nullIdentifier()))) {
// ScanOrientation = Adaptive
vars.value.scanOrientationInLocal = BoletoBarcodePluginModel.staticEntities.scanOrientation.adaptive;
}

// Is PWA?
return OS.Flow.executeSequence(function () {
if((boletoCheckBarcodePluginVar.value.isPWAOut)) {
return controller.safeExecuteAsyncJSNode(BoletoBarcodePlugin_controller_BoletoScanBarcode_RunWebScannerJS, "RunWebScanner", "BoletoScanBarcode", {
ScanInstructions: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanInstructionsInLocal, OS.Types.Text),
ScanText: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanButtonTextInLocal, OS.Types.Text),
ScannerFPS: OS.DataConversion.JSNodeParamConverter.to(vars.value.scannerFPSInLocal, OS.Types.Integer),
ScanLine: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanLineInLocal, OS.Types.Boolean),
ScanOrientation: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanOrientationInLocal, OS.Types.Integer),
ScanButton: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanButtonInLocal, OS.Types.Boolean),
CameraDirection: OS.DataConversion.JSNodeParamConverter.to((vars.value.cameraDirectionInLocal).toString(), OS.Types.Text),
Hint: OS.DataConversion.JSNodeParamConverter.to(vars.value.hintInLocal, OS.Types.Integer),
ShowCameraSelection: OS.DataConversion.JSNodeParamConverter.to(vars.value.showCameraSelectionInLocal, OS.Types.Boolean),
ScanResult: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text),
Success: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean),
ErrorCode: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text),
ErrorMessage: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("BoletoBarcodePlugin.BoletoScanBarcode$runWebScannerJSResult"))();
jsNodeResult.scanResultOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ScanResult, OS.Types.Text);
jsNodeResult.successOut = OS.DataConversion.JSNodeParamConverter.from($parameters.Success, OS.Types.Boolean);
jsNodeResult.errorCodeOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ErrorCode, OS.Types.Text);
jsNodeResult.errorMessageOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ErrorMessage, OS.Types.Text);
return jsNodeResult;
}, {}, {}).then(function (results) {
runWebScannerJSResult.value = results;
}).then(function () {
// Set Scanner Result
// ScannerResult.Success = RunWebScanner.Success
vars.value.scannerResultVar.successAttr = runWebScannerJSResult.value.successOut;
// ScannerResult.ScanResult = RunWebScanner.ScanResult
vars.value.scannerResultVar.scanResultAttr = runWebScannerJSResult.value.scanResultOut;
// ScannerResult.Error.ErrorMessage = RunWebScanner.ErrorMessage
vars.value.scannerResultVar.errorAttr.errorMessageAttr = runWebScannerJSResult.value.errorMessageOut;
// ScannerResult.Error.ErrorCode = RunWebScanner.ErrorCode
vars.value.scannerResultVar.errorAttr.errorCodeAttr = runWebScannerJSResult.value.errorCodeOut;
});
} else {
// Use this action to trigger the barcode reader.
return controller.safeExecuteAsyncJSNode(BoletoBarcodePlugin_controller_BoletoScanBarcode_RunCodeScannerJS, "RunCodeScanner", "BoletoScanBarcode", {
ScanLine: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanLineInLocal, OS.Types.Boolean),
ScanButton: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanButtonInLocal, OS.Types.Boolean),
ScanInstructions: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanInstructionsInLocal, OS.Types.Text),
ScanOrientation: OS.DataConversion.JSNodeParamConverter.to((vars.value.scanOrientationInLocal).toString(), OS.Types.Text),
ScanText: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanButtonTextInLocal, OS.Types.Text),
CameraDirection: OS.DataConversion.JSNodeParamConverter.to((vars.value.cameraDirectionInLocal).toString(), OS.Types.Text),
ScanResult: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text),
ErrorMessage: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text),
Success: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean),
ErrorCode: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("BoletoBarcodePlugin.BoletoScanBarcode$runCodeScannerJSResult"))();
jsNodeResult.scanResultOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ScanResult, OS.Types.Text);
jsNodeResult.errorMessageOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ErrorMessage, OS.Types.Text);
jsNodeResult.successOut = OS.DataConversion.JSNodeParamConverter.from($parameters.Success, OS.Types.Boolean);
jsNodeResult.errorCodeOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ErrorCode, OS.Types.Text);
return jsNodeResult;
}, {}, {}).then(function (results) {
runCodeScannerJSResult.value = results;
}).then(function () {
// Set Scanner Result
// ScannerResult.Success = RunCodeScanner.Success
vars.value.scannerResultVar.successAttr = runCodeScannerJSResult.value.successOut;
// ScannerResult.ScanResult = RunCodeScanner.ScanResult
vars.value.scannerResultVar.scanResultAttr = runCodeScannerJSResult.value.scanResultOut;
// ScannerResult.Error.ErrorMessage = RunCodeScanner.ErrorMessage
vars.value.scannerResultVar.errorAttr.errorMessageAttr = runCodeScannerJSResult.value.errorMessageOut;
// ScannerResult.Error.ErrorCode = RunCodeScanner.ErrorCode
vars.value.scannerResultVar.errorAttr.errorCodeAttr = runCodeScannerJSResult.value.errorCodeOut;
});
}

}).then(function () {
if((vars.value.scannerResultVar.successAttr)) {
// Set Values
// ScanResult = ScannerResult.ScanResult
outVars.value.scanResultOut = vars.value.scannerResultVar.scanResultAttr;
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
// Success = ScannerResult.Success
outVars.value.successOut = vars.value.scannerResultVar.successAttr;
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
} else {
// Set error
// Success = False
outVars.value.successOut = false;
// Error = ScannerResult.Error
outVars.value.errorOut = vars.value.scannerResultVar.errorAttr;
}

});
} else {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = BoletoCheckBarcodePlugin.Error.ErrorMessage
outVars.value.errorOut.errorMessageAttr = boletoCheckBarcodePluginVar.value.errorOut.errorMessageAttr;
// Error.ErrorCode = BoletoCheckBarcodePlugin.Error.ErrorCode
outVars.value.errorOut.errorCodeAttr = boletoCheckBarcodePluginVar.value.errorOut.errorCodeAttr;
}

});
});
}).catch(function (ex) {
OS.Logger.trace("BoletoScanBarcode.BoletoScanBarcode", OS.Exceptions.getMessage(ex), ex.name);
// Handle Error: AllExceptions
if(!(OS.Exceptions.isSystem(ex))) {
OS.Logger.error(null, ex);
allExceptionsVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
return OS.Flow.executeAsyncFlow(function () {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = AllExceptions.ExceptionMessage
outVars.value.errorOut.errorMessageAttr = allExceptionsVar.value.exceptionMessageAttr;
// Error.ErrorCode = -1
outVars.value.errorOut.errorCodeAttr = (-1).toString();
return OS.Flow.returnAsync(outVars.value);

});
}

throw ex;
}).then(function () {
return outVars.value;
});
};
var controller = BoletoBarcodePluginController.default;
BoletoBarcodePluginController.default.constructor.registerVariableGroupType("BoletoBarcodePlugin.BoletoScanBarcode$vars", [{
name: "ScanInstructions",
attrName: "scanInstructionsInLocal",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "Center your code on the frame";
}
}, {
name: "CameraDirection",
attrName: "cameraDirectionInLocal",
mandatory: false,
dataType: OS.Types.Integer,
defaultValue: function () {
return BoletoBarcodePluginModel.staticEntities.cameraDirection.backCamera;
}
}, {
name: "ScanOrientation",
attrName: "scanOrientationInLocal",
mandatory: false,
dataType: OS.Types.Integer,
defaultValue: function () {
return BoletoBarcodePluginModel.staticEntities.scanOrientation.adaptive;
}
}, {
name: "ScanLine",
attrName: "scanLineInLocal",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return true;
}
}, {
name: "ScanButton",
attrName: "scanButtonInLocal",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "ScanButtonText",
attrName: "scanButtonTextInLocal",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "Scan";
}
}, {
name: "ShowCameraSelection",
attrName: "showCameraSelectionInLocal",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Hint",
attrName: "hintInLocal",
mandatory: false,
dataType: OS.Types.Integer,
defaultValue: function () {
return BoletoBarcodePluginModel.staticEntities.formats.aLL;
}
}, {
name: "ScannerFPS",
attrName: "scannerFPSInLocal",
mandatory: false,
dataType: OS.Types.Integer,
defaultValue: function () {
return -1;
}
}, {
name: "ScannerResult",
attrName: "scannerResultVar",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new BoletoBarcodePluginModel.ScannerResultRec();
},
complexType: BoletoBarcodePluginModel.ScannerResultRec
}]);
BoletoBarcodePluginController.default.constructor.registerVariableGroupType("BoletoBarcodePlugin.BoletoScanBarcode$runWebScannerJSResult", [{
name: "ScanResult",
attrName: "scanResultOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "Success",
attrName: "successOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "ErrorCode",
attrName: "errorCodeOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "ErrorMessage",
attrName: "errorMessageOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BoletoBarcodePluginController.default.constructor.registerVariableGroupType("BoletoBarcodePlugin.BoletoScanBarcode$runCodeScannerJSResult", [{
name: "ScanResult",
attrName: "scanResultOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "ErrorMessage",
attrName: "errorMessageOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "Success",
attrName: "successOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "ErrorCode",
attrName: "errorCodeOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BoletoBarcodePluginController.default.constructor.registerVariableGroupType("BoletoBarcodePlugin.BoletoScanBarcode$outVars", [{
name: "ScanResult",
attrName: "scanResultOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "Success",
attrName: "successOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}]);
BoletoBarcodePluginController.default.clientActionProxies.boletoScanBarcode$Action = function (scanInstructionsIn, cameraDirectionIn, scanOrientationIn, scanLineIn, scanButtonIn, scanButtonTextIn, showCameraSelectionIn, hintIn, scannerFPSIn) {
scanInstructionsIn = (scanInstructionsIn === undefined) ? "Center your code on the frame" : scanInstructionsIn;
cameraDirectionIn = (cameraDirectionIn === undefined) ? BoletoBarcodePluginModel.staticEntities.cameraDirection.backCamera : cameraDirectionIn;
scanOrientationIn = (scanOrientationIn === undefined) ? BoletoBarcodePluginModel.staticEntities.scanOrientation.adaptive : scanOrientationIn;
scanLineIn = (scanLineIn === undefined) ? true : scanLineIn;
scanButtonIn = (scanButtonIn === undefined) ? false : scanButtonIn;
scanButtonTextIn = (scanButtonTextIn === undefined) ? "Scan" : scanButtonTextIn;
showCameraSelectionIn = (showCameraSelectionIn === undefined) ? false : showCameraSelectionIn;
hintIn = (hintIn === undefined) ? BoletoBarcodePluginModel.staticEntities.formats.aLL : hintIn;
scannerFPSIn = (scannerFPSIn === undefined) ? -1 : scannerFPSIn;
return controller.executeActionInsideJSNode(BoletoBarcodePluginController.default.boletoScanBarcode$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(scanInstructionsIn, OS.Types.Text), cameraDirectionIn, scanOrientationIn, OS.DataConversion.JSNodeParamConverter.from(scanLineIn, OS.Types.Boolean), OS.DataConversion.JSNodeParamConverter.from(scanButtonIn, OS.Types.Boolean), OS.DataConversion.JSNodeParamConverter.from(scanButtonTextIn, OS.Types.Text), OS.DataConversion.JSNodeParamConverter.from(showCameraSelectionIn, OS.Types.Boolean), hintIn, OS.DataConversion.JSNodeParamConverter.from(scannerFPSIn, OS.Types.Integer)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
ScanResult: OS.DataConversion.JSNodeParamConverter.to(actionResults.scanResultOut, OS.Types.Text),
Success: OS.DataConversion.JSNodeParamConverter.to(actionResults.successOut, OS.Types.Boolean),
Error: actionResults.errorOut
};
});
};
});
define("BoletoBarcodePlugin.controller$BoletoScanBarcode.RunWebScannerJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
return new Promise(function ($resolve, $reject) {
var params = {
    facingMode: $parameters.CameraDirection == '2' ? 'user' : 'environment',
    orientation: $parameters.ScanOrientation,
    scanInstructions: $parameters.ScanInstructions,
    hasScannerButton: $parameters.ScanButton,
    buttonText: $parameters.ScanText,
    showScanLine: $parameters.ScanLine,
    showCameraSelection: $parameters.ShowCameraSelection,
    typeHint: $parameters.Hint == 17 ? undefined : $parameters.Hint,
    scannerFPS: $parameters.ScannerFPS != -1? $parameters.ScannerFPS : 50
}

function onSuccessScan (ScanResult) {
    $parameters.ScanResult = ScanResult;
    $parameters.Success = true;
    $resolve();
}

function onFailScan (errorCode, errorMessage) {
    $parameters.ErrorCode = errorCode;
    $parameters.ErrorMessage = errorMessage;
    $parameters.Success = false;
    $resolve();
}

async function startScan() {
    var parent = document.getElementById('reactContainer'); 
    await OSBarcodePlugin.openScanner(params, parent, onSuccessScan, onFailScan, $public.FeedbackMessage.showFeedbackMessage);    
}

startScan();
});
};
});
define("BoletoBarcodePlugin.controller$BoletoScanBarcode.RunCodeScannerJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
return new Promise(function ($resolve, $reject) {
var params = {
      'scan_instructions': $parameters.ScanInstructions,
      'camera_direction' : $parameters.CameraDirection,
      'scan_orientation' : $parameters.ScanOrientation,
      'scan_line' : $parameters.ScanLine,
      'scan_button' : $parameters.ScanButton,
      'scan_button_text' : $parameters.ScanText
    };

function onSuccessScan (ScanResult) {
    $parameters.ScanResult = ScanResult;
    $parameters.Success = true;
    $resolve();
}

function onFailScan (error) {
    $parameters.ErrorCode = error.code;
    $parameters.ErrorMessage = error.message;
    $parameters.Success = false;
    $resolve();
}

cordova.plugins.OSBarcodeScanner.scan(params, onSuccessScan, onFailScan);
});
};
});

define("BoletoBarcodePlugin.controller", ["exports", "OutSystems/ClientRuntime/Main", "BoletoBarcodePlugin.model"], function (exports, OutSystems, BoletoBarcodePluginModel) {
var OS = OutSystems.Internal;
var BoletoBarcodePluginController = exports;
var Controller = (function (_super) {
__extends(Controller, _super);
function Controller() {
_super.apply(this, arguments);
}
Controller.prototype.clientActionProxies = {};
Controller.prototype.roles = {};
Controller.prototype.defaultTimeout = 10;
Controller.prototype.getDefaultTimeout = function () {
return BoletoBarcodePluginController.default.defaultTimeout;
};
return Controller;
})(OS.Controller.BaseModuleController);
BoletoBarcodePluginController.default = new Controller(null, "BoletoBarcodePlugin");
});
