﻿define("Brazil_Common_MUI.controller$GetDeviceInformation", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Common_MUI.model", "Brazil_Common_MUI.controller", "CommonPlugin.model", "DevicePlugin.controller", "DevicePlugin.model", "Brazil_FundsOut_BL.model", "CommonPlugin.model$ErrorRec", "Brazil_Common_MUI.referencesHealth", "Brazil_Common_MUI.referencesHealth$CommonPlugin", "DevicePlugin.controller$CheckDevicePlugin", "Brazil_Common_MUI.referencesHealth$DevicePlugin", "DevicePlugin.model$DeviceRec", "DevicePlugin.controller$GetDeviceInfo", "Brazil_FundsOut_BL.model$SmartPhoneDetailsRec", "Brazil_Common_MUI.referencesHealth$Brazil_FundsOut_BL"], function (exports, OutSystems, Brazil_Common_MUIModel, Brazil_Common_MUIController, CommonPluginModel, DevicePluginController, DevicePluginModel, Brazil_FundsOut_BLModel) {
var OS = OutSystems.Internal;
Brazil_Common_MUIController.default.getDeviceInformation$Action = function (callContext) {
callContext = controller.callContext(callContext);
var checkDevicePluginVar = new OS.DataTypes.VariableHolder();
var getDeviceInfoVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Common_MUI.GetDeviceInformation$outVars"))());
// Execute Action: CheckDevicePlugin
checkDevicePluginVar.value = DevicePluginController.default.checkDevicePlugin$Action(callContext);

if((checkDevicePluginVar.value.isAvailableOut)) {
// Execute Action: GetDeviceInfo
getDeviceInfoVar.value = DevicePluginController.default.getDeviceInfo$Action(callContext);

// SmartPhoneDetails.SmartphoneDeviceAlias = GetDeviceInfo.Device.Uuid
outVars.value.smartPhoneDetailsOut.smartphoneDeviceAliasAttr = getDeviceInfoVar.value.deviceOut.uuidAttr;
// SmartPhoneDetails.SmartphoneDeviceType = "MOBILE"
outVars.value.smartPhoneDetailsOut.smartphoneDeviceTypeAttr = "MOBILE";
// SmartPhoneDetails.SmartphoneDeviceWuName = If
outVars.value.smartPhoneDetailsOut.smartphoneDeviceWuNameAttr = (((getDeviceInfoVar.value.deviceOut.platformAttr === "Android")) ? (getDeviceInfoVar.value.deviceOut.platformAttr) : ("iPhone"));
// SmartPhoneDetails.SmartphoneDeviceOs = GetDeviceInfo.Device.Platform
outVars.value.smartPhoneDetailsOut.smartphoneDeviceOsAttr = getDeviceInfoVar.value.deviceOut.platformAttr;
// SmartPhoneDetails.SmartphoneDeviceModel = GetDeviceInfo.Device.Model
outVars.value.smartPhoneDetailsOut.smartphoneDeviceModelAttr = getDeviceInfoVar.value.deviceOut.modelAttr;
// SmartPhoneDetails.SmartphoneDeviceOsWuVersion = GetDeviceInfo.Device.Version
outVars.value.smartPhoneDetailsOut.smartphoneDeviceOsWuVersionAttr = getDeviceInfoVar.value.deviceOut.versionAttr;
// DeviceInfoAvailable = True
outVars.value.deviceInfoAvailableOut = true;
}

return outVars.value;
};
var controller = Brazil_Common_MUIController.default;
Brazil_Common_MUIController.default.constructor.registerVariableGroupType("Brazil_Common_MUI.GetDeviceInformation$outVars", [{
name: "SmartPhoneDetails",
attrName: "smartPhoneDetailsOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new Brazil_FundsOut_BLModel.SmartPhoneDetailsRec();
},
complexType: Brazil_FundsOut_BLModel.SmartPhoneDetailsRec
}, {
name: "DeviceInfoAvailable",
attrName: "deviceInfoAvailableOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
Brazil_Common_MUIController.default.clientActionProxies.getDeviceInformation$Action = function () {
return controller.executeActionInsideJSNode(Brazil_Common_MUIController.default.getDeviceInformation$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
SmartPhoneDetails: actionResults.smartPhoneDetailsOut,
DeviceInfoAvailable: OS.DataConversion.JSNodeParamConverter.to(actionResults.deviceInfoAvailableOut, OS.Types.Boolean)
};
});
};
});

define("Brazil_Common_MUI.controller$OpenChatBotInApp", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Common_MUI.model", "Brazil_Common_MUI.controller", "InAppBrowserPlugin.model", "CommonPlugin.model", "InAppBrowserPlugin.controller", "InAppBrowserPlugin.model$OptionsRec", "Brazil_Common_MUI.referencesHealth", "Brazil_Common_MUI.referencesHealth$InAppBrowserPlugin", "CommonPlugin.model$ErrorRec", "Brazil_Common_MUI.referencesHealth$CommonPlugin", "InAppBrowserPlugin.controller$Open", "Brazil_Common_MUI.controller$ServerAction.GetLisaChatBotURL", "InAppBrowserPlugin.controller$CheckInAppBrowserPlugin"], function (exports, OutSystems, Brazil_Common_MUIModel, Brazil_Common_MUIController, InAppBrowserPluginModel, CommonPluginModel, InAppBrowserPluginController) {
var OS = OutSystems.Internal;
Brazil_Common_MUIController.default.openChatBotInApp$Action = function (userIdIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Common_MUI.OpenChatBotInApp$vars"))());
vars.value.userIdInLocal = userIdIn;
var getLisaChatBotURLVar = new OS.DataTypes.VariableHolder();
var openVar = new OS.DataTypes.VariableHolder();
var checkInAppBrowserPluginVar = new OS.DataTypes.VariableHolder();
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: CheckInAppBrowserPlugin
checkInAppBrowserPluginVar.value = InAppBrowserPluginController.default.checkInAppBrowserPlugin$Action(callContext);

// Available?
return OS.Flow.executeSequence(function () {
if((checkInAppBrowserPluginVar.value.isAvailableOut)) {
// Execute Action: GetLisaChatBotURL
return controller.getLisaChatBotURL$ServerAction(vars.value.userIdInLocal, callContext).then(function (value) {
getLisaChatBotURLVar.value = value;
}).then(function () {
// Execute Action: Open
openVar.value = InAppBrowserPluginController.default.open$Action(getLisaChatBotURLVar.value.uRLOut, Brazil_Common_MUIModel.staticEntities.target.iN_APP_BROWSER, function () {
var rec = new InAppBrowserPluginModel.OptionsRec();
rec.locationAttr = false;
return rec;
}(), callContext);

});
} else {
// Raise Error: ChatBotNotAvailable
throw new OS.Exceptions.Exceptions.UserException("Brazil_Common_MUI.ChatBotNotAvailable", OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("GM5nFOaLqkCaOZmDE2JZzA#Message.-1091490030.1", "Chat feature is currently unavailable"));
}

});
}).then(function () {
return ;
});
};
var controller = Brazil_Common_MUIController.default;
Brazil_Common_MUIController.default.constructor.registerVariableGroupType("Brazil_Common_MUI.OpenChatBotInApp$vars", [{
name: "UserId",
attrName: "userIdInLocal",
mandatory: true,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}]);
Brazil_Common_MUIController.default.clientActionProxies.openChatBotInApp$Action = function (userIdIn) {
userIdIn = (userIdIn === undefined) ? 0 : userIdIn;
return controller.executeActionInsideJSNode(Brazil_Common_MUIController.default.openChatBotInApp$Action.bind(controller, userIdIn), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_Common_MUI.controller$ServerAction.GetLisaChatBotURL", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Common_MUI.model", "Brazil_Common_MUI.controller"], function (exports, OutSystems, Brazil_Common_MUIModel, Brazil_Common_MUIController) {
var OS = OutSystems.Internal;
Brazil_Common_MUIController.default.getLisaChatBotURL$ServerAction = function (userIdIn, callContext) {
var controller = this.controller;
var inputs = {
UserId: OS.DataConversion.ServerDataConverter.to(userIdIn, OS.Types.Integer)
};
return controller.callServerAction("GetLisaChatBotURL", "screenservices/Brazil_Common_MUI/ActionGetLisaChatBotURL", "ivEpCYtCNSH1VYsaQi2Nmg", inputs, controller.callContext(callContext), undefined, undefined, true).then(function (outputs) {
var executeServerActionResult = new (controller.constructor.getVariableGroupType("Brazil_Common_MUI$ActionGetLisaChatBotURL"))();
executeServerActionResult.uRLOut = OS.DataConversion.ServerDataConverter.from(outputs.URL, OS.Types.Text);
return executeServerActionResult;
});
};
Brazil_Common_MUIController.default.constructor.registerVariableGroupType("Brazil_Common_MUI$ActionGetLisaChatBotURL", [{
name: "URL",
attrName: "uRLOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
});
define("Brazil_Common_MUI.controller", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Common_MUI.model", "Brazil_Common_MUI.controller$translationsResources"], function (exports, OutSystems, Brazil_Common_MUIModel, Brazil_Common_MUI_Controller_translationsResources) {
var OS = OutSystems.Internal;
var Brazil_Common_MUIController = exports;
var Controller = (function (_super) {
__extends(Controller, _super);
function Controller() {
_super.apply(this, arguments);
}
Controller.prototype.clientActionProxies = {};
Controller.prototype.roles = {};
Controller.prototype.defaultTimeout = 10;
Controller.prototype.getDefaultTimeout = function () {
return Brazil_Common_MUIController.default.defaultTimeout;
};
return Controller;
})(OS.Controller.BaseModuleController);
Brazil_Common_MUIController.default = new Controller(Brazil_Common_MUI_Controller_translationsResources, "Brazil_Common_MUI");
});
define("Brazil_Common_MUI.controller$translationsResources", ["exports", "Brazil_Common_MUI.controller$translationsResources.es-419", "Brazil_Common_MUI.controller$translationsResources.pt-BR"], function (exports, Brazil_Common_MUI_controller_translationsResources_es419, Brazil_Common_MUI_controller_translationsResources_ptBR) {
return {
"es-419": {
"translations": Brazil_Common_MUI_controller_translationsResources_es419,
"isRTL": false
},
"pt-BR": {
"translations": Brazil_Common_MUI_controller_translationsResources_ptBR,
"isRTL": false
}
};
});
define("Brazil_Common_MUI.controller$translationsResources.es-419", [], function () {
return {
"GM5nFOaLqkCaOZmDE2JZzA#Message.-1091490030.1": "La función de chat no está disponible actualmente"
};
});
define("Brazil_Common_MUI.controller$translationsResources.pt-BR", [], function () {
return {
"GM5nFOaLqkCaOZmDE2JZzA#Message.-1091490030.1": "O recurso de ajuda está atualmente indisponível"
};
});
