cordova.define("@outsystems/cordova-outsystems-appshield.logging", function(require, exports, module) {
// Handles event logging to Service Center. Important events are sent to SC
// and and will appear in logs.
module.exports = function () {

    // Available error messages
    var deviceIsRootedMessage = "A rooted device is using the application";

    // Logs a warning message in SC if the event is meaningful
    this.logEventIfImportant = function (event) {
        if (OutSystemsNative && OutSystemsNative.Logger) {

            var message = this.evaluateMessageForEvent(event);
            if (message) {
                OutSystemsNative.Logger.logWarning(message, "ShieldManager");
            }
        }
    };

    // Determines if an event is meaningful enough to be reported. If it is,
    // this method returns which error message should be logged. It returns
    // null if no message should be logged.
    this.evaluateMessageForEvent = function (event) {
        switch (event.Type) {
            case "rooting":
            	return evaluateMessageForRootingEvent(event);
            default:
            	return null;
        }
    };

    // Specific processing for RootingEvent instances
    var evaluateMessageForRootingEvent = function (event) {
        return event.Rooted ? deviceIsRootedMessage : null;
    };
};

});
