﻿define("BarcodePlugin.controller$CheckBarcodePlugin", ["exports", "OutSystems/ClientRuntime/Main", "BarcodePlugin.model", "BarcodePlugin.controller", "CommonPlugin.controller", "CommonPlugin.model", "BarcodePlugin.controller$CheckBarcodePlugin.GetWebAPIJS", "BarcodePlugin.controller$CheckBarcodePlugin.IsPluginAvailableJSJS", "BarcodePlugin.controller$CheckBarcodePlugin.AddCSSJS", "CommonPlugin.controller$IsCordovaDefined", "BarcodePlugin.referencesHealth", "BarcodePlugin.referencesHealth$CommonPlugin", "CommonPlugin.model$ErrorRec"], function (exports, OutSystems, BarcodePluginModel, BarcodePluginController, CommonPluginController, CommonPluginModel, BarcodePlugin_controller_CheckBarcodePlugin_GetWebAPIJS, BarcodePlugin_controller_CheckBarcodePlugin_IsPluginAvailableJSJS, BarcodePlugin_controller_CheckBarcodePlugin_AddCSSJS) {
var OS = OutSystems.Internal;
BarcodePluginController.default.checkBarcodePlugin$Action = function (callContext) {
callContext = controller.callContext(callContext);
var allExceptionsVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var isCordovaDefinedVar = new OS.DataTypes.VariableHolder();
var getWebAPIJSResult = new OS.DataTypes.VariableHolder();
var isPluginAvailableJSJSResult = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BarcodePlugin.CheckBarcodePlugin$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: IsCordovaDefined
isCordovaDefinedVar.value = CommonPluginController.default.isCordovaDefined$Action(callContext);

return OS.Flow.executeSequence(function () {
if((isCordovaDefinedVar.value.isLoadedOut)) {
// Checks if the barcode scanner plugin is loaded and ready to be used.
isPluginAvailableJSJSResult.value = controller.safeExecuteJSNode(BarcodePlugin_controller_CheckBarcodePlugin_IsPluginAvailableJSJS, "IsPluginAvailableJS", "CheckBarcodePlugin", {
IsAvailable: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("BarcodePlugin.CheckBarcodePlugin$isPluginAvailableJSJSResult"))();
jsNodeResult.isAvailableOut = OS.DataConversion.JSNodeParamConverter.from($parameters.IsAvailable, OS.Types.Boolean);
return jsNodeResult;
}, {}, {});
if((isPluginAvailableJSJSResult.value.isAvailableOut)) {
// IsAvailable = IsPluginAvailableJS.IsAvailable
outVars.value.isAvailableOut = isPluginAvailableJSJSResult.value.isAvailableOut;
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
} else {
// Error.ErrorCode = "OS-PLUG-BARC-0012"
outVars.value.errorOut.errorCodeAttr = "OS-PLUG-BARC-0012";
// Error.ErrorMessage = "Barcode Plugin is not available."
outVars.value.errorOut.errorMessageAttr = "Barcode Plugin is not available.";
// IsAvailable = False
outVars.value.isAvailableOut = false;
}

} else {
getWebAPIJSResult.value = controller.safeExecuteJSNode(BarcodePlugin_controller_CheckBarcodePlugin_GetWebAPIJS, "GetWebAPI", "CheckBarcodePlugin", {
IsSupported: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("BarcodePlugin.CheckBarcodePlugin$getWebAPIJSResult"))();
jsNodeResult.isSupportedOut = OS.DataConversion.JSNodeParamConverter.from($parameters.IsSupported, OS.Types.Boolean);
return jsNodeResult;
}, {}, {});
// Is PWA?
return OS.Flow.executeSequence(function () {
if((getWebAPIJSResult.value.isSupportedOut)) {
controller.safeExecuteJSNode(BarcodePlugin_controller_CheckBarcodePlugin_AddCSSJS, "AddCSS", "CheckBarcodePlugin", null, function ($parameters) {
}, {}, {});
// Execute Action: AddOSBarcodePlugin
return OS.SystemActions.requireScript(OS.Navigation.VersionedURL.getVersionedUrl("scripts/BarcodePlugin.OSBarcodePlugin.js"), callContext).then(function () {
// IsAvailable = True
outVars.value.isAvailableOut = true;
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
// IsPWA = True
outVars.value.isPWAOut = true;
});
} else {
// Error.ErrorCode = "OS-PLUG-BARC-0011"
outVars.value.errorOut.errorCodeAttr = "OS-PLUG-BARC-0011";
// Error.ErrorMessage = "Cordova is not available."
outVars.value.errorOut.errorMessageAttr = "Cordova is not available.";
// IsAvailable = False
outVars.value.isAvailableOut = false;
}

});
}

});
}).catch(function (ex) {
OS.Logger.trace("CheckBarcodePlugin.CheckBarcodePlugin", OS.Exceptions.getMessage(ex), ex.name);
// Handle Error: AllExceptions
if(!(OS.Exceptions.isSystem(ex))) {
OS.Logger.error(null, ex);
allExceptionsVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
return OS.Flow.executeAsyncFlow(function () {
// IsAvailable = False
outVars.value.isAvailableOut = false;
// Error.ErrorCode = -1
outVars.value.errorOut.errorCodeAttr = (-1).toString();
// Error.ErrorMessage = AllExceptions.ExceptionMessage
outVars.value.errorOut.errorMessageAttr = allExceptionsVar.value.exceptionMessageAttr;
return OS.Flow.returnAsync(outVars.value);

});
}

throw ex;
}).then(function () {
return outVars.value;
});
};
var controller = BarcodePluginController.default;
BarcodePluginController.default.constructor.registerVariableGroupType("BarcodePlugin.CheckBarcodePlugin$getWebAPIJSResult", [{
name: "IsSupported",
attrName: "isSupportedOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
BarcodePluginController.default.constructor.registerVariableGroupType("BarcodePlugin.CheckBarcodePlugin$isPluginAvailableJSJSResult", [{
name: "IsAvailable",
attrName: "isAvailableOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
BarcodePluginController.default.constructor.registerVariableGroupType("BarcodePlugin.CheckBarcodePlugin$outVars", [{
name: "IsAvailable",
attrName: "isAvailableOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "IsPWA",
attrName: "isPWAOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}]);
BarcodePluginController.default.clientActionProxies.checkBarcodePlugin$Action = function () {
return controller.executeActionInsideJSNode(BarcodePluginController.default.checkBarcodePlugin$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
IsAvailable: OS.DataConversion.JSNodeParamConverter.to(actionResults.isAvailableOut, OS.Types.Boolean),
IsPWA: OS.DataConversion.JSNodeParamConverter.to(actionResults.isPWAOut, OS.Types.Boolean),
Error: actionResults.errorOut
};
});
};
});
define("BarcodePlugin.controller$CheckBarcodePlugin.GetWebAPIJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
$parameters.IsSupported = navigator.mediaDevices !== undefined
};
});
define("BarcodePlugin.controller$CheckBarcodePlugin.IsPluginAvailableJSJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
$parameters.IsAvailable = !!cordova.plugins && (!!cordova.plugins.OSBarcodeScanner || !!cordova.plugins.OSBarcode);
};
});
define("BarcodePlugin.controller$CheckBarcodePlugin.AddCSSJS", [], function () {
return function ($actions, $roles, $public) {
const allcss = [...document.styleSheets]
let hasCss = allcss.filter(item => item.title == "barcode-plugin-css").length > 0;
if(!hasCss) {
    let sheet = document.createElement('style');
    sheet.title = 'barcode-plugin-css';
    sheet.innerHTML = '.interface-wrapper{height:100%;overflow:hidden;width:100%}.scanner-wrapper{display:flex;height:100%;width:100%}.barcode-btn{background:hsla(0,0%,100%,.1);border:1.452px solid #4f575e;color:#fff;font-weight:500;z-index:11}.barcode-btn,.barcode-btn-clicked{align-items:center;backdrop-filter:blur(8.71px);display:flex;justify-content:center}.barcode-btn-clicked{background:#fff;border:1.452px solid #fff;color:#4f575e}.barcode-btn path{fill:#fff}.barcode-btn-clicked path{fill:#4f575e}.barcode-container{height:100%;padding:32px;position:absolute;top:0;width:100%;z-index:11}@media (max-width:320px){.barcode-container{height:100%;padding:10px;position:absolute;top:0;width:100%;z-index:11}}.outsystems-flex{display:flex}.outsystems-col{flex-direction:column}.outsystems-col-reverse{flex-direction:column-reverse}.outsystems-row{flex-direction:row}.outsystems-row-reverse{flex-direction:row-reverse}.outsystems-flex-justify-center{justify-content:center;-webkit-justify-content:center}.outsystems-flex-justify-end{justify-content:end;-webkit-justify-content:flex-end}.outsystems-flex-justify-between{-webkit-justify-content:space-between;justify-content:space-between}.outsystems-flex-start{-webkit-align-items:flex-start;align-items:flex-start}.outsystems-flex-end{-webkit-align-items:flex-end;align-items:flex-end}.outsystems-flex-center{-webkit-align-items:center;align-items:center}.outsystems-fill-height{flex:1 1 0}@media (min-width:641px){.barcode-btn-clicked,.outsystems-row-gap>.barcode-btn{margin-bottom:39px}.barcode-btn-clicked,.outsystems-row-s-gap>.barcode-btn{margin-bottom:24px}}@media (max-width:640px){.outsystems-row-gap{row-gap:39px}.outsystems-row-s-gap{row-gap:24px}}@media (max-width:375px){.outsystems-row-gap{row-gap:10px}}.outsystems-mt-24{margin-top:24px}.outsystems-mb-24{margin-bottom:24px}.outsystems-mt-32{margin-top:32px}.outsystems-torch-btn{border-radius:200px;height:48px;width:48px}.outsystems-scanner-btn{border-radius:4px;height:48px;padding:0 15px;width:fit-content}.outsystems-scanner-instructions{word-wrap:break-word;color:#fff;font-size:16px;font-weight:400;-webkit-justify-content:center;justify-content:center;line-height:24px;text-align:center;word-break:break-all}.outsystems-camera-dropdown{border-radius:54px;padding:7.5px 12px;text-align:center;text-align-last:center}';
    document.getElementsByTagName('head')[0].appendChild(sheet);
}
};
});

define("BarcodePlugin.controller$ScanBarcode", ["exports", "OutSystems/ClientRuntime/Main", "BarcodePlugin.model", "BarcodePlugin.controller", "CommonPlugin.model", "BarcodePlugin.controller$ScanBarcode.LimitScanButtonTextJS", "BarcodePlugin.controller$ScanBarcode.LimitScanInstructionsJS", "BarcodePlugin.controller$ScanBarcode.RunWebScannerJS", "BarcodePlugin.controller$ScanBarcode.RunCodeScannerJS", "CommonPlugin.model$ErrorRec", "BarcodePlugin.referencesHealth", "BarcodePlugin.referencesHealth$CommonPlugin", "BarcodePlugin.controller$CheckBarcodePlugin", "BarcodePlugin.model$ScannerResultRec"], function (exports, OutSystems, BarcodePluginModel, BarcodePluginController, CommonPluginModel, BarcodePlugin_controller_ScanBarcode_LimitScanButtonTextJS, BarcodePlugin_controller_ScanBarcode_LimitScanInstructionsJS, BarcodePlugin_controller_ScanBarcode_RunWebScannerJS, BarcodePlugin_controller_ScanBarcode_RunCodeScannerJS) {
var OS = OutSystems.Internal;
BarcodePluginController.default.scanBarcode$Action = function (scanInstructionsIn, cameraDirectionIn, scanOrientationIn, scanButtonIn, scanButtonTextIn, showCameraSelectionIn, hintIn, scannerFPSIn, androidScanningLibraryIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BarcodePlugin.ScanBarcode$vars"))());
vars.value.scanInstructionsInLocal = scanInstructionsIn;
vars.value.cameraDirectionInLocal = cameraDirectionIn;
vars.value.scanOrientationInLocal = scanOrientationIn;
vars.value.scanButtonInLocal = scanButtonIn;
vars.value.scanButtonTextInLocal = scanButtonTextIn;
vars.value.showCameraSelectionInLocal = showCameraSelectionIn;
vars.value.hintInLocal = hintIn;
vars.value.scannerFPSInLocal = scannerFPSIn;
vars.value.androidScanningLibraryInLocal = androidScanningLibraryIn;
var allExceptionsVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var checkBarcodePluginVar = new OS.DataTypes.VariableHolder();
var limitScanButtonTextJSResult = new OS.DataTypes.VariableHolder();
var limitScanInstructionsJSResult = new OS.DataTypes.VariableHolder();
var runWebScannerJSResult = new OS.DataTypes.VariableHolder();
var runCodeScannerJSResult = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BarcodePlugin.ScanBarcode$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: CheckBarcodePlugin
return BarcodePluginController.default.checkBarcodePlugin$Action(callContext).then(function (value) {
checkBarcodePluginVar.value = value;
}).then(function () {
// Is Barcode available?
return OS.Flow.executeSequence(function () {
if((checkBarcodePluginVar.value.isAvailableOut)) {
limitScanInstructionsJSResult.value = controller.safeExecuteJSNode(BarcodePlugin_controller_ScanBarcode_LimitScanInstructionsJS, "LimitScanInstructions", "ScanBarcode", {
MaxLength: OS.DataConversion.JSNodeParamConverter.to(162, OS.Types.Integer),
Text: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanInstructionsInLocal, OS.Types.Text),
Result: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("BarcodePlugin.ScanBarcode$limitScanInstructionsJSResult"))();
jsNodeResult.resultOut = OS.DataConversion.JSNodeParamConverter.from($parameters.Result, OS.Types.Text);
return jsNodeResult;
}, {}, {});
limitScanButtonTextJSResult.value = controller.safeExecuteJSNode(BarcodePlugin_controller_ScanBarcode_LimitScanButtonTextJS, "LimitScanButtonText", "ScanBarcode", {
MaxLength: OS.DataConversion.JSNodeParamConverter.to(16, OS.Types.Integer),
Text: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanButtonTextInLocal, OS.Types.Text),
Result: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("BarcodePlugin.ScanBarcode$limitScanButtonTextJSResult"))();
jsNodeResult.resultOut = OS.DataConversion.JSNodeParamConverter.from($parameters.Result, OS.Types.Text);
return jsNodeResult;
}, {}, {});
// ScanInstructions = LimitScanInstructions.Result
vars.value.scanInstructionsInLocal = limitScanInstructionsJSResult.value.resultOut;
// ScanButtonText = LimitScanButtonText.Result
vars.value.scanButtonTextInLocal = limitScanButtonTextJSResult.value.resultOut;
if(((vars.value.cameraDirectionInLocal === OS.BuiltinFunctions.nullIdentifier()))) {
// CameraDirection = BackCamera
vars.value.cameraDirectionInLocal = BarcodePluginModel.staticEntities.cameraDirection.backCamera;
}

if(((vars.value.scanOrientationInLocal === OS.BuiltinFunctions.nullIdentifier()))) {
// ScanOrientation = Adaptive
vars.value.scanOrientationInLocal = BarcodePluginModel.staticEntities.scanOrientation.adaptive;
}

// Is PWA?
return OS.Flow.executeSequence(function () {
if((checkBarcodePluginVar.value.isPWAOut)) {
return controller.safeExecuteAsyncJSNode(BarcodePlugin_controller_ScanBarcode_RunWebScannerJS, "RunWebScanner", "ScanBarcode", {
ScanInstructions: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanInstructionsInLocal, OS.Types.Text),
ScanText: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanButtonTextInLocal, OS.Types.Text),
ScannerFPS: OS.DataConversion.JSNodeParamConverter.to(vars.value.scannerFPSInLocal, OS.Types.Integer),
ScanOrientation: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanOrientationInLocal, OS.Types.Integer),
ScanButton: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanButtonInLocal, OS.Types.Boolean),
CameraDirection: OS.DataConversion.JSNodeParamConverter.to((vars.value.cameraDirectionInLocal).toString(), OS.Types.Text),
Hint: OS.DataConversion.JSNodeParamConverter.to(vars.value.hintInLocal, OS.Types.Integer),
ShowCameraSelection: OS.DataConversion.JSNodeParamConverter.to(vars.value.showCameraSelectionInLocal, OS.Types.Boolean),
ScanResult: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text),
Success: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean),
ErrorCode: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text),
ErrorMessage: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("BarcodePlugin.ScanBarcode$runWebScannerJSResult"))();
jsNodeResult.scanResultOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ScanResult, OS.Types.Text);
jsNodeResult.successOut = OS.DataConversion.JSNodeParamConverter.from($parameters.Success, OS.Types.Boolean);
jsNodeResult.errorCodeOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ErrorCode, OS.Types.Text);
jsNodeResult.errorMessageOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ErrorMessage, OS.Types.Text);
return jsNodeResult;
}, {}, {}).then(function (results) {
runWebScannerJSResult.value = results;
}).then(function () {
// Set Scanner Result
// ScannerResult.Success = RunWebScanner.Success
vars.value.scannerResultVar.successAttr = runWebScannerJSResult.value.successOut;
// ScannerResult.ScanResult = RunWebScanner.ScanResult
vars.value.scannerResultVar.scanResultAttr = runWebScannerJSResult.value.scanResultOut;
// ScannerResult.Error.ErrorMessage = RunWebScanner.ErrorMessage
vars.value.scannerResultVar.errorAttr.errorMessageAttr = runWebScannerJSResult.value.errorMessageOut;
// ScannerResult.Error.ErrorCode = RunWebScanner.ErrorCode
vars.value.scannerResultVar.errorAttr.errorCodeAttr = runWebScannerJSResult.value.errorCodeOut;
});
} else {
// Use this action to trigger the barcode reader.
return controller.safeExecuteAsyncJSNode(BarcodePlugin_controller_ScanBarcode_RunCodeScannerJS, "RunCodeScanner", "ScanBarcode", {
Hint: OS.DataConversion.JSNodeParamConverter.to(vars.value.hintInLocal, OS.Types.Integer),
ScanButton: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanButtonInLocal, OS.Types.Boolean),
ScanInstructions: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanInstructionsInLocal, OS.Types.Text),
AndroidScanningLibrary: OS.DataConversion.JSNodeParamConverter.to(vars.value.androidScanningLibraryInLocal, OS.Types.Text),
ScanOrientation: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanOrientationInLocal, OS.Types.Integer),
ScanText: OS.DataConversion.JSNodeParamConverter.to(vars.value.scanButtonTextInLocal, OS.Types.Text),
CameraDirection: OS.DataConversion.JSNodeParamConverter.to(vars.value.cameraDirectionInLocal, OS.Types.Integer),
ScanResult: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text),
ErrorMessage: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text),
Success: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean),
ErrorCode: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("BarcodePlugin.ScanBarcode$runCodeScannerJSResult"))();
jsNodeResult.scanResultOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ScanResult, OS.Types.Text);
jsNodeResult.errorMessageOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ErrorMessage, OS.Types.Text);
jsNodeResult.successOut = OS.DataConversion.JSNodeParamConverter.from($parameters.Success, OS.Types.Boolean);
jsNodeResult.errorCodeOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ErrorCode, OS.Types.Text);
return jsNodeResult;
}, {}, {}).then(function (results) {
runCodeScannerJSResult.value = results;
}).then(function () {
// Set Scanner Result
// ScannerResult.Success = RunCodeScanner.Success
vars.value.scannerResultVar.successAttr = runCodeScannerJSResult.value.successOut;
// ScannerResult.ScanResult = RunCodeScanner.ScanResult
vars.value.scannerResultVar.scanResultAttr = runCodeScannerJSResult.value.scanResultOut;
// ScannerResult.Error.ErrorMessage = RunCodeScanner.ErrorMessage
vars.value.scannerResultVar.errorAttr.errorMessageAttr = runCodeScannerJSResult.value.errorMessageOut;
// ScannerResult.Error.ErrorCode = RunCodeScanner.ErrorCode
vars.value.scannerResultVar.errorAttr.errorCodeAttr = runCodeScannerJSResult.value.errorCodeOut;
});
}

}).then(function () {
if((vars.value.scannerResultVar.successAttr)) {
// Set Values
// ScanResult = ScannerResult.ScanResult
outVars.value.scanResultOut = vars.value.scannerResultVar.scanResultAttr;
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
// Success = ScannerResult.Success
outVars.value.successOut = vars.value.scannerResultVar.successAttr;
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
} else {
// Set error
// Success = False
outVars.value.successOut = false;
// Error = ScannerResult.Error
outVars.value.errorOut = vars.value.scannerResultVar.errorAttr;
}

});
} else {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = CheckBarcodePlugin.Error.ErrorMessage
outVars.value.errorOut.errorMessageAttr = checkBarcodePluginVar.value.errorOut.errorMessageAttr;
// Error.ErrorCode = CheckBarcodePlugin.Error.ErrorCode
outVars.value.errorOut.errorCodeAttr = checkBarcodePluginVar.value.errorOut.errorCodeAttr;
}

});
});
}).catch(function (ex) {
OS.Logger.trace("ScanBarcode.ScanBarcode", OS.Exceptions.getMessage(ex), ex.name);
// Handle Error: AllExceptions
if(!(OS.Exceptions.isSystem(ex))) {
OS.Logger.error(null, ex);
allExceptionsVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
return OS.Flow.executeAsyncFlow(function () {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = AllExceptions.ExceptionMessage
outVars.value.errorOut.errorMessageAttr = allExceptionsVar.value.exceptionMessageAttr;
// Error.ErrorCode = -1
outVars.value.errorOut.errorCodeAttr = (-1).toString();
return OS.Flow.returnAsync(outVars.value);

});
}

throw ex;
}).then(function () {
return outVars.value;
});
};
var controller = BarcodePluginController.default;
BarcodePluginController.default.constructor.registerVariableGroupType("BarcodePlugin.ScanBarcode$vars", [{
name: "ScanInstructions",
attrName: "scanInstructionsInLocal",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "Center your code on the frame";
}
}, {
name: "CameraDirection",
attrName: "cameraDirectionInLocal",
mandatory: false,
dataType: OS.Types.Integer,
defaultValue: function () {
return BarcodePluginModel.staticEntities.cameraDirection.backCamera;
}
}, {
name: "ScanOrientation",
attrName: "scanOrientationInLocal",
mandatory: false,
dataType: OS.Types.Integer,
defaultValue: function () {
return BarcodePluginModel.staticEntities.scanOrientation.adaptive;
}
}, {
name: "ScanButton",
attrName: "scanButtonInLocal",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "ScanButtonText",
attrName: "scanButtonTextInLocal",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "Scan";
}
}, {
name: "ShowCameraSelection",
attrName: "showCameraSelectionInLocal",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Hint",
attrName: "hintInLocal",
mandatory: false,
dataType: OS.Types.Integer,
defaultValue: function () {
return BarcodePluginModel.staticEntities.formats.aLL;
}
}, {
name: "ScannerFPS",
attrName: "scannerFPSInLocal",
mandatory: false,
dataType: OS.Types.Integer,
defaultValue: function () {
return -1;
}
}, {
name: "AndroidScanningLibrary",
attrName: "androidScanningLibraryInLocal",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return BarcodePluginModel.staticEntities.androidScanningLibrary.zXing;
}
}, {
name: "ScannerResult",
attrName: "scannerResultVar",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new BarcodePluginModel.ScannerResultRec();
},
complexType: BarcodePluginModel.ScannerResultRec
}]);
BarcodePluginController.default.constructor.registerVariableGroupType("BarcodePlugin.ScanBarcode$limitScanButtonTextJSResult", [{
name: "Result",
attrName: "resultOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BarcodePluginController.default.constructor.registerVariableGroupType("BarcodePlugin.ScanBarcode$limitScanInstructionsJSResult", [{
name: "Result",
attrName: "resultOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BarcodePluginController.default.constructor.registerVariableGroupType("BarcodePlugin.ScanBarcode$runWebScannerJSResult", [{
name: "ScanResult",
attrName: "scanResultOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "Success",
attrName: "successOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "ErrorCode",
attrName: "errorCodeOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "ErrorMessage",
attrName: "errorMessageOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BarcodePluginController.default.constructor.registerVariableGroupType("BarcodePlugin.ScanBarcode$runCodeScannerJSResult", [{
name: "ScanResult",
attrName: "scanResultOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "ErrorMessage",
attrName: "errorMessageOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "Success",
attrName: "successOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "ErrorCode",
attrName: "errorCodeOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BarcodePluginController.default.constructor.registerVariableGroupType("BarcodePlugin.ScanBarcode$outVars", [{
name: "ScanResult",
attrName: "scanResultOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "Success",
attrName: "successOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}]);
BarcodePluginController.default.clientActionProxies.scanBarcode$Action = function (scanInstructionsIn, cameraDirectionIn, scanOrientationIn, scanButtonIn, scanButtonTextIn, showCameraSelectionIn, hintIn, scannerFPSIn, androidScanningLibraryIn) {
scanInstructionsIn = (scanInstructionsIn === undefined) ? "Center your code on the frame" : scanInstructionsIn;
cameraDirectionIn = (cameraDirectionIn === undefined) ? BarcodePluginModel.staticEntities.cameraDirection.backCamera : cameraDirectionIn;
scanOrientationIn = (scanOrientationIn === undefined) ? BarcodePluginModel.staticEntities.scanOrientation.adaptive : scanOrientationIn;
scanButtonIn = (scanButtonIn === undefined) ? false : scanButtonIn;
scanButtonTextIn = (scanButtonTextIn === undefined) ? "Scan" : scanButtonTextIn;
showCameraSelectionIn = (showCameraSelectionIn === undefined) ? false : showCameraSelectionIn;
hintIn = (hintIn === undefined) ? BarcodePluginModel.staticEntities.formats.aLL : hintIn;
scannerFPSIn = (scannerFPSIn === undefined) ? -1 : scannerFPSIn;
androidScanningLibraryIn = (androidScanningLibraryIn === undefined) ? BarcodePluginModel.staticEntities.androidScanningLibrary.zXing : androidScanningLibraryIn;
return controller.executeActionInsideJSNode(BarcodePluginController.default.scanBarcode$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(scanInstructionsIn, OS.Types.Text), cameraDirectionIn, scanOrientationIn, OS.DataConversion.JSNodeParamConverter.from(scanButtonIn, OS.Types.Boolean), OS.DataConversion.JSNodeParamConverter.from(scanButtonTextIn, OS.Types.Text), OS.DataConversion.JSNodeParamConverter.from(showCameraSelectionIn, OS.Types.Boolean), hintIn, OS.DataConversion.JSNodeParamConverter.from(scannerFPSIn, OS.Types.Integer), androidScanningLibraryIn), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
ScanResult: OS.DataConversion.JSNodeParamConverter.to(actionResults.scanResultOut, OS.Types.Text),
Success: OS.DataConversion.JSNodeParamConverter.to(actionResults.successOut, OS.Types.Boolean),
Error: actionResults.errorOut
};
});
};
});
define("BarcodePlugin.controller$ScanBarcode.LimitScanButtonTextJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
const ellipsis = "...";

if ($public.BuiltinFunctions.length($parameters.Text) <= $parameters.MaxLength) {
    $parameters.Result = $parameters.Text;
} else {
    let truncatedString = $public.BuiltinFunctions.substr($parameters.Text,0,$parameters.MaxLength - ellipsis.length)
    const lastSpaceIndex = truncatedString.lastSpaceIndex

    if (lastSpaceIndex !== -1) {
        truncatedString = truncatedString.substr(0, lastSpaceIndex) + ellipsis
    } else {
        truncatedString = truncatedString + ellipsis
    }
    $parameters.Result = truncatedString
}
};
});
define("BarcodePlugin.controller$ScanBarcode.LimitScanInstructionsJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
const ellipsis = "...";

if ($public.BuiltinFunctions.length($parameters.Text) <= $parameters.MaxLength) {
    $parameters.Result = $parameters.Text;
} else {
    let truncatedString = $public.BuiltinFunctions.substr($parameters.Text,0,$parameters.MaxLength - ellipsis.length)
    const lastSpaceIndex = truncatedString.lastSpaceIndex

    if (lastSpaceIndex !== -1) {
        truncatedString = truncatedString.substr(0, lastSpaceIndex) + ellipsis
    } else {
        truncatedString = truncatedString + ellipsis
    }
    $parameters.Result = truncatedString
}
};
});
define("BarcodePlugin.controller$ScanBarcode.RunWebScannerJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
return new Promise(function ($resolve, $reject) {
var params = {
    facingMode: $parameters.CameraDirection == '2' ? 'user' : 'environment',
    orientation: $parameters.ScanOrientation,
    scanInstructions: $parameters.ScanInstructions,
    hasScannerButton: $parameters.ScanButton,
    buttonText: $parameters.ScanText,
    showCameraSelection: $parameters.ShowCameraSelection,
    typeHint: $parameters.Hint == 17 ? undefined : $parameters.Hint,
    scannerFPS: $parameters.ScannerFPS != -1? $parameters.ScannerFPS : 50
}

function onSuccessScan (ScanResult) {
    $parameters.ScanResult = ScanResult;
    $parameters.Success = true;
    $resolve();
}

function onFailScan (errorCode, errorMessage) {
    $parameters.ErrorCode = errorCode;
    $parameters.ErrorMessage = errorMessage;
    $parameters.Success = false;
    $resolve();
}

async function startScan() {
    var parent = document.getElementById('reactContainer'); 
    await OSBarcodePlugin.openScanner(params, parent, onSuccessScan, onFailScan, $public.FeedbackMessage.showFeedbackMessage);    
}

startScan();
});
};
});
define("BarcodePlugin.controller$ScanBarcode.RunCodeScannerJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
return new Promise(function ($resolve, $reject) {
let params = {
    scanInstructions: $parameters.ScanInstructions,
    cameraDirection: $parameters.CameraDirection,
    scanOrientation: $parameters.ScanOrientation,
    scanButton: $parameters.ScanButton,
    scanText: $parameters.ScanText,
    hint: $parameters.Hint,
    androidScanningLibrary: $parameters.AndroidScanningLibrary
};

function onSuccessScan (ScanResult) {
    $parameters.ScanResult = ScanResult;
    $parameters.Success = true;
    $resolve();
}

function onFailScan (error) {
    $parameters.ErrorCode = error.code;
    $parameters.ErrorMessage = error.message;
    $parameters.Success = false;
    $resolve();
}

if(!!cordova.plugins.OSBarcode){
    cordova.plugins.OSBarcode.scanBarcode(params, onSuccessScan, onFailScan);
} else {
    let legacyFailScan = function(error) {
        $parameters.ErrorCode = 3;
        $parameters.ErrorMessage = error;
        $parameters.Success = false;
        $resolve();
    }
    cordova.plugins.OSBarcodeScanner.scan(params, onSuccessScan, legacyFailScan);
}
});
};
});

define("BarcodePlugin.controller", ["exports", "OutSystems/ClientRuntime/Main", "BarcodePlugin.model"], function (exports, OutSystems, BarcodePluginModel) {
var OS = OutSystems.Internal;
var BarcodePluginController = exports;
var Controller = (function (_super) {
__extends(Controller, _super);
function Controller() {
_super.apply(this, arguments);
}
Controller.prototype.clientActionProxies = {};
Controller.prototype.roles = {};
Controller.prototype.defaultTimeout = 10;
Controller.prototype.getDefaultTimeout = function () {
return BarcodePluginController.default.defaultTimeout;
};
return Controller;
})(OS.Controller.BaseModuleController);
BarcodePluginController.default = new Controller(null, "BarcodePlugin");
});
