﻿define("BrazilFile_BL.controller$CompressAndCheckFile", ["exports", "OutSystems/ClientRuntime/Main", "BrazilFile_BL.model", "BrazilFile_BL.controller", "ImageCompress.controller", "BrazilFile_BL.controller$ServerAction.BinaryDataSize", "ImageCompress.controller$ImageCompress", "BrazilFile_BL.referencesHealth", "BrazilFile_BL.referencesHealth$ImageCompress"], function (exports, OutSystems, BrazilFile_BLModel, BrazilFile_BLController, ImageCompressController) {
var OS = OutSystems.Internal;
BrazilFile_BLController.default.compressAndCheckFile$Action = function (binaryData_InFrontIn, maxFileSizeIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BrazilFile_BL.CompressAndCheckFile$vars"))());
vars.value.binaryData_InFrontInLocal = binaryData_InFrontIn;
vars.value.maxFileSizeInLocal = maxFileSizeIn;
var binaryDataSizeVar = new OS.DataTypes.VariableHolder();
var binaryDataSize2Var = new OS.DataTypes.VariableHolder();
var imageCompressVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BrazilFile_BL.CompressAndCheckFile$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: BinaryDataSize2
return controller.binaryDataSize$ServerAction(vars.value.binaryData_InFrontInLocal, callContext).then(function (value) {
binaryDataSize2Var.value = value;
}).then(function () {
// Size > Max File Size
return OS.Flow.executeSequence(function () {
if(((binaryDataSize2Var.value.sizeOut > (vars.value.maxFileSizeInLocal * 1000)))) {
// Execute Action: LogMessage2
OS.SystemActions.logMessage(("PictureSize_" + (binaryDataSize2Var.value.sizeOut).toString()), "Upload File - BrazilFile_BL", callContext);
return OS.Flow.whileTrueAsync(function () {
// Execute Action: ImageCompress
return ImageCompressController.default.imageCompress$Action(vars.value.binaryData_InFrontInLocal, callContext).then(function (value) {
imageCompressVar.value = value;
}).then(function () {
// IsSuccess
return OS.Flow.executeSequence(function () {
if((imageCompressVar.value.isSuccessOut)) {
// Execute Action: BinaryDataSize
return controller.binaryDataSize$ServerAction(imageCompressVar.value.out_BinaryDataOut, callContext).then(function (value) {
binaryDataSizeVar.value = value;
}).then(function () {
// Size > Max File Size
if(((binaryDataSizeVar.value.sizeOut > (vars.value.maxFileSizeInLocal * 1000)))) {
// Execute Action: LogMessage
OS.SystemActions.logMessage(("Compressing loop tries_" + OS.BuiltinFunctions.longIntegerToText(vars.value.compressingLoopTriesVar)), "Upload File  - BrazilFile_BL", callContext);
// CompressingLoopTries = CompressingLoopTries + 1
vars.value.compressingLoopTriesVar = vars.value.compressingLoopTriesVar.add(OS.BuiltinFunctions.integerToLongInteger(1));
// BinaryData_InFront = ImageCompress.Out_BinaryData
vars.value.binaryData_InFrontInLocal = imageCompressVar.value.out_BinaryDataOut;
} else {
return OS.Flow.breakAsync();
}

});
} else {
return OS.Flow.breakAsync();
}

});
});
}).then(function () {
// BinaryData_Out = ImageCompress.Out_BinaryData
outVars.value.binaryData_OutOut = imageCompressVar.value.out_BinaryDataOut;
});
} else {
// BinaryData_Out = BinaryData_InFront
outVars.value.binaryData_OutOut = vars.value.binaryData_InFrontInLocal;
}

});
});
}).then(function () {
return outVars.value;
});
};
var controller = BrazilFile_BLController.default;
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.CompressAndCheckFile$vars", [{
name: "BinaryData_InFront",
attrName: "binaryData_InFrontInLocal",
mandatory: true,
dataType: OS.Types.BinaryData,
defaultValue: function () {
return OS.DataTypes.BinaryData.defaultValue;
}
}, {
name: "MaxFileSize",
attrName: "maxFileSizeInLocal",
mandatory: true,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}, {
name: "CompressingLoopTries",
attrName: "compressingLoopTriesVar",
mandatory: false,
dataType: OS.Types.LongInteger,
defaultValue: function () {
return OS.DataTypes.LongInteger.defaultValue;
}
}]);
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.CompressAndCheckFile$outVars", [{
name: "BinaryData_Out",
attrName: "binaryData_OutOut",
mandatory: false,
dataType: OS.Types.BinaryData,
defaultValue: function () {
return OS.DataTypes.BinaryData.defaultValue;
}
}]);
BrazilFile_BLController.default.clientActionProxies.compressAndCheckFile$Action = function (binaryData_InFrontIn, maxFileSizeIn) {
binaryData_InFrontIn = (binaryData_InFrontIn === undefined) ? OS.DataTypes.BinaryData.defaultValue : binaryData_InFrontIn;
maxFileSizeIn = (maxFileSizeIn === undefined) ? 0 : maxFileSizeIn;
return controller.executeActionInsideJSNode(BrazilFile_BLController.default.compressAndCheckFile$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(binaryData_InFrontIn, OS.Types.BinaryData), OS.DataConversion.JSNodeParamConverter.from(maxFileSizeIn, OS.Types.Integer)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
BinaryData_Out: OS.DataConversion.JSNodeParamConverter.to(actionResults.binaryData_OutOut, OS.Types.BinaryData)
};
});
};
});

define("BrazilFile_BL.controller$DeleteFileByURI", ["exports", "OutSystems/ClientRuntime/Main", "BrazilFile_BL.model", "BrazilFile_BL.controller", "CommonPlugin.model", "FilePlugin.controller", "CommonPlugin.model$ErrorRec", "BrazilFile_BL.referencesHealth", "BrazilFile_BL.referencesHealth$CommonPlugin", "FilePlugin.controller$DeleteFileFromUri", "BrazilFile_BL.referencesHealth$FilePlugin"], function (exports, OutSystems, BrazilFile_BLModel, BrazilFile_BLController, CommonPluginModel, FilePluginController) {
var OS = OutSystems.Internal;
BrazilFile_BLController.default.deleteFileByURI$Action = function (uRIIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BrazilFile_BL.DeleteFileByURI$vars"))());
vars.value.uRIInLocal = uRIIn;
var deleteFileFromUriVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BrazilFile_BL.DeleteFileByURI$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: DeleteFileFromUri
return FilePluginController.default.deleteFileFromUri$Action(vars.value.uRIInLocal, callContext).then(function (value) {
deleteFileFromUriVar.value = value;
}).then(function () {
if(((deleteFileFromUriVar.value.errorOut.errorMessageAttr === OS.BuiltinFunctions.nullTextIdentifier()))) {
// IsSuccess = True
outVars.value.isSuccessOut = true;
} else {
// ErrorMessage = DeleteFileFromUri.Error.ErrorMessage
outVars.value.errorMessageOut = deleteFileFromUriVar.value.errorOut.errorMessageAttr;
// IsSuccess = False
outVars.value.isSuccessOut = false;
}

});
}).then(function () {
return outVars.value;
});
};
var controller = BrazilFile_BLController.default;
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.DeleteFileByURI$vars", [{
name: "URI",
attrName: "uRIInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.DeleteFileByURI$outVars", [{
name: "IsSuccess",
attrName: "isSuccessOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "ErrorMessage",
attrName: "errorMessageOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BrazilFile_BLController.default.clientActionProxies.deleteFileByURI$Action = function (uRIIn) {
uRIIn = (uRIIn === undefined) ? "" : uRIIn;
return controller.executeActionInsideJSNode(BrazilFile_BLController.default.deleteFileByURI$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(uRIIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
IsSuccess: OS.DataConversion.JSNodeParamConverter.to(actionResults.isSuccessOut, OS.Types.Boolean),
ErrorMessage: OS.DataConversion.JSNodeParamConverter.to(actionResults.errorMessageOut, OS.Types.Text)
};
});
};
});

define("BrazilFile_BL.controller$DownloadOnCLick", ["exports", "OutSystems/ClientRuntime/Main", "BrazilFile_BL.model", "BrazilFile_BL.controller", "CommonPlugin.model", "FilePlugin.controller", "CommonPlugin.model$ErrorRec", "BrazilFile_BL.referencesHealth", "BrazilFile_BL.referencesHealth$CommonPlugin", "FilePlugin.controller$GetFileDataFromUri", "BrazilFile_BL.referencesHealth$FilePlugin"], function (exports, OutSystems, BrazilFile_BLModel, BrazilFile_BLController, CommonPluginModel, FilePluginController) {
var OS = OutSystems.Internal;
BrazilFile_BLController.default.downloadOnCLick$Action = function (uRIIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BrazilFile_BL.DownloadOnCLick$vars"))());
vars.value.uRIInLocal = uRIIn;
var getFileDataFromUriVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BrazilFile_BL.DownloadOnCLick$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: GetFileDataFromUri
return FilePluginController.default.getFileDataFromUri$Action(vars.value.uRIInLocal, callContext).then(function (value) {
getFileDataFromUriVar.value = value;
}).then(function () {
// EmptyBinary
if((!(OS.DataTypes.areBinaryNulls(getFileDataFromUriVar.value.binaryDataOut, OS.BuiltinFunctions.nullBinary())))) {
// out
// Content = GetFileDataFromUri.BinaryData
outVars.value.contentOut = getFileDataFromUriVar.value.binaryDataOut;
// IsSuccess = True
outVars.value.isSuccessOut = true;
} else {
// out
// IsSuccess = False
outVars.value.isSuccessOut = false;
// ErrorMessage = GetFileDataFromUri.Error.ErrorMessage
outVars.value.errorMessageOut = getFileDataFromUriVar.value.errorOut.errorMessageAttr;
}

});
}).then(function () {
return outVars.value;
});
};
var controller = BrazilFile_BLController.default;
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.DownloadOnCLick$vars", [{
name: "URI",
attrName: "uRIInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.DownloadOnCLick$outVars", [{
name: "Content",
attrName: "contentOut",
mandatory: false,
dataType: OS.Types.BinaryData,
defaultValue: function () {
return OS.DataTypes.BinaryData.defaultValue;
}
}, {
name: "IsSuccess",
attrName: "isSuccessOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "ErrorMessage",
attrName: "errorMessageOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BrazilFile_BLController.default.clientActionProxies.downloadOnCLick$Action = function (uRIIn) {
uRIIn = (uRIIn === undefined) ? "" : uRIIn;
return controller.executeActionInsideJSNode(BrazilFile_BLController.default.downloadOnCLick$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(uRIIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Content: OS.DataConversion.JSNodeParamConverter.to(actionResults.contentOut, OS.Types.BinaryData),
IsSuccess: OS.DataConversion.JSNodeParamConverter.to(actionResults.isSuccessOut, OS.Types.Boolean),
ErrorMessage: OS.DataConversion.JSNodeParamConverter.to(actionResults.errorMessageOut, OS.Types.Text)
};
});
};
});

define("BrazilFile_BL.controller$GetFileFormat", ["exports", "OutSystems/ClientRuntime/Main", "BrazilFile_BL.model", "BrazilFile_BL.controller", "BrazilFile_BL.controller$GetFileFormat.String_SplitJS"], function (exports, OutSystems, BrazilFile_BLModel, BrazilFile_BLController, BrazilFile_BL_controller_GetFileFormat_String_SplitJS) {
var OS = OutSystems.Internal;
BrazilFile_BLController.default.getFileFormat$Action = function (filenameIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BrazilFile_BL.GetFileFormat$vars"))());
vars.value.filenameInLocal = filenameIn;
var string_SplitJSResult = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BrazilFile_BL.GetFileFormat$outVars"))());
string_SplitJSResult.value = controller.safeExecuteJSNode(BrazilFile_BL_controller_GetFileFormat_String_SplitJS, "String_Split", "GetFileFormat", {
FileName: OS.DataConversion.JSNodeParamConverter.to(vars.value.filenameInLocal, OS.Types.Text),
Extension: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("BrazilFile_BL.GetFileFormat$string_SplitJSResult"))();
jsNodeResult.extensionOut = OS.DataConversion.JSNodeParamConverter.from($parameters.Extension, OS.Types.Text);
return jsNodeResult;
}, {}, {});
// ContentType = String_Split.Extension
outVars.value.contentTypeOut = string_SplitJSResult.value.extensionOut;
return outVars.value;
};
var controller = BrazilFile_BLController.default;
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.GetFileFormat$vars", [{
name: "Filename",
attrName: "filenameInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.GetFileFormat$string_SplitJSResult", [{
name: "Extension",
attrName: "extensionOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.GetFileFormat$outVars", [{
name: "ContentType",
attrName: "contentTypeOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BrazilFile_BLController.default.clientActionProxies.getFileFormat$Action = function (filenameIn) {
filenameIn = (filenameIn === undefined) ? "" : filenameIn;
return controller.executeActionInsideJSNode(BrazilFile_BLController.default.getFileFormat$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(filenameIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
ContentType: OS.DataConversion.JSNodeParamConverter.to(actionResults.contentTypeOut, OS.Types.Text)
};
});
};
});
define("BrazilFile_BL.controller$GetFileFormat.String_SplitJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
var str = $parameters.FileName;
var list = str.split('.');
$parameters.Extension =  $public.BuiltinFunctions.toLower(list[list.length - 1]);

};
});

define("BrazilFile_BL.controller$SaveFileGetURI", ["exports", "OutSystems/ClientRuntime/Main", "BrazilFile_BL.model", "BrazilFile_BL.controller", "CommonPlugin.model", "FilePlugin.controller", "CommonPlugin.controller", "BrazilFile_BL.controller$SaveFileGetURI.GetFilePath_AndroidJS", "BrazilFile_BL.controller$SaveFileGetURI.GetFilePath_iOSJS", "CommonPlugin.model$ErrorRec", "BrazilFile_BL.referencesHealth", "BrazilFile_BL.referencesHealth$CommonPlugin", "FilePlugin.controller$SaveFile", "BrazilFile_BL.referencesHealth$FilePlugin", "CommonPlugin.controller$GetPlatform"], function (exports, OutSystems, BrazilFile_BLModel, BrazilFile_BLController, CommonPluginModel, FilePluginController, CommonPluginController, BrazilFile_BL_controller_SaveFileGetURI_GetFilePath_AndroidJS, BrazilFile_BL_controller_SaveFileGetURI_GetFilePath_iOSJS) {
var OS = OutSystems.Internal;
BrazilFile_BLController.default.saveFileGetURI$Action = function (binaryDataIn, fileNameIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BrazilFile_BL.SaveFileGetURI$vars"))());
vars.value.binaryDataInLocal = binaryDataIn;
vars.value.fileNameInLocal = fileNameIn;
var saveFileVar = new OS.DataTypes.VariableHolder();
var getPlatformVar = new OS.DataTypes.VariableHolder();
var getFilePath_AndroidJSResult = new OS.DataTypes.VariableHolder();
var getFilePath_iOSJSResult = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BrazilFile_BL.SaveFileGetURI$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: GetPlatform
getPlatformVar.value = CommonPluginController.default.getPlatform$Action(callContext);

// Is ios?
if(((getPlatformVar.value.platformOut === "ios"))) {
getFilePath_iOSJSResult.value = controller.safeExecuteJSNode(BrazilFile_BL_controller_SaveFileGetURI_GetFilePath_iOSJS, "GetFilePath_iOS", "SaveFileGetURI", {
FilePath: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("BrazilFile_BL.SaveFileGetURI$getFilePath_iOSJSResult"))();
jsNodeResult.filePathOut = OS.DataConversion.JSNodeParamConverter.from($parameters.FilePath, OS.Types.Text);
return jsNodeResult;
}, {}, {});
// FilePath = GetFilePath_iOS.FilePath
vars.value.filePathVar = getFilePath_iOSJSResult.value.filePathOut;
} else {
getFilePath_AndroidJSResult.value = controller.safeExecuteJSNode(BrazilFile_BL_controller_SaveFileGetURI_GetFilePath_AndroidJS, "GetFilePath_Android", "SaveFileGetURI", {
FilePath: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("BrazilFile_BL.SaveFileGetURI$getFilePath_AndroidJSResult"))();
jsNodeResult.filePathOut = OS.DataConversion.JSNodeParamConverter.from($parameters.FilePath, OS.Types.Text);
return jsNodeResult;
}, {}, {});
// FilePath = GetFilePath_Android.FilePath
vars.value.filePathVar = getFilePath_AndroidJSResult.value.filePathOut;
}

// Execute Action: SaveFile
return FilePluginController.default.saveFile$Action(vars.value.binaryDataInLocal, vars.value.fileNameInLocal, vars.value.filePathVar, BrazilFile_BLModel.staticEntities.storageType.external, callContext).then(function (value) {
saveFileVar.value = value;
}).then(function () {
if((((saveFileVar.value.errorOut.errorMessageAttr) !== ("")))) {
OS.FeedbackMessageService.showFeedbackMessage(saveFileVar.value.errorOut.errorMessageAttr, /*Error*/ 3);
} else {
// URI = SaveFile.Uri
outVars.value.uRIOut = saveFileVar.value.uriOut;
}

});
}).then(function () {
return outVars.value;
});
};
var controller = BrazilFile_BLController.default;
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.SaveFileGetURI$vars", [{
name: "BinaryData",
attrName: "binaryDataInLocal",
mandatory: true,
dataType: OS.Types.BinaryData,
defaultValue: function () {
return OS.DataTypes.BinaryData.defaultValue;
}
}, {
name: "FileName",
attrName: "fileNameInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "FilePath",
attrName: "filePathVar",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.SaveFileGetURI$getFilePath_AndroidJSResult", [{
name: "FilePath",
attrName: "filePathOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.SaveFileGetURI$getFilePath_iOSJSResult", [{
name: "FilePath",
attrName: "filePathOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.SaveFileGetURI$outVars", [{
name: "URI",
attrName: "uRIOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BrazilFile_BLController.default.clientActionProxies.saveFileGetURI$Action = function (binaryDataIn, fileNameIn) {
binaryDataIn = (binaryDataIn === undefined) ? OS.DataTypes.BinaryData.defaultValue : binaryDataIn;
fileNameIn = (fileNameIn === undefined) ? "" : fileNameIn;
return controller.executeActionInsideJSNode(BrazilFile_BLController.default.saveFileGetURI$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(binaryDataIn, OS.Types.BinaryData), OS.DataConversion.JSNodeParamConverter.from(fileNameIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
URI: OS.DataConversion.JSNodeParamConverter.to(actionResults.uRIOut, OS.Types.Text)
};
});
};
});
define("BrazilFile_BL.controller$SaveFileGetURI.GetFilePath_AndroidJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
$parameters.FilePath = "Documents/";
};
});
define("BrazilFile_BL.controller$SaveFileGetURI.GetFilePath_iOSJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
$parameters.FilePath = "Files/";
};
});

define("BrazilFile_BL.controller$UpdateAndCompress", ["exports", "OutSystems/ClientRuntime/Main", "BrazilFile_BL.model", "BrazilFile_BL.controller", "BrazilFile_BL.controller$CompressAndCheckFile", "BrazilFile_BL.controller$UpdateOnClick"], function (exports, OutSystems, BrazilFile_BLModel, BrazilFile_BLController) {
var OS = OutSystems.Internal;
BrazilFile_BLController.default.updateAndCompress$Action = function (binaryDataInIn, fileNameIn, maxFileSizeIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BrazilFile_BL.UpdateAndCompress$vars"))());
vars.value.binaryDataInInLocal = binaryDataInIn;
vars.value.fileNameInLocal = fileNameIn;
vars.value.maxFileSizeInLocal = maxFileSizeIn;
var compressAndCheckFileVar = new OS.DataTypes.VariableHolder();
var updateOnClickVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BrazilFile_BL.UpdateAndCompress$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: CompressAndCheckFile
return BrazilFile_BLController.default.compressAndCheckFile$Action(vars.value.binaryDataInInLocal, vars.value.maxFileSizeInLocal, callContext).then(function (value) {
compressAndCheckFileVar.value = value;
}).then(function () {
// Execute Action: UpdateOnClick
return BrazilFile_BLController.default.updateOnClick$Action(compressAndCheckFileVar.value.binaryData_OutOut, vars.value.fileNameInLocal, callContext).then(function (value) {
updateOnClickVar.value = value;
});
}).then(function () {
// FilePath = UpdateOnClick.FilePath
outVars.value.filePathOut = updateOnClickVar.value.filePathOut;
// URI = UpdateOnClick.URI
outVars.value.uRIOut = updateOnClickVar.value.uRIOut;
// IsSuccess = UpdateOnClick.IsSuccess
outVars.value.isSuccessOut = updateOnClickVar.value.isSuccessOut;
// Execute Action: LogMessage
OS.SystemActions.logMessage(((((("FilePath_" + outVars.value.filePathOut) + "/URI_") + outVars.value.uRIOut) + "/IsSucces_") + (outVars.value.isSuccessOut ? "True" : "False")), "Compress and Upload - BrazilFile_BL", callContext);
});
}).then(function () {
return outVars.value;
});
};
var controller = BrazilFile_BLController.default;
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.UpdateAndCompress$vars", [{
name: "BinaryDataIn",
attrName: "binaryDataInInLocal",
mandatory: true,
dataType: OS.Types.BinaryData,
defaultValue: function () {
return OS.DataTypes.BinaryData.defaultValue;
}
}, {
name: "FileName",
attrName: "fileNameInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "MaxFileSize",
attrName: "maxFileSizeInLocal",
mandatory: true,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}]);
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.UpdateAndCompress$outVars", [{
name: "FilePath",
attrName: "filePathOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "URI",
attrName: "uRIOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "IsSuccess",
attrName: "isSuccessOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
BrazilFile_BLController.default.clientActionProxies.updateAndCompress$Action = function (binaryDataInIn, fileNameIn, maxFileSizeIn) {
binaryDataInIn = (binaryDataInIn === undefined) ? OS.DataTypes.BinaryData.defaultValue : binaryDataInIn;
fileNameIn = (fileNameIn === undefined) ? "" : fileNameIn;
maxFileSizeIn = (maxFileSizeIn === undefined) ? 0 : maxFileSizeIn;
return controller.executeActionInsideJSNode(BrazilFile_BLController.default.updateAndCompress$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(binaryDataInIn, OS.Types.BinaryData), OS.DataConversion.JSNodeParamConverter.from(fileNameIn, OS.Types.Text), OS.DataConversion.JSNodeParamConverter.from(maxFileSizeIn, OS.Types.Integer)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
FilePath: OS.DataConversion.JSNodeParamConverter.to(actionResults.filePathOut, OS.Types.Text),
URI: OS.DataConversion.JSNodeParamConverter.to(actionResults.uRIOut, OS.Types.Text),
IsSuccess: OS.DataConversion.JSNodeParamConverter.to(actionResults.isSuccessOut, OS.Types.Boolean)
};
});
};
});

define("BrazilFile_BL.controller$UpdateOnClick", ["exports", "OutSystems/ClientRuntime/Main", "BrazilFile_BL.model", "BrazilFile_BL.controller", "CommonPlugin.model", "FilePlugin.controller", "CommonPlugin.controller", "BrazilFile_BL.controller$UpdateOnClick.GetFilePath_AndroidJS", "BrazilFile_BL.controller$UpdateOnClick.GetFilePath_iOSJS", "CommonPlugin.model$ErrorRec", "BrazilFile_BL.referencesHealth", "BrazilFile_BL.referencesHealth$CommonPlugin", "FilePlugin.controller$SaveFile", "BrazilFile_BL.referencesHealth$FilePlugin", "CommonPlugin.controller$GetPlatform"], function (exports, OutSystems, BrazilFile_BLModel, BrazilFile_BLController, CommonPluginModel, FilePluginController, CommonPluginController, BrazilFile_BL_controller_UpdateOnClick_GetFilePath_AndroidJS, BrazilFile_BL_controller_UpdateOnClick_GetFilePath_iOSJS) {
var OS = OutSystems.Internal;
BrazilFile_BLController.default.updateOnClick$Action = function (binaryDataIn, fileNameIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BrazilFile_BL.UpdateOnClick$vars"))());
vars.value.binaryDataInLocal = binaryDataIn;
vars.value.fileNameInLocal = fileNameIn;
var saveFileVar = new OS.DataTypes.VariableHolder();
var getPlatformVar = new OS.DataTypes.VariableHolder();
var getFilePath_AndroidJSResult = new OS.DataTypes.VariableHolder();
var getFilePath_iOSJSResult = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("BrazilFile_BL.UpdateOnClick$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: GetPlatform
getPlatformVar.value = CommonPluginController.default.getPlatform$Action(callContext);

// Execute Action: LogMessage
OS.SystemActions.logMessage(("Platform_" + getPlatformVar.value.platformOut), "File Update  - BrazilFile_BL", callContext);
// Is ios?
if(((getPlatformVar.value.platformOut === "ios"))) {
getFilePath_iOSJSResult.value = controller.safeExecuteJSNode(BrazilFile_BL_controller_UpdateOnClick_GetFilePath_iOSJS, "GetFilePath_iOS", "UpdateOnClick", {
FilePath: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("BrazilFile_BL.UpdateOnClick$getFilePath_iOSJSResult"))();
jsNodeResult.filePathOut = OS.DataConversion.JSNodeParamConverter.from($parameters.FilePath, OS.Types.Text);
return jsNodeResult;
}, {}, {});
// FilePath = GetFilePath_iOS.FilePath
outVars.value.filePathOut = getFilePath_iOSJSResult.value.filePathOut;
} else {
getFilePath_AndroidJSResult.value = controller.safeExecuteJSNode(BrazilFile_BL_controller_UpdateOnClick_GetFilePath_AndroidJS, "GetFilePath_Android", "UpdateOnClick", {
FilePath: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("BrazilFile_BL.UpdateOnClick$getFilePath_AndroidJSResult"))();
jsNodeResult.filePathOut = OS.DataConversion.JSNodeParamConverter.from($parameters.FilePath, OS.Types.Text);
return jsNodeResult;
}, {}, {});
// FilePath = GetFilePath_Android.FilePath
outVars.value.filePathOut = getFilePath_AndroidJSResult.value.filePathOut;
}

// Execute Action: LogMessage2
OS.SystemActions.logMessage(outVars.value.filePathOut, "File Update  - BrazilFile_BL", callContext);
// Execute Action: SaveFile
return FilePluginController.default.saveFile$Action(vars.value.binaryDataInLocal, vars.value.fileNameInLocal, outVars.value.filePathOut, BrazilFile_BLModel.staticEntities.storageType.external, callContext).then(function (value) {
saveFileVar.value = value;
}).then(function () {
// IsSuccess = SaveFile.Error.ErrorMessage = ""
outVars.value.isSuccessOut = (saveFileVar.value.errorOut.errorMessageAttr === "");
// URI = SaveFile.Uri
outVars.value.uRIOut = saveFileVar.value.uriOut;
// Execute Action: LogMessage3
OS.SystemActions.logMessage(("Update Is Success?" + (outVars.value.isSuccessOut ? "True" : "False")), "File Update  - BrazilFile_BL", callContext);
});
}).then(function () {
return outVars.value;
});
};
var controller = BrazilFile_BLController.default;
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.UpdateOnClick$vars", [{
name: "BinaryData",
attrName: "binaryDataInLocal",
mandatory: true,
dataType: OS.Types.BinaryData,
defaultValue: function () {
return OS.DataTypes.BinaryData.defaultValue;
}
}, {
name: "FileName",
attrName: "fileNameInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.UpdateOnClick$getFilePath_AndroidJSResult", [{
name: "FilePath",
attrName: "filePathOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.UpdateOnClick$getFilePath_iOSJSResult", [{
name: "FilePath",
attrName: "filePathOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL.UpdateOnClick$outVars", [{
name: "FilePath",
attrName: "filePathOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "URI",
attrName: "uRIOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "IsSuccess",
attrName: "isSuccessOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
BrazilFile_BLController.default.clientActionProxies.updateOnClick$Action = function (binaryDataIn, fileNameIn) {
binaryDataIn = (binaryDataIn === undefined) ? OS.DataTypes.BinaryData.defaultValue : binaryDataIn;
fileNameIn = (fileNameIn === undefined) ? "" : fileNameIn;
return controller.executeActionInsideJSNode(BrazilFile_BLController.default.updateOnClick$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(binaryDataIn, OS.Types.BinaryData), OS.DataConversion.JSNodeParamConverter.from(fileNameIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
FilePath: OS.DataConversion.JSNodeParamConverter.to(actionResults.filePathOut, OS.Types.Text),
URI: OS.DataConversion.JSNodeParamConverter.to(actionResults.uRIOut, OS.Types.Text),
IsSuccess: OS.DataConversion.JSNodeParamConverter.to(actionResults.isSuccessOut, OS.Types.Boolean)
};
});
};
});
define("BrazilFile_BL.controller$UpdateOnClick.GetFilePath_AndroidJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
$parameters.FilePath = "Documents/";
};
});
define("BrazilFile_BL.controller$UpdateOnClick.GetFilePath_iOSJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
$parameters.FilePath = "Files/";
};
});

define("BrazilFile_BL.controller$ServerAction.BinaryDataSize", ["exports", "OutSystems/ClientRuntime/Main", "BrazilFile_BL.model", "BrazilFile_BL.controller"], function (exports, OutSystems, BrazilFile_BLModel, BrazilFile_BLController) {
var OS = OutSystems.Internal;
BrazilFile_BLController.default.binaryDataSize$ServerAction = function (binaryDataIn, callContext) {
var controller = this.controller;
var inputs = {
BinaryData: OS.DataConversion.ServerDataConverter.to(binaryDataIn, OS.Types.BinaryData)
};
return controller.callServerAction("BinaryDataSize", "screenservices/BrazilFile_BL/ActionBinaryDataSize", "veAKvjUgRf3CgtSUwf_GfA", inputs, controller.callContext(callContext), undefined, undefined, false).then(function (outputs) {
var executeServerActionResult = new (controller.constructor.getVariableGroupType("BrazilFile_BL$rssextensionbinarydata_ActionBinaryDataSize"))();
executeServerActionResult.sizeOut = OS.DataConversion.ServerDataConverter.from(outputs.Size, OS.Types.Integer);
return executeServerActionResult;
});
};
BrazilFile_BLController.default.constructor.registerVariableGroupType("BrazilFile_BL$rssextensionbinarydata_ActionBinaryDataSize", [{
name: "Size",
attrName: "sizeOut",
mandatory: false,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}]);
});
define("BrazilFile_BL.controller", ["exports", "OutSystems/ClientRuntime/Main", "BrazilFile_BL.model"], function (exports, OutSystems, BrazilFile_BLModel) {
var OS = OutSystems.Internal;
var BrazilFile_BLController = exports;
var Controller = (function (_super) {
__extends(Controller, _super);
function Controller() {
_super.apply(this, arguments);
}
Controller.prototype.clientActionProxies = {};
Controller.prototype.roles = {};
Controller.prototype.defaultTimeout = 10;
Controller.prototype.getDefaultTimeout = function () {
return BrazilFile_BLController.default.defaultTimeout;
};
return Controller;
})(OS.Controller.BaseModuleController);
BrazilFile_BLController.default = new Controller(null, "BrazilFile_BL");
});
