﻿define("Brazil_Cards_MUI.aggregates.SQL", ["OutSystems/ClientRuntime/Main", "Brazil_Cards_MUI.model", "Brazil_OfflineStorage.entities", "Brazil_OfflineStorage.model", "Brazil_Cards_MUI.controller", "Brazil_Cards_MUI.model$SettingsRecordList", "Brazil_OfflineStorage.model$SettingsRec"], function (OutSystems, Brazil_Cards_MUIModel, Brazil_OfflineStorageEntities, Brazil_OfflineStorageModel, Brazil_Cards_MUIController) {
var OS = OutSystems.Internal;
var serializer = new OS.WebSQLSerializer.default();
function ClientAggregates() {
}
function executeTransaction(body, entityInfos) {
var dbServ = OS.Injector.resolve(OS.ServiceNames.EntityService);
return dbServ.executeAggregate(function (transaction) {
return body(transaction);
}, entityInfos);
}
ClientAggregates.executePIN_Relogin$Block$getSettingsAggr = function (maxRecords) {
var Settings_Info = Brazil_OfflineStorageEntities.getEntityInfos().filter(function (info) {
return (info.key === "c3486011-eb75-4457-8e15-21cf2d318bdf");
})[0];
var aggrEntityInfos = [Settings_Info];

return executeTransaction(function (transaction) {
return new Promise(function (resolve, reject) {
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var targetListType = Brazil_Cards_MUIModel.SettingsRecordList;
if(!(maxRecords)) {
maxRecords = 1;
}

var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "\"ENSettings\".\"Id\" o0, \"ENSettings\".\"Email\" o1, \"ENSettings\".\"LoginBiometrics\" o2, \"ENSettings\".\"IsBioMaybeLater\" o3, \"ENSettings\".\"IsPasscodeOnDevice\" o4, \"ENSettings\".\"LoginAttemptsCount\" o5, \"ENSettings\".\"HasOnbardingDone\" o6, \"ENSettings\".\"AppLanguage\" o7, \"ENSettings\".\"HasGivenAccessCode\" o8, \"ENSettings\".\"LastLogin\" o9, \"ENSettings\".\"TemporaryIsNotifications\" o10, \"ENSettings\".\"IsCameraDenied\" o11, \"ENSettings\".\"BiometricAttempts\" o12, \"ENSettings\".\"DontShowAgain\" o13, \"ENSettings\".\"PingSessionId\" o14, \"ENSettings\".\"WalletComplianceVersion\" o15";
} else {
selectSql += "\"ENSettings\".\"Id\" o0, \"ENSettings\".\"Email\" o1, \"ENSettings\".\"LoginBiometrics\" o2, \"ENSettings\".\"IsBioMaybeLater\" o3, \"ENSettings\".\"IsPasscodeOnDevice\" o4, \"ENSettings\".\"LoginAttemptsCount\" o5, \"ENSettings\".\"HasOnbardingDone\" o6, \"ENSettings\".\"AppLanguage\" o7, \"ENSettings\".\"HasGivenAccessCode\" o8, \"ENSettings\".\"LastLogin\" o9, \"ENSettings\".\"TemporaryIsNotifications\" o10, \"ENSettings\".\"IsCameraDenied\" o11, \"ENSettings\".\"BiometricAttempts\" o12, \"ENSettings\".\"DontShowAgain\" o13, \"ENSettings\".\"PingSessionId\" o14, \"ENSettings\".\"WalletComplianceVersion\" o15";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_9k2_Settings\" \"ENSettings\"";
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

var successCallback = function (transaction, resultSet) {
var convertedResult = serializer.deserializeAggregate(resultSet.rows, Brazil_Cards_MUIModel.SettingsRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"settingsAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

});
result.list = convertedResult;
resolve(result);
};
var errorCallback = function (transaction, sqlError) {
var error = new Error(sqlError.message.toString());
reject(error);
return false;
};
transaction.executeSql(sql, argsList.argumentList, successCallback, errorCallback);
});
}, aggrEntityInfos).then(function (result) {
return result;
}).then(function (result) {
return result;
});
};
return ClientAggregates;
});
