﻿define("Brazil_Cards_MUI.controller$FilterByDateRange", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Cards_MUI.model", "Brazil_Cards_MUI.controller", "Brazil_Storage_DB.model", "Brazil_Cards_MUI.model$TransactionList", "Brazil_Storage_DB.model$DateRangeRec", "Brazil_Cards_MUI.referencesHealth", "Brazil_Cards_MUI.referencesHealth$Brazil_Storage_DB"], function (exports, OutSystems, Brazil_Cards_MUIModel, Brazil_Cards_MUIController, Brazil_Storage_DBModel) {
var OS = OutSystems.Internal;
Brazil_Cards_MUIController.default.filterByDateRange$Action = function (dateRangeIn, transactionListIn, startDateIn, endDateIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Cards_MUI.FilterByDateRange$vars"))());
vars.value.dateRangeInLocal = dateRangeIn.clone();
vars.value.transactionListInLocal = transactionListIn.clone();
vars.value.startDateInLocal = startDateIn;
vars.value.endDateInLocal = endDateIn;
var listFilterVar = new OS.DataTypes.VariableHolder();
var listFilter4Var = new OS.DataTypes.VariableHolder();
var listFilter3Var = new OS.DataTypes.VariableHolder();
var listFilter2Var = new OS.DataTypes.VariableHolder();
var listFilter5Var = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Cards_MUI.FilterByDateRange$outVars"))());
// DateRange
if(((vars.value.dateRangeInLocal.idAttr === Brazil_Cards_MUIModel.staticEntities.dateRange.last7Days))) {
// Execute Action: ListFilter
listFilterVar.value = OS.SystemActions.listFilter(vars.value.transactionListInLocal, function (p) {
return p.transactionDateAttr.gte(OS.BuiltinFunctions.addDays(OS.BuiltinFunctions.currDate(), -7));
}, callContext);

// TransactionListOut = ListFilter.FilteredList
outVars.value.transactionListOutOut = listFilterVar.value.filteredListOut;
} else {
if((vars.value.dateRangeInLocal.idAttr === Brazil_Cards_MUIModel.staticEntities.dateRange.last30Days)) {
// Execute Action: ListFilter2
listFilter2Var.value = OS.SystemActions.listFilter(vars.value.transactionListInLocal, function (p) {
return p.transactionDateAttr.gte(OS.BuiltinFunctions.addDays(OS.BuiltinFunctions.currDate(), -30));
}, callContext);

// TransactionListOut = ListFilter2.FilteredList
outVars.value.transactionListOutOut = listFilter2Var.value.filteredListOut;
} else {
if((vars.value.dateRangeInLocal.idAttr === Brazil_Cards_MUIModel.staticEntities.dateRange.last60Days)) {
// Execute Action: ListFilter3
listFilter3Var.value = OS.SystemActions.listFilter(vars.value.transactionListInLocal, function (p) {
return p.transactionDateAttr.gte(OS.BuiltinFunctions.addDays(OS.BuiltinFunctions.currDate(), -60));
}, callContext);

// TransactionListOut = ListFilter3.FilteredList
outVars.value.transactionListOutOut = listFilter3Var.value.filteredListOut;
} else {
if((vars.value.dateRangeInLocal.idAttr === Brazil_Cards_MUIModel.staticEntities.dateRange.last90Days)) {
// Execute Action: ListFilter4
listFilter4Var.value = OS.SystemActions.listFilter(vars.value.transactionListInLocal, function (p) {
return p.transactionDateAttr.gte(OS.BuiltinFunctions.addDays(OS.BuiltinFunctions.currDate(), -90));
}, callContext);

// TransactionListOut = ListFilter4.FilteredList
outVars.value.transactionListOutOut = listFilter4Var.value.filteredListOut;
} else {
// Execute Action: ListFilter5
listFilter5Var.value = OS.SystemActions.listFilter(vars.value.transactionListInLocal, function (p) {
return (OS.BuiltinFunctions.dateTimeToDate(p.transactionDateAttr).gte(vars.value.startDateInLocal) && OS.BuiltinFunctions.dateTimeToDate(p.transactionDateAttr).lte(vars.value.endDateInLocal));
}, callContext);

// TransactionListOut = ListFilter5.FilteredList
outVars.value.transactionListOutOut = listFilter5Var.value.filteredListOut;
}

}

}

}

return outVars.value;
};
var controller = Brazil_Cards_MUIController.default;
Brazil_Cards_MUIController.default.constructor.registerVariableGroupType("Brazil_Cards_MUI.FilterByDateRange$vars", [{
name: "DateRange",
attrName: "dateRangeInLocal",
mandatory: true,
dataType: OS.Types.Record,
defaultValue: function () {
return new Brazil_Storage_DBModel.DateRangeRec();
},
complexType: Brazil_Storage_DBModel.DateRangeRec
}, {
name: "TransactionList",
attrName: "transactionListInLocal",
mandatory: true,
dataType: OS.Types.RecordList,
defaultValue: function () {
return new Brazil_Cards_MUIModel.TransactionList();
},
complexType: Brazil_Cards_MUIModel.TransactionList
}, {
name: "StartDate",
attrName: "startDateInLocal",
mandatory: true,
dataType: OS.Types.Date,
defaultValue: function () {
return OS.DataTypes.DateTime.defaultValue;
}
}, {
name: "EndDate",
attrName: "endDateInLocal",
mandatory: true,
dataType: OS.Types.Date,
defaultValue: function () {
return OS.DataTypes.DateTime.defaultValue;
}
}]);
Brazil_Cards_MUIController.default.constructor.registerVariableGroupType("Brazil_Cards_MUI.FilterByDateRange$outVars", [{
name: "TransactionListOut",
attrName: "transactionListOutOut",
mandatory: false,
dataType: OS.Types.RecordList,
defaultValue: function () {
return new Brazil_Cards_MUIModel.TransactionList();
},
complexType: Brazil_Cards_MUIModel.TransactionList
}]);
Brazil_Cards_MUIController.default.clientActionProxies.filterByDateRange$Action = function (dateRangeIn, transactionListIn, startDateIn, endDateIn) {
dateRangeIn = (dateRangeIn === undefined) ? new Brazil_Storage_DBModel.DateRangeRec() : dateRangeIn;
transactionListIn = (transactionListIn === undefined) ? new Brazil_Cards_MUIModel.TransactionList() : transactionListIn;
startDateIn = (startDateIn === undefined) ? OS.DataTypes.DateTime.defaultValue : startDateIn;
endDateIn = (endDateIn === undefined) ? OS.DataTypes.DateTime.defaultValue : endDateIn;
return controller.executeActionInsideJSNode(Brazil_Cards_MUIController.default.filterByDateRange$Action.bind(controller, dateRangeIn, transactionListIn, OS.DataConversion.JSNodeParamConverter.from(startDateIn, OS.Types.Date), OS.DataConversion.JSNodeParamConverter.from(endDateIn, OS.Types.Date)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
TransactionListOut: actionResults.transactionListOutOut
};
});
};
});

define("Brazil_Cards_MUI.controller", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Cards_MUI.model", "Brazil_Cards_MUI.controller$translationsResources"], function (exports, OutSystems, Brazil_Cards_MUIModel, Brazil_Cards_MUI_Controller_translationsResources) {
var OS = OutSystems.Internal;
var Brazil_Cards_MUIController = exports;
var Controller = (function (_super) {
__extends(Controller, _super);
function Controller() {
_super.apply(this, arguments);
}
Controller.prototype.clientActionProxies = {};
Controller.prototype.roles = {};
Controller.prototype.defaultTimeout = 300;
Controller.prototype.getDefaultTimeout = function () {
return Brazil_Cards_MUIController.default.defaultTimeout;
};
return Controller;
})(OS.Controller.BaseModuleController);
Brazil_Cards_MUIController.default = new Controller(Brazil_Cards_MUI_Controller_translationsResources, "Brazil_Cards_MUI");
});
define("Brazil_Cards_MUI.controller$translationsResources", ["exports"], function (exports) {
return {};
});
