﻿define("Brazil_Common_MUI.controller$CheckUpdateId", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Common_MUI.model", "Brazil_Common_MUI.controller", "Brazil_OfflineStorage.model", "Brazil_OfflineStorage.entities", "Brazil_Common_MUI.controller$ServerAction.SiteProperty_ComplianceTemplate", "Brazil_Common_MUI.controller$ServerAction.CheckSecondaryIdWallet", "Brazil_Common_MUI.controller$ServerAction.CheckComplianceVersionWallet", "Brazil_Common_MUI.model$SettingsRecordList", "Brazil_OfflineStorage.model$SettingsRec", "Brazil_Common_MUI.referencesHealth", "Brazil_Common_MUI.referencesHealth$Brazil_OfflineStorage"], function (exports, OutSystems, Brazil_Common_MUIModel, Brazil_Common_MUIController, Brazil_OfflineStorageModel, Brazil_OfflineStorageEntities) {
var OS = OutSystems.Internal;
Brazil_Common_MUIController.default.checkUpdateId$Action = function (callContext) {
callContext = controller.callContext(callContext);
var siteProperty_ComplianceTemplateVar = new OS.DataTypes.VariableHolder();
var checkSecondaryIdWalletVar = new OS.DataTypes.VariableHolder();
var checkComplianceVersionWalletVar = new OS.DataTypes.VariableHolder();
var getSettingsVar = new OS.DataTypes.VariableHolder(new (OS.Controller.BaseController.getAggregateOutputType(Brazil_Common_MUIModel.SettingsRecordList))());
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Common_MUI.CheckUpdateId$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: SiteProperty_ComplianceTemplate
return controller.siteProperty_ComplianceTemplate$ServerAction(callContext).then(function (value) {
siteProperty_ComplianceTemplateVar.value = value;
}).then(function () {
return OS.Flow.executeSequence(function () {
if((siteProperty_ComplianceTemplateVar.value.isEnabledOut)) {
// Execute Action: CheckSecondaryIdWallet
return controller.checkSecondaryIdWallet$ServerAction(callContext).then(function (value) {
checkSecondaryIdWalletVar.value = value;
}).then(function () {
return OS.Flow.executeSequence(function () {
if((!(checkSecondaryIdWalletVar.value.isExpiredOut))) {
// Aggregate: GetSettings
var getSettingsAggr = function (maxRecords) {
var executeQuery = null;
if(OS.NativeHelper.isRunningOnNative()) {
executeQuery = function () {
var targetListType = Brazil_Common_MUIModel.SettingsRecordList;
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var countArgsList = new OS.Entities.QueryArgumentsList();
if(!(maxRecords)) {
maxRecords = 0;
}


var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "NULL o0, NULL o1, NULL o2, NULL o3, NULL o4, NULL o5, NULL o6, NULL o7, NULL o8, NULL o9, NULL o10, NULL o11, NULL o12, NULL o13, NULL o14, \"ENSettings\".\"WalletComplianceVersion\" o15";
} else {
selectSql += "\"ENSettings\".\"Id\" o0, \"ENSettings\".\"Email\" o1, \"ENSettings\".\"LoginBiometrics\" o2, \"ENSettings\".\"IsBioMaybeLater\" o3, \"ENSettings\".\"IsPasscodeOnDevice\" o4, \"ENSettings\".\"LoginAttemptsCount\" o5, \"ENSettings\".\"HasOnbardingDone\" o6, \"ENSettings\".\"AppLanguage\" o7, \"ENSettings\".\"HasGivenAccessCode\" o8, \"ENSettings\".\"LastLogin\" o9, \"ENSettings\".\"TemporaryIsNotifications\" o10, \"ENSettings\".\"IsCameraDenied\" o11, \"ENSettings\".\"BiometricAttempts\" o12, \"ENSettings\".\"DontShowAgain\" o13, \"ENSettings\".\"PingSessionId\" o14, \"ENSettings\".\"WalletComplianceVersion\" o15";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_9k2_Settings\" \"ENSettings\"";
orderBySql += " ORDER BY \"ENSettings\".\"Email\" ASC ";
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

return OS.Entities.webSQLStorageInstance.executeQuery(sql, Brazil_Common_MUIModel.SettingsRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"settingsAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

}, argsList).then(function (resultList) {
result.list = resultList;
}).then(function () {
}).then(function () {
return result;
});
};
} else {
executeQuery = function () {
if(!(maxRecords)) {
maxRecords = 0;
}

return new Promise(function (resolve, reject) {
require(["Brazil_Common_MUI.aggregates.IDB"], function (Brazil_Common_MUIAggregates_IDB) {
return Brazil_Common_MUIAggregates_IDB.executeCheckUpdateId$ClientAction$getSettingsAggr(maxRecords).then(function (result) {
resolve(result);
}).catch(function (e) {
reject(e);
});
});
});
};
}

return controller.executeClientAggregate(executeQuery, function () {
return getSettingsVar.value;
});
};
return getSettingsAggr().then(function () {
// Execute Action: CheckComplianceVersionWallet
return controller.checkComplianceVersionWallet$ServerAction(getSettingsVar.value.listOut.getCurrent(callContext.iterationContext).settingsAttr.walletComplianceVersionAttr, callContext).then(function (value) {
checkComplianceVersionWalletVar.value = value;
});
}).then(function () {
if((!(checkComplianceVersionWalletVar.value.isIdOutdatedOut))) {
// IsToUpdate = False
outVars.value.isToUpdateOut = false;
return OS.Flow.returnAsync(outVars.value);

}

});
}

});
}).then(function () {
// IsToUpdate = True
outVars.value.isToUpdateOut = true;
});
} else {
// IsToUpdate = False
outVars.value.isToUpdateOut = false;
}

});
});
}).then(function () {
return outVars.value;
});
};
var controller = Brazil_Common_MUIController.default;
Brazil_Common_MUIController.default.constructor.registerVariableGroupType("Brazil_Common_MUI.CheckUpdateId$outVars", [{
name: "IsToUpdate",
attrName: "isToUpdateOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
Brazil_Common_MUIController.default.clientActionProxies.checkUpdateId$Action = function () {
return controller.executeActionInsideJSNode(Brazil_Common_MUIController.default.checkUpdateId$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
IsToUpdate: OS.DataConversion.JSNodeParamConverter.to(actionResults.isToUpdateOut, OS.Types.Boolean)
};
});
};
});

define("Brazil_Common_MUI.controller$GetDeviceInformation", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Common_MUI.model", "Brazil_Common_MUI.controller", "CommonPlugin.model", "DevicePlugin.controller", "DevicePlugin.model", "Brazil_FundsOut_BL.model", "CommonPlugin.model$ErrorRec", "Brazil_Common_MUI.referencesHealth", "Brazil_Common_MUI.referencesHealth$CommonPlugin", "DevicePlugin.controller$CheckDevicePlugin", "Brazil_Common_MUI.referencesHealth$DevicePlugin", "DevicePlugin.model$DeviceRec", "DevicePlugin.controller$GetDeviceInfo", "Brazil_FundsOut_BL.model$SmartPhoneDetailsRec", "Brazil_Common_MUI.referencesHealth$Brazil_FundsOut_BL"], function (exports, OutSystems, Brazil_Common_MUIModel, Brazil_Common_MUIController, CommonPluginModel, DevicePluginController, DevicePluginModel, Brazil_FundsOut_BLModel) {
var OS = OutSystems.Internal;
Brazil_Common_MUIController.default.getDeviceInformation$Action = function (callContext) {
callContext = controller.callContext(callContext);
var checkDevicePluginVar = new OS.DataTypes.VariableHolder();
var getDeviceInfoVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Common_MUI.GetDeviceInformation$outVars"))());
// Execute Action: CheckDevicePlugin
checkDevicePluginVar.value = DevicePluginController.default.checkDevicePlugin$Action(callContext);

if((checkDevicePluginVar.value.isAvailableOut)) {
// Execute Action: GetDeviceInfo
getDeviceInfoVar.value = DevicePluginController.default.getDeviceInfo$Action(callContext);

// SmartPhoneDetails.SmartphoneDeviceAlias = GetDeviceInfo.Device.Uuid
outVars.value.smartPhoneDetailsOut.smartphoneDeviceAliasAttr = getDeviceInfoVar.value.deviceOut.uuidAttr;
// SmartPhoneDetails.SmartphoneDeviceType = "MOBILE"
outVars.value.smartPhoneDetailsOut.smartphoneDeviceTypeAttr = "MOBILE";
// SmartPhoneDetails.SmartphoneDeviceWuName = If
outVars.value.smartPhoneDetailsOut.smartphoneDeviceWuNameAttr = (((getDeviceInfoVar.value.deviceOut.platformAttr === "Android")) ? (getDeviceInfoVar.value.deviceOut.platformAttr) : ("iPhone"));
// SmartPhoneDetails.SmartphoneDeviceOs = GetDeviceInfo.Device.Platform
outVars.value.smartPhoneDetailsOut.smartphoneDeviceOsAttr = getDeviceInfoVar.value.deviceOut.platformAttr;
// SmartPhoneDetails.SmartphoneDeviceModel = GetDeviceInfo.Device.Model
outVars.value.smartPhoneDetailsOut.smartphoneDeviceModelAttr = getDeviceInfoVar.value.deviceOut.modelAttr;
// SmartPhoneDetails.SmartphoneDeviceOsWuVersion = GetDeviceInfo.Device.Version
outVars.value.smartPhoneDetailsOut.smartphoneDeviceOsWuVersionAttr = getDeviceInfoVar.value.deviceOut.versionAttr;
// DeviceInfoAvailable = True
outVars.value.deviceInfoAvailableOut = true;
}

return outVars.value;
};
var controller = Brazil_Common_MUIController.default;
Brazil_Common_MUIController.default.constructor.registerVariableGroupType("Brazil_Common_MUI.GetDeviceInformation$outVars", [{
name: "SmartPhoneDetails",
attrName: "smartPhoneDetailsOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new Brazil_FundsOut_BLModel.SmartPhoneDetailsRec();
},
complexType: Brazil_FundsOut_BLModel.SmartPhoneDetailsRec
}, {
name: "DeviceInfoAvailable",
attrName: "deviceInfoAvailableOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
Brazil_Common_MUIController.default.clientActionProxies.getDeviceInformation$Action = function () {
return controller.executeActionInsideJSNode(Brazil_Common_MUIController.default.getDeviceInformation$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
SmartPhoneDetails: actionResults.smartPhoneDetailsOut,
DeviceInfoAvailable: OS.DataConversion.JSNodeParamConverter.to(actionResults.deviceInfoAvailableOut, OS.Types.Boolean)
};
});
};
});

define("Brazil_Common_MUI.controller$GetDeviceLocation", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Common_MUI.model", "Brazil_Common_MUI.controller", "LocationPlugin.model", "CommonPlugin.model", "LocationPlugin.controller", "LocationPlugin.model$LocationRec", "Brazil_Common_MUI.referencesHealth", "Brazil_Common_MUI.referencesHealth$LocationPlugin", "CommonPlugin.model$ErrorRec", "Brazil_Common_MUI.referencesHealth$CommonPlugin", "LocationPlugin.controller$GetLocation", "LocationPlugin.controller$CheckLocationPlugin"], function (exports, OutSystems, Brazil_Common_MUIModel, Brazil_Common_MUIController, LocationPluginModel, CommonPluginModel, LocationPluginController) {
var OS = OutSystems.Internal;
Brazil_Common_MUIController.default.getDeviceLocation$Action = function (callContext) {
callContext = controller.callContext(callContext);
var getLocationVar = new OS.DataTypes.VariableHolder();
var checkLocationPluginVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Common_MUI.GetDeviceLocation$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: CheckLocationPlugin
checkLocationPluginVar.value = LocationPluginController.default.checkLocationPlugin$Action(callContext);

return OS.Flow.executeSequence(function () {
if((checkLocationPluginVar.value.isAvailableOut)) {
// Execute Action: GetLocation
return LocationPluginController.default.getLocation$Action(5000, 3000, true, callContext).then(function (value) {
getLocationVar.value = value;
}).then(function () {
if((getLocationVar.value.successOut)) {
// Location = GetLocation.Location
outVars.value.locationOut = getLocationVar.value.locationOut;
// Success = True
outVars.value.successOut = true;
} else {
// Execute Action: Log_LocationPlugin
OS.SystemActions.logMessage(((("Brazil_Common_MUI > GetDeviceLocation: " + getLocationVar.value.errorOut.errorCodeAttr) + " ErrorMessage: ") + getLocationVar.value.errorOut.errorMessageAttr), "Common", callContext);
// Set Output
// Success = False
outVars.value.successOut = false;
// Error.ErrorCode = 2
outVars.value.errorOut.errorCodeAttr = "2";
// Error.ErrorMessage = "No able to get location."
outVars.value.errorOut.errorMessageAttr = "No able to get location.";
}

});
} else {
// Execute Action: Log_CheckLocationPlugin
OS.SystemActions.logMessage(((("Brazil_Common_MUI > GetDeviceLocation: " + checkLocationPluginVar.value.errorOut.errorCodeAttr) + " ErrorMessage: ") + checkLocationPluginVar.value.errorOut.errorMessageAttr), "Common", callContext);
// Set Output
// Success = False
outVars.value.successOut = false;
// Error.ErrorCode = 1
outVars.value.errorOut.errorCodeAttr = "1";
// Error.ErrorMessage = "Plugin is not loaded."
outVars.value.errorOut.errorMessageAttr = "Plugin is not loaded.";
}

});
}).then(function () {
return outVars.value;
});
};
var controller = Brazil_Common_MUIController.default;
Brazil_Common_MUIController.default.constructor.registerVariableGroupType("Brazil_Common_MUI.GetDeviceLocation$outVars", [{
name: "Location",
attrName: "locationOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new LocationPluginModel.LocationRec();
},
complexType: LocationPluginModel.LocationRec
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}, {
name: "Success",
attrName: "successOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
Brazil_Common_MUIController.default.clientActionProxies.getDeviceLocation$Action = function () {
return controller.executeActionInsideJSNode(Brazil_Common_MUIController.default.getDeviceLocation$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Location: actionResults.locationOut,
Error: actionResults.errorOut,
Success: OS.DataConversion.JSNodeParamConverter.to(actionResults.successOut, OS.Types.Boolean)
};
});
};
});

define("Brazil_Common_MUI.controller$OpenApplicationSettings", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Common_MUI.model", "Brazil_Common_MUI.controller", "CommonPlugin.model", "SettingsPlugin.controller", "CommonPlugin.model$ErrorRec", "Brazil_Common_MUI.referencesHealth", "Brazil_Common_MUI.referencesHealth$CommonPlugin", "SettingsPlugin.controller$OpenSettings", "Brazil_Common_MUI.referencesHealth$SettingsPlugin", "SettingsPlugin.controller$CheckSettingsPlugin"], function (exports, OutSystems, Brazil_Common_MUIModel, Brazil_Common_MUIController, CommonPluginModel, SettingsPluginController) {
var OS = OutSystems.Internal;
Brazil_Common_MUIController.default.openApplicationSettings$Action = function (callContext) {
callContext = controller.callContext(callContext);
var openSettingsVar = new OS.DataTypes.VariableHolder();
var checkSettingsPluginVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Common_MUI.OpenApplicationSettings$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: CheckSettingsPlugin
checkSettingsPluginVar.value = SettingsPluginController.default.checkSettingsPlugin$Action(callContext);

// Check if CheckSettingsPlugin IsAvailable
return OS.Flow.executeSequence(function () {
if((checkSettingsPluginVar.value.isAvailableOut)) {
// Execute Action: OpenSettings
return SettingsPluginController.default.openSettings$Action("application_details", callContext).then(function (value) {
openSettingsVar.value = value;
}).then(function () {
// IsSuccess = True
outVars.value.isSuccessOut = true;
});
} else {
// Set IsSuccess
// IsSuccess = False
outVars.value.isSuccessOut = false;
}

});
}).then(function () {
return outVars.value;
});
};
var controller = Brazil_Common_MUIController.default;
Brazil_Common_MUIController.default.constructor.registerVariableGroupType("Brazil_Common_MUI.OpenApplicationSettings$outVars", [{
name: "IsSuccess",
attrName: "isSuccessOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
Brazil_Common_MUIController.default.clientActionProxies.openApplicationSettings$Action = function () {
return controller.executeActionInsideJSNode(Brazil_Common_MUIController.default.openApplicationSettings$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
IsSuccess: OS.DataConversion.JSNodeParamConverter.to(actionResults.isSuccessOut, OS.Types.Boolean)
};
});
};
});

define("Brazil_Common_MUI.controller$OpenChatBotInApp", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Common_MUI.model", "Brazil_Common_MUI.controller", "InAppBrowserPlugin.model", "CommonPlugin.model", "InAppBrowserPlugin.controller", "InAppBrowserPlugin.model$SystemBrowserOptionsRec", "Brazil_Common_MUI.referencesHealth", "Brazil_Common_MUI.referencesHealth$InAppBrowserPlugin", "CommonPlugin.model$ErrorRec", "Brazil_Common_MUI.referencesHealth$CommonPlugin", "CommonPlugin.model$WarningRec", "InAppBrowserPlugin.controller$OpenInSystemBrowser", "Brazil_Common_MUI.controller$ServerAction.GetLisaChatBotURL", "InAppBrowserPlugin.controller$CheckInAppBrowserPlugin", "InAppBrowserPlugin.model$OptionsRec", "InAppBrowserPlugin.model$AndroidBottomSheetRec"], function (exports, OutSystems, Brazil_Common_MUIModel, Brazil_Common_MUIController, InAppBrowserPluginModel, CommonPluginModel, InAppBrowserPluginController) {
var OS = OutSystems.Internal;
Brazil_Common_MUIController.default.openChatBotInApp$Action = function (userIdIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Common_MUI.OpenChatBotInApp$vars"))());
vars.value.userIdInLocal = userIdIn;
var getLisaChatBotURLVar = new OS.DataTypes.VariableHolder();
var openInSystemBrowserVar = new OS.DataTypes.VariableHolder();
var checkInAppBrowserPluginVar = new OS.DataTypes.VariableHolder();
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: CheckInAppBrowserPlugin
checkInAppBrowserPluginVar.value = InAppBrowserPluginController.default.checkInAppBrowserPlugin$Action(callContext);

// Available?
return OS.Flow.executeSequence(function () {
if((checkInAppBrowserPluginVar.value.isAvailableOut)) {
// Execute Action: GetLisaChatBotURL
return controller.getLisaChatBotURL$ServerAction(vars.value.userIdInLocal, callContext).then(function (value) {
getLisaChatBotURLVar.value = value;
}).then(function () {
// Execute Action: OpenInSystemBrowser
return InAppBrowserPluginController.default.openInSystemBrowser$Action(getLisaChatBotURLVar.value.uRLOut, OS.DataConversion.JSConversions.typeConvertRecord(function () {
var rec = new InAppBrowserPluginModel.OptionsRec();
rec.locationAttr = false;
return rec;
}(), new InAppBrowserPluginModel.SystemBrowserOptionsRec(), function (source, target) {
return target;
}), callContext).then(function (value) {
openInSystemBrowserVar.value = value;
});
});
} else {
// Raise Error: ChatBotNotAvailable
throw new OS.Exceptions.Exceptions.UserException("Brazil_Common_MUI.ChatBotNotAvailable", OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("GM5nFOaLqkCaOZmDE2JZzA#Message.-1091490030.1", "Chat feature is currently unavailable"));
}

});
}).then(function () {
return ;
});
};
var controller = Brazil_Common_MUIController.default;
Brazil_Common_MUIController.default.constructor.registerVariableGroupType("Brazil_Common_MUI.OpenChatBotInApp$vars", [{
name: "UserId",
attrName: "userIdInLocal",
mandatory: true,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}]);
Brazil_Common_MUIController.default.clientActionProxies.openChatBotInApp$Action = function (userIdIn) {
userIdIn = (userIdIn === undefined) ? 0 : userIdIn;
return controller.executeActionInsideJSNode(Brazil_Common_MUIController.default.openChatBotInApp$Action.bind(controller, userIdIn), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_Common_MUI.controller$ServerAction.CheckComplianceVersionWallet", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Common_MUI.model", "Brazil_Common_MUI.controller"], function (exports, OutSystems, Brazil_Common_MUIModel, Brazil_Common_MUIController) {
var OS = OutSystems.Internal;
Brazil_Common_MUIController.default.checkComplianceVersionWallet$ServerAction = function (complianceVersionIn, callContext) {
var controller = this.controller;
var inputs = {
ComplianceVersion: OS.DataConversion.ServerDataConverter.to(complianceVersionIn, OS.Types.Text)
};
return controller.callServerAction("CheckComplianceVersionWallet", "screenservices/Brazil_Common_MUI/ActionCheckComplianceVersionWallet", "pBFgGFtzArGJFkl8YPjumg", inputs, controller.callContext(callContext), undefined, undefined, true).then(function (outputs) {
var executeServerActionResult = new (controller.constructor.getVariableGroupType("Brazil_Common_MUI$ActionCheckComplianceVersionWallet"))();
executeServerActionResult.isIdOutdatedOut = OS.DataConversion.ServerDataConverter.from(outputs.IsIdOutdated, OS.Types.Boolean);
return executeServerActionResult;
});
};
Brazil_Common_MUIController.default.constructor.registerVariableGroupType("Brazil_Common_MUI$ActionCheckComplianceVersionWallet", [{
name: "IsIdOutdated",
attrName: "isIdOutdatedOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
});
define("Brazil_Common_MUI.controller$ServerAction.CheckSecondaryIdWallet", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Common_MUI.model", "Brazil_Common_MUI.controller"], function (exports, OutSystems, Brazil_Common_MUIModel, Brazil_Common_MUIController) {
var OS = OutSystems.Internal;
Brazil_Common_MUIController.default.checkSecondaryIdWallet$ServerAction = function (callContext) {
var controller = this.controller;
return controller.callServerAction("CheckSecondaryIdWallet", "screenservices/Brazil_Common_MUI/ActionCheckSecondaryIdWallet", "O5gc6_KFUIWwU4e0wKmd6w", {}, controller.callContext(callContext), undefined, undefined, true).then(function (outputs) {
var executeServerActionResult = new (controller.constructor.getVariableGroupType("Brazil_Common_MUI$ActionCheckSecondaryIdWallet"))();
executeServerActionResult.isExpiredOut = OS.DataConversion.ServerDataConverter.from(outputs.IsExpired, OS.Types.Boolean);
return executeServerActionResult;
});
};
Brazil_Common_MUIController.default.constructor.registerVariableGroupType("Brazil_Common_MUI$ActionCheckSecondaryIdWallet", [{
name: "IsExpired",
attrName: "isExpiredOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
});
define("Brazil_Common_MUI.controller$ServerAction.GetLisaChatBotURL", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Common_MUI.model", "Brazil_Common_MUI.controller"], function (exports, OutSystems, Brazil_Common_MUIModel, Brazil_Common_MUIController) {
var OS = OutSystems.Internal;
Brazil_Common_MUIController.default.getLisaChatBotURL$ServerAction = function (userIdIn, callContext) {
var controller = this.controller;
var inputs = {
UserId: OS.DataConversion.ServerDataConverter.to(userIdIn, OS.Types.Integer)
};
return controller.callServerAction("GetLisaChatBotURL", "screenservices/Brazil_Common_MUI/ActionGetLisaChatBotURL", "ivEpCYtCNSH1VYsaQi2Nmg", inputs, controller.callContext(callContext), undefined, undefined, true).then(function (outputs) {
var executeServerActionResult = new (controller.constructor.getVariableGroupType("Brazil_Common_MUI$ActionGetLisaChatBotURL"))();
executeServerActionResult.uRLOut = OS.DataConversion.ServerDataConverter.from(outputs.URL, OS.Types.Text);
return executeServerActionResult;
});
};
Brazil_Common_MUIController.default.constructor.registerVariableGroupType("Brazil_Common_MUI$ActionGetLisaChatBotURL", [{
name: "URL",
attrName: "uRLOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
});
define("Brazil_Common_MUI.controller$ServerAction.SiteProperty_ComplianceTemplate", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Common_MUI.model", "Brazil_Common_MUI.controller"], function (exports, OutSystems, Brazil_Common_MUIModel, Brazil_Common_MUIController) {
var OS = OutSystems.Internal;
Brazil_Common_MUIController.default.siteProperty_ComplianceTemplate$ServerAction = function (callContext) {
var controller = this.controller;
return controller.callServerAction("SiteProperty_ComplianceTemplate", "screenservices/Brazil_Common_MUI/ServiceAPISiteProperty_ComplianceTemplate", "o5xksG1Jna+pwdYaB6Ka+Q", {}, controller.callContext(callContext), undefined, undefined, true).then(function (outputs) {
var executeServerActionResult = new (controller.constructor.getVariableGroupType("Brazil_Common_MUI$ServiceAPISiteProperty_ComplianceTemplate"))();
executeServerActionResult.isEnabledOut = OS.DataConversion.ServerDataConverter.from(outputs.IsEnabled, OS.Types.Boolean);
return executeServerActionResult;
});
};
Brazil_Common_MUIController.default.constructor.registerVariableGroupType("Brazil_Common_MUI$ServiceAPISiteProperty_ComplianceTemplate", [{
name: "IsEnabled",
attrName: "isEnabledOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
});
define("Brazil_Common_MUI.controller", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Common_MUI.model", "Brazil_Common_MUI.controller$translationsResources"], function (exports, OutSystems, Brazil_Common_MUIModel, Brazil_Common_MUI_Controller_translationsResources) {
var OS = OutSystems.Internal;
var Brazil_Common_MUIController = exports;
var Controller = (function (_super) {
__extends(Controller, _super);
function Controller() {
_super.apply(this, arguments);
}
Controller.prototype.clientActionProxies = {};
Controller.prototype.roles = {};
Controller.prototype.defaultTimeout = 10;
Controller.prototype.getDefaultTimeout = function () {
return Brazil_Common_MUIController.default.defaultTimeout;
};
return Controller;
})(OS.Controller.BaseModuleController);
Brazil_Common_MUIController.default = new Controller(Brazil_Common_MUI_Controller_translationsResources, "Brazil_Common_MUI");
});
define("Brazil_Common_MUI.controller$translationsResources", ["exports", "Brazil_Common_MUI.controller$translationsResources.es-419", "Brazil_Common_MUI.controller$translationsResources.pt-BR"], function (exports, Brazil_Common_MUI_controller_translationsResources_es419, Brazil_Common_MUI_controller_translationsResources_ptBR) {
return {
"es-419": {
"translations": Brazil_Common_MUI_controller_translationsResources_es419,
"isRTL": false
},
"pt-BR": {
"translations": Brazil_Common_MUI_controller_translationsResources_ptBR,
"isRTL": false
}
};
});
define("Brazil_Common_MUI.controller$translationsResources.es-419", [], function () {
return {
"GM5nFOaLqkCaOZmDE2JZzA#Message.-1091490030.1": "La función de chat no está disponible actualmente"
};
});
define("Brazil_Common_MUI.controller$translationsResources.pt-BR", [], function () {
return {
"GM5nFOaLqkCaOZmDE2JZzA#Message.-1091490030.1": "O recurso de ajuda está atualmente indisponível"
};
});
