﻿define("Brazil_DeviceManagement_MUI.controller$BannerMessages", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_DeviceManagement_MUI.model", "Brazil_DeviceManagement_MUI.controller", "Brazil_DeviceManagement_MUI.clientVariables"], function (exports, OutSystems, Brazil_DeviceManagement_MUIModel, Brazil_DeviceManagement_MUIController, Brazil_DeviceManagement_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_DeviceManagement_MUIController.default.bannerMessages$Action = function (deviceIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_DeviceManagement_MUI.BannerMessages$vars"))());
vars.value.deviceInLocal = deviceIn;
if(((vars.value.deviceInLocal === "A"))) {
// Message = "Your device is now registered.  Start making Pix safely!"
vars.value.messageVar = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("fuDOs+73IU2pRpEdagYyLw#Value.-1843543304.1", "Your device is now registered.  Start making Pix safely!");
} else {
if((vars.value.deviceInLocal === "B")) {
// Message = "Your device it’s not registered. To proceed with Pix Transactions, you need register it. Register"
vars.value.messageVar = "Your device it’s not registered. To proceed with Pix Transactions, you need register it. Register";
} else {
if(!((vars.value.deviceInLocal === "I"))) {
}

}

}

return ;
};
var controller = Brazil_DeviceManagement_MUIController.default;
Brazil_DeviceManagement_MUIController.default.constructor.registerVariableGroupType("Brazil_DeviceManagement_MUI.BannerMessages$vars", [{
name: "Device",
attrName: "deviceInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "Message",
attrName: "messageVar",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_DeviceManagement_MUIController.default.clientActionProxies.bannerMessages$Action = function (deviceIn) {
deviceIn = (deviceIn === undefined) ? "" : deviceIn;
return controller.executeActionInsideJSNode(Brazil_DeviceManagement_MUIController.default.bannerMessages$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(deviceIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_DeviceManagement_MUI.controller$BlockDevice", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_DeviceManagement_MUI.model", "Brazil_DeviceManagement_MUI.controller", "Brazil_DeviceManagement_MUI.clientVariables", "Brazil_DeviceManagement_MUI.controller$ServerAction.UpdateDeviceStatus_BL"], function (exports, OutSystems, Brazil_DeviceManagement_MUIModel, Brazil_DeviceManagement_MUIController, Brazil_DeviceManagement_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_DeviceManagement_MUIController.default.blockDevice$Action = function (callContext) {
callContext = controller.callContext(callContext);
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: LogMessage
OS.SystemActions.logMessage("DeviceManagement > BlockDevice - Run", "DeviceManage", callContext);
// Execute Action: UpdateDeviceStatus_BL
return controller.updateDeviceStatus_BL$ServerAction(Brazil_DeviceManagement_MUIModel.staticEntities.availableDeviceStatuses.blocked, callContext);
}).then(function () {
return ;
});
};
var controller = Brazil_DeviceManagement_MUIController.default;
Brazil_DeviceManagement_MUIController.default.clientActionProxies.blockDevice$Action = function () {
return controller.executeActionInsideJSNode(Brazil_DeviceManagement_MUIController.default.blockDevice$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_DeviceManagement_MUI.controller$GenerateAndSetDeviceId", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_DeviceManagement_MUI.model", "Brazil_DeviceManagement_MUI.controller", "ReactiveUtilities.controller", "CommonPlugin.model", "CommonPlugin.controller", "Brazil_DeviceManagement_MUI.clientVariables", "ReactiveUtilities.controller$RandomGUID", "Brazil_DeviceManagement_MUI.referencesHealth", "Brazil_DeviceManagement_MUI.referencesHealth$ReactiveUtilities", "CommonPlugin.model$ErrorRec", "Brazil_DeviceManagement_MUI.referencesHealth$CommonPlugin", "Brazil_DeviceManagement_MUI.controller$GetDeviceId", "Brazil_DeviceManagement_MUI.controller$SetDeviceId", "CommonPlugin.controller$IsCordovaDefined"], function (exports, OutSystems, Brazil_DeviceManagement_MUIModel, Brazil_DeviceManagement_MUIController, ReactiveUtilitiesController, CommonPluginModel, CommonPluginController, Brazil_DeviceManagement_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_DeviceManagement_MUIController.default.generateAndSetDeviceId$Action = function (callContext) {
callContext = controller.callContext(callContext);
var randomGUIDVar = new OS.DataTypes.VariableHolder();
var getDeviceIdVar = new OS.DataTypes.VariableHolder();
var setDeviceIdVar = new OS.DataTypes.VariableHolder();
var isCordovaDefinedVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_DeviceManagement_MUI.GenerateAndSetDeviceId$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: IsCordovaDefined
isCordovaDefinedVar.value = CommonPluginController.default.isCordovaDefined$Action(callContext);

return OS.Flow.executeSequence(function () {
if((isCordovaDefinedVar.value.isLoadedOut)) {
// Execute Action: GetDeviceId
return Brazil_DeviceManagement_MUIController.default.getDeviceId$Action(callContext).then(function (value) {
getDeviceIdVar.value = value;
}).then(function () {
return OS.Flow.executeSequence(function () {
if((getDeviceIdVar.value.successOut)) {
// Execute Action: Log_Id
OS.SystemActions.logMessage(("DeviceManagement > GenerateAndSetDeviceId - Get_DeviceId: " + getDeviceIdVar.value.deviceIdOut), "DeviceManage", callContext);
// Set Output
// DeviceId = GetDeviceId.DeviceId
outVars.value.deviceIdOut = getDeviceIdVar.value.deviceIdOut;
// Success = True
outVars.value.successOut = true;
} else {
// Execute Action: Log_GetDeviceIdError
OS.SystemActions.logMessage(((("DeviceManagement > GenerateAndSetDeviceId - Get_DeviceId ErrorCode: " + getDeviceIdVar.value.errorOut.errorCodeAttr) + " ErrorMessage: ") + getDeviceIdVar.value.errorOut.errorMessageAttr), "DeviceManage", callContext);
// Execute Action: RandomGUID
randomGUIDVar.value = ReactiveUtilitiesController.default.randomGUID$Action(callContext);

// Execute Action: SetDeviceId
return Brazil_DeviceManagement_MUIController.default.setDeviceId$Action(randomGUIDVar.value.gUIDOut, callContext).then(function (value) {
setDeviceIdVar.value = value;
}).then(function () {
if((setDeviceIdVar.value.successOut)) {
// Execute Action: Log_DeviceIdSet
OS.SystemActions.logMessage(("DeviceManagement > GenerateAndSetDeviceId - DeviceIdSet: " + randomGUIDVar.value.gUIDOut), "DeviceManage", callContext);
// Set Output
// DeviceId = RandomGUID.GUID
outVars.value.deviceIdOut = randomGUIDVar.value.gUIDOut;
// Success = True
outVars.value.successOut = true;
} else {
// Execute Action: Log_SetDeviceIdError
OS.SystemActions.logMessage(((("DeviceManagement > GenerateAndSetDeviceId - Set keystore ErrorCode: " + setDeviceIdVar.value.errorOut.errorCodeAttr) + " ErrorMessage: ") + setDeviceIdVar.value.errorOut.errorMessageAttr), "DeviceManage", callContext);
// Set Output
// Success = False
outVars.value.successOut = false;
// Error.ErrorCode = 2
outVars.value.errorOut.errorCodeAttr = "2";
// Error.ErrorMessage = "Not able to store deviceId"
outVars.value.errorOut.errorMessageAttr = "Not able to store deviceId";
// DeviceId = NullTextIdentifier
outVars.value.deviceIdOut = OS.BuiltinFunctions.nullTextIdentifier();
}

});
}

});
});
} else {
// Set Output
// Success = False
outVars.value.successOut = false;
// Error.ErrorCode = 1
outVars.value.errorOut.errorCodeAttr = "1";
// Error.ErrorMessage = "cordova is not defined"
outVars.value.errorOut.errorMessageAttr = "cordova is not defined";
}

});
}).then(function () {
return outVars.value;
});
};
var controller = Brazil_DeviceManagement_MUIController.default;
Brazil_DeviceManagement_MUIController.default.constructor.registerVariableGroupType("Brazil_DeviceManagement_MUI.GenerateAndSetDeviceId$outVars", [{
name: "DeviceId",
attrName: "deviceIdOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}, {
name: "Success",
attrName: "successOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
Brazil_DeviceManagement_MUIController.default.clientActionProxies.generateAndSetDeviceId$Action = function () {
return controller.executeActionInsideJSNode(Brazil_DeviceManagement_MUIController.default.generateAndSetDeviceId$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
DeviceId: OS.DataConversion.JSNodeParamConverter.to(actionResults.deviceIdOut, OS.Types.Text),
Error: actionResults.errorOut,
Success: OS.DataConversion.JSNodeParamConverter.to(actionResults.successOut, OS.Types.Boolean)
};
});
};
});

define("Brazil_DeviceManagement_MUI.controller$GetDeviceId", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_DeviceManagement_MUI.model", "Brazil_DeviceManagement_MUI.controller", "CommonPlugin.model", "Brazil_Common_MBL.controller", "KeyStorePlugin.controller", "Brazil_DeviceManagement_MUI.clientVariables", "CommonPlugin.model$ErrorRec", "Brazil_DeviceManagement_MUI.referencesHealth", "Brazil_DeviceManagement_MUI.referencesHealth$CommonPlugin", "Brazil_Common_MBL.controller$CheckSecureStorageAvailable", "Brazil_DeviceManagement_MUI.referencesHealth$Brazil_Common_MBL", "KeyStorePlugin.controller$GetValue", "Brazil_DeviceManagement_MUI.referencesHealth$KeyStorePlugin"], function (exports, OutSystems, Brazil_DeviceManagement_MUIModel, Brazil_DeviceManagement_MUIController, CommonPluginModel, Brazil_Common_MBLController, KeyStorePluginController, Brazil_DeviceManagement_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_DeviceManagement_MUIController.default.getDeviceId$Action = function (callContext) {
callContext = controller.callContext(callContext);
var checkSecureStorageAvailableVar = new OS.DataTypes.VariableHolder();
var getDeviceIdVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_DeviceManagement_MUI.GetDeviceId$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: CheckSecureStorageAvailable
return Brazil_Common_MBLController.default.checkSecureStorageAvailable$Action(callContext).then(function (value) {
checkSecureStorageAvailableVar.value = value;
}).then(function () {
return OS.Flow.executeSequence(function () {
if((checkSecureStorageAvailableVar.value.isSecureStorageAvailableOut)) {
// Execute Action: GetDeviceId
return KeyStorePluginController.default.getValue$Action("WU.Brazil.Secure.Storage", "deviceId", callContext).then(function (value) {
getDeviceIdVar.value = value;
}).then(function () {
if((getDeviceIdVar.value.successOut)) {
// Outputs
// DeviceId = GetDeviceId.Value
outVars.value.deviceIdOut = getDeviceIdVar.value.valueOut;
// Success = True
outVars.value.successOut = true;
} else {
// Error outputs
// Error = GetDeviceId.Error
outVars.value.errorOut = getDeviceIdVar.value.errorOut;
// Success = False
outVars.value.successOut = false;
// DeviceId = ""
outVars.value.deviceIdOut = "";
}

});
} else {
// Error outputs
// Error = CheckSecureStorageAvailable.Error
outVars.value.errorOut = checkSecureStorageAvailableVar.value.errorOut;
// Success = False
outVars.value.successOut = false;
// DeviceId = ""
outVars.value.deviceIdOut = "";
}

});
});
}).then(function () {
return outVars.value;
});
};
var controller = Brazil_DeviceManagement_MUIController.default;
Brazil_DeviceManagement_MUIController.default.constructor.registerVariableGroupType("Brazil_DeviceManagement_MUI.GetDeviceId$outVars", [{
name: "Success",
attrName: "successOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}, {
name: "DeviceId",
attrName: "deviceIdOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_DeviceManagement_MUIController.default.clientActionProxies.getDeviceId$Action = function () {
return controller.executeActionInsideJSNode(Brazil_DeviceManagement_MUIController.default.getDeviceId$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Success: OS.DataConversion.JSNodeParamConverter.to(actionResults.successOut, OS.Types.Boolean),
Error: actionResults.errorOut,
DeviceId: OS.DataConversion.JSNodeParamConverter.to(actionResults.deviceIdOut, OS.Types.Text)
};
});
};
});

define("Brazil_DeviceManagement_MUI.controller$GetNamedDayOfTheWeek", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_DeviceManagement_MUI.model", "Brazil_DeviceManagement_MUI.controller", "Brazil_DeviceManagement_MUI.clientVariables"], function (exports, OutSystems, Brazil_DeviceManagement_MUIModel, Brazil_DeviceManagement_MUIController, Brazil_DeviceManagement_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_DeviceManagement_MUIController.default.getNamedDayOfTheWeek$Action = function (dateIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_DeviceManagement_MUI.GetNamedDayOfTheWeek$vars"))());
vars.value.dateInLocal = dateIn;
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_DeviceManagement_MUI.GetNamedDayOfTheWeek$outVars"))());
// dateNumber = DayOfWeek
vars.value.dateNumberVar = OS.BuiltinFunctions.dayOfWeek(vars.value.dateInLocal);
// Day of the week
if(((vars.value.dateNumberVar === 0))) {
// dayOfTheWeek = "Sunday"
outVars.value.dayOfTheWeekOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("f1O77l3Zrkq0tTC+bJyBwQ#Value.-1807319568.1", "Sunday");
} else {
if((vars.value.dateNumberVar === 1)) {
// Set dayOfTheWeek
// dayOfTheWeek = "Monday"
outVars.value.dayOfTheWeekOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("5uVnOPtGE0qMKej9f2E9FA#Value.-1984635600.1", "Monday");
} else {
if((vars.value.dateNumberVar === 2)) {
// Set dayOfTheWeek
// dayOfTheWeek = "Tuesday"
outVars.value.dayOfTheWeekOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("HyXq1P0bw0uVMQHir7XkXA#Value.687309357.1", "Tuesday");
} else {
if((vars.value.dateNumberVar === 3)) {
// Set dayOfTheWeek
// dayOfTheWeek = "Wednesday"
outVars.value.dayOfTheWeekOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("8PxBWiBUXUu59+lmPCTNGg#Value.-897468618.1", "Wednesday");
} else {
if((vars.value.dateNumberVar === 4)) {
// Set dayOfTheWeek
// dayOfTheWeek = "Thursday"
outVars.value.dayOfTheWeekOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("NLMZQQkS7Ueyi4BuBFfOvA#Value.1636699642.1", "Thursday");
} else {
if((vars.value.dateNumberVar === 5)) {
// Set dayOfTheWeek
// dayOfTheWeek = "Friday"
outVars.value.dayOfTheWeekOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("A6niNQPZzEiql2_81_nP8Q#Value.2112549247.1", "Friday");
} else {
if((vars.value.dateNumberVar === 6)) {
// Set dayOfTheWeek
// dayOfTheWeek = "Saturday"
outVars.value.dayOfTheWeekOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("pShGGUJ93UCzMo6BjQqFYg#Value.-2049557543.1", "Saturday");
}

}

}

}

}

}

}

return outVars.value;
};
var controller = Brazil_DeviceManagement_MUIController.default;
Brazil_DeviceManagement_MUIController.default.constructor.registerVariableGroupType("Brazil_DeviceManagement_MUI.GetNamedDayOfTheWeek$vars", [{
name: "Date",
attrName: "dateInLocal",
mandatory: true,
dataType: OS.Types.Date,
defaultValue: function () {
return OS.DataTypes.DateTime.defaultValue;
}
}, {
name: "dateNumber",
attrName: "dateNumberVar",
mandatory: false,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}]);
Brazil_DeviceManagement_MUIController.default.constructor.registerVariableGroupType("Brazil_DeviceManagement_MUI.GetNamedDayOfTheWeek$outVars", [{
name: "dayOfTheWeek",
attrName: "dayOfTheWeekOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_DeviceManagement_MUIController.default.clientActionProxies.getNamedDayOfTheWeek$Action = function (dateIn) {
dateIn = (dateIn === undefined) ? OS.DataTypes.DateTime.defaultValue : dateIn;
return controller.executeActionInsideJSNode(Brazil_DeviceManagement_MUIController.default.getNamedDayOfTheWeek$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(dateIn, OS.Types.Date)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
dayOfTheWeek: OS.DataConversion.JSNodeParamConverter.to(actionResults.dayOfTheWeekOut, OS.Types.Text)
};
});
};
});

define("Brazil_DeviceManagement_MUI.controller$IsDevicePixAllowed", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_DeviceManagement_MUI.model", "Brazil_DeviceManagement_MUI.controller", "Brazil_DeviceManagement_BL.model", "Brazil_DeviceManagement_MUI.clientVariables", "Brazil_DeviceManagement_BL.model$ClientRenderedDeviceInfoRec", "Brazil_DeviceManagement_MUI.referencesHealth", "Brazil_DeviceManagement_MUI.referencesHealth$Brazil_DeviceManagement_BL"], function (exports, OutSystems, Brazil_DeviceManagement_MUIModel, Brazil_DeviceManagement_MUIController, Brazil_DeviceManagement_BLModel, Brazil_DeviceManagement_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_DeviceManagement_MUIController.default.isDevicePixAllowed$Action = function (deviceInfoIn, isManageDeviceEnabledIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_DeviceManagement_MUI.IsDevicePixAllowed$vars"))());
vars.value.deviceInfoInLocal = deviceInfoIn.clone();
vars.value.isManageDeviceEnabledInLocal = isManageDeviceEnabledIn;
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_DeviceManagement_MUI.IsDevicePixAllowed$outVars"))());
// is Manage Device property enabled?
if((vars.value.isManageDeviceEnabledInLocal)) {
// is device active?
if(((vars.value.deviceInfoInLocal.deviceStatusAttr === "A"))) {
// is first device?
if((vars.value.deviceInfoInLocal.isFirstDeviceAttr)) {
return outVars.value;

} else {
// has device waited 24h?
if((OS.BuiltinFunctions.currDateTime().gte(vars.value.deviceInfoInLocal.startDateAttr))) {
return outVars.value;

}

}

}

// Pix not allowed
// isPixAllowed = False
outVars.value.isPixAllowedOut = false;
}

return outVars.value;
};
var controller = Brazil_DeviceManagement_MUIController.default;
Brazil_DeviceManagement_MUIController.default.constructor.registerVariableGroupType("Brazil_DeviceManagement_MUI.IsDevicePixAllowed$vars", [{
name: "DeviceInfo",
attrName: "deviceInfoInLocal",
mandatory: true,
dataType: OS.Types.Record,
defaultValue: function () {
return new Brazil_DeviceManagement_BLModel.ClientRenderedDeviceInfoRec();
},
complexType: Brazil_DeviceManagement_BLModel.ClientRenderedDeviceInfoRec
}, {
name: "IsManageDeviceEnabled",
attrName: "isManageDeviceEnabledInLocal",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
Brazil_DeviceManagement_MUIController.default.constructor.registerVariableGroupType("Brazil_DeviceManagement_MUI.IsDevicePixAllowed$outVars", [{
name: "isPixAllowed",
attrName: "isPixAllowedOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return true;
}
}]);
Brazil_DeviceManagement_MUIController.default.clientActionProxies.isDevicePixAllowed$Action = function (deviceInfoIn, isManageDeviceEnabledIn) {
deviceInfoIn = (deviceInfoIn === undefined) ? new Brazil_DeviceManagement_BLModel.ClientRenderedDeviceInfoRec() : deviceInfoIn;
isManageDeviceEnabledIn = (isManageDeviceEnabledIn === undefined) ? false : isManageDeviceEnabledIn;
return controller.executeActionInsideJSNode(Brazil_DeviceManagement_MUIController.default.isDevicePixAllowed$Action.bind(controller, deviceInfoIn, OS.DataConversion.JSNodeParamConverter.from(isManageDeviceEnabledIn, OS.Types.Boolean)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
isPixAllowed: OS.DataConversion.JSNodeParamConverter.to(actionResults.isPixAllowedOut, OS.Types.Boolean)
};
});
};
});

define("Brazil_DeviceManagement_MUI.controller$RegisterDevice", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_DeviceManagement_MUI.model", "Brazil_DeviceManagement_MUI.controller", "DevicePlugin.model", "CommonPlugin.model", "DevicePlugin.controller", "Brazil_DeviceManagement_BL.model", "Brazil_DeviceManagement_MUI.clientVariables", "DevicePlugin.model$DeviceRec", "Brazil_DeviceManagement_MUI.referencesHealth", "Brazil_DeviceManagement_MUI.referencesHealth$DevicePlugin", "CommonPlugin.model$ErrorRec", "Brazil_DeviceManagement_MUI.referencesHealth$CommonPlugin", "DevicePlugin.controller$GetDeviceInfo", "Brazil_DeviceManagement_BL.model$RegisterDeviceInfoRec", "Brazil_DeviceManagement_MUI.referencesHealth$Brazil_DeviceManagement_BL", "Brazil_DeviceManagement_MUI.controller$ServerAction.RegisterDevice_BL", "Brazil_DeviceManagement_MUI.controller$GetDeviceId", "DevicePlugin.controller$CheckDevicePlugin"], function (exports, OutSystems, Brazil_DeviceManagement_MUIModel, Brazil_DeviceManagement_MUIController, DevicePluginModel, CommonPluginModel, DevicePluginController, Brazil_DeviceManagement_BLModel, Brazil_DeviceManagement_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_DeviceManagement_MUIController.default.registerDevice$Action = function (callContext) {
callContext = controller.callContext(callContext);
var getDeviceInfoVar = new OS.DataTypes.VariableHolder();
var getDeviceIdVar = new OS.DataTypes.VariableHolder();
var checkDevicePluginVar = new OS.DataTypes.VariableHolder();
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: GetDeviceId
return Brazil_DeviceManagement_MUIController.default.getDeviceId$Action(callContext).then(function (value) {
getDeviceIdVar.value = value;
}).then(function () {
return OS.Flow.executeSequence(function () {
if((getDeviceIdVar.value.successOut)) {
// Execute Action: CheckDevicePlugin
checkDevicePluginVar.value = DevicePluginController.default.checkDevicePlugin$Action(callContext);

return OS.Flow.executeSequence(function () {
if((checkDevicePluginVar.value.isAvailableOut)) {
// Execute Action: GetDeviceInfo
getDeviceInfoVar.value = DevicePluginController.default.getDeviceInfo$Action(callContext);

// Execute Action: Log
OS.SystemActions.logMessage(("DeviceManagement > RegisterDevice - DeviceId: " + getDeviceIdVar.value.deviceIdOut), "DeviceManage", callContext);
// Execute Action: RegisterDevice_BL
return controller.registerDevice_BL$ServerAction(function () {
var rec = new Brazil_DeviceManagement_BLModel.RegisterDeviceInfoRec();
rec.deviceIdAttr = getDeviceIdVar.value.deviceIdOut;
rec.deviceNameAttr = Brazil_DeviceManagement_MUIClientVariables.getDeviceName();
rec.deviceOsAttr = ((getDeviceInfoVar.value.deviceOut.platformAttr + " - ") + getDeviceInfoVar.value.deviceOut.versionAttr);
rec.deviceModelAttr = getDeviceInfoVar.value.deviceOut.modelAttr;
return rec;
}(), callContext);
} else {
// Execute Action: Log_DeviceInfoError
OS.SystemActions.logMessage(((("DeviceManagement > RegisterDevice - CheckDevicePlugin not available Error: " + checkDevicePluginVar.value.errorOut.errorCodeAttr) + " ErrorMessage: ") + checkDevicePluginVar.value.errorOut.errorMessageAttr), "DeviceManage", callContext);
OS.FeedbackMessageService.showFeedbackMessage("Something went wrong", /*Error*/ 3);
}

});
} else {
// Execute Action: Log_KeystoreError
OS.SystemActions.logMessage(((("DeviceManagement > RegisterDevice - Get_DeviceId ErrorCode: " + getDeviceIdVar.value.errorOut.errorCodeAttr) + " ErrorMessage: ") + getDeviceIdVar.value.errorOut.errorMessageAttr), "DeviceManage", callContext);
OS.FeedbackMessageService.showFeedbackMessage("Something went wrong", /*Error*/ 3);
}

});
});
}).then(function () {
return ;
});
};
var controller = Brazil_DeviceManagement_MUIController.default;
Brazil_DeviceManagement_MUIController.default.clientActionProxies.registerDevice$Action = function () {
return controller.executeActionInsideJSNode(Brazil_DeviceManagement_MUIController.default.registerDevice$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_DeviceManagement_MUI.controller$Remove_DeviceId", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_DeviceManagement_MUI.model", "Brazil_DeviceManagement_MUI.controller", "CommonPlugin.model", "KeyStorePlugin.controller", "Brazil_Common_MBL.controller", "Brazil_DeviceManagement_MUI.clientVariables", "CommonPlugin.model$ErrorRec", "Brazil_DeviceManagement_MUI.referencesHealth", "Brazil_DeviceManagement_MUI.referencesHealth$CommonPlugin", "KeyStorePlugin.controller$RemoveKey", "Brazil_DeviceManagement_MUI.referencesHealth$KeyStorePlugin", "Brazil_Common_MBL.controller$CheckSecureStorageAvailable", "Brazil_DeviceManagement_MUI.referencesHealth$Brazil_Common_MBL"], function (exports, OutSystems, Brazil_DeviceManagement_MUIModel, Brazil_DeviceManagement_MUIController, CommonPluginModel, KeyStorePluginController, Brazil_Common_MBLController, Brazil_DeviceManagement_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_DeviceManagement_MUIController.default.remove_DeviceId$Action = function (callContext) {
callContext = controller.callContext(callContext);
var removeDeviceIdVar = new OS.DataTypes.VariableHolder();
var checkSecureStorageAvailableVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_DeviceManagement_MUI.Remove_DeviceId$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: CheckSecureStorageAvailable
return Brazil_Common_MBLController.default.checkSecureStorageAvailable$Action(callContext).then(function (value) {
checkSecureStorageAvailableVar.value = value;
}).then(function () {
return OS.Flow.executeSequence(function () {
if((checkSecureStorageAvailableVar.value.isSecureStorageAvailableOut)) {
// Execute Action: RemoveDeviceId
return KeyStorePluginController.default.removeKey$Action("WU.Brazil.Secure.Storage", "deviceId", callContext).then(function (value) {
removeDeviceIdVar.value = value;
}).then(function () {
if((removeDeviceIdVar.value.successOut)) {
// Outputs
// Success = True
outVars.value.successOut = true;
} else {
// Error outputs
// Error = RemoveDeviceId.Error
outVars.value.errorOut = removeDeviceIdVar.value.errorOut;
// Success = False
outVars.value.successOut = false;
}

});
} else {
// Error outputs
// Error = CheckSecureStorageAvailable.Error
outVars.value.errorOut = checkSecureStorageAvailableVar.value.errorOut;
// Success = False
outVars.value.successOut = false;
}

});
});
}).then(function () {
return outVars.value;
});
};
var controller = Brazil_DeviceManagement_MUIController.default;
Brazil_DeviceManagement_MUIController.default.constructor.registerVariableGroupType("Brazil_DeviceManagement_MUI.Remove_DeviceId$outVars", [{
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}, {
name: "Success",
attrName: "successOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
Brazil_DeviceManagement_MUIController.default.clientActionProxies.remove_DeviceId$Action = function () {
return controller.executeActionInsideJSNode(Brazil_DeviceManagement_MUIController.default.remove_DeviceId$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Error: actionResults.errorOut,
Success: OS.DataConversion.JSNodeParamConverter.to(actionResults.successOut, OS.Types.Boolean)
};
});
};
});

define("Brazil_DeviceManagement_MUI.controller$RemoveDevice", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_DeviceManagement_MUI.model", "Brazil_DeviceManagement_MUI.controller", "Brazil_DeviceManagement_MUI.clientVariables", "Brazil_DeviceManagement_MUI.controller$ServerAction.UpdateDeviceStatus_BL"], function (exports, OutSystems, Brazil_DeviceManagement_MUIModel, Brazil_DeviceManagement_MUIController, Brazil_DeviceManagement_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_DeviceManagement_MUIController.default.removeDevice$Action = function (callContext) {
callContext = controller.callContext(callContext);
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: LogMessage
OS.SystemActions.logMessage("DeviceManagement > RemoveDevice - Run", "DeviceManage", callContext);
// Execute Action: UpdateDeviceStatus_BL
return controller.updateDeviceStatus_BL$ServerAction(Brazil_DeviceManagement_MUIModel.staticEntities.availableDeviceStatuses.inactive, callContext);
}).then(function () {
return ;
});
};
var controller = Brazil_DeviceManagement_MUIController.default;
Brazil_DeviceManagement_MUIController.default.clientActionProxies.removeDevice$Action = function () {
return controller.executeActionInsideJSNode(Brazil_DeviceManagement_MUIController.default.removeDevice$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_DeviceManagement_MUI.controller$SetDeviceId", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_DeviceManagement_MUI.model", "Brazil_DeviceManagement_MUI.controller", "CommonPlugin.model", "Brazil_Common_MBL.controller", "KeyStorePlugin.controller", "Brazil_DeviceManagement_MUI.clientVariables", "CommonPlugin.model$ErrorRec", "Brazil_DeviceManagement_MUI.referencesHealth", "Brazil_DeviceManagement_MUI.referencesHealth$CommonPlugin", "Brazil_Common_MBL.controller$CheckSecureStorageAvailable", "Brazil_DeviceManagement_MUI.referencesHealth$Brazil_Common_MBL", "KeyStorePlugin.controller$SetValue", "Brazil_DeviceManagement_MUI.referencesHealth$KeyStorePlugin"], function (exports, OutSystems, Brazil_DeviceManagement_MUIModel, Brazil_DeviceManagement_MUIController, CommonPluginModel, Brazil_Common_MBLController, KeyStorePluginController, Brazil_DeviceManagement_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_DeviceManagement_MUIController.default.setDeviceId$Action = function (deviceIdIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_DeviceManagement_MUI.SetDeviceId$vars"))());
vars.value.deviceIdInLocal = deviceIdIn;
var checkSecureStorageAvailableVar = new OS.DataTypes.VariableHolder();
var setValuePasscodeVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_DeviceManagement_MUI.SetDeviceId$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: CheckSecureStorageAvailable
return Brazil_Common_MBLController.default.checkSecureStorageAvailable$Action(callContext).then(function (value) {
checkSecureStorageAvailableVar.value = value;
}).then(function () {
// Is Plugin Available?
return OS.Flow.executeSequence(function () {
if((checkSecureStorageAvailableVar.value.isSecureStorageAvailableOut)) {
// Execute Action: SetValuePasscode
return KeyStorePluginController.default.setValue$Action("WU.Brazil.Secure.Storage", "deviceId", vars.value.deviceIdInLocal, false, callContext).then(function (value) {
setValuePasscodeVar.value = value;
}).then(function () {
if((setValuePasscodeVar.value.successOut)) {
// Outputs
// Success = True
outVars.value.successOut = true;
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
} else {
// Error outputs
// Success = False
outVars.value.successOut = false;
// Error = SetValuePasscode.Error
outVars.value.errorOut = setValuePasscodeVar.value.errorOut;
}

});
} else {
// Error outputs
// Success = False
outVars.value.successOut = false;
// Error = CheckSecureStorageAvailable.Error
outVars.value.errorOut = checkSecureStorageAvailableVar.value.errorOut;
}

});
});
}).then(function () {
return outVars.value;
});
};
var controller = Brazil_DeviceManagement_MUIController.default;
Brazil_DeviceManagement_MUIController.default.constructor.registerVariableGroupType("Brazil_DeviceManagement_MUI.SetDeviceId$vars", [{
name: "DeviceId",
attrName: "deviceIdInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_DeviceManagement_MUIController.default.constructor.registerVariableGroupType("Brazil_DeviceManagement_MUI.SetDeviceId$outVars", [{
name: "Success",
attrName: "successOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}]);
Brazil_DeviceManagement_MUIController.default.clientActionProxies.setDeviceId$Action = function (deviceIdIn) {
deviceIdIn = (deviceIdIn === undefined) ? "" : deviceIdIn;
return controller.executeActionInsideJSNode(Brazil_DeviceManagement_MUIController.default.setDeviceId$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(deviceIdIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Success: OS.DataConversion.JSNodeParamConverter.to(actionResults.successOut, OS.Types.Boolean),
Error: actionResults.errorOut
};
});
};
});

define("Brazil_DeviceManagement_MUI.controller$UnblockDevice", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_DeviceManagement_MUI.model", "Brazil_DeviceManagement_MUI.controller", "Brazil_DeviceManagement_MUI.clientVariables", "Brazil_DeviceManagement_MUI.controller$ServerAction.UpdateDeviceStatus_BL"], function (exports, OutSystems, Brazil_DeviceManagement_MUIModel, Brazil_DeviceManagement_MUIController, Brazil_DeviceManagement_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_DeviceManagement_MUIController.default.unblockDevice$Action = function (callContext) {
callContext = controller.callContext(callContext);
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: LogMessage
OS.SystemActions.logMessage("DeviceManagement > UnblockDevice - Run", "DeviceManage", callContext);
// Execute Action: UpdateDeviceStatus_BL
return controller.updateDeviceStatus_BL$ServerAction(Brazil_DeviceManagement_MUIModel.staticEntities.availableDeviceStatuses.active, callContext);
}).then(function () {
return ;
});
};
var controller = Brazil_DeviceManagement_MUIController.default;
Brazil_DeviceManagement_MUIController.default.clientActionProxies.unblockDevice$Action = function () {
return controller.executeActionInsideJSNode(Brazil_DeviceManagement_MUIController.default.unblockDevice$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_DeviceManagement_MUI.controller$ServerAction.RegisterDevice_BL", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_DeviceManagement_MUI.model", "Brazil_DeviceManagement_MUI.controller"], function (exports, OutSystems, Brazil_DeviceManagement_MUIModel, Brazil_DeviceManagement_MUIController) {
var OS = OutSystems.Internal;
Brazil_DeviceManagement_MUIController.default.registerDevice_BL$ServerAction = function (deviceInfoIn, callContext) {
var controller = this.controller;
var inputs = {
DeviceInfo: OS.DataConversion.ServerDataConverter.to(deviceInfoIn, OS.Types.Record)
};
return controller.callServerAction("RegisterDevice_BL", "screenservices/Brazil_DeviceManagement_MUI/ActionRegisterDevice_BL", "g7Cf6qPHKKZ86QsUTw+H8g", inputs, controller.callContext(callContext), undefined, undefined, true).then(function (outputs) {
});
};
});
define("Brazil_DeviceManagement_MUI.controller$ServerAction.UpdateDeviceStatus_BL", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_DeviceManagement_MUI.model", "Brazil_DeviceManagement_MUI.controller"], function (exports, OutSystems, Brazil_DeviceManagement_MUIModel, Brazil_DeviceManagement_MUIController) {
var OS = OutSystems.Internal;
Brazil_DeviceManagement_MUIController.default.updateDeviceStatus_BL$ServerAction = function (statusIn, callContext) {
var controller = this.controller;
var inputs = {
Status: OS.DataConversion.ServerDataConverter.to(statusIn, OS.Types.Integer)
};
return controller.callServerAction("UpdateDeviceStatus_BL", "screenservices/Brazil_DeviceManagement_MUI/ActionUpdateDeviceStatus_BL", "KQaVdbGhl8Hxg0+emVDEpg", inputs, controller.callContext(callContext), undefined, undefined, true).then(function (outputs) {
});
};
});
define("Brazil_DeviceManagement_MUI.controller", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_DeviceManagement_MUI.model", "Brazil_DeviceManagement_MUI.controller$translationsResources"], function (exports, OutSystems, Brazil_DeviceManagement_MUIModel, Brazil_DeviceManagement_MUI_Controller_translationsResources) {
var OS = OutSystems.Internal;
var Brazil_DeviceManagement_MUIController = exports;
var Controller = (function (_super) {
__extends(Controller, _super);
function Controller() {
_super.apply(this, arguments);
}
Controller.prototype.clientActionProxies = {};
Controller.prototype.roles = {};
Controller.prototype.defaultTimeout = 300;
Controller.prototype.getDefaultTimeout = function () {
return Brazil_DeviceManagement_MUIController.default.defaultTimeout;
};
return Controller;
})(OS.Controller.BaseModuleController);
Brazil_DeviceManagement_MUIController.default = new Controller(Brazil_DeviceManagement_MUI_Controller_translationsResources, "Brazil_DeviceManagement_MUI");
});
define("Brazil_DeviceManagement_MUI.controller$translationsResources", ["exports", "Brazil_DeviceManagement_MUI.controller$translationsResources.es-419", "Brazil_DeviceManagement_MUI.controller$translationsResources.pt-BR"], function (exports, Brazil_DeviceManagement_MUI_controller_translationsResources_es419, Brazil_DeviceManagement_MUI_controller_translationsResources_ptBR) {
return {
"es-419": {
"translations": Brazil_DeviceManagement_MUI_controller_translationsResources_es419,
"isRTL": false
},
"pt-BR": {
"translations": Brazil_DeviceManagement_MUI_controller_translationsResources_ptBR,
"isRTL": false
}
};
});
define("Brazil_DeviceManagement_MUI.controller$translationsResources.es-419", [], function () {
return {
"fuDOs+73IU2pRpEdagYyLw#Value.-1843543304.1": "Tu dispositivo ya está registrado.  ¡Empieza a hacer Pix de forma segura!",
"f1O77l3Zrkq0tTC+bJyBwQ#Value.-1807319568.1": "Domingo",
"HyXq1P0bw0uVMQHir7XkXA#Value.687309357.1": "Martes",
"8PxBWiBUXUu59+lmPCTNGg#Value.-897468618.1": "Miércoles",
"NLMZQQkS7Ueyi4BuBFfOvA#Value.1636699642.1": "Jueves",
"A6niNQPZzEiql2_81_nP8Q#Value.2112549247.1": "Viernes",
"5uVnOPtGE0qMKej9f2E9FA#Value.-1984635600.1": "Lunes",
"pShGGUJ93UCzMo6BjQqFYg#Value.-2049557543.1": "Sábado"
};
});
define("Brazil_DeviceManagement_MUI.controller$translationsResources.pt-BR", [], function () {
return {
"fuDOs+73IU2pRpEdagYyLw#Value.-1843543304.1": "Seu dispositivo foi cadastrado. Comece a fazer Pix de forma segura!",
"f1O77l3Zrkq0tTC+bJyBwQ#Value.-1807319568.1": "Domingo",
"HyXq1P0bw0uVMQHir7XkXA#Value.687309357.1": "Terça-feira",
"8PxBWiBUXUu59+lmPCTNGg#Value.-897468618.1": "Quarta-feira",
"NLMZQQkS7Ueyi4BuBFfOvA#Value.1636699642.1": "Quinta-feira",
"A6niNQPZzEiql2_81_nP8Q#Value.2112549247.1": "Sexta-feira",
"5uVnOPtGE0qMKej9f2E9FA#Value.-1984635600.1": "Segunda-feira",
"pShGGUJ93UCzMo6BjQqFYg#Value.-2049557543.1": "Sábado"
};
});
