﻿function InputToView() {
    
    var inputFocus;
    var isFocus;
    
    var onFocusEvent = function () {
        inputFocus = event.target;
        isFocus = true;
                    
        setTimeout(function(){ 
            var mainElement = document.querySelector('.main');
            var layout = document.querySelector('.layout');
            if(mainElement !== undefined && layout !== null) {
                document.querySelector('.main').scrollTo(0, mainElement.scrollTop + inputFocus.getBoundingClientRect().top - window.innerHeight + 48 + 72);
            } 
        }, 300);
    }
    
    var onFocus = function () {

        var inputArray= document.querySelectorAll('input.form-control');
        
        [].map.call(inputArray, function(obj) {
        
            if(!obj.closest(".action-sheet-container")){
                
                obj.removeEventListener('focus', onFocusEvent, false);
                obj.addEventListener('focus', onFocusEvent, false);
        
            }
        });
        
        var observer = new MutationObserver(function() {
            document.querySelectorAll('input').forEach(function(e) {
                e.removeEventListener('focus', onFocusEvent, false);
                e.addEventListener('focus', onFocusEvent, false);
            });
        });
        
        var layout = document.querySelector('.layout');
        if(layout !== null) {
            observer.observe(document.querySelector('.layout'), {
                childList: true, subtree: true
            });
        }

    };
    
    var addEventListeners = function () {

       window.addEventListener('resize', function() {
            if(isFocus){
                var mainElement = document.querySelector('.main');
                if(mainElement !== undefined) {
                    var scroll = mainElement.scrollTop + inputFocus.getBoundingClientRect().top  - window.innerHeight + document.querySelector('.footer').offsetHeight + 72;
                
                    if(window.innerHeight < inputFocus.getBoundingClientRect().top + 44){
                        document.querySelector('.main').scrollTo(0, scroll); 
                    }
                    isFocus = false;
                }
            }
        });

    };
    

    return {
        init: function() {
            onFocus();
            addEventListeners();
        },
        update: function() {
            onFocus();
        }
    };

}