﻿define("Brazil_OfflineStorage.controller$CreateOrUpdateLocalSettings", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_OfflineStorage.model", "Brazil_OfflineStorage.controller", "Brazil_OfflineStorage.entities", "Brazil_OfflineStorage.model$SettingsRecord", "Brazil_OfflineStorage.model$SettingsRec"], function (exports, OutSystems, Brazil_OfflineStorageModel, Brazil_OfflineStorageController, Brazil_OfflineStorageEntities) {
var OS = OutSystems.Internal;
Brazil_OfflineStorageController.default.createOrUpdateLocalSettings$Action = function (settingsIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_OfflineStorage.CreateOrUpdateLocalSettings$vars"))());
vars.value.settingsInLocal = settingsIn.clone();
var createOrUpdateSettingsVar = new OS.DataTypes.VariableHolder();
var jSONSerialize1Var = new OS.DataTypes.VariableHolder(new OS.DataTypes.JSONSerializeOutputType());
return OS.Flow.executeAsyncFlow(function () {
// JSON Serialize: JSONSerialize1
jSONSerialize1Var.value.jSONOut = OS.JSONUtils.serializeToJSON(vars.value.settingsInLocal, false, false);
// Execute Action: LogMessage
OS.SystemActions.logMessage(jSONSerialize1Var.value.jSONOut, "Local_Storage", callContext);
// Execute Action: CreateOrUpdateSettings
return Brazil_OfflineStorageModel.entities.Settings.createOrUpdate(Brazil_OfflineStorageModel.SettingsRecord.fromStructure(vars.value.settingsInLocal), callContext).then(function (value) {
createOrUpdateSettingsVar.value = value;
});
}).then(function () {
return ;
});
};
var controller = Brazil_OfflineStorageController.default;
Brazil_OfflineStorageController.default.constructor.registerVariableGroupType("Brazil_OfflineStorage.CreateOrUpdateLocalSettings$vars", [{
name: "Settings",
attrName: "settingsInLocal",
mandatory: true,
dataType: OS.Types.Record,
defaultValue: function () {
return new Brazil_OfflineStorageModel.SettingsRec();
},
complexType: Brazil_OfflineStorageModel.SettingsRec
}]);
Brazil_OfflineStorageController.default.clientActionProxies.createOrUpdateLocalSettings$Action = function (settingsIn) {
settingsIn = (settingsIn === undefined) ? new Brazil_OfflineStorageModel.SettingsRec() : settingsIn;
return controller.executeActionInsideJSNode(Brazil_OfflineStorageController.default.createOrUpdateLocalSettings$Action.bind(controller, settingsIn), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_OfflineStorage.controller$SyncLocalDeeplinkAllowedPages", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_OfflineStorage.model", "Brazil_OfflineStorage.controller", "Brazil_OfflineStorage.entities", "Brazil_OfflineStorage.model$LocalDeeplinkAllowedPageRecordList", "Brazil_OfflineStorage.model$LocalDeeplinkAllowedPageList", "Brazil_OfflineStorage.controller$ServerAction.SyncDeeplinkAllowedPages", "Brazil_OfflineStorage.model$DateRecordList", "Brazil_OfflineStorage.model$LocalDeeplinkAllowedPageRec"], function (exports, OutSystems, Brazil_OfflineStorageModel, Brazil_OfflineStorageController, Brazil_OfflineStorageEntities) {
var OS = OutSystems.Internal;
Brazil_OfflineStorageController.default.syncLocalDeeplinkAllowedPages$Action = function (callContext) {
callContext = controller.callContext(callContext);
var syncDeeplinkAllowedPagesVar = new OS.DataTypes.VariableHolder();
var getLastUpdatedAtVar = new OS.DataTypes.VariableHolder(new (OS.Controller.BaseController.getAggregateOutputType(Brazil_OfflineStorageModel.DateRecordList))());
return OS.Flow.executeAsyncFlow(function () {
// Aggregate: GetLastUpdatedAt
var getLastUpdatedAtAggr = function (maxRecords) {
var executeQuery = null;
if(OS.NativeHelper.isRunningOnNative()) {
executeQuery = function () {
var targetListType = Brazil_OfflineStorageModel.DateRecordList;
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var countArgsList = new OS.Entities.QueryArgumentsList();
if(!(maxRecords)) {
maxRecords = 1;
}


var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "Max(\"ENLocalDeeplinkAllowedPage\".\"LastUpdatedAt\") \"LastUpdatedAtMax\"";
} else {
selectSql += "Max(\"ENLocalDeeplinkAllowedPage\".\"LastUpdatedAt\") \"LastUpdatedAtMax\"";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_9k2_LocalDeeplinkAllowedPage\" \"ENLocalDeeplinkAllowedPage\"";
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

return OS.Entities.webSQLStorageInstance.executeQuery(sql, Brazil_OfflineStorageModel.DateRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"lastUpdatedAtMaxAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

}, argsList).then(function (resultList) {
result.list = resultList;
}).then(function () {
}).then(function () {
return result;
});
};
} else {
executeQuery = function () {
if(!(maxRecords)) {
maxRecords = 1;
}

return new Promise(function (resolve, reject) {
require(["Brazil_OfflineStorage.aggregates.IDB"], function (Brazil_OfflineStorageAggregates_IDB) {
return Brazil_OfflineStorageAggregates_IDB.executeSyncLocalDeeplinkAllowedPages$ClientAction$getLastUpdatedAtAggr(maxRecords).then(function (result) {
resolve(result);
}).catch(function (e) {
reject(e);
});
});
});
};
}

return controller.executeClientAggregate(executeQuery, function () {
return getLastUpdatedAtVar.value;
});
};
return getLastUpdatedAtAggr().then(function () {
// Execute Action: SyncDeeplinkAllowedPages
return controller.syncDeeplinkAllowedPages$ServerAction(getLastUpdatedAtVar.value.listOut.getCurrent(callContext.iterationContext).lastUpdatedAtMaxAttr, callContext).then(function (value) {
syncDeeplinkAllowedPagesVar.value = value;
});
}).then(function () {
// Has records to sync?
return OS.Flow.executeSequence(function () {
if((!(syncDeeplinkAllowedPagesVar.value.localDeeplinkAllowedPagesOut.isEmpty))) {
// Execute Action: CreateOrUpdateSomeLocalDeeplinkAllowedPage
return Brazil_OfflineStorageModel.entities.LocalDeeplinkAllowedPage.createOrUpdateAll(OS.DataConversion.JSConversions.typeConvertRecordList(syncDeeplinkAllowedPagesVar.value.localDeeplinkAllowedPagesOut, new Brazil_OfflineStorageModel.LocalDeeplinkAllowedPageRecordList(), function (source, target) {
target = Brazil_OfflineStorageModel.LocalDeeplinkAllowedPageRecord.fromStructure(source);
return target;
}), callContext);
}

});
});
}).then(function () {
return ;
});
};
var controller = Brazil_OfflineStorageController.default;
Brazil_OfflineStorageController.default.clientActionProxies.syncLocalDeeplinkAllowedPages$Action = function () {
return controller.executeActionInsideJSNode(Brazil_OfflineStorageController.default.syncLocalDeeplinkAllowedPages$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_OfflineStorage.controller$ServerAction.SyncDeeplinkAllowedPages", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_OfflineStorage.model", "Brazil_OfflineStorage.controller", "Brazil_OfflineStorage.model$LocalDeeplinkAllowedPageList"], function (exports, OutSystems, Brazil_OfflineStorageModel, Brazil_OfflineStorageController) {
var OS = OutSystems.Internal;
Brazil_OfflineStorageController.default.syncDeeplinkAllowedPages$ServerAction = function (lastUpdatedAtIn, callContext) {
var controller = this.controller;
var inputs = {
LastUpdatedAt: OS.DataConversion.ServerDataConverter.to(lastUpdatedAtIn, OS.Types.Date)
};
return controller.callServerAction("SyncDeeplinkAllowedPages", "screenservices/Brazil_OfflineStorage/ActionSyncDeeplinkAllowedPages", "xDc0BIVxXcM30UNAhlWdQQ", inputs, controller.callContext(callContext), undefined, undefined, false).then(function (outputs) {
var executeServerActionResult = new (controller.constructor.getVariableGroupType("Brazil_OfflineStorage$ActionSyncDeeplinkAllowedPages"))();
executeServerActionResult.localDeeplinkAllowedPagesOut = OS.DataConversion.ServerDataConverter.from(outputs.LocalDeeplinkAllowedPages, Brazil_OfflineStorageModel.LocalDeeplinkAllowedPageList);
return executeServerActionResult;
});
};
Brazil_OfflineStorageController.default.constructor.registerVariableGroupType("Brazil_OfflineStorage$ActionSyncDeeplinkAllowedPages", [{
name: "LocalDeeplinkAllowedPages",
attrName: "localDeeplinkAllowedPagesOut",
mandatory: false,
dataType: OS.Types.RecordList,
defaultValue: function () {
return new Brazil_OfflineStorageModel.LocalDeeplinkAllowedPageList();
},
complexType: Brazil_OfflineStorageModel.LocalDeeplinkAllowedPageList
}]);
});
define("Brazil_OfflineStorage.controller", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_OfflineStorage.model"], function (exports, OutSystems, Brazil_OfflineStorageModel) {
var OS = OutSystems.Internal;
var Brazil_OfflineStorageController = exports;
var Controller = (function (_super) {
__extends(Controller, _super);
function Controller() {
_super.apply(this, arguments);
}
Controller.prototype.clientActionProxies = {};
Controller.prototype.roles = {};
Controller.prototype.defaultTimeout = 10;
Controller.prototype.getDefaultTimeout = function () {
return Brazil_OfflineStorageController.default.defaultTimeout;
};
return Controller;
})(OS.Controller.BaseModuleController);
Brazil_OfflineStorageController.default = new Controller(null, "Brazil_OfflineStorage");
});
