﻿define("Brazil_OfflineStorage.entities", ["OutSystems/ClientRuntime/Main", "Brazil_OfflineStorage.model", "Brazil_OfflineStorage.model$LocalDeeplinkAllowedPageRecord", "Brazil_OfflineStorage.model$SettingsRecord"], function (OutSystems, Brazil_OfflineStorageModel) {
var OS = OutSystems.Internal;
var moduleKey = "ef990384-dbb4-480b-bf20-88c7d3213b83";
var infoLocalDeeplinkAllowedPage = {
key: "96b32df6-e4eb-4a1e-8c3f-8cee17c1a2e1",
moduleKey: moduleKey,
name: "LocalDeeplinkAllowedPage",
implicitAnonymousType: Brazil_OfflineStorageModel.LocalDeeplinkAllowedPageRecord,
tableName: "OSUSR_9K2_LOCALDEEPLINKALLOWEDPAGE",
attributes: [{
name: "Id",
columnName: "ID",
type: /*INTEGER*/ 3,
isEntityReference: true,
isPrimaryKey: true
}, {
name: "Page",
columnName: "PAGE",
type: /*TEXT*/ 0,
length: 50,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_LOCALDEEPLINKALLOWEDPAGE\" ADD \"Page\" TEXT(50) DEFAULT \'\'"
}
}, {
name: "LastUpdatedAt",
columnName: "LASTUPDATEDAT",
type: /*DATE*/ 7,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_LOCALDEEPLINKALLOWEDPAGE\" ADD \"LastUpdatedAt\" DATETIME DEFAULT \'1900-01-01 00:00:00\'"
}
}],
idIsAutoNumber: /*No*/ 0,
getIdAttribute: function () {
return this.attributes[0];
},
hash: "64da1019-39a9-35cc-2585-782a0fe2d7c9",
dbRecordToRecord: function (dbRecord) {
return new Brazil_OfflineStorageModel.LocalDeeplinkAllowedPageRecord(OS.DataConversion.LocalStorageConverter.from(dbRecord, Brazil_OfflineStorageModel.LocalDeeplinkAllowedPageRecord, {
value: 0
}));
},
createTable: {
sql: "CREATE TABLE \"MAIN\".\"OSUSR_9K2_LOCALDEEPLINKALLOWEDPAGE\" (\"Id\" INTEGER PRIMARY KEY NOT NULL, \"Page\" TEXT(50) DEFAULT \'\', \"LastUpdatedAt\" DATETIME DEFAULT \'1900-01-01 00:00:00\')"
},
select: {
sql: "SELECT \"Id\" o0, \"Page\" o1, \"LastUpdatedAt\" o2 FROM \"OSUSR_9K2_LOCALDEEPLINKALLOWEDPAGE\" WHERE \"Id\" = ?"
},
insert: {
sql: "INSERT INTO \"OSUSR_9K2_LOCALDEEPLINKALLOWEDPAGE\" (\"Id\", \"Page\", \"LastUpdatedAt\") VALUES (?, ?, ?)",
getArguments: function (record) {
var obj = record.localDeeplinkAllowedPageAttr;
var argsList = new OS.Entities.QueryArgumentsList();
argsList.add("Id", /*INTEGER*/ 3, obj.idAttr, null, null, true);
argsList.add("Page", /*TEXT*/ 0, obj.pageAttr);
argsList.add("LastUpdatedAt", /*DATE*/ 7, obj.lastUpdatedAtAttr);

return argsList;
}
},
upsert: {
sql: "INSERT OR REPLACE INTO \"OSUSR_9K2_LOCALDEEPLINKALLOWEDPAGE\" (\"Id\", \"Page\", \"LastUpdatedAt\") VALUES (?, ?, ?)",
getArguments: function (record) {
var obj = record.localDeeplinkAllowedPageAttr;
var argsList = new OS.Entities.QueryArgumentsList();
argsList.add("Id", /*INTEGER*/ 3, obj.idAttr, null, null, true);
argsList.add("Page", /*TEXT*/ 0, obj.pageAttr);
argsList.add("LastUpdatedAt", /*DATE*/ 7, obj.lastUpdatedAtAttr);

return argsList;
},
getBulkSql: function (recordCount) {
return OS.ObjectExtensions.concatenateMultipleTimes(this.sql, ",(?,?,?)", (recordCount - 1));
}
},
update: {
sql: "UPDATE \"OSUSR_9K2_LOCALDEEPLINKALLOWEDPAGE\" SET \"Page\" = ?, \"LastUpdatedAt\" = ? WHERE \"Id\" = ?",
getArguments: function (record) {
var obj = record.localDeeplinkAllowedPageAttr;
var argsList = new OS.Entities.QueryArgumentsList();
argsList.add("Page", /*TEXT*/ 0, obj.pageAttr);
argsList.add("LastUpdatedAt", /*DATE*/ 7, obj.lastUpdatedAtAttr);
argsList.add("Id", /*INTEGER*/ 3, obj.idAttr, null, null, true);

return argsList;
}
},
delete: {
sql: "DELETE FROM \"OSUSR_9K2_LOCALDEEPLINKALLOWEDPAGE\" WHERE \"Id\" = ?"
},
deleteAll: {
sql: "DELETE FROM \"OSUSR_9K2_LOCALDEEPLINKALLOWEDPAGE\""
},
getAllAttributesFromRecord: function (record) {
var obj = record.localDeeplinkAllowedPageAttr;
var argsList = new OS.Entities.QueryArgumentsList();
argsList.add("Id", /*INTEGER*/ 3, obj.idAttr, null, null, true);
argsList.add("Page", /*TEXT*/ 0, obj.pageAttr);
argsList.add("LastUpdatedAt", /*DATE*/ 7, obj.lastUpdatedAtAttr);

return argsList;
},
hasNullId: function (record) {
var obj = record.localDeeplinkAllowedPageAttr;
return false;

},
getIdFromRecord: function (record) {
var obj = record.localDeeplinkAllowedPageAttr;
return obj.idAttr;

}
};
var infoSettings = {
key: "c3486011-eb75-4457-8e15-21cf2d318bdf",
moduleKey: moduleKey,
name: "Settings",
implicitAnonymousType: Brazil_OfflineStorageModel.SettingsRecord,
tableName: "OSUSR_9K2_SETTINGS",
attributes: [{
name: "Id",
columnName: "ID",
type: /*LONGINTEGER*/ 4,
isPrimaryKey: true
}, {
name: "Email",
columnName: "EMAIL",
type: /*TEXT*/ 0,
length: 250,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" ADD \"Email\" TEXT(250) DEFAULT \'\'"
}
}, {
name: "LoginBiometrics",
columnName: "LOGINBIOMETRICS",
type: /*BOOLEAN*/ 2,
default: false,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" ADD \"LoginBiometrics\" BOOLEAN DEFAULT 0"
}
}, {
name: "IsBioMaybeLater",
columnName: "ISBIOMAYBELATER",
type: /*BOOLEAN*/ 2,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" ADD \"IsBioMaybeLater\" BOOLEAN DEFAULT 0"
}
}, {
name: "IsPasscodeOnDevice",
columnName: "ISPASSCODEONDEVICE",
type: /*BOOLEAN*/ 2,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" ADD \"IsPasscodeOnDevice\" BOOLEAN DEFAULT 0"
}
}, {
name: "LoginAttemptsCount",
columnName: "LOGINATTEMPTSCOUNT",
type: /*INTEGER*/ 3,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" ADD \"LoginAttemptsCount\" INTEGER DEFAULT 0"
}
}, {
name: "HasOnbardingDone",
columnName: "HASONBARDINGDONE",
type: /*BOOLEAN*/ 2,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" ADD \"HasOnbardingDone\" BOOLEAN DEFAULT 0"
}
}, {
name: "AppLanguage",
columnName: "APPLANGUAGE",
type: /*TEXT*/ 0,
length: 6,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" ADD \"AppLanguage\" TEXT(6) DEFAULT \'\'"
}
}, {
name: "HasGivenAccessCode",
columnName: "HASGIVENACCESSCODE",
type: /*BOOLEAN*/ 2,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" ADD \"HasGivenAccessCode\" BOOLEAN DEFAULT 0"
}
}, {
name: "LastLogin",
columnName: "LASTLOGIN",
type: /*DATE_TIME*/ 6,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" ADD \"LastLogin\" DATETIME DEFAULT \'1900-01-01 00:00:00\'"
}
}, {
name: "TemporaryIsNotifications",
columnName: "TEMPORARYISNOTIFICATIONS",
type: /*BOOLEAN*/ 2,
default: false,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" ADD \"TemporaryIsNotifications\" BOOLEAN DEFAULT 0"
}
}, {
name: "IsCameraDenied",
columnName: "ISCAMERADENIED",
type: /*BOOLEAN*/ 2,
default: false,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" ADD \"IsCameraDenied\" BOOLEAN DEFAULT 0"
}
}, {
name: "BiometricAttempts",
columnName: "BIOMETRICATTEMPTS",
type: /*INTEGER*/ 3,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" ADD \"BiometricAttempts\" INTEGER DEFAULT 0"
}
}, {
name: "DontShowAgain",
columnName: "DONTSHOWAGAIN",
type: /*BOOLEAN*/ 2,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" ADD \"DontShowAgain\" BOOLEAN DEFAULT 0"
}
}, {
name: "PingSessionId",
columnName: "PINGSESSIONID",
type: /*TEXT*/ 0,
length: 50,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" ADD \"PingSessionId\" TEXT(50) DEFAULT \'\'"
}
}, {
name: "WalletComplianceVersion",
columnName: "WALLETCOMPLIANCEVERSION",
type: /*TEXT*/ 0,
default: "BR_1.1",
length: 50,
addColumn: {
sql: "ALTER TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" ADD \"WalletComplianceVersion\" TEXT(50) DEFAULT \'\'"
}
}],
idIsAutoNumber: /*YesIfEmpty*/ 2,
getIdAttribute: function () {
return this.attributes[0];
},
hash: "05143594-ec75-e481-8b65-36b7e7f15e4e",
dbRecordToRecord: function (dbRecord) {
return new Brazil_OfflineStorageModel.SettingsRecord(OS.DataConversion.LocalStorageConverter.from(dbRecord, Brazil_OfflineStorageModel.SettingsRecord, {
value: 0
}));
},
createTable: {
sql: "CREATE TABLE \"MAIN\".\"OSUSR_9K2_SETTINGS\" (\"Id\" INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, \"Email\" TEXT(250) DEFAULT \'\', \"LoginBiometrics\" BOOLEAN DEFAULT 0, \"IsBioMaybeLater\" BOOLEAN DEFAULT 0, \"IsPasscodeOnDevice\" BOOLEAN DEFAULT 0, \"LoginAttemptsCount\" INTEGER DEFAULT 0, \"HasOnbardingDone\" BOOLEAN DEFAULT 0, \"AppLanguage\" TEXT(6) DEFAULT \'\', \"HasGivenAccessCode\" BOOLEAN DEFAULT 0, \"LastLogin\" DATETIME DEFAULT \'1900-01-01 00:00:00\', \"TemporaryIsNotifications\" BOOLEAN DEFAULT 0, \"IsCameraDenied\" BOOLEAN DEFAULT 0, \"BiometricAttempts\" INTEGER DEFAULT 0, \"DontShowAgain\" BOOLEAN DEFAULT 0, \"PingSessionId\" TEXT(50) DEFAULT \'\', \"WalletComplianceVersion\" TEXT(50) DEFAULT \'\')"
},
select: {
sql: "SELECT \"Id\" o0, \"Email\" o1, \"LoginBiometrics\" o2, \"IsBioMaybeLater\" o3, \"IsPasscodeOnDevice\" o4, \"LoginAttemptsCount\" o5, \"HasOnbardingDone\" o6, \"AppLanguage\" o7, \"HasGivenAccessCode\" o8, \"LastLogin\" o9, \"TemporaryIsNotifications\" o10, \"IsCameraDenied\" o11, \"BiometricAttempts\" o12, \"DontShowAgain\" o13, \"PingSessionId\" o14, \"WalletComplianceVersion\" o15 FROM \"OSUSR_9K2_SETTINGS\" WHERE \"Id\" = ?"
},
insert: {
sql: "INSERT INTO \"OSUSR_9K2_SETTINGS\" (\"Id\", \"Email\", \"LoginBiometrics\", \"IsBioMaybeLater\", \"IsPasscodeOnDevice\", \"LoginAttemptsCount\", \"HasOnbardingDone\", \"AppLanguage\", \"HasGivenAccessCode\", \"LastLogin\", \"TemporaryIsNotifications\", \"IsCameraDenied\", \"BiometricAttempts\", \"DontShowAgain\", \"PingSessionId\", \"WalletComplianceVersion\") VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)",
getArguments: function (record) {
var obj = record.settingsAttr;
var argsList = new OS.Entities.QueryArgumentsList();
argsList.add("Id", /*LONGINTEGER*/ 4, obj.idAttr.equals(OS.DataTypes.LongInteger.defaultValue) ? null : obj.idAttr);
argsList.add("Email", /*TEXT*/ 0, obj.emailAttr);
argsList.add("LoginBiometrics", /*BOOLEAN*/ 2, obj.loginBiometricsAttr);
argsList.add("IsBioMaybeLater", /*BOOLEAN*/ 2, obj.isBioMaybeLaterAttr);
argsList.add("IsPasscodeOnDevice", /*BOOLEAN*/ 2, obj.isPasscodeOnDeviceAttr);
argsList.add("LoginAttemptsCount", /*INTEGER*/ 3, obj.loginAttemptsCountAttr);
argsList.add("HasOnbardingDone", /*BOOLEAN*/ 2, obj.hasOnbardingDoneAttr);
argsList.add("AppLanguage", /*TEXT*/ 0, obj.appLanguageAttr);
argsList.add("HasGivenAccessCode", /*BOOLEAN*/ 2, obj.hasGivenAccessCodeAttr);
argsList.add("LastLogin", /*DATE_TIME*/ 6, obj.lastLoginAttr);
argsList.add("TemporaryIsNotifications", /*BOOLEAN*/ 2, obj.temporaryIsNotificationsAttr);
argsList.add("IsCameraDenied", /*BOOLEAN*/ 2, obj.isCameraDeniedAttr);
argsList.add("BiometricAttempts", /*INTEGER*/ 3, obj.biometricAttemptsAttr);
argsList.add("DontShowAgain", /*BOOLEAN*/ 2, obj.dontShowAgainAttr);
argsList.add("PingSessionId", /*TEXT*/ 0, obj.pingSessionIdAttr);
argsList.add("WalletComplianceVersion", /*TEXT*/ 0, obj.walletComplianceVersionAttr);

return argsList;
}
},
upsert: {
sql: "INSERT OR REPLACE INTO \"OSUSR_9K2_SETTINGS\" (\"Id\", \"Email\", \"LoginBiometrics\", \"IsBioMaybeLater\", \"IsPasscodeOnDevice\", \"LoginAttemptsCount\", \"HasOnbardingDone\", \"AppLanguage\", \"HasGivenAccessCode\", \"LastLogin\", \"TemporaryIsNotifications\", \"IsCameraDenied\", \"BiometricAttempts\", \"DontShowAgain\", \"PingSessionId\", \"WalletComplianceVersion\") VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)",
getArguments: function (record) {
var obj = record.settingsAttr;
var argsList = new OS.Entities.QueryArgumentsList();
argsList.add("Id", /*LONGINTEGER*/ 4, obj.idAttr.equals(OS.DataTypes.LongInteger.defaultValue) ? null : obj.idAttr);
argsList.add("Email", /*TEXT*/ 0, obj.emailAttr);
argsList.add("LoginBiometrics", /*BOOLEAN*/ 2, obj.loginBiometricsAttr);
argsList.add("IsBioMaybeLater", /*BOOLEAN*/ 2, obj.isBioMaybeLaterAttr);
argsList.add("IsPasscodeOnDevice", /*BOOLEAN*/ 2, obj.isPasscodeOnDeviceAttr);
argsList.add("LoginAttemptsCount", /*INTEGER*/ 3, obj.loginAttemptsCountAttr);
argsList.add("HasOnbardingDone", /*BOOLEAN*/ 2, obj.hasOnbardingDoneAttr);
argsList.add("AppLanguage", /*TEXT*/ 0, obj.appLanguageAttr);
argsList.add("HasGivenAccessCode", /*BOOLEAN*/ 2, obj.hasGivenAccessCodeAttr);
argsList.add("LastLogin", /*DATE_TIME*/ 6, obj.lastLoginAttr);
argsList.add("TemporaryIsNotifications", /*BOOLEAN*/ 2, obj.temporaryIsNotificationsAttr);
argsList.add("IsCameraDenied", /*BOOLEAN*/ 2, obj.isCameraDeniedAttr);
argsList.add("BiometricAttempts", /*INTEGER*/ 3, obj.biometricAttemptsAttr);
argsList.add("DontShowAgain", /*BOOLEAN*/ 2, obj.dontShowAgainAttr);
argsList.add("PingSessionId", /*TEXT*/ 0, obj.pingSessionIdAttr);
argsList.add("WalletComplianceVersion", /*TEXT*/ 0, obj.walletComplianceVersionAttr);

return argsList;
},
getBulkSql: function (recordCount) {
return OS.ObjectExtensions.concatenateMultipleTimes(this.sql, ",(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", (recordCount - 1));
}
},
update: {
sql: "UPDATE \"OSUSR_9K2_SETTINGS\" SET \"Email\" = ?, \"LoginBiometrics\" = ?, \"IsBioMaybeLater\" = ?, \"IsPasscodeOnDevice\" = ?, \"LoginAttemptsCount\" = ?, \"HasOnbardingDone\" = ?, \"AppLanguage\" = ?, \"HasGivenAccessCode\" = ?, \"LastLogin\" = ?, \"TemporaryIsNotifications\" = ?, \"IsCameraDenied\" = ?, \"BiometricAttempts\" = ?, \"DontShowAgain\" = ?, \"PingSessionId\" = ?, \"WalletComplianceVersion\" = ? WHERE \"Id\" = ?",
getArguments: function (record) {
var obj = record.settingsAttr;
var argsList = new OS.Entities.QueryArgumentsList();
argsList.add("Email", /*TEXT*/ 0, obj.emailAttr);
argsList.add("LoginBiometrics", /*BOOLEAN*/ 2, obj.loginBiometricsAttr);
argsList.add("IsBioMaybeLater", /*BOOLEAN*/ 2, obj.isBioMaybeLaterAttr);
argsList.add("IsPasscodeOnDevice", /*BOOLEAN*/ 2, obj.isPasscodeOnDeviceAttr);
argsList.add("LoginAttemptsCount", /*INTEGER*/ 3, obj.loginAttemptsCountAttr);
argsList.add("HasOnbardingDone", /*BOOLEAN*/ 2, obj.hasOnbardingDoneAttr);
argsList.add("AppLanguage", /*TEXT*/ 0, obj.appLanguageAttr);
argsList.add("HasGivenAccessCode", /*BOOLEAN*/ 2, obj.hasGivenAccessCodeAttr);
argsList.add("LastLogin", /*DATE_TIME*/ 6, obj.lastLoginAttr);
argsList.add("TemporaryIsNotifications", /*BOOLEAN*/ 2, obj.temporaryIsNotificationsAttr);
argsList.add("IsCameraDenied", /*BOOLEAN*/ 2, obj.isCameraDeniedAttr);
argsList.add("BiometricAttempts", /*INTEGER*/ 3, obj.biometricAttemptsAttr);
argsList.add("DontShowAgain", /*BOOLEAN*/ 2, obj.dontShowAgainAttr);
argsList.add("PingSessionId", /*TEXT*/ 0, obj.pingSessionIdAttr);
argsList.add("WalletComplianceVersion", /*TEXT*/ 0, obj.walletComplianceVersionAttr);
argsList.add("Id", /*LONGINTEGER*/ 4, obj.idAttr);

return argsList;
}
},
delete: {
sql: "DELETE FROM \"OSUSR_9K2_SETTINGS\" WHERE \"Id\" = ?"
},
deleteAll: {
sql: "DELETE FROM \"OSUSR_9K2_SETTINGS\""
},
getAllAttributesFromRecord: function (record) {
var obj = record.settingsAttr;
var argsList = new OS.Entities.QueryArgumentsList();
argsList.add("Id", /*LONGINTEGER*/ 4, obj.idAttr);
argsList.add("Email", /*TEXT*/ 0, obj.emailAttr);
argsList.add("LoginBiometrics", /*BOOLEAN*/ 2, obj.loginBiometricsAttr);
argsList.add("IsBioMaybeLater", /*BOOLEAN*/ 2, obj.isBioMaybeLaterAttr);
argsList.add("IsPasscodeOnDevice", /*BOOLEAN*/ 2, obj.isPasscodeOnDeviceAttr);
argsList.add("LoginAttemptsCount", /*INTEGER*/ 3, obj.loginAttemptsCountAttr);
argsList.add("HasOnbardingDone", /*BOOLEAN*/ 2, obj.hasOnbardingDoneAttr);
argsList.add("AppLanguage", /*TEXT*/ 0, obj.appLanguageAttr);
argsList.add("HasGivenAccessCode", /*BOOLEAN*/ 2, obj.hasGivenAccessCodeAttr);
argsList.add("LastLogin", /*DATE_TIME*/ 6, obj.lastLoginAttr);
argsList.add("TemporaryIsNotifications", /*BOOLEAN*/ 2, obj.temporaryIsNotificationsAttr);
argsList.add("IsCameraDenied", /*BOOLEAN*/ 2, obj.isCameraDeniedAttr);
argsList.add("BiometricAttempts", /*INTEGER*/ 3, obj.biometricAttemptsAttr);
argsList.add("DontShowAgain", /*BOOLEAN*/ 2, obj.dontShowAgainAttr);
argsList.add("PingSessionId", /*TEXT*/ 0, obj.pingSessionIdAttr);
argsList.add("WalletComplianceVersion", /*TEXT*/ 0, obj.walletComplianceVersionAttr);

return argsList;
},
hasNullId: function (record) {
var obj = record.settingsAttr;
return obj.idAttr.equals(OS.DataTypes.LongInteger.defaultValue);

},
getIdFromRecord: function (record) {
var obj = record.settingsAttr;
return obj.idAttr;

}
};
var allEntityInfos = [infoLocalDeeplinkAllowedPage, infoSettings];
var entityService = OS.Injector.resolve(OS.ServiceNames.EntityService);
var browserDbInstance = OS.Settings.getEnvParams().IndexedDBOffline ? entityService : OS.Entities.webSQLStorageInstance;
var nativeDbInstance = OS.Settings.getEnvParams().UseNewWebSQLImpl ? entityService : OS.Entities.webSQLStorageInstance;
var dbInstance = OS.NativeHelper.isRunningOnNative() ? nativeDbInstance : browserDbInstance;
Brazil_OfflineStorageModel.entities = {
LocalDeeplinkAllowedPage: new OS.Entities.Entity(dbInstance, infoLocalDeeplinkAllowedPage, moduleKey),
Settings: new OS.Entities.Entity(dbInstance, infoSettings, moduleKey)
};
return {
getEntityInfos: function () {
return allEntityInfos;
},
init: function (runner) {
return OS.Entities.webSQLStorageInstance.initModule(allEntityInfos, runner, moduleKey);
},
switch: function (runner) {
return OS.Entities.webSQLStorageInstance.switchModule(runner, moduleKey);
}
};
});
