﻿define("Brazil_Pix_MUI.controller$CalculateRepetitions", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Pix_MUI.model", "Brazil_Pix_MUI.controller", "Brazil_Pix_MUI.clientVariables"], function (exports, OutSystems, Brazil_Pix_MUIModel, Brazil_Pix_MUIController, Brazil_Pix_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_Pix_MUIController.default.calculateRepetitions$Action = function (scheduleDateIn, scheduleFrequencyIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.CalculateRepetitions$vars"))());
vars.value.scheduleDateInLocal = scheduleDateIn;
vars.value.scheduleFrequencyInLocal = scheduleFrequencyIn;
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.CalculateRepetitions$outVars"))());
// Frequency
if(((vars.value.scheduleFrequencyInLocal === Brazil_Pix_MUIModel.staticEntities.scheduleFrequency.monthly))) {
// MaxEndDate = AddMonths
vars.value.maxEndDateVar = OS.BuiltinFunctions.dateTimeToDate(OS.BuiltinFunctions.addMonths(OS.BuiltinFunctions.currDate(), 12));
// TransactionDate = AddMonths
vars.value.transactionDateVar = OS.BuiltinFunctions.dateTimeToDate(OS.BuiltinFunctions.addMonths(vars.value.scheduleDateInLocal, 1));
// Repetitions = 0
vars.value.repetitionsVar = 0;
while ((vars.value.transactionDateVar.lte(vars.value.maxEndDateVar))) {
// Repetitions = Repetitions + 1
vars.value.repetitionsVar = (vars.value.repetitionsVar + 1);
// TransactionDate = AddMonths
vars.value.transactionDateVar = OS.BuiltinFunctions.dateTimeToDate(OS.BuiltinFunctions.addMonths(vars.value.scheduleDateInLocal, (vars.value.repetitionsVar + 1)));
}

// AllowedRepetitions = Repetitions
outVars.value.allowedRepetitionsOut = vars.value.repetitionsVar;
} else {
if((vars.value.scheduleFrequencyInLocal === Brazil_Pix_MUIModel.staticEntities.scheduleFrequency.weekly)) {
// MaxEndDate = AddDays
vars.value.maxEndDateVar = OS.BuiltinFunctions.dateTimeToDate(OS.BuiltinFunctions.addDays(OS.BuiltinFunctions.currDate(), (52 * 7)));
// TransactionDate = AddDays
vars.value.transactionDateVar = OS.BuiltinFunctions.dateTimeToDate(OS.BuiltinFunctions.addDays(vars.value.scheduleDateInLocal, 7));
// Repetitions = 0
vars.value.repetitionsVar = 0;
while ((vars.value.transactionDateVar.lte(vars.value.maxEndDateVar))) {
// Repetitions = Repetitions + 1
vars.value.repetitionsVar = (vars.value.repetitionsVar + 1);
// TransactionDate = AddDays
vars.value.transactionDateVar = OS.BuiltinFunctions.dateTimeToDate(OS.BuiltinFunctions.addDays(vars.value.scheduleDateInLocal, (7 * (vars.value.repetitionsVar + 1))));
}

// AllowedRepetitions = Repetitions
outVars.value.allowedRepetitionsOut = vars.value.repetitionsVar;
} else {
// AllowedRepetitions = 0
outVars.value.allowedRepetitionsOut = 0;
}

}

return outVars.value;
};
var controller = Brazil_Pix_MUIController.default;
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.CalculateRepetitions$vars", [{
name: "ScheduleDate",
attrName: "scheduleDateInLocal",
mandatory: true,
dataType: OS.Types.Date,
defaultValue: function () {
return OS.DataTypes.DateTime.defaultValue;
}
}, {
name: "ScheduleFrequency",
attrName: "scheduleFrequencyInLocal",
mandatory: true,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}, {
name: "MaxEndDate",
attrName: "maxEndDateVar",
mandatory: false,
dataType: OS.Types.Date,
defaultValue: function () {
return OS.DataTypes.DateTime.defaultValue;
}
}, {
name: "TransactionDate",
attrName: "transactionDateVar",
mandatory: false,
dataType: OS.Types.Date,
defaultValue: function () {
return OS.DataTypes.DateTime.defaultValue;
}
}, {
name: "Repetitions",
attrName: "repetitionsVar",
mandatory: false,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}]);
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.CalculateRepetitions$outVars", [{
name: "AllowedRepetitions",
attrName: "allowedRepetitionsOut",
mandatory: false,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}]);
Brazil_Pix_MUIController.default.clientActionProxies.calculateRepetitions$Action = function (scheduleDateIn, scheduleFrequencyIn) {
scheduleDateIn = (scheduleDateIn === undefined) ? OS.DataTypes.DateTime.defaultValue : scheduleDateIn;
scheduleFrequencyIn = (scheduleFrequencyIn === undefined) ? 0 : scheduleFrequencyIn;
return controller.executeActionInsideJSNode(Brazil_Pix_MUIController.default.calculateRepetitions$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(scheduleDateIn, OS.Types.Date), scheduleFrequencyIn), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
AllowedRepetitions: OS.DataConversion.JSNodeParamConverter.to(actionResults.allowedRepetitionsOut, OS.Types.Integer)
};
});
};
});

define("Brazil_Pix_MUI.controller$GetFormattedScheduledDate", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Pix_MUI.model", "Brazil_Pix_MUI.controller", "Brazil_Pix_MUI.clientVariables", "Brazil_Pix_MUI.controller$GetSuffixForNumber", "Brazil_Pix_MUI.controller$TranslateMonth"], function (exports, OutSystems, Brazil_Pix_MUIModel, Brazil_Pix_MUIController, Brazil_Pix_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_Pix_MUIController.default.getFormattedScheduledDate$Action = function (dateIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.GetFormattedScheduledDate$vars"))());
vars.value.dateInLocal = dateIn;
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.GetFormattedScheduledDate$outVars"))());
// ES or PT
if((((OS.BuiltinFunctions.getCurrentLocale() === "es-419") || (OS.BuiltinFunctions.getCurrentLocale() === "pt-BR")))) {
// Set FormattedScheduledDate
// FormattedScheduledDate = GetSuffixForNumber(TextToInteger, true) + " " + ToLower + " " + "de" + " " + FormatDateTime
outVars.value.formattedScheduledDateOut = ((((((Brazil_Pix_MUIController.default.getSuffixForNumber$Action(OS.BuiltinFunctions.textToInteger(OS.BuiltinFunctions.formatDateTime(vars.value.dateInLocal, "dd")), true, callContext).textOut + " ") + OS.BuiltinFunctions.toLower(Brazil_Pix_MUIController.default.translateMonth$Action(OS.BuiltinFunctions.month(vars.value.dateInLocal), callContext).translatedMonthOut)) + " ") + "de") + " ") + OS.BuiltinFunctions.formatDateTime(vars.value.dateInLocal, "yyyy"));
} else {
// Set FormattedScheduledDate
// FormattedScheduledDate = TranslateMonth(Month) + " " + GetSuffixForNumber(TextToInteger, true) + ", " + FormatDateTime
outVars.value.formattedScheduledDateOut = ((((Brazil_Pix_MUIController.default.translateMonth$Action(OS.BuiltinFunctions.month(vars.value.dateInLocal), callContext).translatedMonthOut + " ") + Brazil_Pix_MUIController.default.getSuffixForNumber$Action(OS.BuiltinFunctions.textToInteger(OS.BuiltinFunctions.formatDateTime(vars.value.dateInLocal, "dd")), true, callContext).textOut) + ", ") + OS.BuiltinFunctions.formatDateTime(vars.value.dateInLocal, "yyyy"));
}

return outVars.value;
};
var controller = Brazil_Pix_MUIController.default;
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.GetFormattedScheduledDate$vars", [{
name: "Date",
attrName: "dateInLocal",
mandatory: true,
dataType: OS.Types.Date,
defaultValue: function () {
return OS.DataTypes.DateTime.defaultValue;
}
}]);
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.GetFormattedScheduledDate$outVars", [{
name: "FormattedScheduledDate",
attrName: "formattedScheduledDateOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_Pix_MUIController.default.clientActionProxies.getFormattedScheduledDate$Action = function (dateIn) {
dateIn = (dateIn === undefined) ? OS.DataTypes.DateTime.defaultValue : dateIn;
return controller.executeActionInsideJSNode(Brazil_Pix_MUIController.default.getFormattedScheduledDate$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(dateIn, OS.Types.Date)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
FormattedScheduledDate: OS.DataConversion.JSNodeParamConverter.to(actionResults.formattedScheduledDateOut, OS.Types.Text)
};
});
};
});

define("Brazil_Pix_MUI.controller$GetFrequencyFormat", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Pix_MUI.model", "Brazil_Pix_MUI.controller", "Brazil_Pix_MUI.clientVariables", "Brazil_Pix_MUI.controller$TranslateWeek"], function (exports, OutSystems, Brazil_Pix_MUIModel, Brazil_Pix_MUIController, Brazil_Pix_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_Pix_MUIController.default.getFrequencyFormat$Action = function (frequencyIn, dateIn, isShowWeeklyIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.GetFrequencyFormat$vars"))());
vars.value.frequencyInLocal = frequencyIn;
vars.value.dateInLocal = dateIn;
vars.value.isShowWeeklyInLocal = isShowWeeklyIn;
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.GetFrequencyFormat$outVars"))());
// Frequency
if(((vars.value.frequencyInLocal === Brazil_Pix_MUIModel.staticEntities.scheduleFrequency.weekly))) {
// Set FormattedFrequencyText
// FormattedFrequencyText = If
outVars.value.formattedFrequencyTextOut = ((vars.value.isShowWeeklyInLocal) ? (((((OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("cPzxRcNnykmqvKWfsOP4Ig#Value.-1707840351.1", "Weekly") + ", ") + OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("cPzxRcNnykmqvKWfsOP4Ig#Value.96891675.1", "every")) + " ") + (((OS.BuiltinFunctions.getCurrentLocale() === "en-US")) ? (Brazil_Pix_MUIController.default.translateWeek$Action(OS.BuiltinFunctions.dayOfWeek(vars.value.dateInLocal), callContext).weekOut) : (OS.BuiltinFunctions.toLower(Brazil_Pix_MUIController.default.translateWeek$Action(OS.BuiltinFunctions.dayOfWeek(vars.value.dateInLocal), callContext).weekOut))))) : (((OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("cPzxRcNnykmqvKWfsOP4Ig#Value.67339003.1", "Every") + " ") + (((OS.BuiltinFunctions.getCurrentLocale() === "en-US")) ? (Brazil_Pix_MUIController.default.translateWeek$Action(OS.BuiltinFunctions.dayOfWeek(vars.value.dateInLocal), callContext).weekOut) : (OS.BuiltinFunctions.toLower(Brazil_Pix_MUIController.default.translateWeek$Action(OS.BuiltinFunctions.dayOfWeek(vars.value.dateInLocal), callContext).weekOut))))));
} else {
if((vars.value.frequencyInLocal === Brazil_Pix_MUIModel.staticEntities.scheduleFrequency.monthly)) {
// Set FormattedFrequencyText
// FormattedFrequencyText = "Monthly"
outVars.value.formattedFrequencyTextOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("y6ep8RHh50G8xz6dV8t4Dw#Value.-1393678355.1", "Monthly");
} else {
// Set FormattedFrequencyText
// FormattedFrequencyText = "No"
outVars.value.formattedFrequencyTextOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("DTrF1p7LM0yXnqcqxADQjQ#Value.2529.1", "No");
}

}

return outVars.value;
};
var controller = Brazil_Pix_MUIController.default;
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.GetFrequencyFormat$vars", [{
name: "Frequency",
attrName: "frequencyInLocal",
mandatory: true,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}, {
name: "Date",
attrName: "dateInLocal",
mandatory: true,
dataType: OS.Types.Date,
defaultValue: function () {
return OS.DataTypes.DateTime.defaultValue;
}
}, {
name: "IsShowWeekly",
attrName: "isShowWeeklyInLocal",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return true;
}
}]);
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.GetFrequencyFormat$outVars", [{
name: "FormattedFrequencyText",
attrName: "formattedFrequencyTextOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_Pix_MUIController.default.clientActionProxies.getFrequencyFormat$Action = function (frequencyIn, dateIn, isShowWeeklyIn) {
frequencyIn = (frequencyIn === undefined) ? 0 : frequencyIn;
dateIn = (dateIn === undefined) ? OS.DataTypes.DateTime.defaultValue : dateIn;
isShowWeeklyIn = (isShowWeeklyIn === undefined) ? true : isShowWeeklyIn;
return controller.executeActionInsideJSNode(Brazil_Pix_MUIController.default.getFrequencyFormat$Action.bind(controller, frequencyIn, OS.DataConversion.JSNodeParamConverter.from(dateIn, OS.Types.Date), OS.DataConversion.JSNodeParamConverter.from(isShowWeeklyIn, OS.Types.Boolean)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
FormattedFrequencyText: OS.DataConversion.JSNodeParamConverter.to(actionResults.formattedFrequencyTextOut, OS.Types.Text)
};
});
};
});

define("Brazil_Pix_MUI.controller$GetScheduledEndDate", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Pix_MUI.model", "Brazil_Pix_MUI.controller", "DateTimeUtils_Lib.controller", "Brazil_Pix_MUI.clientVariables", "DateTimeUtils_Lib.controller$Month_End", "Brazil_Pix_MUI.referencesHealth", "Brazil_Pix_MUI.referencesHealth$DateTimeUtils_Lib"], function (exports, OutSystems, Brazil_Pix_MUIModel, Brazil_Pix_MUIController, DateTimeUtils_LibController, Brazil_Pix_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_Pix_MUIController.default.getScheduledEndDate$Action = function (frequencyIn, repetitionsIn, startDateIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.GetScheduledEndDate$vars"))());
vars.value.frequencyInLocal = frequencyIn;
vars.value.repetitionsInLocal = repetitionsIn;
vars.value.startDateInLocal = startDateIn;
var month_EndVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.GetScheduledEndDate$outVars"))());
if(((vars.value.frequencyInLocal === Brazil_Pix_MUIModel.staticEntities.scheduleFrequency.weekly))) {
// Set ScheduledEndDate
// ScheduledEndDate = AddDays
outVars.value.scheduledEndDateOut = OS.BuiltinFunctions.dateTimeToDate(OS.BuiltinFunctions.addDays(vars.value.startDateInLocal, (7 * vars.value.repetitionsInLocal)));
} else {
if((vars.value.frequencyInLocal === Brazil_Pix_MUIModel.staticEntities.scheduleFrequency.monthly)) {
// Execute Action: Month_End
month_EndVar.value = DateTimeUtils_LibController.default.month_End$Action(vars.value.startDateInLocal, callContext);

// StartDate = Month_End.EndOfTheMonth
if((vars.value.startDateInLocal.equals(month_EndVar.value.endOfTheMonthOut))) {
// Set ScheduledEndDate
// ScheduledEndDate = AddMonths
outVars.value.scheduledEndDateOut = OS.BuiltinFunctions.dateTimeToDate(OS.BuiltinFunctions.addMonths(month_EndVar.value.endOfTheMonthOut, vars.value.repetitionsInLocal));
} else {
// ScheduledEndDate = AddMonths
outVars.value.scheduledEndDateOut = OS.BuiltinFunctions.dateTimeToDate(OS.BuiltinFunctions.addMonths(vars.value.startDateInLocal, vars.value.repetitionsInLocal));
}

} else {
// Set ScheduledEndDate
// ScheduledEndDate = StartDate
outVars.value.scheduledEndDateOut = vars.value.startDateInLocal;
}

}

return outVars.value;
};
var controller = Brazil_Pix_MUIController.default;
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.GetScheduledEndDate$vars", [{
name: "Frequency",
attrName: "frequencyInLocal",
mandatory: true,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}, {
name: "Repetitions",
attrName: "repetitionsInLocal",
mandatory: true,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}, {
name: "StartDate",
attrName: "startDateInLocal",
mandatory: true,
dataType: OS.Types.Date,
defaultValue: function () {
return OS.DataTypes.DateTime.defaultValue;
}
}]);
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.GetScheduledEndDate$outVars", [{
name: "ScheduledEndDate",
attrName: "scheduledEndDateOut",
mandatory: false,
dataType: OS.Types.Date,
defaultValue: function () {
return OS.DataTypes.DateTime.defaultValue;
}
}]);
Brazil_Pix_MUIController.default.clientActionProxies.getScheduledEndDate$Action = function (frequencyIn, repetitionsIn, startDateIn) {
frequencyIn = (frequencyIn === undefined) ? 0 : frequencyIn;
repetitionsIn = (repetitionsIn === undefined) ? 0 : repetitionsIn;
startDateIn = (startDateIn === undefined) ? OS.DataTypes.DateTime.defaultValue : startDateIn;
return controller.executeActionInsideJSNode(Brazil_Pix_MUIController.default.getScheduledEndDate$Action.bind(controller, frequencyIn, OS.DataConversion.JSNodeParamConverter.from(repetitionsIn, OS.Types.Integer), OS.DataConversion.JSNodeParamConverter.from(startDateIn, OS.Types.Date)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
ScheduledEndDate: OS.DataConversion.JSNodeParamConverter.to(actionResults.scheduledEndDateOut, OS.Types.Date)
};
});
};
});

define("Brazil_Pix_MUI.controller$GetSuffixForNumber", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Pix_MUI.model", "Brazil_Pix_MUI.controller", "Brazil_Pix_MUI.clientVariables"], function (exports, OutSystems, Brazil_Pix_MUIModel, Brazil_Pix_MUIController, Brazil_Pix_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_Pix_MUIController.default.getSuffixForNumber$Action = function (inputNumberIn, shouldTranslateIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.GetSuffixForNumber$vars"))());
vars.value.inputNumberInLocal = inputNumberIn;
vars.value.shouldTranslateInLocal = shouldTranslateIn;
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.GetSuffixForNumber$outVars"))());
// Number = If
vars.value.numberVar = (((vars.value.inputNumberInLocal < 10)) ? (("0" + (vars.value.inputNumberInLocal).toString())) : ((vars.value.inputNumberInLocal).toString()));
// Number > 3 and Number < 21
if((!(((vars.value.inputNumberInLocal > 3) && (vars.value.inputNumberInLocal < 21))))) {
// NumberModulus = Mod
vars.value.numberModulusVar = OS.BuiltinFunctions.decimalToInteger(OS.BuiltinFunctions.trunc(OS.BuiltinFunctions.mod(OS.BuiltinFunctions.integerToDecimal(vars.value.inputNumberInLocal), OS.BuiltinFunctions.integerToDecimal(10))));
if(((vars.value.numberModulusVar === 1))) {
// Set Text
// Text = Number + If
outVars.value.textOut = (vars.value.numberVar + ((vars.value.shouldTranslateInLocal) ? (OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("AThCvimN30+k+ulGPQKiWQ#Value.3681.1", "st")) : ("st")));
return outVars.value;

} else {
if((vars.value.numberModulusVar === 2)) {
// Set Text
// Text = Number + If
outVars.value.textOut = (vars.value.numberVar + ((vars.value.shouldTranslateInLocal) ? (OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("wr4DhCmw80mKN7ZN_IazkQ#Value.3510.1", "nd")) : ("nd")));
return outVars.value;

} else {
if((vars.value.numberModulusVar === 3)) {
// Set Text
// Text = Number + If
outVars.value.textOut = (vars.value.numberVar + ((vars.value.shouldTranslateInLocal) ? (OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("f3gcFkH5hEiFu+ur1iKEZw#Value.3634.1", "rd")) : ("rd")));
return outVars.value;

}

}

}

}

// Set Text
// Text = Number + If
outVars.value.textOut = (vars.value.numberVar + ((vars.value.shouldTranslateInLocal) ? (OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("txdae3KZTE2swY2r_Rd4wQ#Value.3700.1", "th")) : ("th")));
return outVars.value;
};
var controller = Brazil_Pix_MUIController.default;
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.GetSuffixForNumber$vars", [{
name: "InputNumber",
attrName: "inputNumberInLocal",
mandatory: true,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}, {
name: "ShouldTranslate",
attrName: "shouldTranslateInLocal",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return true;
}
}, {
name: "NumberModulus",
attrName: "numberModulusVar",
mandatory: false,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}, {
name: "Number",
attrName: "numberVar",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.GetSuffixForNumber$outVars", [{
name: "Text",
attrName: "textOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_Pix_MUIController.default.clientActionProxies.getSuffixForNumber$Action = function (inputNumberIn, shouldTranslateIn) {
inputNumberIn = (inputNumberIn === undefined) ? 0 : inputNumberIn;
shouldTranslateIn = (shouldTranslateIn === undefined) ? true : shouldTranslateIn;
return controller.executeActionInsideJSNode(Brazil_Pix_MUIController.default.getSuffixForNumber$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(inputNumberIn, OS.Types.Integer), OS.DataConversion.JSNodeParamConverter.from(shouldTranslateIn, OS.Types.Boolean)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Text: OS.DataConversion.JSNodeParamConverter.to(actionResults.textOut, OS.Types.Text)
};
});
};
});

define("Brazil_Pix_MUI.controller$isModificationsToScheduledPixAllowed", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Pix_MUI.model", "Brazil_Pix_MUI.controller", "Brazil_Pix_MUI.clientVariables"], function (exports, OutSystems, Brazil_Pix_MUIModel, Brazil_Pix_MUIController, Brazil_Pix_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_Pix_MUIController.default.isModificationsToScheduledPixAllowed$Action = function (scheduledDateIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.isModificationsToScheduledPixAllowed$vars"))());
vars.value.scheduledDateInLocal = scheduledDateIn;
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.isModificationsToScheduledPixAllowed$outVars"))());
// isAllowed = CurrDateTime < BuildDateTime
outVars.value.isAllowedOut = OS.BuiltinFunctions.currDateTime().lt(OS.BuiltinFunctions.buildDateTime(OS.BuiltinFunctions.dateTimeToDate(OS.BuiltinFunctions.addDays(vars.value.scheduledDateInLocal, -1)), OS.BuiltinFunctions.textToTime("23:59:59")));
return outVars.value;
};
var controller = Brazil_Pix_MUIController.default;
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.isModificationsToScheduledPixAllowed$vars", [{
name: "scheduledDate",
attrName: "scheduledDateInLocal",
mandatory: true,
dataType: OS.Types.Date,
defaultValue: function () {
return OS.DataTypes.DateTime.defaultValue;
}
}]);
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.isModificationsToScheduledPixAllowed$outVars", [{
name: "isAllowed",
attrName: "isAllowedOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
Brazil_Pix_MUIController.default.clientActionProxies.isModificationsToScheduledPixAllowed$Action = function (scheduledDateIn) {
scheduledDateIn = (scheduledDateIn === undefined) ? OS.DataTypes.DateTime.defaultValue : scheduledDateIn;
return controller.executeActionInsideJSNode(Brazil_Pix_MUIController.default.isModificationsToScheduledPixAllowed$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(scheduledDateIn, OS.Types.Date)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
isAllowed: OS.DataConversion.JSNodeParamConverter.to(actionResults.isAllowedOut, OS.Types.Boolean)
};
});
};
});

define("Brazil_Pix_MUI.controller$IsMonthEnd", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Pix_MUI.model", "Brazil_Pix_MUI.controller", "Brazil_Pix_MUI.clientVariables"], function (exports, OutSystems, Brazil_Pix_MUIModel, Brazil_Pix_MUIController, Brazil_Pix_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_Pix_MUIController.default.isMonthEnd$Action = function (dateIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.IsMonthEnd$vars"))());
vars.value.dateInLocal = dateIn;
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.IsMonthEnd$outVars"))());
// Set IsMonthEnd
// IsMonthEnd = Day = 29 or Day = 30 or Day = 31
outVars.value.isMonthEndOut = (((OS.BuiltinFunctions.day(vars.value.dateInLocal) === 29) || (OS.BuiltinFunctions.day(vars.value.dateInLocal) === 30)) || (OS.BuiltinFunctions.day(vars.value.dateInLocal) === 31));
return outVars.value;
};
var controller = Brazil_Pix_MUIController.default;
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.IsMonthEnd$vars", [{
name: "Date",
attrName: "dateInLocal",
mandatory: true,
dataType: OS.Types.Date,
defaultValue: function () {
return OS.DataTypes.DateTime.defaultValue;
}
}]);
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.IsMonthEnd$outVars", [{
name: "IsMonthEnd",
attrName: "isMonthEndOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
Brazil_Pix_MUIController.default.clientActionProxies.isMonthEnd$Action = function (dateIn) {
dateIn = (dateIn === undefined) ? OS.DataTypes.DateTime.defaultValue : dateIn;
return controller.executeActionInsideJSNode(Brazil_Pix_MUIController.default.isMonthEnd$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(dateIn, OS.Types.Date)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
IsMonthEnd: OS.DataConversion.JSNodeParamConverter.to(actionResults.isMonthEndOut, OS.Types.Boolean)
};
});
};
});

define("Brazil_Pix_MUI.controller$setDateInfoText", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Pix_MUI.model", "Brazil_Pix_MUI.controller", "Brazil_Pix_MUI.clientVariables", "Brazil_Pix_MUI.model$authorizationHistoryEntryRec"], function (exports, OutSystems, Brazil_Pix_MUIModel, Brazil_Pix_MUIController, Brazil_Pix_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_Pix_MUIController.default.setDateInfoText$Action = function (authorizationHistoryEntryIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.setDateInfoText$vars"))());
vars.value.authorizationHistoryEntryInLocal = authorizationHistoryEntryIn.clone();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.setDateInfoText$outVars"))());
if((((((vars.value.authorizationHistoryEntryInLocal.statusAttr) !== (Brazil_Pix_MUIModel.staticEntities.authorizationStatus.active)) && ((vars.value.authorizationHistoryEntryInLocal.statusAttr) !== (Brazil_Pix_MUIModel.staticEntities.authorizationStatus.cancelled))) && vars.value.authorizationHistoryEntryInLocal.expirationDateAttr.lt(OS.BuiltinFunctions.currDate())))) {
// dateText = "Expired on" + " " + FormatDateTime
outVars.value.dateTextOut = ((OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("vRoyJw1eXEmtp5taGKo28Q#Value.1159146714.1", "Expired on") + " ") + OS.BuiltinFunctions.formatDateTime(vars.value.authorizationHistoryEntryInLocal.expirationDateAttr, "dd/MM/yyyy"));
} else {
if(((vars.value.authorizationHistoryEntryInLocal.statusAttr === Brazil_Pix_MUIModel.staticEntities.authorizationStatus.cancelled) && !(vars.value.authorizationHistoryEntryInLocal.cancelledDateAttr.equals(OS.BuiltinFunctions.nullDate())))) {
// dateText = "Cancelled on" + " " + FormatDateTime
outVars.value.dateTextOut = ((OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("Ym9B+lBOZk6JqUJM04lTFQ#Value.-953425106.1", "Cancelled on") + " ") + OS.BuiltinFunctions.formatDateTime(vars.value.authorizationHistoryEntryInLocal.cancelledDateAttr, "dd/MM/yyyy"));
} else {
if((((vars.value.authorizationHistoryEntryInLocal.statusAttr) !== (Brazil_Pix_MUIModel.staticEntities.authorizationStatus.active)) && vars.value.authorizationHistoryEntryInLocal.expirationDateAttr.gte(OS.BuiltinFunctions.currDate()))) {
// dateText = "Expires" + " " + FormatDateTime
outVars.value.dateTextOut = ((OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("bZRVcNTx6Ui51VafZw_q5w#Value.355417876.1", "Expires") + " ") + OS.BuiltinFunctions.formatDateTime(vars.value.authorizationHistoryEntryInLocal.expirationDateAttr, "dd/MM/yyyy"));
} else {
if(((vars.value.authorizationHistoryEntryInLocal.statusAttr === Brazil_Pix_MUIModel.staticEntities.authorizationStatus.active) && !(vars.value.authorizationHistoryEntryInLocal.authorizationDateAttr.equals(OS.BuiltinFunctions.nullDate())))) {
// dateText = "Authorized on" + " " + FormatDateTime
outVars.value.dateTextOut = ((OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("edEcYe5AqUm1+vkoqpyaGA#Value.-583461276.1", "Authorized on") + " ") + OS.BuiltinFunctions.formatDateTime(vars.value.authorizationHistoryEntryInLocal.authorizationDateAttr, "dd/MM/yyyy"));
}

}

}

}

return outVars.value;
};
var controller = Brazil_Pix_MUIController.default;
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.setDateInfoText$vars", [{
name: "authorizationHistoryEntry",
attrName: "authorizationHistoryEntryInLocal",
mandatory: true,
dataType: OS.Types.Record,
defaultValue: function () {
return new Brazil_Pix_MUIModel.authorizationHistoryEntryRec();
},
complexType: Brazil_Pix_MUIModel.authorizationHistoryEntryRec
}]);
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.setDateInfoText$outVars", [{
name: "dateText",
attrName: "dateTextOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_Pix_MUIController.default.clientActionProxies.setDateInfoText$Action = function (authorizationHistoryEntryIn) {
authorizationHistoryEntryIn = (authorizationHistoryEntryIn === undefined) ? new Brazil_Pix_MUIModel.authorizationHistoryEntryRec() : authorizationHistoryEntryIn;
return controller.executeActionInsideJSNode(Brazil_Pix_MUIController.default.setDateInfoText$Action.bind(controller, authorizationHistoryEntryIn), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
dateText: OS.DataConversion.JSNodeParamConverter.to(actionResults.dateTextOut, OS.Types.Text)
};
});
};
});

define("Brazil_Pix_MUI.controller$setStatusColorClassName", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Pix_MUI.model", "Brazil_Pix_MUI.controller", "Brazil_Pix_MUI.clientVariables"], function (exports, OutSystems, Brazil_Pix_MUIModel, Brazil_Pix_MUIController, Brazil_Pix_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_Pix_MUIController.default.setStatusColorClassName$Action = function (authorizationStatusIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.setStatusColorClassName$vars"))());
vars.value.authorizationStatusInLocal = authorizationStatusIn;
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.setStatusColorClassName$outVars"))());
if(((vars.value.authorizationStatusInLocal === Brazil_Pix_MUIModel.staticEntities.authorizationStatus.active))) {
// className = "background-green"
outVars.value.classNameOut = "background-green";
} else {
if((vars.value.authorizationStatusInLocal === Brazil_Pix_MUIModel.staticEntities.authorizationStatus.cancelled)) {
// className = "background-red-dark"
outVars.value.classNameOut = "background-red-dark";
} else {
if((vars.value.authorizationStatusInLocal === Brazil_Pix_MUIModel.staticEntities.authorizationStatus.expired)) {
// className = "background-neutral-5"
outVars.value.classNameOut = "background-neutral-5";
} else {
if((vars.value.authorizationStatusInLocal === Brazil_Pix_MUIModel.staticEntities.authorizationStatus.processing)) {
// className = "background-info"
outVars.value.classNameOut = "background-info";
} else {
if((vars.value.authorizationStatusInLocal === Brazil_Pix_MUIModel.staticEntities.authorizationStatus.pending)) {
// className = "background-warning"
outVars.value.classNameOut = "background-warning";
}

}

}

}

}

return outVars.value;
};
var controller = Brazil_Pix_MUIController.default;
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.setStatusColorClassName$vars", [{
name: "authorizationStatus",
attrName: "authorizationStatusInLocal",
mandatory: true,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}]);
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.setStatusColorClassName$outVars", [{
name: "className",
attrName: "classNameOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_Pix_MUIController.default.clientActionProxies.setStatusColorClassName$Action = function (authorizationStatusIn) {
authorizationStatusIn = (authorizationStatusIn === undefined) ? 0 : authorizationStatusIn;
return controller.executeActionInsideJSNode(Brazil_Pix_MUIController.default.setStatusColorClassName$Action.bind(controller, authorizationStatusIn), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
className: OS.DataConversion.JSNodeParamConverter.to(actionResults.classNameOut, OS.Types.Text)
};
});
};
});

define("Brazil_Pix_MUI.controller$setStatusText", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Pix_MUI.model", "Brazil_Pix_MUI.controller", "Brazil_Pix_MUI.clientVariables"], function (exports, OutSystems, Brazil_Pix_MUIModel, Brazil_Pix_MUIController, Brazil_Pix_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_Pix_MUIController.default.setStatusText$Action = function (authorizationStatusIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.setStatusText$vars"))());
vars.value.authorizationStatusInLocal = authorizationStatusIn;
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.setStatusText$outVars"))());
if(((vars.value.authorizationStatusInLocal === Brazil_Pix_MUIModel.staticEntities.authorizationStatus.active))) {
// statusText = "Active"
outVars.value.statusTextOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("pBPvugMc6EOIDIGvgpeHKA#Value.1955883814.1", "Active");
} else {
if((vars.value.authorizationStatusInLocal === Brazil_Pix_MUIModel.staticEntities.authorizationStatus.cancelled)) {
// statusText = "Cancelled"
outVars.value.statusTextOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("ovaN27q1rU6ueYi8dGAg1g#Value.-1814410959.1", "Cancelled");
} else {
if((vars.value.authorizationStatusInLocal === Brazil_Pix_MUIModel.staticEntities.authorizationStatus.expired)) {
// statusText = "Expired"
outVars.value.statusTextOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("Qz6ltae3yU+J2NFMZ+sDMA#Value.355417861.1", "Expired");
} else {
if((vars.value.authorizationStatusInLocal === Brazil_Pix_MUIModel.staticEntities.authorizationStatus.processing)) {
// statusText = "In Processing"
outVars.value.statusTextOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("W1P5hx39HkSFzTg4us2kXQ#Value.2118405358.1", "In Processing");
} else {
if((vars.value.authorizationStatusInLocal === Brazil_Pix_MUIModel.staticEntities.authorizationStatus.pending)) {
// statusText = "Pending"
outVars.value.statusTextOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("dXhA8KAXokOnrdlYYwVHPA#Value.982065527.1", "Pending");
}

}

}

}

}

return outVars.value;
};
var controller = Brazil_Pix_MUIController.default;
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.setStatusText$vars", [{
name: "authorizationStatus",
attrName: "authorizationStatusInLocal",
mandatory: true,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}]);
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.setStatusText$outVars", [{
name: "statusText",
attrName: "statusTextOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_Pix_MUIController.default.clientActionProxies.setStatusText$Action = function (authorizationStatusIn) {
authorizationStatusIn = (authorizationStatusIn === undefined) ? 0 : authorizationStatusIn;
return controller.executeActionInsideJSNode(Brazil_Pix_MUIController.default.setStatusText$Action.bind(controller, authorizationStatusIn), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
statusText: OS.DataConversion.JSNodeParamConverter.to(actionResults.statusTextOut, OS.Types.Text)
};
});
};
});

define("Brazil_Pix_MUI.controller$TranslateMonth", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Pix_MUI.model", "Brazil_Pix_MUI.controller", "Brazil_Pix_MUI.clientVariables"], function (exports, OutSystems, Brazil_Pix_MUIModel, Brazil_Pix_MUIController, Brazil_Pix_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_Pix_MUIController.default.translateMonth$Action = function (monthNumberIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.TranslateMonth$vars"))());
vars.value.monthNumberInLocal = monthNumberIn;
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.TranslateMonth$outVars"))());
if(((vars.value.monthNumberInLocal === 1))) {
// Set TranslatedMonth
// TranslatedMonth = "January"
outVars.value.translatedMonthOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("6H27FoE480GqB2lfka4iPw#Value.-162006966.1", "January");
} else {
if((vars.value.monthNumberInLocal === 2)) {
// Set TranslatedMonth
// TranslatedMonth = "February"
outVars.value.translatedMonthOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("UMpGeJ1JXEq2Asbf9OHQcA#Value.-199248958.1", "February");
} else {
if((vars.value.monthNumberInLocal === 3)) {
// TranslatedMonth = "March"
outVars.value.translatedMonthOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("fn31joB_ukKMHnnAbrd98A#Value.74113571.1", "March");
} else {
if((vars.value.monthNumberInLocal === 4)) {
// Set TranslatedMonth
// TranslatedMonth = "April"
outVars.value.translatedMonthOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("8TnX2Cq5tUSfi42qSDs5+g#Value.63478374.1", "April");
} else {
if((vars.value.monthNumberInLocal === 5)) {
// Set TranslatedMonth
// TranslatedMonth = "May"
outVars.value.translatedMonthOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("LlDsx5GXXEuxDEp9wcchMw#Value.77125.1", "May");
} else {
if((vars.value.monthNumberInLocal === 6)) {
// Set TranslatedMonth
// TranslatedMonth = "June"
outVars.value.translatedMonthOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("_8ss1ZtEO02VRi__QvKWlg#Value.2320482.1", "June");
} else {
if((vars.value.monthNumberInLocal === 7)) {
// Set TranslatedMonth
// TranslatedMonth = "July"
outVars.value.translatedMonthOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("X7Cnm86pPkaU5+SJCJniQQ#Value.2320440.1", "July");
} else {
if((vars.value.monthNumberInLocal === 8)) {
// Set TranslatedMonth
// TranslatedMonth = "August"
outVars.value.translatedMonthOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("Kaa3lzJFmUKqIf2XI4PMvg#Value.1972131363.1", "August");
} else {
if((vars.value.monthNumberInLocal === 9)) {
// Set TranslatedMonth
// TranslatedMonth = "September"
outVars.value.translatedMonthOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("CCU2fo95jEeVkwe4EDuD7g#Value.-25881423.1", "September");
} else {
if((vars.value.monthNumberInLocal === 10)) {
// Set TranslatedMonth
// TranslatedMonth = "October"
outVars.value.translatedMonthOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("BePMO8xPlEeov75KL2zWzQ#Value.43165376.1", "October");
} else {
if((vars.value.monthNumberInLocal === 11)) {
// Set TranslatedMonth
// TranslatedMonth = "November"
outVars.value.translatedMonthOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("5ian1HzJ70uYcEy+1gAadQ#Value.1703773522.1", "November");
} else {
if((vars.value.monthNumberInLocal === 12)) {
// Set TranslatedMonth
// TranslatedMonth = "December"
outVars.value.translatedMonthOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("GFhgsScFB0KnauxKeaCrCQ#Value.626483269.1", "December");
} else {
// Set TranslatedMonth
// TranslatedMonth = ""
outVars.value.translatedMonthOut = "";
}

}

}

}

}

}

}

}

}

}

}

}

return outVars.value;
};
var controller = Brazil_Pix_MUIController.default;
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.TranslateMonth$vars", [{
name: "MonthNumber",
attrName: "monthNumberInLocal",
mandatory: true,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}]);
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.TranslateMonth$outVars", [{
name: "TranslatedMonth",
attrName: "translatedMonthOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_Pix_MUIController.default.clientActionProxies.translateMonth$Action = function (monthNumberIn) {
monthNumberIn = (monthNumberIn === undefined) ? 0 : monthNumberIn;
return controller.executeActionInsideJSNode(Brazil_Pix_MUIController.default.translateMonth$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(monthNumberIn, OS.Types.Integer)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
TranslatedMonth: OS.DataConversion.JSNodeParamConverter.to(actionResults.translatedMonthOut, OS.Types.Text)
};
});
};
});

define("Brazil_Pix_MUI.controller$TranslateWeek", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Pix_MUI.model", "Brazil_Pix_MUI.controller", "Brazil_Pix_MUI.clientVariables"], function (exports, OutSystems, Brazil_Pix_MUIModel, Brazil_Pix_MUIController, Brazil_Pix_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_Pix_MUIController.default.translateWeek$Action = function (weekNumberIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.TranslateWeek$vars"))());
vars.value.weekNumberInLocal = weekNumberIn;
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_Pix_MUI.TranslateWeek$outVars"))());
if(((vars.value.weekNumberInLocal === 0))) {
// Set Week
// Week = "Sunday"
outVars.value.weekOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("Lrp120AweEygYoKsKpPFOg#Value.-1807319568.1", "Sunday");
} else {
if((vars.value.weekNumberInLocal === 1)) {
// Set Week
// Week = "Monday"
outVars.value.weekOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("_Yl4oIqYbUWKiXYjMkHrlQ#Value.-1984635600.1", "Monday");
} else {
if((vars.value.weekNumberInLocal === 2)) {
// Set Week
// Week = "Tuesday"
outVars.value.weekOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("YvWGF1FNdEqeYnQgPxDbug#Value.687309357.1", "Tuesday");
} else {
if((vars.value.weekNumberInLocal === 3)) {
// Set Week
// Week = "Wednesday"
outVars.value.weekOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("YSGHLrBFBEerXb0YN2zrSQ#Value.-897468618.1", "Wednesday");
} else {
if((vars.value.weekNumberInLocal === 4)) {
// Set Week
// Week = "Thursday"
outVars.value.weekOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("HE7MYrA+X0CnH3G8y4YlSQ#Value.1636699642.1", "Thursday");
} else {
if((vars.value.weekNumberInLocal === 5)) {
// Set Week
// Week = "Friday"
outVars.value.weekOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("q8OD0e3R+0eSHyvz8Z+jFw#Value.2112549247.1", "Friday");
} else {
if((vars.value.weekNumberInLocal === 6)) {
// Set Week
// Week = "Saturday"
outVars.value.weekOut = OS.Injector.resolve(OS.ServiceNames.TranslationsService).getMessage("+fS54hYskUKVnuKrmI9T8w#Value.-2049557543.1", "Saturday");
}

}

}

}

}

}

}

return outVars.value;
};
var controller = Brazil_Pix_MUIController.default;
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.TranslateWeek$vars", [{
name: "WeekNumber",
attrName: "weekNumberInLocal",
mandatory: true,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}]);
Brazil_Pix_MUIController.default.constructor.registerVariableGroupType("Brazil_Pix_MUI.TranslateWeek$outVars", [{
name: "Week",
attrName: "weekOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_Pix_MUIController.default.clientActionProxies.translateWeek$Action = function (weekNumberIn) {
weekNumberIn = (weekNumberIn === undefined) ? 0 : weekNumberIn;
return controller.executeActionInsideJSNode(Brazil_Pix_MUIController.default.translateWeek$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(weekNumberIn, OS.Types.Integer)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Week: OS.DataConversion.JSNodeParamConverter.to(actionResults.weekOut, OS.Types.Text)
};
});
};
});

define("Brazil_Pix_MUI.controller", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_Pix_MUI.model", "Brazil_Pix_MUI.controller$translationsResources"], function (exports, OutSystems, Brazil_Pix_MUIModel, Brazil_Pix_MUI_Controller_translationsResources) {
var OS = OutSystems.Internal;
var Brazil_Pix_MUIController = exports;
var Controller = (function (_super) {
__extends(Controller, _super);
function Controller() {
_super.apply(this, arguments);
}
Controller.prototype.clientActionProxies = {};
Controller.prototype.roles = {};
Controller.prototype.defaultTimeout = 300;
Controller.prototype.getDefaultTimeout = function () {
return Brazil_Pix_MUIController.default.defaultTimeout;
};
return Controller;
})(OS.Controller.BaseModuleController);
Brazil_Pix_MUIController.default = new Controller(Brazil_Pix_MUI_Controller_translationsResources, "Brazil_Pix_MUI");
});
define("Brazil_Pix_MUI.controller$translationsResources", ["exports", "Brazil_Pix_MUI.controller$translationsResources.es-419", "Brazil_Pix_MUI.controller$translationsResources.pt-BR"], function (exports, Brazil_Pix_MUI_controller_translationsResources_es419, Brazil_Pix_MUI_controller_translationsResources_ptBR) {
return {
"es-419": {
"translations": Brazil_Pix_MUI_controller_translationsResources_es419,
"isRTL": false
},
"pt-BR": {
"translations": Brazil_Pix_MUI_controller_translationsResources_ptBR,
"isRTL": false
}
};
});
define("Brazil_Pix_MUI.controller$translationsResources.es-419", [], function () {
return {
"DTrF1p7LM0yXnqcqxADQjQ#Value.2529.1": "No",
"cPzxRcNnykmqvKWfsOP4Ig#Value.-1707840351.1": "Semanalmente",
"cPzxRcNnykmqvKWfsOP4Ig#Value.67339003.1": "Todos los",
"cPzxRcNnykmqvKWfsOP4Ig#Value.96891675.1": "todos los",
"y6ep8RHh50G8xz6dV8t4Dw#Value.-1393678355.1": "Mensual",
"wr4DhCmw80mKN7ZN_IazkQ#Value.3510.1": " de",
"txdae3KZTE2swY2r_Rd4wQ#Value.3700.1": " de",
"f3gcFkH5hEiFu+ur1iKEZw#Value.3634.1": " de",
"AThCvimN30+k+ulGPQKiWQ#Value.3681.1": " de",
"bZRVcNTx6Ui51VafZw_q5w#Value.355417876.1": "Caduca el",
"vRoyJw1eXEmtp5taGKo28Q#Value.1159146714.1": "Venció el",
"Ym9B+lBOZk6JqUJM04lTFQ#Value.-953425106.1": "Cancelada el",
"edEcYe5AqUm1+vkoqpyaGA#Value.-583461276.1": "Autorizado el",
"dXhA8KAXokOnrdlYYwVHPA#Value.982065527.1": "Pendiente",
"ovaN27q1rU6ueYi8dGAg1g#Value.-1814410959.1": "Cancelado",
"Qz6ltae3yU+J2NFMZ+sDMA#Value.355417861.1": "Venció",
"pBPvugMc6EOIDIGvgpeHKA#Value.1955883814.1": "Activo",
"W1P5hx39HkSFzTg4us2kXQ#Value.2118405358.1": "En proceso",
"CCU2fo95jEeVkwe4EDuD7g#Value.-25881423.1": "Septiembre",
"6H27FoE480GqB2lfka4iPw#Value.-162006966.1": "Enero",
"fn31joB_ukKMHnnAbrd98A#Value.74113571.1": "Marzo",
"Kaa3lzJFmUKqIf2XI4PMvg#Value.1972131363.1": "Agosto",
"GFhgsScFB0KnauxKeaCrCQ#Value.626483269.1": "Diciembre",
"UMpGeJ1JXEq2Asbf9OHQcA#Value.-199248958.1": "Febrero",
"_8ss1ZtEO02VRi__QvKWlg#Value.2320482.1": "Junio",
"BePMO8xPlEeov75KL2zWzQ#Value.43165376.1": "Octubre",
"8TnX2Cq5tUSfi42qSDs5+g#Value.63478374.1": "Abril",
"5ian1HzJ70uYcEy+1gAadQ#Value.1703773522.1": "Noviembre",
"X7Cnm86pPkaU5+SJCJniQQ#Value.2320440.1": "Julio",
"LlDsx5GXXEuxDEp9wcchMw#Value.77125.1": "Mayo",
"Lrp120AweEygYoKsKpPFOg#Value.-1807319568.1": "Domingo",
"_Yl4oIqYbUWKiXYjMkHrlQ#Value.-1984635600.1": "Lunes",
"YSGHLrBFBEerXb0YN2zrSQ#Value.-897468618.1": "Miércoles",
"HE7MYrA+X0CnH3G8y4YlSQ#Value.1636699642.1": "Jueves",
"q8OD0e3R+0eSHyvz8Z+jFw#Value.2112549247.1": "Viernes",
"YvWGF1FNdEqeYnQgPxDbug#Value.687309357.1": "Martes",
"+fS54hYskUKVnuKrmI9T8w#Value.-2049557543.1": "Sábado"
};
});
define("Brazil_Pix_MUI.controller$translationsResources.pt-BR", [], function () {
return {
"DTrF1p7LM0yXnqcqxADQjQ#Value.2529.1": "Não",
"cPzxRcNnykmqvKWfsOP4Ig#Value.-1707840351.1": "Semanalmente",
"cPzxRcNnykmqvKWfsOP4Ig#Value.67339003.1": "Todo",
"cPzxRcNnykmqvKWfsOP4Ig#Value.96891675.1": "todo",
"y6ep8RHh50G8xz6dV8t4Dw#Value.-1393678355.1": "Mensal",
"wr4DhCmw80mKN7ZN_IazkQ#Value.3510.1": " de",
"txdae3KZTE2swY2r_Rd4wQ#Value.3700.1": " de",
"f3gcFkH5hEiFu+ur1iKEZw#Value.3634.1": " de",
"AThCvimN30+k+ulGPQKiWQ#Value.3681.1": " de",
"bZRVcNTx6Ui51VafZw_q5w#Value.355417876.1": "Expira em",
"vRoyJw1eXEmtp5taGKo28Q#Value.1159146714.1": "Expirou em",
"Ym9B+lBOZk6JqUJM04lTFQ#Value.-953425106.1": "Cancelada em",
"edEcYe5AqUm1+vkoqpyaGA#Value.-583461276.1": "Autorizada em",
"dXhA8KAXokOnrdlYYwVHPA#Value.982065527.1": "Pendente",
"ovaN27q1rU6ueYi8dGAg1g#Value.-1814410959.1": "Cancelada",
"Qz6ltae3yU+J2NFMZ+sDMA#Value.355417861.1": "Expirada",
"pBPvugMc6EOIDIGvgpeHKA#Value.1955883814.1": "Ativa",
"W1P5hx39HkSFzTg4us2kXQ#Value.2118405358.1": "Em processamento",
"CCU2fo95jEeVkwe4EDuD7g#Value.-25881423.1": "Setembro",
"6H27FoE480GqB2lfka4iPw#Value.-162006966.1": "Janeiro",
"fn31joB_ukKMHnnAbrd98A#Value.74113571.1": "Março",
"Kaa3lzJFmUKqIf2XI4PMvg#Value.1972131363.1": "Agosto",
"GFhgsScFB0KnauxKeaCrCQ#Value.626483269.1": "Dezembro",
"UMpGeJ1JXEq2Asbf9OHQcA#Value.-199248958.1": "Fevereiro",
"_8ss1ZtEO02VRi__QvKWlg#Value.2320482.1": "Junho",
"BePMO8xPlEeov75KL2zWzQ#Value.43165376.1": "Outubro",
"8TnX2Cq5tUSfi42qSDs5+g#Value.63478374.1": "Abril",
"5ian1HzJ70uYcEy+1gAadQ#Value.1703773522.1": "Novembro",
"X7Cnm86pPkaU5+SJCJniQQ#Value.2320440.1": "Julho",
"LlDsx5GXXEuxDEp9wcchMw#Value.77125.1": "Maio",
"Lrp120AweEygYoKsKpPFOg#Value.-1807319568.1": "Domingo",
"_Yl4oIqYbUWKiXYjMkHrlQ#Value.-1984635600.1": "Segunda-feira",
"YSGHLrBFBEerXb0YN2zrSQ#Value.-897468618.1": "Quarta-feira",
"HE7MYrA+X0CnH3G8y4YlSQ#Value.1636699642.1": "Quinta-feira",
"q8OD0e3R+0eSHyvz8Z+jFw#Value.2112549247.1": "Sexta-feira",
"YvWGF1FNdEqeYnQgPxDbug#Value.687309357.1": "Terça-feira",
"+fS54hYskUKVnuKrmI9T8w#Value.-2049557543.1": "Sábado"
};
});
