﻿define("Brazil_TrackTransfer_MUI.controller$CreateOrUpdate_AirPickup", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_Storage_DB.model", "Brazil_TrackTransfer_MUI.clientVariables", "Brazil_Storage_DB.model$AirPickupRec", "Brazil_TrackTransfer_MUI.referencesHealth", "Brazil_TrackTransfer_MUI.referencesHealth$Brazil_Storage_DB", "Brazil_TrackTransfer_MUI.controller$ServerAction.CreateOrUpdate_AirPickup"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_Storage_DBModel, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.createOrUpdate_AirPickup$Action = function (airPickupIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_TrackTransfer_MUI.CreateOrUpdate_AirPickup$vars"))());
vars.value.airPickupInLocal = airPickupIn.clone();
var createOrUpdate_AirPickupVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_TrackTransfer_MUI.CreateOrUpdate_AirPickup$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: CreateOrUpdate_AirPickup
return controller.createOrUpdate_AirPickup$ServerAction(vars.value.airPickupInLocal, callContext).then(function (value) {
createOrUpdate_AirPickupVar.value = value;
}).then(function () {
// Output Variables
// Out_CreateOrUpdate_AirPickup_AirPickupId = CreateOrUpdate_AirPickup.AirPickupId
outVars.value.out_CreateOrUpdate_AirPickup_AirPickupIdOut = createOrUpdate_AirPickupVar.value.airPickupIdOut;
});
}).then(function () {
return outVars.value;
});
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.constructor.registerVariableGroupType("Brazil_TrackTransfer_MUI.CreateOrUpdate_AirPickup$vars", [{
name: "AirPickup",
attrName: "airPickupInLocal",
mandatory: true,
dataType: OS.Types.Record,
defaultValue: function () {
return new Brazil_Storage_DBModel.AirPickupRec();
},
complexType: Brazil_Storage_DBModel.AirPickupRec
}]);
Brazil_TrackTransfer_MUIController.default.constructor.registerVariableGroupType("Brazil_TrackTransfer_MUI.CreateOrUpdate_AirPickup$outVars", [{
name: "Out_CreateOrUpdate_AirPickup_AirPickupId",
attrName: "out_CreateOrUpdate_AirPickup_AirPickupIdOut",
mandatory: false,
dataType: OS.Types.LongInteger,
defaultValue: function () {
return OS.DataTypes.LongInteger.defaultValue;
}
}]);
Brazil_TrackTransfer_MUIController.default.clientActionProxies.createOrUpdate_AirPickup$Action = function (airPickupIn) {
airPickupIn = (airPickupIn === undefined) ? new Brazil_Storage_DBModel.AirPickupRec() : airPickupIn;
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.createOrUpdate_AirPickup$Action.bind(controller, airPickupIn), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Out_CreateOrUpdate_AirPickup_AirPickupId: actionResults.out_CreateOrUpdate_AirPickup_AirPickupIdOut
};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$GetTransferStatus", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_CS.model", "Brazil_TrackTransfer_MUI.clientVariables", "Brazil_TrackTransfer_CS.model$TransferStatusRec", "Brazil_TrackTransfer_MUI.referencesHealth", "Brazil_TrackTransfer_MUI.referencesHealth$Brazil_TrackTransfer_CS"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_TrackTransfer_CSModel, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.getTransferStatus$Action = function (callContext) {
callContext = controller.callContext(callContext);
var jSONTransferStatusVar = new OS.DataTypes.VariableHolder(new (OS.Controller.BaseController.getJSONDeserializeOutputType(Brazil_TrackTransfer_CSModel.TransferStatusRec))());
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_TrackTransfer_MUI.GetTransferStatus$outVars"))());
// JSON Deserialize: JSONTransferStatus
jSONTransferStatusVar.value.dataOut = OS.JSONUtils.deserializeFromJSON(Brazil_TrackTransfer_MUIClientVariables.getTrackTransfer_TransferStatusJSON(), Brazil_TrackTransfer_CSModel.TransferStatusRec, false);
// TransferStatus = JSONTransferStatus.Data
outVars.value.transferStatusOut = jSONTransferStatusVar.value.dataOut;
// HasData = Trim <> ""
outVars.value.hasDataOut = ((OS.BuiltinFunctions.trim(Brazil_TrackTransfer_MUIClientVariables.getTrackTransfer_TransferStatusJSON())) !== (""));
return outVars.value;
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.constructor.registerVariableGroupType("Brazil_TrackTransfer_MUI.GetTransferStatus$outVars", [{
name: "TransferStatus",
attrName: "transferStatusOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new Brazil_TrackTransfer_CSModel.TransferStatusRec();
},
complexType: Brazil_TrackTransfer_CSModel.TransferStatusRec
}, {
name: "HasData",
attrName: "hasDataOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
Brazil_TrackTransfer_MUIController.default.clientActionProxies.getTransferStatus$Action = function () {
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.getTransferStatus$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
TransferStatus: actionResults.transferStatusOut,
HasData: OS.DataConversion.JSNodeParamConverter.to(actionResults.hasDataOut, OS.Types.Boolean)
};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$Loading_OFF", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_MUI.clientVariables"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.loading_OFF$Action = function (callContext) {
callContext = controller.callContext(callContext);
// TrackTransfer_IsLoading = False
Brazil_TrackTransfer_MUIClientVariables.setTrackTransfer_IsLoading(false);
return ;
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.clientActionProxies.loading_OFF$Action = function () {
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.loading_OFF$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$Loading_ON", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_MUI.clientVariables"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.loading_ON$Action = function (callContext) {
callContext = controller.callContext(callContext);
// TrackTransfer_IsLoading = True
Brazil_TrackTransfer_MUIClientVariables.setTrackTransfer_IsLoading(true);
return ;
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.clientActionProxies.loading_ON$Action = function () {
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.loading_ON$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$NoMTCN_Index2Tab", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_MUI.entities", "Brazil_TrackTransfer_MUI.clientVariables", "Brazil_TrackTransfer_MUI.model$LocalTrackTransfer_NoMTCN_TabRecordList", "Brazil_TrackTransfer_MUI.model$LocalTrackTransfer_NoMTCN_TabRec"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_TrackTransfer_MUIEntities, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.noMTCN_Index2Tab$Action = function (tabIndexIn, stepIdIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_TrackTransfer_MUI.NoMTCN_Index2Tab$vars"))());
vars.value.tabIndexInLocal = tabIndexIn;
vars.value.stepIdInLocal = stepIdIn;
var getLocalTrackTransferNoMTCNTabsByStepVar = new OS.DataTypes.VariableHolder(new (OS.Controller.BaseController.getAggregateOutputType(Brazil_TrackTransfer_MUIModel.LocalTrackTransfer_NoMTCN_TabRecordList))());
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_TrackTransfer_MUI.NoMTCN_Index2Tab$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Aggregate: GetLocalTrackTransferNoMTCNTabsByStep
var getLocalTrackTransferNoMTCNTabsByStepAggr = function (maxRecords) {
var executeQuery = null;
if(OS.NativeHelper.isRunningOnNative()) {
executeQuery = function () {
var targetListType = Brazil_TrackTransfer_MUIModel.LocalTrackTransfer_NoMTCN_TabRecordList;
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var countArgsList = new OS.Entities.QueryArgumentsList();
if(!(maxRecords)) {
maxRecords = 1;
}

var qpstStep = vars.value.stepIdInLocal;
var qpinTabIndex = vars.value.tabIndexInLocal;

var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "\"ENLocalTrackTransfer_NoMTCN_Tab\".\"Id\" o0, NULL o1, NULL o2";
} else {
selectSql += "\"ENLocalTrackTransfer_NoMTCN_Tab\".\"Id\" o0, \"ENLocalTrackTransfer_NoMTCN_Tab\".\"Step\" o1, \"ENLocalTrackTransfer_NoMTCN_Tab\".\"TabIndex\" o2";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_7zu_LocalTrackTransfer_NoMTCN_Tab\" \"ENLocalTrackTransfer_NoMTCN_Tab\"";
fromAndWhereSql += " WHERE (\"ENLocalTrackTransfer_NoMTCN_Tab\".\"Step\" = (:qpstStep)) AND (\"ENLocalTrackTransfer_NoMTCN_Tab\".\"TabIndex\" = :qpinTabIndex)";
argsList.add("qpstStep", /*TEXT*/ 0, qpstStep);
argsList.add("qpinTabIndex", /*INTEGER*/ 3, qpinTabIndex);
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

return OS.Entities.webSQLStorageInstance.executeQuery(sql, Brazil_TrackTransfer_MUIModel.LocalTrackTransfer_NoMTCN_TabRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"localTrackTransfer_NoMTCN_TabAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

}, argsList).then(function (resultList) {
result.list = resultList;
}).then(function () {
}).then(function () {
return result;
});
};
} else {
executeQuery = function () {
if(!(maxRecords)) {
maxRecords = 1;
}

return new Promise(function (resolve, reject) {
require(["Brazil_TrackTransfer_MUI.aggregates.IDB"], function (Brazil_TrackTransfer_MUIAggregates_IDB) {
return Brazil_TrackTransfer_MUIAggregates_IDB.executeNoMTCNIndex2Tab$ClientAction$getLocalTrackTransferNoMTCNTabsByStepAggr(vars.value.stepIdInLocal, vars.value.tabIndexInLocal, maxRecords).then(function (result) {
resolve(result);
}).catch(function (e) {
reject(e);
});
});
});
};
}

return controller.executeClientAggregate(executeQuery, function () {
return getLocalTrackTransferNoMTCNTabsByStepVar.value;
});
};
return getLocalTrackTransferNoMTCNTabsByStepAggr().then(function () {
// TabId = GetLocalTrackTransferNoMTCNTabsByStep.List.Current.LocalTrackTransfer_NoMTCN_Tab.Id
outVars.value.tabIdOut = getLocalTrackTransferNoMTCNTabsByStepVar.value.listOut.getCurrent(callContext.iterationContext).localTrackTransfer_NoMTCN_TabAttr.idAttr;
});
}).then(function () {
return outVars.value;
});
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.constructor.registerVariableGroupType("Brazil_TrackTransfer_MUI.NoMTCN_Index2Tab$vars", [{
name: "TabIndex",
attrName: "tabIndexInLocal",
mandatory: true,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}, {
name: "StepId",
attrName: "stepIdInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_TrackTransfer_MUIController.default.constructor.registerVariableGroupType("Brazil_TrackTransfer_MUI.NoMTCN_Index2Tab$outVars", [{
name: "TabId",
attrName: "tabIdOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_TrackTransfer_MUIController.default.clientActionProxies.noMTCN_Index2Tab$Action = function (tabIndexIn, stepIdIn) {
tabIndexIn = (tabIndexIn === undefined) ? 0 : tabIndexIn;
stepIdIn = (stepIdIn === undefined) ? "" : stepIdIn;
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.noMTCN_Index2Tab$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(tabIndexIn, OS.Types.Integer), stepIdIn), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
TabId: actionResults.tabIdOut
};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$NoMTCN_NextStep", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_CW.controller", "Brazil_TrackTransfer_MUI.clientVariables", "Brazil_TrackTransfer_CW.controller$NoMTCN_NextStep", "Brazil_TrackTransfer_MUI.referencesHealth", "Brazil_TrackTransfer_MUI.referencesHealth$Brazil_TrackTransfer_CW"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_TrackTransfer_CWController, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.noMTCN_NextStep$Action = function (callContext) {
callContext = controller.callContext(callContext);
// Execute Action: NoMTCN_NextStep_CW
Brazil_TrackTransfer_CWController.default.noMTCN_NextStep$Action(callContext);
// TrackTransfer_CurrentStep = CollectPersonalData
Brazil_TrackTransfer_MUIClientVariables.setTrackTransfer_CurrentStep(Brazil_TrackTransfer_MUIModel.staticEntities.trackTransfer_NoMTCN_Flow.collectPersonalData);
return ;
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.clientActionProxies.noMTCN_NextStep$Action = function () {
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.noMTCN_NextStep$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$NoMTCN_Restore2PreviousState", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_CW.controller", "Brazil_TrackTransfer_MUI.clientVariables", "Brazil_TrackTransfer_CW.controller$GetDefaultTrackTransfer_DialCode", "Brazil_TrackTransfer_MUI.referencesHealth", "Brazil_TrackTransfer_MUI.referencesHealth$Brazil_TrackTransfer_CW", "Brazil_TrackTransfer_MUI.controller$ResetTrackTransfer_FullState", "Brazil_TrackTransfer_CW.controller$NoMTCN_Restore2PreviousState", "Brazil_TrackTransfer_CW.controller$SetCountryDialCode"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_TrackTransfer_CWController, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.noMTCN_Restore2PreviousState$Action = function (callContext) {
callContext = controller.callContext(callContext);
var getDefaultTrackTransfer_DialCodeVar = new OS.DataTypes.VariableHolder();
if(((Brazil_TrackTransfer_MUIClientVariables.getTrackTransfer_CurrentStep() === Brazil_TrackTransfer_MUIModel.staticEntities.trackTransfer_NoMTCN_Flow.collectPersonalData))) {
// TrackTransfer_DateOfTransfer = NullDate
Brazil_TrackTransfer_MUIClientVariables.setTrackTransfer_DateOfTransfer(OS.BuiltinFunctions.nullDate());
// TrackTransfer_CurrentStep = CollectAmount
Brazil_TrackTransfer_MUIClientVariables.setTrackTransfer_CurrentStep(Brazil_TrackTransfer_MUIModel.staticEntities.trackTransfer_NoMTCN_Flow.collectAmount);
// Execute Action: NoMTCN_Restore2PreviousState_CW
Brazil_TrackTransfer_CWController.default.noMTCN_Restore2PreviousState$Action(callContext);
// Execute Action: GetDefaultTrackTransfer_DialCode
getDefaultTrackTransfer_DialCodeVar.value = Brazil_TrackTransfer_CWController.default.getDefaultTrackTransfer_DialCode$Action(callContext);

// Execute Action: SetDefaultTrackTransfer_DialCode
Brazil_TrackTransfer_CWController.default.setCountryDialCode$Action(getDefaultTrackTransfer_DialCodeVar.value.dialCodeOut, callContext);
} else {
// Execute Action: ResetTrackTransfer_FullStateClientVariables
Brazil_TrackTransfer_MUIController.default.resetTrackTransfer_FullState$Action(callContext);
}

return ;
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.clientActionProxies.noMTCN_Restore2PreviousState$Action = function () {
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.noMTCN_Restore2PreviousState$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$PurgeTransferStatus2", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_MUI.clientVariables"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.purgeTransferStatus2$Action = function (callContext) {
callContext = controller.callContext(callContext);
// TrackTransfer_TransferStatusJSON = ""
Brazil_TrackTransfer_MUIClientVariables.setTrackTransfer_TransferStatusJSON("");
return ;
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.clientActionProxies.purgeTransferStatus2$Action = function () {
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.purgeTransferStatus2$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$ResetTrackTransfer_FullState", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_CW.controller", "Brazil_TrackTransfer_MUI.clientVariables", "Brazil_TrackTransfer_CW.controller$ResetTrackTransfer_MTCN_State", "Brazil_TrackTransfer_MUI.referencesHealth", "Brazil_TrackTransfer_MUI.referencesHealth$Brazil_TrackTransfer_CW", "Brazil_TrackTransfer_MUI.controller$ResetTrackTransfer_State", "Brazil_TrackTransfer_MUI.controller$ResetTransferStatus_State", "Brazil_TrackTransfer_MUI.controller$ResetTrackTransfer_NoMTCN_State"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_TrackTransfer_CWController, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.resetTrackTransfer_FullState$Action = function (callContext) {
callContext = controller.callContext(callContext);
// Execute Action: ResetTrackTransfer_State
Brazil_TrackTransfer_MUIController.default.resetTrackTransfer_State$Action(callContext);
// Execute Action: ResetTrackTransfer_MTCN_State
Brazil_TrackTransfer_CWController.default.resetTrackTransfer_MTCN_State$Action(callContext);
// Execute Action: ResetTrackTransfer_NoMTCN_State
Brazil_TrackTransfer_MUIController.default.resetTrackTransfer_NoMTCN_State$Action(callContext);
// Execute Action: ResetTransferStatus_State
Brazil_TrackTransfer_MUIController.default.resetTransferStatus_State$Action(callContext);
return ;
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.clientActionProxies.resetTrackTransfer_FullState$Action = function () {
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.resetTrackTransfer_FullState$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$ResetTrackTransfer_NoMTCN_State", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_CW.controller", "Brazil_Common_BL.controller", "Brazil_TrackTransfer_MUI.clientVariables", "Brazil_TrackTransfer_CW.controller$GetDefaultTrackTransfer_DialCode", "Brazil_TrackTransfer_MUI.referencesHealth", "Brazil_TrackTransfer_MUI.referencesHealth$Brazil_TrackTransfer_CW", "Brazil_TrackTransfer_CW.controller$SetCountryDialCode", "Brazil_TrackTransfer_CW.controller$ResetTrackTransfer_NoMTCN_State", "Brazil_Common_BL.controller$Get_Brazil_MainCurrency_Code", "Brazil_TrackTransfer_MUI.referencesHealth$Brazil_Common_BL", "Brazil_TrackTransfer_MUI.controller$SetDefaulttTrackTransfer_AmountCurrency", "Brazil_TrackTransfer_CW.controller$SetDefaultTrackTransfer_TrackingAs"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_TrackTransfer_CWController, Brazil_Common_BLController, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.resetTrackTransfer_NoMTCN_State$Action = function (callContext) {
callContext = controller.callContext(callContext);
var getDefaultTrackTransfer_DialCodeVar = new OS.DataTypes.VariableHolder();
var get_Brazil_MainCurrency_CodeVar = new OS.DataTypes.VariableHolder();
// TrackTransfer_SelectedCountry = NullIdentifier
Brazil_TrackTransfer_MUIClientVariables.setTrackTransfer_SelectedCountry(OS.BuiltinFunctions.integerToLongInteger(OS.BuiltinFunctions.nullIdentifier()));
// TrackTransfer_DateOfTransfer = NullDate
Brazil_TrackTransfer_MUIClientVariables.setTrackTransfer_DateOfTransfer(OS.BuiltinFunctions.nullDate());
// TrackTransfer_CurrentStep = CollectAmount
Brazil_TrackTransfer_MUIClientVariables.setTrackTransfer_CurrentStep(Brazil_TrackTransfer_MUIModel.staticEntities.trackTransfer_NoMTCN_Flow.collectAmount);
// TrackTransfer_IsDateMandatory = False
Brazil_TrackTransfer_MUIClientVariables.setTrackTransfer_IsDateMandatory(false);
// Execute Action: SetDefaultTrackTransfer_TrackingAs
Brazil_TrackTransfer_CWController.default.setDefaultTrackTransfer_TrackingAs$Action(callContext);
// Execute Action: Get_Brazil_MainCurrency_Code
get_Brazil_MainCurrency_CodeVar.value = Brazil_Common_BLController.default.get_Brazil_MainCurrency_Code$Action(callContext);

// Execute Action: SetDefaulttTrackTransfer_AmountCurrency
Brazil_TrackTransfer_MUIController.default.setDefaulttTrackTransfer_AmountCurrency$Action(get_Brazil_MainCurrency_CodeVar.value.currency_CodeOut, callContext);
// Execute Action: ResetTrackTransfer_NoMTCN_State_CW
Brazil_TrackTransfer_CWController.default.resetTrackTransfer_NoMTCN_State$Action(callContext);
// Execute Action: GetDefaultTrackTransfer_DialCode
getDefaultTrackTransfer_DialCodeVar.value = Brazil_TrackTransfer_CWController.default.getDefaultTrackTransfer_DialCode$Action(callContext);

// Execute Action: SetDefaultTrackTransfer_DialCode
Brazil_TrackTransfer_CWController.default.setCountryDialCode$Action(getDefaultTrackTransfer_DialCodeVar.value.dialCodeOut, callContext);
return ;
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.clientActionProxies.resetTrackTransfer_NoMTCN_State$Action = function () {
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.resetTrackTransfer_NoMTCN_State$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$ResetTrackTransfer_State", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_CW.controller", "Brazil_TrackTransfer_MUI.clientVariables", "Brazil_TrackTransfer_CW.controller$SetDefaultTrackTransfer_TrackingAs", "Brazil_TrackTransfer_MUI.referencesHealth", "Brazil_TrackTransfer_MUI.referencesHealth$Brazil_TrackTransfer_CW"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_TrackTransfer_CWController, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.resetTrackTransfer_State$Action = function (callContext) {
callContext = controller.callContext(callContext);
// TrackTransfer_IsUsingMTCN = True
Brazil_TrackTransfer_MUIClientVariables.setTrackTransfer_IsUsingMTCN(true);
// Execute Action: SetDefaultTrackTransfer_TrackingAs
Brazil_TrackTransfer_CWController.default.setDefaultTrackTransfer_TrackingAs$Action(callContext);
return ;
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.clientActionProxies.resetTrackTransfer_State$Action = function () {
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.resetTrackTransfer_State$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$ResetTransferStatus_State", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_CW.controller", "Brazil_TrackTransfer_MUI.clientVariables", "Brazil_TrackTransfer_CW.controller$ResetTransferStatus_TargetScreen", "Brazil_TrackTransfer_MUI.referencesHealth", "Brazil_TrackTransfer_MUI.referencesHealth$Brazil_TrackTransfer_CW", "Brazil_TrackTransfer_MUI.controller$PurgeTransferStatus2"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_TrackTransfer_CWController, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.resetTransferStatus_State$Action = function (callContext) {
callContext = controller.callContext(callContext);
// TrackTransfer_NeedLogin = False
Brazil_TrackTransfer_MUIClientVariables.setTrackTransfer_NeedLogin(false);
// Execute Action: ResetTransferStatus_TargetScreen2
Brazil_TrackTransfer_CWController.default.resetTransferStatus_TargetScreen$Action(callContext);
// Execute Action: ResetTransferStatus_TargetScreen
Brazil_TrackTransfer_CWController.default.resetTransferStatus_TargetScreen$Action(callContext);
// Execute Action: PurgeTransferStatus2
Brazil_TrackTransfer_MUIController.default.purgeTransferStatus2$Action(callContext);
return ;
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.clientActionProxies.resetTransferStatus_State$Action = function () {
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.resetTransferStatus_State$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$SaveTransferStatus", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_CS.model", "Brazil_TrackTransfer_MUI.clientVariables", "Brazil_TrackTransfer_CS.model$TransferStatusRec", "Brazil_TrackTransfer_MUI.referencesHealth", "Brazil_TrackTransfer_MUI.referencesHealth$Brazil_TrackTransfer_CS"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_TrackTransfer_CSModel, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.saveTransferStatus$Action = function (transferStatusIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_TrackTransfer_MUI.SaveTransferStatus$vars"))());
vars.value.transferStatusInLocal = transferStatusIn.clone();
var jSONTransferStatusVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.JSONSerializeOutputType());
// JSON Serialize: JSONTransferStatus
jSONTransferStatusVar.value.jSONOut = OS.JSONUtils.serializeToJSON(vars.value.transferStatusInLocal, false, false);
// TrackTransfer_TransferStatusJSON = JSONTransferStatus.JSON
Brazil_TrackTransfer_MUIClientVariables.setTrackTransfer_TransferStatusJSON(jSONTransferStatusVar.value.jSONOut);
return ;
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.constructor.registerVariableGroupType("Brazil_TrackTransfer_MUI.SaveTransferStatus$vars", [{
name: "TransferStatus",
attrName: "transferStatusInLocal",
mandatory: true,
dataType: OS.Types.Record,
defaultValue: function () {
return new Brazil_TrackTransfer_CSModel.TransferStatusRec();
},
complexType: Brazil_TrackTransfer_CSModel.TransferStatusRec
}]);
Brazil_TrackTransfer_MUIController.default.clientActionProxies.saveTransferStatus$Action = function (transferStatusIn) {
transferStatusIn = (transferStatusIn === undefined) ? new Brazil_TrackTransfer_CSModel.TransferStatusRec() : transferStatusIn;
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.saveTransferStatus$Action.bind(controller, transferStatusIn), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$SetDefaulttTrackTransfer_AmountCurrency", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_MUI.clientVariables"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.setDefaulttTrackTransfer_AmountCurrency$Action = function (currencyIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_TrackTransfer_MUI.SetDefaulttTrackTransfer_AmountCurrency$vars"))());
vars.value.currencyInLocal = currencyIn;
// BRL
// TrackTransfer_AmountCurrency = Currency
Brazil_TrackTransfer_MUIClientVariables.setTrackTransfer_AmountCurrency(vars.value.currencyInLocal);
return ;
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.constructor.registerVariableGroupType("Brazil_TrackTransfer_MUI.SetDefaulttTrackTransfer_AmountCurrency$vars", [{
name: "Currency",
attrName: "currencyInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_TrackTransfer_MUIController.default.clientActionProxies.setDefaulttTrackTransfer_AmountCurrency$Action = function (currencyIn) {
currencyIn = (currencyIn === undefined) ? "" : currencyIn;
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.setDefaulttTrackTransfer_AmountCurrency$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(currencyIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$SyncLocalTrackTransfer_NoMTCN_Tabs", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_MUI.entities", "Brazil_TrackTransfer_MUI.clientVariables", "Brazil_TrackTransfer_MUI.model$TrackTransfer_NoMTCN_TabList", "Brazil_TrackTransfer_MUI.controller$ServerAction.SyncTrackTransfer_Sync", "Brazil_TrackTransfer_MUI.model$LocalTrackTransfer_NoMTCN_TabRecordList", "Brazil_TrackTransfer_MUI.model$LocalSyncControlRecord", "Brazil_TrackTransfer_MUI.model$LocalSyncControlRecordList", "Brazil_TrackTransfer_MUI.model$LocalTrackTransfer_NoMTCN_TabRec", "Brazil_TrackTransfer_MUI.model$LocalSyncControlRec"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_TrackTransfer_MUIEntities, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.syncLocalTrackTransfer_NoMTCN_Tabs$Action = function (callContext) {
callContext = controller.callContext(callContext);
var allExceptionsVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var syncTrackTransfer_SyncVar = new OS.DataTypes.VariableHolder();
var createOrUpdateLocalSyncControlVar = new OS.DataTypes.VariableHolder();
var getLocalSyncControlsVar = new OS.DataTypes.VariableHolder(new (OS.Controller.BaseController.getAggregateOutputType(Brazil_TrackTransfer_MUIModel.LocalSyncControlRecordList))());
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("Brazil_TrackTransfer_MUI.SyncLocalTrackTransfer_NoMTCN_Tabs$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Aggregate: GetLocalSyncControls
var getLocalSyncControlsAggr = function (maxRecords) {
var executeQuery = null;
if(OS.NativeHelper.isRunningOnNative()) {
executeQuery = function () {
var targetListType = Brazil_TrackTransfer_MUIModel.LocalSyncControlRecordList;
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var countArgsList = new OS.Entities.QueryArgumentsList();
if(!(maxRecords)) {
maxRecords = 1;
}


var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "\"ENLocalSyncControl\".\"Id\" o0, \"ENLocalSyncControl\".\"LastSyncDate\" o1";
} else {
selectSql += "\"ENLocalSyncControl\".\"Id\" o0, \"ENLocalSyncControl\".\"LastSyncDate\" o1";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_7zu_LocalSyncControl\" \"ENLocalSyncControl\"";
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

return OS.Entities.webSQLStorageInstance.executeQuery(sql, Brazil_TrackTransfer_MUIModel.LocalSyncControlRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"localSyncControlAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

}, argsList).then(function (resultList) {
result.list = resultList;
}).then(function () {
}).then(function () {
return result;
});
};
} else {
executeQuery = function () {
if(!(maxRecords)) {
maxRecords = 1;
}

return new Promise(function (resolve, reject) {
require(["Brazil_TrackTransfer_MUI.aggregates.IDB"], function (Brazil_TrackTransfer_MUIAggregates_IDB) {
return Brazil_TrackTransfer_MUIAggregates_IDB.executeSyncLocalTrackTransferNoMTCNTabs$ClientAction$getLocalSyncControlsAggr(maxRecords).then(function (result) {
resolve(result);
}).catch(function (e) {
reject(e);
});
});
});
};
}

return controller.executeClientAggregate(executeQuery, function () {
return getLocalSyncControlsVar.value;
});
};
return getLocalSyncControlsAggr().then(function () {
// Execute Action: SyncTrackTransfer_Sync
return controller.syncTrackTransfer_Sync$ServerAction(getLocalSyncControlsVar.value.listOut.getCurrent(callContext.iterationContext).localSyncControlAttr.lastSyncDateAttr, callContext).then(function (value) {
syncTrackTransfer_SyncVar.value = value;
});
}).then(function () {
// Has data to sync?
return OS.Flow.executeSequence(function () {
if((!(syncTrackTransfer_SyncVar.value.tabsOut.isEmpty))) {
// Execute Action: DeleteAllLocalTrackTransfer_NoMTCN_Tab
return Brazil_TrackTransfer_MUIModel.entities.LocalTrackTransfer_NoMTCN_Tab.deleteAll(callContext).then(function () {
// Execute Action: CreateOrUpdateSomeLocalTrackTransfer_NoMTCN_Tab
return Brazil_TrackTransfer_MUIModel.entities.LocalTrackTransfer_NoMTCN_Tab.createOrUpdateAll(OS.DataConversion.JSConversions.typeConvertRecordList(syncTrackTransfer_SyncVar.value.tabsOut, new Brazil_TrackTransfer_MUIModel.LocalTrackTransfer_NoMTCN_TabRecordList(), function (source, target) {
target.localTrackTransfer_NoMTCN_TabAttr.idAttr = source.idAttr;
target.localTrackTransfer_NoMTCN_TabAttr.stepAttr = source.stepAttr;
target.localTrackTransfer_NoMTCN_TabAttr.tabIndexAttr = source.tabIndexAttr;
return target;
}), callContext);
}).then(function () {
// GetLocalSyncControls.List.Current.LocalSyncControl.LastSyncDate = CurrDateTime
getLocalSyncControlsVar.value.listOut.getCurrent(callContext.iterationContext).localSyncControlAttr.lastSyncDateAttr = OS.BuiltinFunctions.currDateTime();
// Execute Action: CreateOrUpdateLocalSyncControl
return Brazil_TrackTransfer_MUIModel.entities.LocalSyncControl.createOrUpdate(getLocalSyncControlsVar.value.listOut.getCurrent(callContext.iterationContext), callContext).then(function (value) {
createOrUpdateLocalSyncControlVar.value = value;
});
}).then(function () {
// Success = True
outVars.value.successOut = true;
});
} else {
// Success = True
outVars.value.successOut = true;
}

});
});
}).catch(function (ex) {
OS.Logger.trace("SyncLocalTrackTransfer_NoMTCN_Tabs.SyncLocalTrackTransfer_NoMTCN_Tabs", OS.Exceptions.getMessage(ex), ex.name);
// Handle Error: AllExceptions
if(!(OS.Exceptions.isSystem(ex))) {
OS.Logger.error(null, ex);
allExceptionsVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
return OS.Flow.executeAsyncFlow(function () {
// ErrorMessage = AllExceptions.ExceptionMessage
outVars.value.errorMessageOut = allExceptionsVar.value.exceptionMessageAttr;
return OS.Flow.returnAsync(outVars.value);

});
}

throw ex;
}).then(function () {
return outVars.value;
});
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.constructor.registerVariableGroupType("Brazil_TrackTransfer_MUI.SyncLocalTrackTransfer_NoMTCN_Tabs$outVars", [{
name: "Success",
attrName: "successOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "ErrorMessage",
attrName: "errorMessageOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
Brazil_TrackTransfer_MUIController.default.clientActionProxies.syncLocalTrackTransfer_NoMTCN_Tabs$Action = function () {
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.syncLocalTrackTransfer_NoMTCN_Tabs$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Success: OS.DataConversion.JSNodeParamConverter.to(actionResults.successOut, OS.Types.Boolean),
ErrorMessage: OS.DataConversion.JSNodeParamConverter.to(actionResults.errorMessageOut, OS.Types.Text)
};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$ToggleTrackMethod", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_CW.controller", "Brazil_TrackTransfer_MUI.clientVariables", "Brazil_TrackTransfer_MUI.controller$Loading_ON", "Brazil_TrackTransfer_CW.controller$ResetTrackTransfer_MTCN_State", "Brazil_TrackTransfer_MUI.referencesHealth", "Brazil_TrackTransfer_MUI.referencesHealth$Brazil_TrackTransfer_CW", "Brazil_TrackTransfer_MUI.controller$ResetTrackTransfer_NoMTCN_State", "Brazil_TrackTransfer_MUI.controller$Loading_OFF"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController, Brazil_TrackTransfer_CWController, Brazil_TrackTransfer_MUIClientVariables) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.toggleTrackMethod$Action = function (callContext) {
callContext = controller.callContext(callContext);
// Execute Action: Loading_ON
Brazil_TrackTransfer_MUIController.default.loading_ON$Action(callContext);
// Execute Action: ResetTrackTransfer_MTCN_State
Brazil_TrackTransfer_CWController.default.resetTrackTransfer_MTCN_State$Action(callContext);
// Execute Action: ResetTrackTransfer_NoMTCN_State
Brazil_TrackTransfer_MUIController.default.resetTrackTransfer_NoMTCN_State$Action(callContext);
// TrackTransfer_IsUsingMTCN = notTrackTransfer_IsUsingMTCN
Brazil_TrackTransfer_MUIClientVariables.setTrackTransfer_IsUsingMTCN(!(Brazil_TrackTransfer_MUIClientVariables.getTrackTransfer_IsUsingMTCN()));
// Execute Action: Loading_OFF
Brazil_TrackTransfer_MUIController.default.loading_OFF$Action(callContext);
return ;
};
var controller = Brazil_TrackTransfer_MUIController.default;
Brazil_TrackTransfer_MUIController.default.clientActionProxies.toggleTrackMethod$Action = function () {
return controller.executeActionInsideJSNode(Brazil_TrackTransfer_MUIController.default.toggleTrackMethod$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("Brazil_TrackTransfer_MUI.controller$ServerAction.CreateOrUpdate_AirPickup", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.createOrUpdate_AirPickup$ServerAction = function (airPickupIn, callContext) {
var controller = this.controller;
var inputs = {
AirPickup: OS.DataConversion.ServerDataConverter.to(airPickupIn, OS.Types.Record)
};
return controller.callServerAction("CreateOrUpdate_AirPickup", "screenservices/Brazil_TrackTransfer_MUI/ActionCreateOrUpdate_AirPickup", "OG+jB6LLRl+Ot3O9X4KQ+A", inputs, controller.callContext(callContext), undefined, undefined, true).then(function (outputs) {
var executeServerActionResult = new (controller.constructor.getVariableGroupType("Brazil_TrackTransfer_MUI$rssespacebrazil_storage_db_ActionCreateOrUpdate_AirPickup"))();
executeServerActionResult.airPickupIdOut = OS.DataConversion.ServerDataConverter.from(outputs.AirPickupId, OS.Types.LongInteger);
return executeServerActionResult;
});
};
Brazil_TrackTransfer_MUIController.default.constructor.registerVariableGroupType("Brazil_TrackTransfer_MUI$rssespacebrazil_storage_db_ActionCreateOrUpdate_AirPickup", [{
name: "AirPickupId",
attrName: "airPickupIdOut",
mandatory: false,
dataType: OS.Types.LongInteger,
defaultValue: function () {
return OS.DataTypes.LongInteger.defaultValue;
}
}]);
});
define("Brazil_TrackTransfer_MUI.controller$ServerAction.SyncTrackTransfer_Sync", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller", "Brazil_TrackTransfer_MUI.model$TrackTransfer_NoMTCN_TabList"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUIController) {
var OS = OutSystems.Internal;
Brazil_TrackTransfer_MUIController.default.syncTrackTransfer_Sync$ServerAction = function (lastSyncDateIn, callContext) {
var controller = this.controller;
var inputs = {
LastSyncDate: OS.DataConversion.ServerDataConverter.to(lastSyncDateIn, OS.Types.DateTime)
};
return controller.callServerAction("SyncTrackTransfer_Sync", "screenservices/Brazil_TrackTransfer_MUI/ActionSyncTrackTransfer_Sync", "iUh3SBxe6xE5QLaAl7EhXw", inputs, controller.callContext(callContext), undefined, undefined, true).then(function (outputs) {
var executeServerActionResult = new (controller.constructor.getVariableGroupType("Brazil_TrackTransfer_MUI$rssespacebrazil_tracktransfer_cs_ActionSyncTrackTransfer_Sync"))();
executeServerActionResult.tabsOut = OS.DataConversion.ServerDataConverter.from(outputs.Tabs, Brazil_TrackTransfer_MUIModel.TrackTransfer_NoMTCN_TabList);
return executeServerActionResult;
});
};
Brazil_TrackTransfer_MUIController.default.constructor.registerVariableGroupType("Brazil_TrackTransfer_MUI$rssespacebrazil_tracktransfer_cs_ActionSyncTrackTransfer_Sync", [{
name: "Tabs",
attrName: "tabsOut",
mandatory: false,
dataType: OS.Types.RecordList,
defaultValue: function () {
return new Brazil_TrackTransfer_MUIModel.TrackTransfer_NoMTCN_TabList();
},
complexType: Brazil_TrackTransfer_MUIModel.TrackTransfer_NoMTCN_TabList
}]);
});
define("Brazil_TrackTransfer_MUI.controller", ["exports", "OutSystems/ClientRuntime/Main", "Brazil_TrackTransfer_MUI.model", "Brazil_TrackTransfer_MUI.controller$translationsResources"], function (exports, OutSystems, Brazil_TrackTransfer_MUIModel, Brazil_TrackTransfer_MUI_Controller_translationsResources) {
var OS = OutSystems.Internal;
var Brazil_TrackTransfer_MUIController = exports;
var Controller = (function (_super) {
__extends(Controller, _super);
function Controller() {
_super.apply(this, arguments);
}
Controller.prototype.clientActionProxies = {};
Controller.prototype.roles = {};
Controller.prototype.defaultTimeout = 100;
Controller.prototype.getDefaultTimeout = function () {
return Brazil_TrackTransfer_MUIController.default.defaultTimeout;
};
return Controller;
})(OS.Controller.BaseModuleController);
Brazil_TrackTransfer_MUIController.default = new Controller(Brazil_TrackTransfer_MUI_Controller_translationsResources, "Brazil_TrackTransfer_MUI");
});
define("Brazil_TrackTransfer_MUI.controller$translationsResources", ["exports"], function (exports) {
return {};
});
