﻿define("DevicePlugin.controller$CheckDevicePlugin", ["exports", "OutSystems/ClientRuntime/Main", "DevicePlugin.model", "DevicePlugin.controller", "CommonPlugin.controller", "CommonPlugin.model", "DevicePlugin.controller$CheckDevicePlugin.IsPluginAvailableJSJS", "CommonPlugin.controller$IsCordovaDefined", "DevicePlugin.referencesHealth", "DevicePlugin.referencesHealth$CommonPlugin", "CommonPlugin.model$ErrorRec"], function (exports, OutSystems, DevicePluginModel, DevicePluginController, CommonPluginController, CommonPluginModel, DevicePlugin_controller_CheckDevicePlugin_IsPluginAvailableJSJS) {
var OS = OutSystems.Internal;
DevicePluginController.default.checkDevicePlugin$Action = function (callContext) {
callContext = controller.callContext(callContext);
var allExceptionsVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var isCordovaDefinedVar = new OS.DataTypes.VariableHolder();
var isPluginAvailableJSJSResult = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("DevicePlugin.CheckDevicePlugin$outVars"))());
try {// Execute Action: IsCordovaDefined
isCordovaDefinedVar.value = CommonPluginController.default.isCordovaDefined$Action(callContext);

if((isCordovaDefinedVar.value.isLoadedOut)) {
// Validates if the plugin is currently available. Useful to verify if the current application has the plugin installed.
isPluginAvailableJSJSResult.value = controller.safeExecuteJSNode(DevicePlugin_controller_CheckDevicePlugin_IsPluginAvailableJSJS, "IsPluginAvailableJS", "CheckDevicePlugin", {
IsAvailable: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("DevicePlugin.CheckDevicePlugin$isPluginAvailableJSJSResult"))();
jsNodeResult.isAvailableOut = OS.DataConversion.JSNodeParamConverter.from($parameters.IsAvailable, OS.Types.Boolean);
return jsNodeResult;
}, {}, {});
if((isPluginAvailableJSJSResult.value.isAvailableOut)) {
// IsAvailable = IsPluginAvailableJS.IsAvailable
outVars.value.isAvailableOut = isPluginAvailableJSJSResult.value.isAvailableOut;
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
} else {
// Error.ErrorCode = 2
outVars.value.errorOut.errorCodeAttr = "2";
// Error.ErrorMessage = "Device plugin is unavailable"
outVars.value.errorOut.errorMessageAttr = "Device plugin is unavailable";
// IsAvailable = False
outVars.value.isAvailableOut = false;
}

} else {
// Error.ErrorCode = 1
outVars.value.errorOut.errorCodeAttr = "1";
// Error.ErrorMessage = "Cordova is not available"
outVars.value.errorOut.errorMessageAttr = "Cordova is not available";
// IsAvailable = False
outVars.value.isAvailableOut = false;
}

} catch (ex) {
(function () {
OS.Logger.trace("CheckDevicePlugin.CheckDevicePlugin", OS.Exceptions.getMessage(ex), ex.name);
// Handle Error: AllExceptions
if(!(OS.Exceptions.isSystem(ex))) {
OS.Logger.error(null, ex);
allExceptionsVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
// IsAvailable = False
outVars.value.isAvailableOut = false;
// Error.ErrorCode = -1
outVars.value.errorOut.errorCodeAttr = (-1).toString();
// Error.ErrorMessage = AllExceptions.ExceptionMessage
outVars.value.errorOut.errorMessageAttr = allExceptionsVar.value.exceptionMessageAttr;
return outVars.value;

}

throw ex;
})();
}

return outVars.value;
};
var controller = DevicePluginController.default;
DevicePluginController.default.constructor.registerVariableGroupType("DevicePlugin.CheckDevicePlugin$isPluginAvailableJSJSResult", [{
name: "IsAvailable",
attrName: "isAvailableOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
DevicePluginController.default.constructor.registerVariableGroupType("DevicePlugin.CheckDevicePlugin$outVars", [{
name: "IsAvailable",
attrName: "isAvailableOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}]);
DevicePluginController.default.clientActionProxies.checkDevicePlugin$Action = function () {
return controller.executeActionInsideJSNode(DevicePluginController.default.checkDevicePlugin$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
IsAvailable: OS.DataConversion.JSNodeParamConverter.to(actionResults.isAvailableOut, OS.Types.Boolean),
Error: actionResults.errorOut
};
});
};
});
define("DevicePlugin.controller$CheckDevicePlugin.IsPluginAvailableJSJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
$parameters.IsAvailable = !!window.device;
};
});

define("DevicePlugin.controller$GetDeviceInfo", ["exports", "OutSystems/ClientRuntime/Main", "DevicePlugin.model", "DevicePlugin.controller", "CommonPlugin.model", "DevicePlugin.controller$GetDeviceInfo.GetDeviceJS", "CommonPlugin.model$ErrorRec", "DevicePlugin.referencesHealth", "DevicePlugin.referencesHealth$CommonPlugin", "DevicePlugin.controller$CheckDevicePlugin", "DevicePlugin.model$DeviceRec"], function (exports, OutSystems, DevicePluginModel, DevicePluginController, CommonPluginModel, DevicePlugin_controller_GetDeviceInfo_GetDeviceJS) {
var OS = OutSystems.Internal;
DevicePluginController.default.getDeviceInfo$Action = function (callContext) {
callContext = controller.callContext(callContext);
var allExceptionsVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var checkDevicePluginVar = new OS.DataTypes.VariableHolder();
var getDeviceJSResult = new OS.DataTypes.VariableHolder();
var jSONDeserializeDeviceVar = new OS.DataTypes.VariableHolder(new (OS.Controller.BaseController.getJSONDeserializeOutputType(DevicePluginModel.DeviceRec))());
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("DevicePlugin.GetDeviceInfo$outVars"))());
try {// Execute Action: CheckDevicePlugin
checkDevicePluginVar.value = DevicePluginController.default.checkDevicePlugin$Action(callContext);

// Is Console Plugin Available?
if((checkDevicePluginVar.value.isAvailableOut)) {
getDeviceJSResult.value = controller.safeExecuteJSNode(DevicePlugin_controller_GetDeviceInfo_GetDeviceJS, "GetDevice", "GetDeviceInfo", {
Success: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean),
JsonDevice: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text),
ErrorMessage: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("DevicePlugin.GetDeviceInfo$getDeviceJSResult"))();
jsNodeResult.successOut = OS.DataConversion.JSNodeParamConverter.from($parameters.Success, OS.Types.Boolean);
jsNodeResult.jsonDeviceOut = OS.DataConversion.JSNodeParamConverter.from($parameters.JsonDevice, OS.Types.Text);
jsNodeResult.errorMessageOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ErrorMessage, OS.Types.Text);
return jsNodeResult;
}, {}, {});
if((getDeviceJSResult.value.successOut)) {
// JSON Deserialize: JSONDeserializeDevice
jSONDeserializeDeviceVar.value.dataOut = OS.JSONUtils.deserializeFromJSON(getDeviceJSResult.value.jsonDeviceOut, DevicePluginModel.DeviceRec, false);
// AssignOutput
// Device = JSONDeserializeDevice.Data
outVars.value.deviceOut = jSONDeserializeDeviceVar.value.dataOut;
// Success = True
outVars.value.successOut = true;
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
} else {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorCode = 3
outVars.value.errorOut.errorCodeAttr = "3";
// Error.ErrorMessage = GetDevice.ErrorMessage
outVars.value.errorOut.errorMessageAttr = getDeviceJSResult.value.errorMessageOut;
}

} else {
// Error.ErrorCode = CheckDevicePlugin.Error.ErrorCode
outVars.value.errorOut.errorCodeAttr = checkDevicePluginVar.value.errorOut.errorCodeAttr;
// Error.ErrorMessage = CheckDevicePlugin.Error.ErrorMessage
outVars.value.errorOut.errorMessageAttr = checkDevicePluginVar.value.errorOut.errorMessageAttr;
// Success = False
outVars.value.successOut = false;
}

} catch (ex) {
(function () {
OS.Logger.trace("GetDeviceInfo.GetDeviceInfo", OS.Exceptions.getMessage(ex), ex.name);
// Handle Error: AllExceptions
if(!(OS.Exceptions.isSystem(ex))) {
OS.Logger.error(null, ex);
allExceptionsVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = AllExceptions.ExceptionMessage
outVars.value.errorOut.errorMessageAttr = allExceptionsVar.value.exceptionMessageAttr;
// Error.ErrorCode = -1
outVars.value.errorOut.errorCodeAttr = (-1).toString();
return outVars.value;

}

throw ex;
})();
}

return outVars.value;
};
var controller = DevicePluginController.default;
DevicePluginController.default.constructor.registerVariableGroupType("DevicePlugin.GetDeviceInfo$getDeviceJSResult", [{
name: "Success",
attrName: "successOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "JsonDevice",
attrName: "jsonDeviceOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "ErrorMessage",
attrName: "errorMessageOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
DevicePluginController.default.constructor.registerVariableGroupType("DevicePlugin.GetDeviceInfo$outVars", [{
name: "Device",
attrName: "deviceOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new DevicePluginModel.DeviceRec();
},
complexType: DevicePluginModel.DeviceRec
}, {
name: "Success",
attrName: "successOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}]);
DevicePluginController.default.clientActionProxies.getDeviceInfo$Action = function () {
return controller.executeActionInsideJSNode(DevicePluginController.default.getDeviceInfo$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Device: actionResults.deviceOut,
Success: OS.DataConversion.JSNodeParamConverter.to(actionResults.successOut, OS.Types.Boolean),
Error: actionResults.errorOut
};
});
};
});
define("DevicePlugin.controller$GetDeviceInfo.GetDeviceJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
try{

    var jsonString = JSON.stringify(window.device);

    

    $parameters.JsonDevice = jsonString

    $parameters.Success = true;

    $parameters.ErrorMessage = "";

}catch(error){

    $parameters.Success = false;

    

    if(error === "object"){

        $parameters.ErrorMessage = error.message;

    }

    else{

        $parameters.ErrorMessage = error;

    }

    

}


};
});

define("DevicePlugin.controller", ["exports", "OutSystems/ClientRuntime/Main", "DevicePlugin.model"], function (exports, OutSystems, DevicePluginModel) {
var OS = OutSystems.Internal;
var DevicePluginController = exports;
var Controller = (function (_super) {
__extends(Controller, _super);
function Controller() {
_super.apply(this, arguments);
}
Controller.prototype.clientActionProxies = {};
Controller.prototype.roles = {};
Controller.prototype.defaultTimeout = 10;
Controller.prototype.getDefaultTimeout = function () {
return DevicePluginController.default.defaultTimeout;
};
return Controller;
})(OS.Controller.BaseModuleController);
DevicePluginController.default = new Controller(null, "DevicePlugin");
});
