﻿define("SettingsPlugin.controller$CheckSettingsPlugin", ["exports", "OutSystems/ClientRuntime/Main", "SettingsPlugin.model", "SettingsPlugin.controller", "CommonPlugin.controller", "CommonPlugin.model", "SettingsPlugin.controller$CheckSettingsPlugin.IsPluginAvailableJSJS", "CommonPlugin.controller$IsCordovaDefined", "SettingsPlugin.referencesHealth", "SettingsPlugin.referencesHealth$CommonPlugin", "CommonPlugin.model$ErrorRec"], function (exports, OutSystems, SettingsPluginModel, SettingsPluginController, CommonPluginController, CommonPluginModel, SettingsPlugin_controller_CheckSettingsPlugin_IsPluginAvailableJSJS) {
var OS = OutSystems.Internal;
SettingsPluginController.default.checkSettingsPlugin$Action = function (callContext) {
callContext = controller.callContext(callContext);
var allExceptionsVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var isCordovaDefinedVar = new OS.DataTypes.VariableHolder();
var isPluginAvailableJSJSResult = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("SettingsPlugin.CheckSettingsPlugin$outVars"))());
try {// Execute Action: IsCordovaDefined
isCordovaDefinedVar.value = CommonPluginController.default.isCordovaDefined$Action(callContext);

if((isCordovaDefinedVar.value.isLoadedOut)) {
// Validates if the plugin is currently available. Useful to verify if the current application has the plugin installed.
isPluginAvailableJSJSResult.value = controller.safeExecuteJSNode(SettingsPlugin_controller_CheckSettingsPlugin_IsPluginAvailableJSJS, "IsPluginAvailableJS", "CheckSettingsPlugin", {
IsAvailable: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("SettingsPlugin.CheckSettingsPlugin$isPluginAvailableJSJSResult"))();
jsNodeResult.isAvailableOut = OS.DataConversion.JSNodeParamConverter.from($parameters.IsAvailable, OS.Types.Boolean);
return jsNodeResult;
}, {}, {});
if((isPluginAvailableJSJSResult.value.isAvailableOut)) {
// IsAvailable = IsPluginAvailableJS.IsAvailable
outVars.value.isAvailableOut = isPluginAvailableJSJSResult.value.isAvailableOut;
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
} else {
// Error.ErrorCode = 2
outVars.value.errorOut.errorCodeAttr = "2";
// Error.ErrorMessage = "Settings Plugin is unavailable"
outVars.value.errorOut.errorMessageAttr = "Settings Plugin is unavailable";
// IsAvailable = False
outVars.value.isAvailableOut = false;
}

} else {
// Error.ErrorCode = 1
outVars.value.errorOut.errorCodeAttr = "1";
// Error.ErrorMessage = "Cordova is not available"
outVars.value.errorOut.errorMessageAttr = "Cordova is not available";
// IsAvailable = False
outVars.value.isAvailableOut = false;
}

} catch (ex) {
(function () {
OS.Logger.trace("CheckSettingsPlugin.CheckSettingsPlugin", OS.Exceptions.getMessage(ex), ex.name);
// Handle Error: AllExceptions
if(!(OS.Exceptions.isSystem(ex))) {
OS.Logger.error(null, ex);
allExceptionsVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
// IsAvailable = False
outVars.value.isAvailableOut = false;
// Error.ErrorCode = -1
outVars.value.errorOut.errorCodeAttr = (-1).toString();
// Error.ErrorMessage = AllExceptions.ExceptionMessage
outVars.value.errorOut.errorMessageAttr = allExceptionsVar.value.exceptionMessageAttr;
return outVars.value;

}

throw ex;
})();
}

return outVars.value;
};
var controller = SettingsPluginController.default;
SettingsPluginController.default.constructor.registerVariableGroupType("SettingsPlugin.CheckSettingsPlugin$isPluginAvailableJSJSResult", [{
name: "IsAvailable",
attrName: "isAvailableOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
SettingsPluginController.default.constructor.registerVariableGroupType("SettingsPlugin.CheckSettingsPlugin$outVars", [{
name: "IsAvailable",
attrName: "isAvailableOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}]);
SettingsPluginController.default.clientActionProxies.checkSettingsPlugin$Action = function () {
return controller.executeActionInsideJSNode(SettingsPluginController.default.checkSettingsPlugin$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
IsAvailable: OS.DataConversion.JSNodeParamConverter.to(actionResults.isAvailableOut, OS.Types.Boolean),
Error: actionResults.errorOut
};
});
};
});
define("SettingsPlugin.controller$CheckSettingsPlugin.IsPluginAvailableJSJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
$parameters.IsAvailable = !!window.cordova.plugins.settings
};
});

define("SettingsPlugin.controller$OpenSettings", ["exports", "OutSystems/ClientRuntime/Main", "SettingsPlugin.model", "SettingsPlugin.controller", "CommonPlugin.model", "SettingsPlugin.controller$OpenSettings.OpenSettingsJSJS", "CommonPlugin.model$ErrorRec", "SettingsPlugin.referencesHealth", "SettingsPlugin.referencesHealth$CommonPlugin", "SettingsPlugin.controller$CheckSettingsPlugin"], function (exports, OutSystems, SettingsPluginModel, SettingsPluginController, CommonPluginModel, SettingsPlugin_controller_OpenSettings_OpenSettingsJSJS) {
var OS = OutSystems.Internal;
SettingsPluginController.default.openSettings$Action = function (settingIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("SettingsPlugin.OpenSettings$vars"))());
vars.value.settingInLocal = settingIn;
var allExceptionsVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var checkSettingsPluginVar = new OS.DataTypes.VariableHolder();
var openSettingsJSJSResult = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("SettingsPlugin.OpenSettings$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: CheckSettingsPlugin
checkSettingsPluginVar.value = SettingsPluginController.default.checkSettingsPlugin$Action(callContext);

// Is Settings Plugin available?
return OS.Flow.executeSequence(function () {
if((checkSettingsPluginVar.value.isAvailableOut)) {
// Use this action to add a contact to the device's address book.
return controller.safeExecuteAsyncJSNode(SettingsPlugin_controller_OpenSettings_OpenSettingsJSJS, "OpenSettingsJS", "OpenSettings", {
Setting: OS.DataConversion.JSNodeParamConverter.to(vars.value.settingInLocal, OS.Types.Text),
Success: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean),
ErrorMessage: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("SettingsPlugin.OpenSettings$openSettingsJSJSResult"))();
jsNodeResult.successOut = OS.DataConversion.JSNodeParamConverter.from($parameters.Success, OS.Types.Boolean);
jsNodeResult.errorMessageOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ErrorMessage, OS.Types.Text);
return jsNodeResult;
}, {}, {}).then(function (results) {
openSettingsJSJSResult.value = results;
}).then(function () {
if((openSettingsJSJSResult.value.successOut)) {
// Set Values
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
// Success = OpenSettingsJS.Success
outVars.value.successOut = openSettingsJSJSResult.value.successOut;
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
} else {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = OpenSettingsJS.ErrorMessage
outVars.value.errorOut.errorMessageAttr = openSettingsJSJSResult.value.errorMessageOut;
// Error.ErrorCode = 3
outVars.value.errorOut.errorCodeAttr = "3";
}

});
} else {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = CheckSettingsPlugin.Error.ErrorMessage
outVars.value.errorOut.errorMessageAttr = checkSettingsPluginVar.value.errorOut.errorMessageAttr;
// Error.ErrorCode = CheckSettingsPlugin.Error.ErrorCode
outVars.value.errorOut.errorCodeAttr = checkSettingsPluginVar.value.errorOut.errorCodeAttr;
}

});
}).catch(function (ex) {
OS.Logger.trace("OpenSettings.OpenSettings", OS.Exceptions.getMessage(ex), ex.name);
// Handle Error: AllExceptions
if(!(OS.Exceptions.isSystem(ex))) {
OS.Logger.error(null, ex);
allExceptionsVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
return OS.Flow.executeAsyncFlow(function () {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = AllExceptions.ExceptionMessage
outVars.value.errorOut.errorMessageAttr = allExceptionsVar.value.exceptionMessageAttr;
// Error.ErrorCode = -1
outVars.value.errorOut.errorCodeAttr = (-1).toString();
return OS.Flow.returnAsync(outVars.value);

});
}

throw ex;
}).then(function () {
return outVars.value;
});
};
var controller = SettingsPluginController.default;
SettingsPluginController.default.constructor.registerVariableGroupType("SettingsPlugin.OpenSettings$vars", [{
name: "Setting",
attrName: "settingInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
SettingsPluginController.default.constructor.registerVariableGroupType("SettingsPlugin.OpenSettings$openSettingsJSJSResult", [{
name: "Success",
attrName: "successOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "ErrorMessage",
attrName: "errorMessageOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
SettingsPluginController.default.constructor.registerVariableGroupType("SettingsPlugin.OpenSettings$outVars", [{
name: "Success",
attrName: "successOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}]);
SettingsPluginController.default.clientActionProxies.openSettings$Action = function (settingIn) {
settingIn = (settingIn === undefined) ? "" : settingIn;
return controller.executeActionInsideJSNode(SettingsPluginController.default.openSettings$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(settingIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Success: OS.DataConversion.JSNodeParamConverter.to(actionResults.successOut, OS.Types.Boolean),
Error: actionResults.errorOut
};
});
};
});
define("SettingsPlugin.controller$OpenSettings.OpenSettingsJSJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
return new Promise(function ($resolve, $reject) {
function onSuccess() {
    $parameters.Success = true;
    $parameters.ErrorMessage = "";
    $resolve(); 
}

function onError() {
    $parameters.Success = false;
    $parameters.ErrorMessage = "Could not open settings";
    $resolve();
}

// open
window.cordova.plugins.settings.open($parameters.Setting, onSuccess, onError);
});
};
});

define("SettingsPlugin.controller", ["exports", "OutSystems/ClientRuntime/Main", "SettingsPlugin.model"], function (exports, OutSystems, SettingsPluginModel) {
var OS = OutSystems.Internal;
var SettingsPluginController = exports;
var Controller = (function (_super) {
__extends(Controller, _super);
function Controller() {
_super.apply(this, arguments);
}
Controller.prototype.clientActionProxies = {};
Controller.prototype.roles = {};
Controller.prototype.defaultTimeout = 10;
Controller.prototype.getDefaultTimeout = function () {
return SettingsPluginController.default.defaultTimeout;
};
return Controller;
})(OS.Controller.BaseModuleController);
SettingsPluginController.default = new Controller(null, "SettingsPlugin");
});
