﻿define("WUBrazilMobileApp.Common.controller", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller", "Brazil_MTh.controller", "WUBrazilMobileApp.clientVariables", "WUBrazilMobileApp.Common.controller$translationsResources", "WUBrazilMobileApp.controller$ServerAction.NonProdLogMessage", "Brazil_MTh.controller$GetIsOfflineMesssage", "WUBrazilMobileApp.referencesHealth", "WUBrazilMobileApp.referencesHealth$Brazil_MTh"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController, Brazil_MThController, WUBrazilMobileAppClientVariables, WUBrazilMobileApp_Common_Controller_translationsResources) {
var OS = OutSystems.Internal;
var WUBrazilMobileApp_CommonController = exports;
var Controller = (function (_super) {
__extends(Controller, _super);
function Controller() {
_super.apply(this, arguments);
}
Controller.prototype.getDefaultTimeout = function () {
return WUBrazilMobileAppController.default.defaultTimeout;
};
Controller.prototype.handleError = function (ex, callContext) {
var controller = this.controller;
var allExceptionsVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var noInternetVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var communicationExceptionVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var securityExceptionVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
OS.Logger.trace("Common.OnException", OS.Exceptions.getMessage(ex), ex.name);
if(OS.ErrorHandling.ignoreError(ex, callContext)) {
return OS.ErrorHandling.IGNORED_ERROR_RESULT;
}

return OS.Flow.tryCatch(function () {
OS.Logger.trace("Common.OnException", OS.Exceptions.getMessage(ex), ex.name);
// Handle Error: NoInternet
if(OS.Exceptions.isInstanceOf(ex, OS.Exceptions.Exceptions.UserException, "WUBrazilMobileApp.NoInternet")) {
OS.Logger.error(null, ex);
noInternetVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: NonProdLogMessage3
return controller.nonProdLogMessage$ServerAction(("noInternet exceptions: " + noInternetVar.value.exceptionMessageAttr), "splash", callContext).then(function () {
OS.FeedbackMessageService.showFeedbackMessage(Brazil_MThController.default.getIsOfflineMesssage$Action(callContext).offlineMessageOut, /*Info*/ 0);
return OS.Flow.returnAsync();

});
});
}

// Handle Error: CommunicationException
if(OS.Exceptions.isInstanceOf(ex, OS.Exceptions.Exceptions.CommunicationException)) {
OS.Logger.error(null, ex);
communicationExceptionVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: NonProdLogMessage2
return controller.nonProdLogMessage$ServerAction(("comms exceptions: " + communicationExceptionVar.value.exceptionMessageAttr), "splash", callContext).then(function () {
OS.FeedbackMessageService.showFeedbackMessage(Brazil_MThController.default.getIsOfflineMesssage$Action(callContext).offlineMessageOut, /*Info*/ 0);
return OS.Flow.returnAsync();

});
});
}

// Handle Error: SecurityException
if(OS.Exceptions.isInstanceOf(ex, OS.Exceptions.Exceptions.SecurityException)) {
securityExceptionVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: NonProdLogMessage4
return controller.nonProdLogMessage$ServerAction(("sec exceptions: " + securityExceptionVar.value.exceptionMessageAttr), "splash", callContext).then(function () {
// Destination: /WUBrazilMobileApp/WalletWelcome
return OS.Flow.returnAsync(OS.Navigation.navigateTo(OS.Navigation.generateScreenURL("/WUBrazilMobileApp/WalletWelcome", {}), OS.Transitions.createTransition(OS.Transitions.TransitionAnimation.Default), callContext, true));
});
});
}

// Handle Error: AllExceptions
if(!(OS.Exceptions.isSystem(ex))) {
OS.Logger.error(null, ex);
allExceptionsVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: NonProdLogMessage
return controller.nonProdLogMessage$ServerAction(("all exceptions: " + allExceptionsVar.value.exceptionMessageAttr), "splash", callContext).then(function () {
OS.FeedbackMessageService.showFeedbackMessage(allExceptionsVar.value.exceptionMessageAttr, /*Error*/ 3);
return OS.Flow.returnAsync();

});
});
}

throw ex;
}, function (unhandledEx) {
OS.Logger.trace("Common.OnException", OS.Exceptions.getMessage(ex), ex.name);
if(!(OS.ErrorHandling.ignoreError(unhandledEx, callContext))) {
OS.ErrorHandling.handleError(unhandledEx, callContext);
return OS.ErrorHandling.UNHANDLED_ERROR_RESULT;

}

return OS.ErrorHandling.IGNORED_ERROR_RESULT;

});


};
Controller.prototype.nonProdLogMessage$ServerAction = function (messageIn, moduleIn, callContext) {
var controller = this.controller;
var inputs = {
Message: OS.DataConversion.ServerDataConverter.to(messageIn, OS.Types.Text),
Module: OS.DataConversion.ServerDataConverter.to(moduleIn, OS.Types.Text)
};
return controller.callServerAction("NonProdLogMessage", "screenservices/WUBrazilMobileApp/ActionNonProdLogMessage", "7d0b5n2wLZQuwtBxoIn5ZA", inputs, controller.callContext(callContext), undefined, undefined, true).then(function (outputs) {
});
};
return Controller;
})(OS.Controller.BaseController);
WUBrazilMobileApp_CommonController.default = new Controller(WUBrazilMobileApp_Common_Controller_translationsResources);
});

define("WUBrazilMobileApp.Common.controller$translationsResources", ["exports"], function (exports) {
return {};
});
