﻿define("WUBrazilMobileApp.aggregates.SQL", ["OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "Brazil_OfflineStorage.entities", "Brazil_OfflineStorage.model", "WUBrazilMobileApp.controller", "WUBrazilMobileApp.model$SettingsRecordList", "WUBrazilMobileApp.model$LocalDeeplinkAllowedPageRecordList", "Brazil_OfflineStorage.model$SettingsRec", "Brazil_OfflineStorage.model$LocalDeeplinkAllowedPageRec"], function (OutSystems, WUBrazilMobileAppModel, Brazil_OfflineStorageEntities, Brazil_OfflineStorageModel, WUBrazilMobileAppController) {
var OS = OutSystems.Internal;
var serializer = new OS.WebSQLSerializer.default();
function ClientAggregates() {
}
function executeTransaction(body, entityInfos) {
var dbServ = OS.Injector.resolve(OS.ServiceNames.EntityService);
return dbServ.executeAggregate(function (transaction) {
return body(transaction);
}, entityInfos);
}
ClientAggregates.executeOnApplicationReady$ClientSystemAction$getSettingsAggr = function (maxRecords) {
var Settings_Info = Brazil_OfflineStorageEntities.getEntityInfos().filter(function (info) {
return (info.key === "c3486011-eb75-4457-8e15-21cf2d318bdf");
})[0];
var aggrEntityInfos = [Settings_Info];

return executeTransaction(function (transaction) {
return new Promise(function (resolve, reject) {
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var targetListType = WUBrazilMobileAppModel.SettingsRecordList;
if(!(maxRecords)) {
maxRecords = 0;
}

var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "NULL o0, NULL o1, NULL o2, NULL o3, NULL o4, NULL o5, NULL o6, \"ENSettings\".\"AppLanguage\" o7, NULL o8, NULL o9, NULL o10, NULL o11, NULL o12, NULL o13, NULL o14, NULL o15";
} else {
selectSql += "\"ENSettings\".\"Id\" o0, \"ENSettings\".\"Email\" o1, \"ENSettings\".\"LoginBiometrics\" o2, \"ENSettings\".\"IsBioMaybeLater\" o3, \"ENSettings\".\"IsPasscodeOnDevice\" o4, \"ENSettings\".\"LoginAttemptsCount\" o5, \"ENSettings\".\"HasOnbardingDone\" o6, \"ENSettings\".\"AppLanguage\" o7, \"ENSettings\".\"HasGivenAccessCode\" o8, \"ENSettings\".\"LastLogin\" o9, \"ENSettings\".\"TemporaryIsNotifications\" o10, \"ENSettings\".\"IsCameraDenied\" o11, \"ENSettings\".\"BiometricAttempts\" o12, \"ENSettings\".\"DontShowAgain\" o13, \"ENSettings\".\"PingSessionId\" o14, \"ENSettings\".\"WalletComplianceVersion\" o15";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_9k2_Settings\" \"ENSettings\"";
orderBySql += " ORDER BY \"ENSettings\".\"Email\" ASC ";
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

var successCallback = function (transaction, resultSet) {
var convertedResult = serializer.deserializeAggregate(resultSet.rows, WUBrazilMobileAppModel.SettingsRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"settingsAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

});
result.list = convertedResult;
resolve(result);
};
var errorCallback = function (transaction, sqlError) {
var error = new Error(sqlError.message.toString());
reject(error);
return false;
};
transaction.executeSql(sql, argsList.argumentList, successCallback, errorCallback);
});
}, aggrEntityInfos).then(function (result) {
return result;
}).then(function (result) {
return result;
});
};
ClientAggregates.executeDeeplinkAllowedList$ClientAction$getLocalDeeplinkAllowedPageByIdAggr = function (qpstId, maxRecords) {
var LocalDeeplinkAllowedPage_Info = Brazil_OfflineStorageEntities.getEntityInfos().filter(function (info) {
return (info.key === "96b32df6-e4eb-4a1e-8c3f-8cee17c1a2e1");
})[0];
var aggrEntityInfos = [LocalDeeplinkAllowedPage_Info];

return executeTransaction(function (transaction) {
return new Promise(function (resolve, reject) {
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var targetListType = WUBrazilMobileAppModel.LocalDeeplinkAllowedPageRecordList;
if(!(maxRecords)) {
maxRecords = 9999;
}

var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "NULL o0, \"ENLocalDeeplinkAllowedPage\".\"Page\" o1, NULL o2";
} else {
selectSql += "\"ENLocalDeeplinkAllowedPage\".\"Id\" o0, \"ENLocalDeeplinkAllowedPage\".\"Page\" o1, \"ENLocalDeeplinkAllowedPage\".\"LastUpdatedAt\" o2";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_9k2_LocalDeeplinkAllowedPage\" \"ENLocalDeeplinkAllowedPage\"";
fromAndWhereSql += " WHERE (\"ENLocalDeeplinkAllowedPage\".\"Id\" = ((CAST(:qpstId AS INTEGER))))";
argsList.add("qpstId", /*TEXT*/ 0, qpstId);
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

var successCallback = function (transaction, resultSet) {
var convertedResult = serializer.deserializeAggregate(resultSet.rows, WUBrazilMobileAppModel.LocalDeeplinkAllowedPageRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"localDeeplinkAllowedPageAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

});
result.list = convertedResult;
resolve(result);
};
var errorCallback = function (transaction, sqlError) {
var error = new Error(sqlError.message.toString());
reject(error);
return false;
};
transaction.executeSql(sql, argsList.argumentList, successCallback, errorCallback);
});
}, aggrEntityInfos).then(function (result) {
return result;
}).then(function (result) {
return result;
});
};
ClientAggregates.executeDeeplinkAllowedList$ClientAction$getLocalDeeplinkAllowedPageByTargetScreenAggr = function (qpstPage, maxRecords) {
var LocalDeeplinkAllowedPage_Info = Brazil_OfflineStorageEntities.getEntityInfos().filter(function (info) {
return (info.key === "96b32df6-e4eb-4a1e-8c3f-8cee17c1a2e1");
})[0];
var aggrEntityInfos = [LocalDeeplinkAllowedPage_Info];

return executeTransaction(function (transaction) {
return new Promise(function (resolve, reject) {
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var targetListType = WUBrazilMobileAppModel.LocalDeeplinkAllowedPageRecordList;
if(!(maxRecords)) {
maxRecords = 9999;
}

var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "NULL o0, \"ENLocalDeeplinkAllowedPage\".\"Page\" o1, NULL o2";
} else {
selectSql += "\"ENLocalDeeplinkAllowedPage\".\"Id\" o0, \"ENLocalDeeplinkAllowedPage\".\"Page\" o1, \"ENLocalDeeplinkAllowedPage\".\"LastUpdatedAt\" o2";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_9k2_LocalDeeplinkAllowedPage\" \"ENLocalDeeplinkAllowedPage\"";
fromAndWhereSql += " WHERE ((Lower(\"ENLocalDeeplinkAllowedPage\".\"Page\")) = (Lower(:qpstPage)))";
argsList.add("qpstPage", /*TEXT*/ 0, qpstPage);
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

var successCallback = function (transaction, resultSet) {
var convertedResult = serializer.deserializeAggregate(resultSet.rows, WUBrazilMobileAppModel.LocalDeeplinkAllowedPageRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"localDeeplinkAllowedPageAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

});
result.list = convertedResult;
resolve(result);
};
var errorCallback = function (transaction, sqlError) {
var error = new Error(sqlError.message.toString());
reject(error);
return false;
};
transaction.executeSql(sql, argsList.argumentList, successCallback, errorCallback);
});
}, aggrEntityInfos).then(function (result) {
return result;
}).then(function (result) {
return result;
});
};
ClientAggregates.executeOneAppWelcome$WelcomeLogIn$Action$getSettingsAggr = function (maxRecords) {
var Settings_Info = Brazil_OfflineStorageEntities.getEntityInfos().filter(function (info) {
return (info.key === "c3486011-eb75-4457-8e15-21cf2d318bdf");
})[0];
var aggrEntityInfos = [Settings_Info];

return executeTransaction(function (transaction) {
return new Promise(function (resolve, reject) {
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var targetListType = WUBrazilMobileAppModel.SettingsRecordList;
if(!(maxRecords)) {
maxRecords = 1;
}

var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "NULL o0, \"ENSettings\".\"Email\" o1, NULL o2, NULL o3, \"ENSettings\".\"IsPasscodeOnDevice\" o4, NULL o5, NULL o6, NULL o7, NULL o8, \"ENSettings\".\"LastLogin\" o9, NULL o10, NULL o11, NULL o12, NULL o13, NULL o14, NULL o15";
} else {
selectSql += "\"ENSettings\".\"Id\" o0, \"ENSettings\".\"Email\" o1, \"ENSettings\".\"LoginBiometrics\" o2, \"ENSettings\".\"IsBioMaybeLater\" o3, \"ENSettings\".\"IsPasscodeOnDevice\" o4, \"ENSettings\".\"LoginAttemptsCount\" o5, \"ENSettings\".\"HasOnbardingDone\" o6, \"ENSettings\".\"AppLanguage\" o7, \"ENSettings\".\"HasGivenAccessCode\" o8, \"ENSettings\".\"LastLogin\" o9, \"ENSettings\".\"TemporaryIsNotifications\" o10, \"ENSettings\".\"IsCameraDenied\" o11, \"ENSettings\".\"BiometricAttempts\" o12, \"ENSettings\".\"DontShowAgain\" o13, \"ENSettings\".\"PingSessionId\" o14, \"ENSettings\".\"WalletComplianceVersion\" o15";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_9k2_Settings\" \"ENSettings\"";
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

var successCallback = function (transaction, resultSet) {
var convertedResult = serializer.deserializeAggregate(resultSet.rows, WUBrazilMobileAppModel.SettingsRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"settingsAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

});
result.list = convertedResult;
resolve(result);
};
var errorCallback = function (transaction, sqlError) {
var error = new Error(sqlError.message.toString());
reject(error);
return false;
};
transaction.executeSql(sql, argsList.argumentList, successCallback, errorCallback);
});
}, aggrEntityInfos).then(function (result) {
return result;
}).then(function (result) {
return result;
});
};
ClientAggregates.executeOneAppWelcome$WelcomeReceiveMoney$Action$getSettingsAggr = function (maxRecords) {
var Settings_Info = Brazil_OfflineStorageEntities.getEntityInfos().filter(function (info) {
return (info.key === "c3486011-eb75-4457-8e15-21cf2d318bdf");
})[0];
var aggrEntityInfos = [Settings_Info];

return executeTransaction(function (transaction) {
return new Promise(function (resolve, reject) {
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var targetListType = WUBrazilMobileAppModel.SettingsRecordList;
if(!(maxRecords)) {
maxRecords = 1000000;
}

var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "NULL o0, NULL o1, NULL o2, NULL o3, NULL o4, NULL o5, NULL o6, NULL o7, NULL o8, NULL o9, NULL o10, NULL o11, NULL o12, \"ENSettings\".\"DontShowAgain\" o13, NULL o14, NULL o15";
} else {
selectSql += "\"ENSettings\".\"Id\" o0, \"ENSettings\".\"Email\" o1, \"ENSettings\".\"LoginBiometrics\" o2, \"ENSettings\".\"IsBioMaybeLater\" o3, \"ENSettings\".\"IsPasscodeOnDevice\" o4, \"ENSettings\".\"LoginAttemptsCount\" o5, \"ENSettings\".\"HasOnbardingDone\" o6, \"ENSettings\".\"AppLanguage\" o7, \"ENSettings\".\"HasGivenAccessCode\" o8, \"ENSettings\".\"LastLogin\" o9, \"ENSettings\".\"TemporaryIsNotifications\" o10, \"ENSettings\".\"IsCameraDenied\" o11, \"ENSettings\".\"BiometricAttempts\" o12, \"ENSettings\".\"DontShowAgain\" o13, \"ENSettings\".\"PingSessionId\" o14, \"ENSettings\".\"WalletComplianceVersion\" o15";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_9k2_Settings\" \"ENSettings\"";
orderBySql += " ORDER BY \"ENSettings\".\"Email\" ASC ";
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

var successCallback = function (transaction, resultSet) {
var convertedResult = serializer.deserializeAggregate(resultSet.rows, WUBrazilMobileAppModel.SettingsRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"settingsAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

});
result.list = convertedResult;
resolve(result);
};
var errorCallback = function (transaction, sqlError) {
var error = new Error(sqlError.message.toString());
reject(error);
return false;
};
transaction.executeSql(sql, argsList.argumentList, successCallback, errorCallback);
});
}, aggrEntityInfos).then(function (result) {
return result;
}).then(function (result) {
return result;
});
};
ClientAggregates.executeMaintenanceScreen$MaintenanceScreenReceiveMoney$Action$getSettingsAggr = function (maxRecords) {
var Settings_Info = Brazil_OfflineStorageEntities.getEntityInfos().filter(function (info) {
return (info.key === "c3486011-eb75-4457-8e15-21cf2d318bdf");
})[0];
var aggrEntityInfos = [Settings_Info];

return executeTransaction(function (transaction) {
return new Promise(function (resolve, reject) {
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var targetListType = WUBrazilMobileAppModel.SettingsRecordList;
if(!(maxRecords)) {
maxRecords = 1000000;
}

var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "NULL o0, NULL o1, NULL o2, NULL o3, NULL o4, NULL o5, NULL o6, NULL o7, NULL o8, NULL o9, NULL o10, NULL o11, NULL o12, \"ENSettings\".\"DontShowAgain\" o13, NULL o14, NULL o15";
} else {
selectSql += "\"ENSettings\".\"Id\" o0, \"ENSettings\".\"Email\" o1, \"ENSettings\".\"LoginBiometrics\" o2, \"ENSettings\".\"IsBioMaybeLater\" o3, \"ENSettings\".\"IsPasscodeOnDevice\" o4, \"ENSettings\".\"LoginAttemptsCount\" o5, \"ENSettings\".\"HasOnbardingDone\" o6, \"ENSettings\".\"AppLanguage\" o7, \"ENSettings\".\"HasGivenAccessCode\" o8, \"ENSettings\".\"LastLogin\" o9, \"ENSettings\".\"TemporaryIsNotifications\" o10, \"ENSettings\".\"IsCameraDenied\" o11, \"ENSettings\".\"BiometricAttempts\" o12, \"ENSettings\".\"DontShowAgain\" o13, \"ENSettings\".\"PingSessionId\" o14, \"ENSettings\".\"WalletComplianceVersion\" o15";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_9k2_Settings\" \"ENSettings\"";
orderBySql += " ORDER BY \"ENSettings\".\"Email\" ASC ";
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

var successCallback = function (transaction, resultSet) {
var convertedResult = serializer.deserializeAggregate(resultSet.rows, WUBrazilMobileAppModel.SettingsRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"settingsAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

});
result.list = convertedResult;
resolve(result);
};
var errorCallback = function (transaction, sqlError) {
var error = new Error(sqlError.message.toString());
reject(error);
return false;
};
transaction.executeSql(sql, argsList.argumentList, successCallback, errorCallback);
});
}, aggrEntityInfos).then(function (result) {
return result;
}).then(function (result) {
return result;
});
};
ClientAggregates.executeWalletWelcome$Screen$getSettingsAggr = function (maxRecords) {
var Settings_Info = Brazil_OfflineStorageEntities.getEntityInfos().filter(function (info) {
return (info.key === "c3486011-eb75-4457-8e15-21cf2d318bdf");
})[0];
var aggrEntityInfos = [Settings_Info];

return executeTransaction(function (transaction) {
return new Promise(function (resolve, reject) {
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var targetListType = WUBrazilMobileAppModel.SettingsRecordList;
if(!(maxRecords)) {
maxRecords = 50;
}

var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "NULL o0, \"ENSettings\".\"Email\" o1, \"ENSettings\".\"LoginBiometrics\" o2, NULL o3, \"ENSettings\".\"IsPasscodeOnDevice\" o4, NULL o5, NULL o6, NULL o7, NULL o8, \"ENSettings\".\"LastLogin\" o9, NULL o10, NULL o11, NULL o12, NULL o13, NULL o14, NULL o15";
} else {
selectSql += "\"ENSettings\".\"Id\" o0, \"ENSettings\".\"Email\" o1, \"ENSettings\".\"LoginBiometrics\" o2, \"ENSettings\".\"IsBioMaybeLater\" o3, \"ENSettings\".\"IsPasscodeOnDevice\" o4, \"ENSettings\".\"LoginAttemptsCount\" o5, \"ENSettings\".\"HasOnbardingDone\" o6, \"ENSettings\".\"AppLanguage\" o7, \"ENSettings\".\"HasGivenAccessCode\" o8, \"ENSettings\".\"LastLogin\" o9, \"ENSettings\".\"TemporaryIsNotifications\" o10, \"ENSettings\".\"IsCameraDenied\" o11, \"ENSettings\".\"BiometricAttempts\" o12, \"ENSettings\".\"DontShowAgain\" o13, \"ENSettings\".\"PingSessionId\" o14, \"ENSettings\".\"WalletComplianceVersion\" o15";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_9k2_Settings\" \"ENSettings\"";
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

var successCallback = function (transaction, resultSet) {
var convertedResult = serializer.deserializeAggregate(resultSet.rows, WUBrazilMobileAppModel.SettingsRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"settingsAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

});
result.list = convertedResult;
resolve(result);
};
var errorCallback = function (transaction, sqlError) {
var error = new Error(sqlError.message.toString());
reject(error);
return false;
};
transaction.executeSql(sql, argsList.argumentList, successCallback, errorCallback);
});
}, aggrEntityInfos).then(function (result) {
return result;
}).then(function (result) {
return result;
});
};
ClientAggregates.executeWelcome$Screen$getSettingsAggr = function (maxRecords) {
var Settings_Info = Brazil_OfflineStorageEntities.getEntityInfos().filter(function (info) {
return (info.key === "c3486011-eb75-4457-8e15-21cf2d318bdf");
})[0];
var aggrEntityInfos = [Settings_Info];

return executeTransaction(function (transaction) {
return new Promise(function (resolve, reject) {
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var targetListType = WUBrazilMobileAppModel.SettingsRecordList;
if(!(maxRecords)) {
maxRecords = 50;
}

var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "NULL o0, \"ENSettings\".\"Email\" o1, NULL o2, NULL o3, \"ENSettings\".\"IsPasscodeOnDevice\" o4, NULL o5, NULL o6, NULL o7, NULL o8, \"ENSettings\".\"LastLogin\" o9, NULL o10, NULL o11, NULL o12, NULL o13, NULL o14, NULL o15";
} else {
selectSql += "\"ENSettings\".\"Id\" o0, \"ENSettings\".\"Email\" o1, \"ENSettings\".\"LoginBiometrics\" o2, \"ENSettings\".\"IsBioMaybeLater\" o3, \"ENSettings\".\"IsPasscodeOnDevice\" o4, \"ENSettings\".\"LoginAttemptsCount\" o5, \"ENSettings\".\"HasOnbardingDone\" o6, \"ENSettings\".\"AppLanguage\" o7, \"ENSettings\".\"HasGivenAccessCode\" o8, \"ENSettings\".\"LastLogin\" o9, \"ENSettings\".\"TemporaryIsNotifications\" o10, \"ENSettings\".\"IsCameraDenied\" o11, \"ENSettings\".\"BiometricAttempts\" o12, \"ENSettings\".\"DontShowAgain\" o13, \"ENSettings\".\"PingSessionId\" o14, \"ENSettings\".\"WalletComplianceVersion\" o15";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_9k2_Settings\" \"ENSettings\"";
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

var successCallback = function (transaction, resultSet) {
var convertedResult = serializer.deserializeAggregate(resultSet.rows, WUBrazilMobileAppModel.SettingsRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"settingsAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

});
result.list = convertedResult;
resolve(result);
};
var errorCallback = function (transaction, sqlError) {
var error = new Error(sqlError.message.toString());
reject(error);
return false;
};
transaction.executeSql(sql, argsList.argumentList, successCallback, errorCallback);
});
}, aggrEntityInfos).then(function (result) {
return result;
}).then(function (result) {
return result;
});
};
ClientAggregates.executeTrackTransferStatus$Login$Action$getLoginPageNameAggr = function (maxRecords) {
var LocalDeeplinkAllowedPage_Info = Brazil_OfflineStorageEntities.getEntityInfos().filter(function (info) {
return (info.key === "96b32df6-e4eb-4a1e-8c3f-8cee17c1a2e1");
})[0];
var aggrEntityInfos = [LocalDeeplinkAllowedPage_Info];

return executeTransaction(function (transaction) {
return new Promise(function (resolve, reject) {
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var targetListType = WUBrazilMobileAppModel.LocalDeeplinkAllowedPageRecordList;
if(!(maxRecords)) {
maxRecords = 1;
}

var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "NULL o0, \"ENLocalDeeplinkAllowedPage\".\"Page\" o1, NULL o2";
} else {
selectSql += "\"ENLocalDeeplinkAllowedPage\".\"Id\" o0, \"ENLocalDeeplinkAllowedPage\".\"Page\" o1, \"ENLocalDeeplinkAllowedPage\".\"LastUpdatedAt\" o2";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_9k2_LocalDeeplinkAllowedPage\" \"ENLocalDeeplinkAllowedPage\"";
fromAndWhereSql += " WHERE (\"ENLocalDeeplinkAllowedPage\".\"Id\" = ";
fromAndWhereSql += WUBrazilMobileAppModel.staticEntities.deeplinkAllowedPage.login;
fromAndWhereSql += ")";
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

var successCallback = function (transaction, resultSet) {
var convertedResult = serializer.deserializeAggregate(resultSet.rows, WUBrazilMobileAppModel.LocalDeeplinkAllowedPageRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"localDeeplinkAllowedPageAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

});
result.list = convertedResult;
resolve(result);
};
var errorCallback = function (transaction, sqlError) {
var error = new Error(sqlError.message.toString());
reject(error);
return false;
};
transaction.executeSql(sql, argsList.argumentList, successCallback, errorCallback);
});
}, aggrEntityInfos).then(function (result) {
return result;
}).then(function (result) {
return result;
});
};
return ClientAggregates;
});
