﻿define("WUBrazilMobileApp.controller$DeeplinkAllowedList", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller", "Brazil_OfflineStorage.model", "Brazil_OfflineStorage.entities", "WUBrazilMobileApp.clientVariables", "WUBrazilMobileApp.model$LocalDeeplinkAllowedPageRecordList", "Brazil_OfflineStorage.model$LocalDeeplinkAllowedPageRec", "WUBrazilMobileApp.referencesHealth", "WUBrazilMobileApp.referencesHealth$Brazil_OfflineStorage"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController, Brazil_OfflineStorageModel, Brazil_OfflineStorageEntities, WUBrazilMobileAppClientVariables) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.deeplinkAllowedList$Action = function (screenNameIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.DeeplinkAllowedList$vars"))());
vars.value.screenNameInLocal = screenNameIn;
var getLocalDeeplinkAllowedPageByIdVar = new OS.DataTypes.VariableHolder(new (OS.Controller.BaseController.getAggregateOutputType(WUBrazilMobileAppModel.LocalDeeplinkAllowedPageRecordList))());
var getLocalDeeplinkAllowedPageByTargetScreenVar = new OS.DataTypes.VariableHolder(new (OS.Controller.BaseController.getAggregateOutputType(WUBrazilMobileAppModel.LocalDeeplinkAllowedPageRecordList))());
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.DeeplinkAllowedList$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Has Target Screen?
return OS.Flow.executeSequence(function () {
if((((OS.BuiltinFunctions.trim(vars.value.screenNameInLocal)) !== ("")))) {
// Is a number?
return OS.Flow.executeSequence(function () {
if((OS.BuiltinFunctions.textToIntegerValidate(vars.value.screenNameInLocal))) {
// Aggregate: GetLocalDeeplinkAllowedPageById
var getLocalDeeplinkAllowedPageByIdAggr = function (maxRecords) {
var executeQuery = null;
if(OS.NativeHelper.isRunningOnNative()) {
executeQuery = function () {
var targetListType = WUBrazilMobileAppModel.LocalDeeplinkAllowedPageRecordList;
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var countArgsList = new OS.Entities.QueryArgumentsList();
if(!(maxRecords)) {
maxRecords = 9999;
}

var qpstId = vars.value.screenNameInLocal;

var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "NULL o0, \"ENLocalDeeplinkAllowedPage\".\"Page\" o1, NULL o2";
} else {
selectSql += "\"ENLocalDeeplinkAllowedPage\".\"Id\" o0, \"ENLocalDeeplinkAllowedPage\".\"Page\" o1, \"ENLocalDeeplinkAllowedPage\".\"LastUpdatedAt\" o2";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_9k2_LocalDeeplinkAllowedPage\" \"ENLocalDeeplinkAllowedPage\"";
fromAndWhereSql += " WHERE (\"ENLocalDeeplinkAllowedPage\".\"Id\" = ((CAST(:qpstId AS INTEGER))))";
argsList.add("qpstId", /*TEXT*/ 0, qpstId);
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

return OS.Entities.webSQLStorageInstance.executeQuery(sql, WUBrazilMobileAppModel.LocalDeeplinkAllowedPageRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"localDeeplinkAllowedPageAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

}, argsList).then(function (resultList) {
result.list = resultList;
}).then(function () {
}).then(function () {
return result;
});
};
} else {
executeQuery = function () {
if(!(maxRecords)) {
maxRecords = 9999;
}

return new Promise(function (resolve, reject) {
require(["WUBrazilMobileApp.aggregates.IDB"], function (WUBrazilMobileAppAggregates_IDB) {
return WUBrazilMobileAppAggregates_IDB.executeDeeplinkAllowedList$ClientAction$getLocalDeeplinkAllowedPageByIdAggr(vars.value.screenNameInLocal, maxRecords).then(function (result) {
resolve(result);
}).catch(function (e) {
reject(e);
});
});
});
};
}

return controller.executeClientAggregate(executeQuery, function () {
return getLocalDeeplinkAllowedPageByIdVar.value;
});
};
return getLocalDeeplinkAllowedPageByIdAggr().then(function () {
// IsValid = notGetLocalDeeplinkAllowedPageById.List.Empty
outVars.value.isValidOut = !(getLocalDeeplinkAllowedPageByIdVar.value.listOut.isEmpty);
// TargetScreen = GetLocalDeeplinkAllowedPageById.List.Current.LocalDeeplinkAllowedPage.Page
outVars.value.targetScreenOut = getLocalDeeplinkAllowedPageByIdVar.value.listOut.getCurrent(callContext.iterationContext).localDeeplinkAllowedPageAttr.pageAttr;
});
} else {
// Aggregate: GetLocalDeeplinkAllowedPageByTargetScreen
var getLocalDeeplinkAllowedPageByTargetScreenAggr = function (maxRecords) {
var executeQuery = null;
if(OS.NativeHelper.isRunningOnNative()) {
executeQuery = function () {
var targetListType = WUBrazilMobileAppModel.LocalDeeplinkAllowedPageRecordList;
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var countArgsList = new OS.Entities.QueryArgumentsList();
if(!(maxRecords)) {
maxRecords = 9999;
}

var qpstPage = vars.value.screenNameInLocal;

var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "NULL o0, \"ENLocalDeeplinkAllowedPage\".\"Page\" o1, NULL o2";
} else {
selectSql += "\"ENLocalDeeplinkAllowedPage\".\"Id\" o0, \"ENLocalDeeplinkAllowedPage\".\"Page\" o1, \"ENLocalDeeplinkAllowedPage\".\"LastUpdatedAt\" o2";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_9k2_LocalDeeplinkAllowedPage\" \"ENLocalDeeplinkAllowedPage\"";
fromAndWhereSql += " WHERE ((Lower(\"ENLocalDeeplinkAllowedPage\".\"Page\")) = (Lower(:qpstPage)))";
argsList.add("qpstPage", /*TEXT*/ 0, qpstPage);
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

return OS.Entities.webSQLStorageInstance.executeQuery(sql, WUBrazilMobileAppModel.LocalDeeplinkAllowedPageRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"localDeeplinkAllowedPageAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

}, argsList).then(function (resultList) {
result.list = resultList;
}).then(function () {
}).then(function () {
return result;
});
};
} else {
executeQuery = function () {
if(!(maxRecords)) {
maxRecords = 9999;
}

return new Promise(function (resolve, reject) {
require(["WUBrazilMobileApp.aggregates.IDB"], function (WUBrazilMobileAppAggregates_IDB) {
return WUBrazilMobileAppAggregates_IDB.executeDeeplinkAllowedList$ClientAction$getLocalDeeplinkAllowedPageByTargetScreenAggr(vars.value.screenNameInLocal, maxRecords).then(function (result) {
resolve(result);
}).catch(function (e) {
reject(e);
});
});
});
};
}

return controller.executeClientAggregate(executeQuery, function () {
return getLocalDeeplinkAllowedPageByTargetScreenVar.value;
});
};
return getLocalDeeplinkAllowedPageByTargetScreenAggr().then(function () {
// IsValid = notGetLocalDeeplinkAllowedPageByTargetScreen.List.Empty
outVars.value.isValidOut = !(getLocalDeeplinkAllowedPageByTargetScreenVar.value.listOut.isEmpty);
// TargetScreen = GetLocalDeeplinkAllowedPageByTargetScreen.List.Current.LocalDeeplinkAllowedPage.Page
outVars.value.targetScreenOut = getLocalDeeplinkAllowedPageByTargetScreenVar.value.listOut.getCurrent(callContext.iterationContext).localDeeplinkAllowedPageAttr.pageAttr;
});
}

}).then(function () {
// Is Valid??
if((outVars.value.isValidOut)) {
}

});
}

});
}).then(function () {
return outVars.value;
});
};
var controller = WUBrazilMobileAppController.default;
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.DeeplinkAllowedList$vars", [{
name: "ScreenName",
attrName: "screenNameInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.DeeplinkAllowedList$outVars", [{
name: "IsValid",
attrName: "isValidOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "TargetScreen",
attrName: "targetScreenOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUBrazilMobileAppController.default.clientActionProxies.deeplinkAllowedList$Action = function (screenNameIn) {
screenNameIn = (screenNameIn === undefined) ? "" : screenNameIn;
return controller.executeActionInsideJSNode(WUBrazilMobileAppController.default.deeplinkAllowedList$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(screenNameIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
IsValid: OS.DataConversion.JSNodeParamConverter.to(actionResults.isValidOut, OS.Types.Boolean),
TargetScreen: OS.DataConversion.JSNodeParamConverter.to(actionResults.targetScreenOut, OS.Types.Text)
};
});
};
});

define("WUBrazilMobileApp.controller$DeeplinkRedirectsTo", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller", "WUBrazilMobileApp.controller$DeeplinkRedirectsTo.redirectsToJS", "WUBrazilMobileApp.clientVariables"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController, WUBrazilMobileApp_controller_DeeplinkRedirectsTo_redirectsToJS, WUBrazilMobileAppClientVariables) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.deeplinkRedirectsTo$Action = function (uRLIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.DeeplinkRedirectsTo$vars"))());
vars.value.uRLInLocal = uRLIn;
controller.safeExecuteJSNode(WUBrazilMobileApp_controller_DeeplinkRedirectsTo_redirectsToJS, "redirectsTo", "DeeplinkRedirectsTo", {
url: OS.DataConversion.JSNodeParamConverter.to(vars.value.uRLInLocal, OS.Types.Text)
}, function ($parameters) {
}, {}, {});
return ;
};
var controller = WUBrazilMobileAppController.default;
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.DeeplinkRedirectsTo$vars", [{
name: "URL",
attrName: "uRLInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUBrazilMobileAppController.default.clientActionProxies.deeplinkRedirectsTo$Action = function (uRLIn) {
uRLIn = (uRLIn === undefined) ? "" : uRLIn;
return controller.executeActionInsideJSNode(WUBrazilMobileAppController.default.deeplinkRedirectsTo$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(uRLIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});
define("WUBrazilMobileApp.controller$DeeplinkRedirectsTo.redirectsToJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
// const urlMethod = '/WUBrazilMobileApp/'
// try {
//     if(!!$public.Navigation.navigateTo) {
//         $public.Navigation.navigateTo(urlMethod + $parameters.url,2,false);
//     } else {
//         //fallback
//         location.href = $parameters.url;
//     }
// }
// catch(e) {
//         //fallback
//         location.href = $parameters.url;
//     }
// }
// catch(e) {
//     location.href = $parameters.url;
// }


location.href = $parameters.url;
};
});

define("WUBrazilMobileApp.controller$DeeplinkURLHandler", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller", "WUBrazilMobileApp.clientVariables", "WUBrazilMobileApp.controller$DeeplinkRedirectsTo", "WUBrazilMobileApp.controller$GetScreenFromURL", "WUBrazilMobileApp.controller$DeeplinkAllowedList"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController, WUBrazilMobileAppClientVariables) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.deeplinkURLHandler$Action = function (uRLIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.DeeplinkURLHandler$vars"))());
vars.value.uRLInLocal = uRLIn;
var getScreenFromURLVar = new OS.DataTypes.VariableHolder();
var deeplinkAllowedListVar = new OS.DataTypes.VariableHolder();
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: GetScreenFromURL
getScreenFromURLVar.value = WUBrazilMobileAppController.default.getScreenFromURL$Action(vars.value.uRLInLocal, callContext);

// Execute Action: DeeplinkAllowedList
return WUBrazilMobileAppController.default.deeplinkAllowedList$Action(getScreenFromURLVar.value.screenNameOut, callContext).then(function (value) {
deeplinkAllowedListVar.value = value;
}).then(function () {
if((deeplinkAllowedListVar.value.isValidOut)) {
// Is Anonymous screen ?
if((((((OS.BuiltinFunctions.toLower(getScreenFromURLVar.value.screenNameOut) === "login") || (OS.BuiltinFunctions.toLower(getScreenFromURLVar.value.screenNameOut) === "actionfailed")) || (OS.BuiltinFunctions.toLower(getScreenFromURLVar.value.screenNameOut) === "instructionspage")) || (OS.BuiltinFunctions.toLower(getScreenFromURLVar.value.screenNameOut) === "maintenancescreen")))) {
// Execute Action: DeeplinkRedirectsTo3
WUBrazilMobileAppController.default.deeplinkRedirectsTo$Action(vars.value.uRLInLocal, callContext);
} else {
// Is user logged in?
if((((OS.BuiltinFunctions.getUserId()) !== (OS.BuiltinFunctions.nullIdentifier())))) {
// Execute Action: DeeplinkRedirectsTo
WUBrazilMobileAppController.default.deeplinkRedirectsTo$Action((getScreenFromURLVar.value.screenNameOut + getScreenFromURLVar.value.queryStringOut), callContext);
} else {
// Execute Action: DeeplinkRedirectsTo2
WUBrazilMobileAppController.default.deeplinkRedirectsTo$Action((((OS.BuiltinFunctions.getOwnerURLPath() + "Welcome?TargetScreen=") + getScreenFromURLVar.value.screenNameOut) + getScreenFromURLVar.value.queryStringOut), callContext);
}

}

}

});
}).then(function () {
return ;
});
};
var controller = WUBrazilMobileAppController.default;
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.DeeplinkURLHandler$vars", [{
name: "URL",
attrName: "uRLInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUBrazilMobileAppController.default.clientActionProxies.deeplinkURLHandler$Action = function (uRLIn) {
uRLIn = (uRLIn === undefined) ? "" : uRLIn;
return controller.executeActionInsideJSNode(WUBrazilMobileAppController.default.deeplinkURLHandler$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(uRLIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("WUBrazilMobileApp.controller$GetScreenFromURL", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller", "WUBrazilMobileApp.clientVariables", "WUBrazilMobileApp.controller$SplitString"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController, WUBrazilMobileAppClientVariables) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.getScreenFromURL$Action = function (uRLIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.GetScreenFromURL$vars"))());
vars.value.uRLInLocal = uRLIn;
var splitQueryStringVar = new OS.DataTypes.VariableHolder();
var splitStringURLVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.GetScreenFromURL$outVars"))());
// Execute Action: SplitStringURL
splitStringURLVar.value = WUBrazilMobileAppController.default.splitString$Action(vars.value.uRLInLocal, "/", callContext);

// ScreenName = SplitStringURL.TextList[SplitStringURL.TextList.Length - 1]
outVars.value.screenNameOut = splitStringURLVar.value.textListOut.getItem((splitStringURLVar.value.textListOut.length - 1));
// Has parameters?
if(((OS.BuiltinFunctions.index(outVars.value.screenNameOut, "?", 0, false, false) > -1))) {
// Execute Action: SplitQueryString
splitQueryStringVar.value = WUBrazilMobileAppController.default.splitString$Action(outVars.value.screenNameOut, "?", callContext);

// ScreenName = SplitQueryString.TextList[0]
outVars.value.screenNameOut = splitQueryStringVar.value.textListOut.getItem(0);
// QueryString = "&" + SplitQueryString.TextList[1]
outVars.value.queryStringOut = ("&" + splitQueryStringVar.value.textListOut.getItem(1));
}

return outVars.value;
};
var controller = WUBrazilMobileAppController.default;
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.GetScreenFromURL$vars", [{
name: "URL",
attrName: "uRLInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.GetScreenFromURL$outVars", [{
name: "ScreenName",
attrName: "screenNameOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "QueryString",
attrName: "queryStringOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUBrazilMobileAppController.default.clientActionProxies.getScreenFromURL$Action = function (uRLIn) {
uRLIn = (uRLIn === undefined) ? "" : uRLIn;
return controller.executeActionInsideJSNode(WUBrazilMobileAppController.default.getScreenFromURL$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(uRLIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
ScreenName: OS.DataConversion.JSNodeParamConverter.to(actionResults.screenNameOut, OS.Types.Text),
QueryString: OS.DataConversion.JSNodeParamConverter.to(actionResults.queryStringOut, OS.Types.Text)
};
});
};
});

define("WUBrazilMobileApp.controller$LoginParameters", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller", "WUBrazilMobileApp.clientVariables"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController, WUBrazilMobileAppClientVariables) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.loginParameters$Action = function (targetScreenIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.LoginParameters$vars"))());
vars.value.targetScreenInLocal = targetScreenIn;
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.LoginParameters$outVars"))());
// Parameters = "?RememberEmail=" + BooleanToText + "&" + "EnableBiometrics=" + BooleanToText + "&" + "IsMoneyTransfer=" + BooleanToText + "&" + If
outVars.value.parametersOut = ((((((((("?RememberEmail=" + OS.BuiltinFunctions.booleanToText(true)) + "&") + "EnableBiometrics=") + OS.BuiltinFunctions.booleanToText(true)) + "&") + "IsMoneyTransfer=") + OS.BuiltinFunctions.booleanToText(false)) + "&") + ((((OS.BuiltinFunctions.trim(vars.value.targetScreenInLocal)) !== (""))) ? (("TargetScreen=" + vars.value.targetScreenInLocal)) : ("")));
return outVars.value;
};
var controller = WUBrazilMobileAppController.default;
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.LoginParameters$vars", [{
name: "TargetScreen",
attrName: "targetScreenInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.LoginParameters$outVars", [{
name: "Parameters",
attrName: "parametersOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUBrazilMobileAppController.default.clientActionProxies.loginParameters$Action = function (targetScreenIn) {
targetScreenIn = (targetScreenIn === undefined) ? "" : targetScreenIn;
return controller.executeActionInsideJSNode(WUBrazilMobileAppController.default.loginParameters$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(targetScreenIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Parameters: OS.DataConversion.JSNodeParamConverter.to(actionResults.parametersOut, OS.Types.Text)
};
});
};
});

define("WUBrazilMobileApp.controller$OfflineDataSync", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller", "Brazil_OfflineStorage.controller", "WUBrazilMobileApp.clientVariables", "Brazil_OfflineStorage.controller$SyncLocalDeeplinkAllowedPages", "WUBrazilMobileApp.referencesHealth", "WUBrazilMobileApp.referencesHealth$Brazil_OfflineStorage"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController, Brazil_OfflineStorageController, WUBrazilMobileAppClientVariables) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.offlineDataSync$Action = function (syncUnitIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.OfflineDataSync$vars"))());
vars.value.syncUnitInLocal = syncUnitIn;
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: SyncLocalDeeplinkAllowedPages
return Brazil_OfflineStorageController.default.syncLocalDeeplinkAllowedPages$Action(callContext);
}).then(function () {
return ;
});
};
var controller = WUBrazilMobileAppController.default;
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.OfflineDataSync$vars", [{
name: "SyncUnit",
attrName: "syncUnitInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUBrazilMobileAppController.default.clientActionProxies.offlineDataSync$Action = function (syncUnitIn) {
syncUnitIn = (syncUnitIn === undefined) ? "" : syncUnitIn;
return controller.executeActionInsideJSNode(WUBrazilMobileAppController.default.offlineDataSync$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(syncUnitIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("WUBrazilMobileApp.controller$OfflineDataSyncConfiguration", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller", "WUBrazilMobileApp.clientVariables"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController, WUBrazilMobileAppClientVariables) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.offlineDataSyncConfiguration$Action = function (callContext) {
callContext = controller.callContext(callContext);
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.OfflineDataSyncConfiguration$outVars"))());
// SyncOnOnline = False
outVars.value.syncOnOnlineOut = false;
// SyncOnLogin = False
outVars.value.syncOnLoginOut = false;
// SyncOnResume = False
outVars.value.syncOnResumeOut = false;
// RetryOnError = False
outVars.value.retryOnErrorOut = false;
// RetryIntervalInSeconds = 30
outVars.value.retryIntervalInSecondsOut = 30;
return outVars.value;
};
var controller = WUBrazilMobileAppController.default;
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.OfflineDataSyncConfiguration$outVars", [{
name: "SyncOnOnline",
attrName: "syncOnOnlineOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "SyncOnLogin",
attrName: "syncOnLoginOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "SyncOnResume",
attrName: "syncOnResumeOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "RetryOnError",
attrName: "retryOnErrorOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "RetryIntervalInSeconds",
attrName: "retryIntervalInSecondsOut",
mandatory: false,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}]);
WUBrazilMobileAppController.default.clientActionProxies.offlineDataSyncConfiguration$Action = function () {
return controller.executeActionInsideJSNode(WUBrazilMobileAppController.default.offlineDataSyncConfiguration$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
SyncOnOnline: OS.DataConversion.JSNodeParamConverter.to(actionResults.syncOnOnlineOut, OS.Types.Boolean),
SyncOnLogin: OS.DataConversion.JSNodeParamConverter.to(actionResults.syncOnLoginOut, OS.Types.Boolean),
SyncOnResume: OS.DataConversion.JSNodeParamConverter.to(actionResults.syncOnResumeOut, OS.Types.Boolean),
RetryOnError: OS.DataConversion.JSNodeParamConverter.to(actionResults.retryOnErrorOut, OS.Types.Boolean),
RetryIntervalInSeconds: OS.DataConversion.JSNodeParamConverter.to(actionResults.retryIntervalInSecondsOut, OS.Types.Integer)
};
});
};
});

define("WUBrazilMobileApp.controller$OnApplicationReady", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller", "Brazil_Common_MBL.controller", "Brazil_CommonFoundation_Lib.controller", "UltimatePDF.controller", "Brazil_OfflineStorage.model", "Brazil_OfflineStorage.entities", "WUBrazilMobileApp.controller$OnApplicationReady.DynatraceProdScriptJS", "WUBrazilMobileApp.controller$OnApplicationReady.DynatraceJS", "WUBrazilMobileApp.controller$OnApplicationReady.getDeviceLocaleJS", "WUBrazilMobileApp.controller$OnApplicationReady.handleOpenURLJS", "WUBrazilMobileApp.clientVariables", "WUBrazilMobileApp.controller$ServerAction.SiteProperty_CurrentEnv_Get", "Brazil_Common_MBL.controller$GetEnvironmentBaseUrl", "WUBrazilMobileApp.referencesHealth", "WUBrazilMobileApp.referencesHealth$Brazil_Common_MBL", "Brazil_Common_MBL.controller$Akamai_Initialize_On_DeviceReady", "WUBrazilMobileApp.controller$Request_Notification_Permission", "Brazil_CommonFoundation_Lib.controller$SetSessionGUID", "WUBrazilMobileApp.referencesHealth$Brazil_CommonFoundation_Lib", "UltimatePDF.controller$OnApplicationReady_UltimatePDF", "WUBrazilMobileApp.referencesHealth$UltimatePDF", "WUBrazilMobileApp.controller$DeeplinkURLHandler", "WUBrazilMobileApp.model$SettingsRecordList", "Brazil_OfflineStorage.model$SettingsRec", "WUBrazilMobileApp.referencesHealth$Brazil_OfflineStorage"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController, Brazil_Common_MBLController, Brazil_CommonFoundation_LibController, UltimatePDFController, Brazil_OfflineStorageModel, Brazil_OfflineStorageEntities, WUBrazilMobileApp_controller_OnApplicationReady_DynatraceProdScriptJS, WUBrazilMobileApp_controller_OnApplicationReady_DynatraceJS, WUBrazilMobileApp_controller_OnApplicationReady_getDeviceLocaleJS, WUBrazilMobileApp_controller_OnApplicationReady_handleOpenURLJS, WUBrazilMobileAppClientVariables) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.onApplicationReady$Action = function (callContext) {
var model = this.model;
var controller = this.controller;
var idService = this.idService;
callContext = controller.callContext(callContext);
var siteProperty_CurrentEnv_GetVar = new OS.DataTypes.VariableHolder();
var getEnvironmentBaseUrlVar = new OS.DataTypes.VariableHolder();
var getDeviceLocaleJSResult = new OS.DataTypes.VariableHolder();
var getSettingsVar = new OS.DataTypes.VariableHolder(new (OS.Controller.BaseController.getAggregateOutputType(WUBrazilMobileAppModel.SettingsRecordList))());
return OS.Flow.executeAsyncFlow(function () {
// Aggregate: GetSettings
var getSettingsAggr = function (maxRecords) {
var executeQuery = null;
if(OS.NativeHelper.isRunningOnNative()) {
executeQuery = function () {
var targetListType = WUBrazilMobileAppModel.SettingsRecordList;
var result = {
list: null,
count: OS.DataTypes.LongInteger.defaultValue
};
var countArgsList = new OS.Entities.QueryArgumentsList();
if(!(maxRecords)) {
maxRecords = 0;
}


var optimizeSelect = false;
var selectSql = "";
var fromAndWhereSql = "";
var groupByAndHavingSql = "";
var orderBySql = "";
var argsList = new OS.Entities.QueryArgumentsList();

selectSql += "SELECT ";
if (optimizeSelect) {
selectSql += "NULL o0, NULL o1, NULL o2, NULL o3, NULL o4, NULL o5, NULL o6, \"ENSettings\".\"AppLanguage\" o7, NULL o8, NULL o9, NULL o10, NULL o11, NULL o12, NULL o13, NULL o14, NULL o15";
} else {
selectSql += "\"ENSettings\".\"Id\" o0, \"ENSettings\".\"Email\" o1, \"ENSettings\".\"LoginBiometrics\" o2, \"ENSettings\".\"IsBioMaybeLater\" o3, \"ENSettings\".\"IsPasscodeOnDevice\" o4, \"ENSettings\".\"LoginAttemptsCount\" o5, \"ENSettings\".\"HasOnbardingDone\" o6, \"ENSettings\".\"AppLanguage\" o7, \"ENSettings\".\"HasGivenAccessCode\" o8, \"ENSettings\".\"LastLogin\" o9, \"ENSettings\".\"TemporaryIsNotifications\" o10, \"ENSettings\".\"IsCameraDenied\" o11, \"ENSettings\".\"BiometricAttempts\" o12, \"ENSettings\".\"DontShowAgain\" o13, \"ENSettings\".\"PingSessionId\" o14, \"ENSettings\".\"WalletComplianceVersion\" o15";
}
fromAndWhereSql += " FROM \"MAIN\".\"OSUSR_9k2_Settings\" \"ENSettings\"";
orderBySql += " ORDER BY \"ENSettings\".\"Email\" ASC ";
if (maxRecords > 0) {
orderBySql += " LIMIT ";
orderBySql += maxRecords;
}
var sql = selectSql + fromAndWhereSql + groupByAndHavingSql + orderBySql;

return OS.Entities.webSQLStorageInstance.executeQuery(sql, WUBrazilMobileAppModel.SettingsRecordList, function (rec, r) {
var indexRef = {
value: 0
};
var attrOrder = [
"settingsAttr",
];
return OS.DataConversion.LocalStorageConverter.from(r, targetListType.getItemType(), indexRef, attrOrder);

}, argsList).then(function (resultList) {
result.list = resultList;
}).then(function () {
}).then(function () {
return result;
});
};
} else {
executeQuery = function () {
if(!(maxRecords)) {
maxRecords = 0;
}

return new Promise(function (resolve, reject) {
require(["WUBrazilMobileApp.aggregates.IDB"], function (WUBrazilMobileAppAggregates_IDB) {
return WUBrazilMobileAppAggregates_IDB.executeOnApplicationReady$ClientSystemAction$getSettingsAggr(maxRecords).then(function (result) {
resolve(result);
}).catch(function (e) {
reject(e);
});
});
});
};
}

return controller.executeClientAggregate(executeQuery, function () {
return getSettingsVar.value;
});
};
return getSettingsAggr().then(function () {
getDeviceLocaleJSResult.value = controller.safeExecuteJSNode(WUBrazilMobileApp_controller_OnApplicationReady_getDeviceLocaleJS, "getDeviceLocale", "On Application Ready", {
navigatorLanguage: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text),
isAvailable: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.OnApplicationReady$getDeviceLocaleJSResult"))();
jsNodeResult.navigatorLanguageOut = OS.DataConversion.JSNodeParamConverter.from($parameters.navigatorLanguage, OS.Types.Text);
jsNodeResult.isAvailableOut = OS.DataConversion.JSNodeParamConverter.from($parameters.isAvailable, OS.Types.Boolean);
return jsNodeResult;
}, {}, {});
// Execute Action: SetCurrentLocale
OS.SystemActions.setCurrentLocale(((((getSettingsVar.value.listOut.getCurrent(callContext.iterationContext).settingsAttr.appLanguageAttr) !== (""))) ? (getSettingsVar.value.listOut.getCurrent(callContext.iterationContext).settingsAttr.appLanguageAttr) : (getDeviceLocaleJSResult.value.navigatorLanguageOut)), callContext);
// Execute Action: SiteProperty_CurrentEnv_Get
return controller.siteProperty_CurrentEnv_Get$ServerAction(callContext).then(function (value) {
siteProperty_CurrentEnv_GetVar.value = value;
});
}).then(function () {
// Execute Action: SetSessionGUID
Brazil_CommonFoundation_LibController.default.setSessionGUID$Action(callContext);
// Execute Action: LogMessage4
OS.SystemActions.logMessage("Session setted", "Dynatrace", callContext);
// Execute Action: GetEnvironmentBaseUrl
getEnvironmentBaseUrlVar.value = Brazil_Common_MBLController.default.getEnvironmentBaseUrl$Action(callContext);

}).then(function () {
// If lower env
if(((((siteProperty_CurrentEnv_GetVar.value.envOut === "DEV") || (siteProperty_CurrentEnv_GetVar.value.envOut === "QA")) || (siteProperty_CurrentEnv_GetVar.value.envOut === "UAT")))) {
// Execute Action: LogMessage3
OS.SystemActions.logMessage("Is DEV env", "Dynatrace", callContext);
controller.safeExecuteJSNode(WUBrazilMobileApp_controller_OnApplicationReady_DynatraceJS, "Dynatrace", "On Application Ready", null, function ($parameters) {
}, {}, {});
}

// If prod env
if(((siteProperty_CurrentEnv_GetVar.value.envOut === "PROD"))) {
// Execute Action: LogMessage5
OS.SystemActions.logMessage("Is prodenv", "Dynatrace", callContext);
controller.safeExecuteJSNode(WUBrazilMobileApp_controller_OnApplicationReady_DynatraceProdScriptJS, "DynatraceProdScript", "On Application Ready", null, function ($parameters) {
}, {}, {});
}

// Execute Action: Request_Notification_Permission
return WUBrazilMobileAppController.default.request_Notification_Permission$Action(callContext).then(function () {
// Execute Action: Akamai_Initialize_On_DeviceReady
Brazil_Common_MBLController.default.akamai_Initialize_On_DeviceReady$Action(callContext);
// Execute Action: OnApplicationReady_UltimatePDF
return UltimatePDFController.default.onApplicationReady_UltimatePDF$Action(callContext);
}).then(function () {
// Deeplink URL handler.
controller.safeExecuteJSNode(WUBrazilMobileApp_controller_OnApplicationReady_handleOpenURLJS, "handleOpenURL", "On Application Ready", null, function ($parameters) {
}, {
DeeplinkURLHandler: WUBrazilMobileAppController.default.clientActionProxies.deeplinkURLHandler$Action
}, {});
});
});
});
};
var controller = WUBrazilMobileAppController.default;
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.OnApplicationReady$getDeviceLocaleJSResult", [{
name: "navigatorLanguage",
attrName: "navigatorLanguageOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "isAvailable",
attrName: "isAvailableOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
WUBrazilMobileAppController.default.clientActionProxies.onApplicationReady$Action = function () {
return controller.executeActionInsideJSNode(WUBrazilMobileAppController.default.onApplicationReady$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});
define("WUBrazilMobileApp.controller$OnApplicationReady.DynatraceProdScriptJS", [], function () {
return function ($actions, $roles, $public) {
var scriptDynatrace = document.createElement("script");
scriptDynatrace.type = "text/javascript";
scriptDynatrace.src = "https://js-cdn.dynatrace.com/jstag/1672bab6729/bf88946xdi/9291d148bf433696_complete.js"
scriptDynatrace.crossOrigin = "anonymous";
document.querySelector("head").appendChild(scriptDynatrace)
};
});
define("WUBrazilMobileApp.controller$OnApplicationReady.DynatraceJS", [], function () {
return function ($actions, $roles, $public) {
var scriptDynatrace = document.createElement("script");
scriptDynatrace.type = "text/javascript";
scriptDynatrace.src = "https://js-cdn.dynatrace.com/jstag/1672bab6729/bf37543mdx/f4029561bb26c9_complete.js";
scriptDynatrace.crossOrigin = "anonymous";
document.querySelector("head").appendChild(scriptDynatrace)
};
});
define("WUBrazilMobileApp.controller$OnApplicationReady.getDeviceLocaleJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
if(navigator.language) {
    $parameters.isAvailable = true

    if(navigator.language.includes('en')) {
        $parameters.navigatorLanguage = 'en-US';
    } else if (navigator.language.includes('es')) {
        $parameters.navigatorLanguage = 'es-419';
    } else {
        $parameters.navigatorLanguage = 'pt-BR';
    }
} else {
    $parameters.navigatorLanguage = 'pt-BR';
}
};
});
define("WUBrazilMobileApp.controller$OnApplicationReady.handleOpenURLJS", [], function () {
return function ($actions, $roles, $public) {
window.handleOpenURL = function (url) {
    console.log("handleOpenURL:"+url);
    $actions.DeeplinkURLHandler(url);
}
};
});

define("WUBrazilMobileApp.controller$Request_Notification_Permission", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller", "OutSystemsUI.controller", "CommonPlugin.model", "AndroidPermissionsPluginUpdated.controller", "WUBrazilMobileApp.clientVariables", "OutSystemsUI.controller$GetOS", "WUBrazilMobileApp.referencesHealth", "WUBrazilMobileApp.referencesHealth$OutSystemsUI", "CommonPlugin.model$ErrorRec", "WUBrazilMobileApp.referencesHealth$CommonPlugin", "AndroidPermissionsPluginUpdated.controller$areNotificationsEnabled", "WUBrazilMobileApp.referencesHealth$AndroidPermissionsPluginUpdated", "AndroidPermissionsPluginUpdated.controller$shouldShowRequestPermissionRational", "AndroidPermissionsPluginUpdated.controller$CheckAndroidPermissionsPlugin", "AndroidPermissionsPluginUpdated.controller$requestPermission"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController, OutSystemsUIController, CommonPluginModel, AndroidPermissionsPluginUpdatedController, WUBrazilMobileAppClientVariables) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.request_Notification_Permission$Action = function (callContext) {
callContext = controller.callContext(callContext);
var getOSVar = new OS.DataTypes.VariableHolder();
var areNotificationsEnabledVar = new OS.DataTypes.VariableHolder();
var shouldShowRequestPermissionRationalVar = new OS.DataTypes.VariableHolder();
var checkAndroidPermissionsPluginVar = new OS.DataTypes.VariableHolder();
var requestPermissionVar = new OS.DataTypes.VariableHolder();
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: GetOS
getOSVar.value = OutSystemsUIController.default.getOS$Action(OS.BuiltinFunctions.getUserAgent(), callContext);

return OS.Flow.executeSequence(function () {
if((!(((getOSVar.value.oSOut) !== ("android"))))) {
// Execute Action: CheckAndroidPermissionsPlugin
checkAndroidPermissionsPluginVar.value = AndroidPermissionsPluginUpdatedController.default.checkAndroidPermissionsPlugin$Action(callContext);

// IsAvailable ?
return OS.Flow.executeSequence(function () {
if((checkAndroidPermissionsPluginVar.value.isAvailableOut)) {
// Execute Action: areNotificationsEnabled
return AndroidPermissionsPluginUpdatedController.default.areNotificationsEnabled$Action(callContext).then(function (value) {
areNotificationsEnabledVar.value = value;
}).then(function () {
return OS.Flow.executeSequence(function () {
if((areNotificationsEnabledVar.value.successOut)) {
// Execute Action: LogMessage_Debug
OS.SystemActions.logMessage((((((("areNotificationsEnabled: Success: " + (areNotificationsEnabledVar.value.successOut ? "True" : "False")) + ((!(areNotificationsEnabledVar.value.successOut)) ? ((" ErrorMessage: " + areNotificationsEnabledVar.value.errorOut.errorMessageAttr)) : (""))) + " isEnabled: ") + (areNotificationsEnabledVar.value.isEnabledOut ? "True" : "False")) + " isRationaleAvailable: ") + (areNotificationsEnabledVar.value.isRationaleAvailableOut ? "True" : "False")), "AndroidPermissions", callContext);
// Not enabled and has rationale ?
return OS.Flow.executeSequence(function () {
if((((areNotificationsEnabledVar.value.successOut && !(areNotificationsEnabledVar.value.isEnabledOut)) && areNotificationsEnabledVar.value.isRationaleAvailableOut))) {
// Execute Action: shouldShowRequestPermissionRational
return AndroidPermissionsPluginUpdatedController.default.shouldShowRequestPermissionRational$Action(WUBrazilMobileAppModel.staticEntities.androidPermission.pOST_NOTIFICATIONS, callContext).then(function (value) {
shouldShowRequestPermissionRationalVar.value = value;
}).then(function () {
return OS.Flow.executeSequence(function () {
if(((shouldShowRequestPermissionRationalVar.value.successOut && shouldShowRequestPermissionRationalVar.value.isEnabledOut))) {
// Execute Action: LogMessage_TBD
OS.SystemActions.logMessage("shouldShowRequestPermissionRational", "AndroidPermissions", callContext);
} else {
// POST_NOTIFICATIONS exists?
return OS.Flow.executeSequence(function () {
if((((WUBrazilMobileAppModel.staticEntities.androidPermission.pOST_NOTIFICATIONS) !== (OS.BuiltinFunctions.nullTextIdentifier())))) {
// Execute Action: requestPermission
return AndroidPermissionsPluginUpdatedController.default.requestPermission$Action(WUBrazilMobileAppModel.staticEntities.androidPermission.pOST_NOTIFICATIONS, callContext).then(function (value) {
requestPermissionVar.value = value;
});
}

});
}

});
});
}

});
} else {
// Execute Action: LogMessage_error
OS.SystemActions.logMessage(areNotificationsEnabledVar.value.errorOut.errorMessageAttr, "AndroidPermissions", callContext);
}

});
});
} else {
// Execute Action: LogMessage_NotAvaiable
OS.SystemActions.logMessage("Plugin not available", "AndroidPermissions", callContext);
}

});
}

});
}).then(function () {
return ;
});
};
var controller = WUBrazilMobileAppController.default;
WUBrazilMobileAppController.default.clientActionProxies.request_Notification_Permission$Action = function () {
return controller.executeActionInsideJSNode(WUBrazilMobileAppController.default.request_Notification_Permission$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("WUBrazilMobileApp.controller$ShouldGoToUpdateScreen", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller", "CommonPlugin.model", "BuildInfoPlugin.controller", "WUBrazilMobileApp.controller$ShouldGoToUpdateScreen.VersionToIntegerJS", "WUBrazilMobileApp.clientVariables", "CommonPlugin.model$ErrorRec", "WUBrazilMobileApp.referencesHealth", "WUBrazilMobileApp.referencesHealth$CommonPlugin", "BuildInfoPlugin.controller$GetBuildInfo", "WUBrazilMobileApp.referencesHealth$BuildInfoPlugin", "WUBrazilMobileApp.controller$ServerAction.SiteProperty_IsShowAppUpdateScreen", "WUBrazilMobileApp.controller$ServerAction.GetUseNewWelcomeScreenFeatureFlag"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController, CommonPluginModel, BuildInfoPluginController, WUBrazilMobileApp_controller_ShouldGoToUpdateScreen_VersionToIntegerJS, WUBrazilMobileAppClientVariables) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.shouldGoToUpdateScreen$Action = function (callContext) {
callContext = controller.callContext(callContext);
var siteProperty_IsShowAppUpdateScreenVar = new OS.DataTypes.VariableHolder();
var getUseNewWelcomeScreenFeatureFlagVar = new OS.DataTypes.VariableHolder();
var getBuildInfoVar = new OS.DataTypes.VariableHolder();
var versionToIntegerJSResult = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.ShouldGoToUpdateScreen$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: SiteProperty_IsShowAppUpdateScreen
return controller.siteProperty_IsShowAppUpdateScreen$ServerAction(callContext).then(function (value) {
siteProperty_IsShowAppUpdateScreenVar.value = value;
}).then(function () {
// IsShowAppUpdateScreen?
return OS.Flow.executeSequence(function () {
if((siteProperty_IsShowAppUpdateScreenVar.value.isShowAppUpdateScreenOut)) {
// Execute Action: GetUseNewWelcomeScreenFeatureFlag
return controller.getUseNewWelcomeScreenFeatureFlag$ServerAction(callContext).then(function (value) {
getUseNewWelcomeScreenFeatureFlagVar.value = value;
}).then(function () {
// Execute Action: GetBuildInfo
getBuildInfoVar.value = BuildInfoPluginController.default.getBuildInfo$Action(callContext);

}).then(function () {
if((getBuildInfoVar.value.successOut)) {
// Execute Action: LogMessage
OS.SystemActions.logMessage(("Build Version" + getBuildInfoVar.value.versionOut), "WUBrazilMobileApp", callContext);
versionToIntegerJSResult.value = controller.safeExecuteJSNode(WUBrazilMobileApp_controller_ShouldGoToUpdateScreen_VersionToIntegerJS, "VersionToInteger", "ShouldGoToUpdateScreen", {
BuildVersion: OS.DataConversion.JSNodeParamConverter.to(getBuildInfoVar.value.versionOut, OS.Types.Text),
BuildVersionNumber: OS.DataConversion.JSNodeParamConverter.to(0, OS.Types.Integer)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.ShouldGoToUpdateScreen$versionToIntegerJSResult"))();
jsNodeResult.buildVersionNumberOut = OS.DataConversion.JSNodeParamConverter.from($parameters.BuildVersionNumber, OS.Types.Integer);
return jsNodeResult;
}, {}, {});
// Set IsGoToUpdateScreen
// IsGoToUpdateScreen = VersionToInteger.BuildVersionNumber < GetUseNewWelcomeScreenFeatureFlag.LowerBuildVersionAccepted
outVars.value.isGoToUpdateScreenOut = (versionToIntegerJSResult.value.buildVersionNumberOut < getUseNewWelcomeScreenFeatureFlagVar.value.lowerBuildVersionAcceptedOut);
return OS.Flow.returnAsync(outVars.value);

}

});
}

});
}).then(function () {
// Set IsGoToUpdateScreen
// IsGoToUpdateScreen = False
outVars.value.isGoToUpdateScreenOut = false;
});
}).then(function () {
return outVars.value;
});
};
var controller = WUBrazilMobileAppController.default;
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.ShouldGoToUpdateScreen$versionToIntegerJSResult", [{
name: "BuildVersionNumber",
attrName: "buildVersionNumberOut",
mandatory: true,
dataType: OS.Types.Integer,
defaultValue: function () {
return 0;
}
}]);
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.ShouldGoToUpdateScreen$outVars", [{
name: "IsGoToUpdateScreen",
attrName: "isGoToUpdateScreenOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
WUBrazilMobileAppController.default.clientActionProxies.shouldGoToUpdateScreen$Action = function () {
return controller.executeActionInsideJSNode(WUBrazilMobileAppController.default.shouldGoToUpdateScreen$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
IsGoToUpdateScreen: OS.DataConversion.JSNodeParamConverter.to(actionResults.isGoToUpdateScreenOut, OS.Types.Boolean)
};
});
};
});
define("WUBrazilMobileApp.controller$ShouldGoToUpdateScreen.VersionToIntegerJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
$parameters.BuildVersionNumber =  parseInt($parameters.BuildVersion.split(".")[0])
};
});

define("WUBrazilMobileApp.controller$SplitString", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller", "WUBrazilMobileApp.controller$SplitString.JavaScript1JS", "WUBrazilMobileApp.clientVariables"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController, WUBrazilMobileApp_controller_SplitString_JavaScript1JS, WUBrazilMobileAppClientVariables) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.splitString$Action = function (textIn, delimiterIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.SplitString$vars"))());
vars.value.textInLocal = textIn;
vars.value.delimiterInLocal = delimiterIn;
var javaScript1JSResult = new OS.DataTypes.VariableHolder();
var jSONDeserializeTextListVar = new OS.DataTypes.VariableHolder(new (OS.Controller.BaseController.getJSONDeserializeOutputType(OS.DataTypes.TextList))());
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.SplitString$outVars"))());
javaScript1JSResult.value = controller.safeExecuteJSNode(WUBrazilMobileApp_controller_SplitString_JavaScript1JS, "JavaScript1", "SplitString", {
Text: OS.DataConversion.JSNodeParamConverter.to(vars.value.textInLocal, OS.Types.Text),
Delimiter: OS.DataConversion.JSNodeParamConverter.to(vars.value.delimiterInLocal, OS.Types.Text),
TextList: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.SplitString$javaScript1JSResult"))();
jsNodeResult.textListOut = OS.DataConversion.JSNodeParamConverter.from($parameters.TextList, OS.Types.Text);
return jsNodeResult;
}, {}, {});
// JSON Deserialize: JSONDeserializeTextList
jSONDeserializeTextListVar.value.dataOut = OS.JSONUtils.deserializeFromJSON(javaScript1JSResult.value.textListOut, OS.DataTypes.TextList, false);
// TextList = JSONDeserializeTextList.Data
outVars.value.textListOut = jSONDeserializeTextListVar.value.dataOut;
return outVars.value;
};
var controller = WUBrazilMobileAppController.default;
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.SplitString$vars", [{
name: "Text",
attrName: "textInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "Delimiter",
attrName: "delimiterInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.SplitString$javaScript1JSResult", [{
name: "TextList",
attrName: "textListOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.SplitString$outVars", [{
name: "TextList",
attrName: "textListOut",
mandatory: false,
dataType: OS.Types.RecordList,
defaultValue: function () {
return new OS.DataTypes.TextList();
},
complexType: OS.DataTypes.TextList
}]);
WUBrazilMobileAppController.default.clientActionProxies.splitString$Action = function (textIn, delimiterIn) {
textIn = (textIn === undefined) ? "" : textIn;
delimiterIn = (delimiterIn === undefined) ? "" : delimiterIn;
return controller.executeActionInsideJSNode(WUBrazilMobileAppController.default.splitString$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(textIn, OS.Types.Text), OS.DataConversion.JSNodeParamConverter.from(delimiterIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
TextList: actionResults.textListOut
};
});
};
});
define("WUBrazilMobileApp.controller$SplitString.JavaScript1JS", [], function () {
return function ($parameters, $actions, $roles, $public) {
$parameters.TextList = JSON.stringify($parameters.Text.split($parameters.Delimiter));
};
});

define("WUBrazilMobileApp.controller$TargetScreenGoTo", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller", "WUBrazilMobileApp.clientVariables", "WUBrazilMobileApp.controller$DeeplinkAllowedList", "WUBrazilMobileApp.controller$DeeplinkRedirectsTo"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController, WUBrazilMobileAppClientVariables) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.targetScreenGoTo$Action = function (targetScreenIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.TargetScreenGoTo$vars"))());
vars.value.targetScreenInLocal = targetScreenIn;
var deeplinkAllowedListVar = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.TargetScreenGoTo$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: DeeplinkAllowedList
return WUBrazilMobileAppController.default.deeplinkAllowedList$Action(vars.value.targetScreenInLocal, callContext).then(function (value) {
deeplinkAllowedListVar.value = value;
}).then(function () {
if((deeplinkAllowedListVar.value.isValidOut)) {
// Execute Action: DeeplinkRedirectsTo
WUBrazilMobileAppController.default.deeplinkRedirectsTo$Action(deeplinkAllowedListVar.value.targetScreenOut, callContext);
// IsSuccess = True
outVars.value.isSuccessOut = true;
} else {
// Execute Action: LogMessage
OS.SystemActions.logMessage("Not allowed", "Deeplink", callContext);
// IsSuccess = False
outVars.value.isSuccessOut = false;
}

});
}).then(function () {
return outVars.value;
});
};
var controller = WUBrazilMobileAppController.default;
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.TargetScreenGoTo$vars", [{
name: "TargetScreen",
attrName: "targetScreenInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.TargetScreenGoTo$outVars", [{
name: "IsSuccess",
attrName: "isSuccessOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
WUBrazilMobileAppController.default.clientActionProxies.targetScreenGoTo$Action = function (targetScreenIn) {
targetScreenIn = (targetScreenIn === undefined) ? "" : targetScreenIn;
return controller.executeActionInsideJSNode(WUBrazilMobileAppController.default.targetScreenGoTo$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(targetScreenIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
IsSuccess: OS.DataConversion.JSNodeParamConverter.to(actionResults.isSuccessOut, OS.Types.Boolean)
};
});
};
});

define("WUBrazilMobileApp.controller$TriggerOfflineDataSync", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller", "OutSystemsUI.controller", "WUBrazilMobileApp.clientVariables", "OutSystemsUI.controller$StartOfflineDataSync", "WUBrazilMobileApp.referencesHealth", "WUBrazilMobileApp.referencesHealth$OutSystemsUI"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController, OutSystemsUIController, WUBrazilMobileAppClientVariables) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.triggerOfflineDataSync$Action = function (syncUnitIn, discardPendingSyncUnitsIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUBrazilMobileApp.TriggerOfflineDataSync$vars"))());
vars.value.syncUnitInLocal = syncUnitIn;
vars.value.discardPendingSyncUnitsInLocal = discardPendingSyncUnitsIn;
// Execute Action: StartOfflineDataSync
OutSystemsUIController.default.startOfflineDataSync$Action(vars.value.syncUnitInLocal, vars.value.discardPendingSyncUnitsInLocal, callContext);
return ;
};
var controller = WUBrazilMobileAppController.default;
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp.TriggerOfflineDataSync$vars", [{
name: "SyncUnit",
attrName: "syncUnitInLocal",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "DiscardPendingSyncUnits",
attrName: "discardPendingSyncUnitsInLocal",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
WUBrazilMobileAppController.default.clientActionProxies.triggerOfflineDataSync$Action = function (syncUnitIn, discardPendingSyncUnitsIn) {
syncUnitIn = (syncUnitIn === undefined) ? "" : syncUnitIn;
discardPendingSyncUnitsIn = (discardPendingSyncUnitsIn === undefined) ? false : discardPendingSyncUnitsIn;
return controller.executeActionInsideJSNode(WUBrazilMobileAppController.default.triggerOfflineDataSync$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(syncUnitIn, OS.Types.Text), OS.DataConversion.JSNodeParamConverter.from(discardPendingSyncUnitsIn, OS.Types.Boolean)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {};
});
};
});

define("WUBrazilMobileApp.controller$ServerAction.GetUseNewWelcomeScreenFeatureFlag", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.getUseNewWelcomeScreenFeatureFlag$ServerAction = function (callContext) {
var controller = this.controller;
return controller.callServerAction("GetUseNewWelcomeScreenFeatureFlag", "screenservices/WUBrazilMobileApp/ActionGetUseNewWelcomeScreenFeatureFlag", "Kifc5CLrjYCYF4FOwTw4aQ", {}, controller.callContext(callContext), undefined, undefined, true).then(function (outputs) {
var executeServerActionResult = new (controller.constructor.getVariableGroupType("WUBrazilMobileApp$rssespacebrazil_applicationsettings_ActionGetUseNewWelcomeScreenFeatureFlag"))();
executeServerActionResult.isEnabledOut = OS.DataConversion.ServerDataConverter.from(outputs.IsEnabled, OS.Types.Boolean);
executeServerActionResult.lowerBuildVersionAcceptedOut = OS.DataConversion.ServerDataConverter.from(outputs.LowerBuildVersionAccepted, OS.Types.Integer);
return executeServerActionResult;
});
};
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp$rssespacebrazil_applicationsettings_ActionGetUseNewWelcomeScreenFeatureFlag", [{
name: "IsEnabled",
attrName: "isEnabledOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "LowerBuildVersionAccepted",
attrName: "lowerBuildVersionAcceptedOut",
mandatory: false,
dataType: OS.Types.Integer,
defaultValue: function () {
return 6;
}
}]);
});
define("WUBrazilMobileApp.controller$ServerAction.NonProdLogMessage", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.nonProdLogMessage$ServerAction = function (messageIn, moduleIn, callContext) {
var controller = this.controller;
var inputs = {
Message: OS.DataConversion.ServerDataConverter.to(messageIn, OS.Types.Text),
Module: OS.DataConversion.ServerDataConverter.to(moduleIn, OS.Types.Text)
};
return controller.callServerAction("NonProdLogMessage", "screenservices/WUBrazilMobileApp/ActionNonProdLogMessage", "7d0b5n2wLZQuwtBxoIn5ZA", inputs, controller.callContext(callContext), undefined, undefined, true).then(function (outputs) {
});
};
});
define("WUBrazilMobileApp.controller$ServerAction.SiteProperty_CurrentEnv_Get", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.siteProperty_CurrentEnv_Get$ServerAction = function (callContext) {
var controller = this.controller;
return controller.callServerAction("SiteProperty_CurrentEnv_Get", "screenservices/WUBrazilMobileApp/ActionSiteProperty_CurrentEnv_Get", "rqlOW9TueLHYVEsjwhQgaA", {}, controller.callContext(callContext), undefined, undefined, true).then(function (outputs) {
var executeServerActionResult = new (controller.constructor.getVariableGroupType("WUBrazilMobileApp$rssespacebrazil_applicationsettings_ActionSiteProperty_CurrentEnv_Get"))();
executeServerActionResult.envOut = OS.DataConversion.ServerDataConverter.from(outputs.Env, OS.Types.Text);
return executeServerActionResult;
});
};
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp$rssespacebrazil_applicationsettings_ActionSiteProperty_CurrentEnv_Get", [{
name: "Env",
attrName: "envOut",
mandatory: false,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
});
define("WUBrazilMobileApp.controller$ServerAction.SiteProperty_IsShowAppUpdateScreen", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileAppController) {
var OS = OutSystems.Internal;
WUBrazilMobileAppController.default.siteProperty_IsShowAppUpdateScreen$ServerAction = function (callContext) {
var controller = this.controller;
return controller.callServerAction("SiteProperty_IsShowAppUpdateScreen", "screenservices/WUBrazilMobileApp/ServiceAPISiteProperty_IsShowAppUpdateScreen", "UK6zXQbafSMLeHSHKqJBPQ", {}, controller.callContext(callContext), undefined, undefined, true).then(function (outputs) {
var executeServerActionResult = new (controller.constructor.getVariableGroupType("WUBrazilMobileApp$ServiceAPISiteProperty_IsShowAppUpdateScreen"))();
executeServerActionResult.isShowAppUpdateScreenOut = OS.DataConversion.ServerDataConverter.from(outputs.IsShowAppUpdateScreen, OS.Types.Boolean);
return executeServerActionResult;
});
};
WUBrazilMobileAppController.default.constructor.registerVariableGroupType("WUBrazilMobileApp$ServiceAPISiteProperty_IsShowAppUpdateScreen", [{
name: "IsShowAppUpdateScreen",
attrName: "isShowAppUpdateScreenOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
});
define("WUBrazilMobileApp.controller", ["exports", "OutSystems/ClientRuntime/Main", "WUBrazilMobileApp.model", "WUBrazilMobileApp.controller$translationsResources"], function (exports, OutSystems, WUBrazilMobileAppModel, WUBrazilMobileApp_Controller_translationsResources) {
var OS = OutSystems.Internal;
var WUBrazilMobileAppController = exports;
var Controller = (function (_super) {
__extends(Controller, _super);
function Controller() {
_super.apply(this, arguments);
this.registerOnApplicationReadyHandler("WUBrazilMobileApp.controller$OnApplicationReady", "onApplicationReady$Action");
}
Controller.prototype.clientActionProxies = {};
Controller.prototype.roles = {};
Controller.prototype.defaultTimeout = 500;
Controller.prototype.getDefaultTimeout = function () {
return WUBrazilMobileAppController.default.defaultTimeout;
};
return Controller;
})(OS.Controller.BaseModuleController);
WUBrazilMobileAppController.default = new Controller(WUBrazilMobileApp_Controller_translationsResources, "WUBrazilMobileApp");
});
define("WUBrazilMobileApp.controller$translationsResources", ["exports"], function (exports) {
return {};
});
