﻿define("WUContactsPlugin.controller$AddToContacts", ["exports", "OutSystems/ClientRuntime/Main", "WUContactsPlugin.model", "WUContactsPlugin.controller", "CommonPlugin.model", "WUContactsPlugin.controller$AddToContacts.AddToContactsJSJS", "CommonPlugin.model$ErrorRec", "WUContactsPlugin.referencesHealth", "WUContactsPlugin.referencesHealth$CommonPlugin", "WUContactsPlugin.controller$CheckContactsPlugin"], function (exports, OutSystems, WUContactsPluginModel, WUContactsPluginController, CommonPluginModel, WUContactsPlugin_controller_AddToContacts_AddToContactsJSJS) {
var OS = OutSystems.Internal;
WUContactsPluginController.default.addToContacts$Action = function (firstNameIn, lastNameIn, phoneIn, emailIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUContactsPlugin.AddToContacts$vars"))());
vars.value.firstNameInLocal = firstNameIn;
vars.value.lastNameInLocal = lastNameIn;
vars.value.phoneInLocal = phoneIn;
vars.value.emailInLocal = emailIn;
var allExceptionsVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var checkContactsPluginVar = new OS.DataTypes.VariableHolder();
var addToContactsJSJSResult = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUContactsPlugin.AddToContacts$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: CheckContactsPlugin
checkContactsPluginVar.value = WUContactsPluginController.default.checkContactsPlugin$Action(callContext);

// Is Contacts Plugin available?
return OS.Flow.executeSequence(function () {
if((checkContactsPluginVar.value.isAvailableOut)) {
// Use this action to add a contact to the device's address book.
return controller.safeExecuteAsyncJSNode(WUContactsPlugin_controller_AddToContacts_AddToContactsJSJS, "AddToContactsJS", "AddToContacts", {
FirstName: OS.DataConversion.JSNodeParamConverter.to(vars.value.firstNameInLocal, OS.Types.Text),
LastName: OS.DataConversion.JSNodeParamConverter.to(vars.value.lastNameInLocal, OS.Types.Text),
Email: OS.DataConversion.JSNodeParamConverter.to(vars.value.emailInLocal, OS.Types.Text),
Phone: OS.DataConversion.JSNodeParamConverter.to(vars.value.phoneInLocal, OS.Types.Text),
Success: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean),
ErrorMessage: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("WUContactsPlugin.AddToContacts$addToContactsJSJSResult"))();
jsNodeResult.successOut = OS.DataConversion.JSNodeParamConverter.from($parameters.Success, OS.Types.Boolean);
jsNodeResult.errorMessageOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ErrorMessage, OS.Types.Text);
return jsNodeResult;
}, {}, {}).then(function (results) {
addToContactsJSJSResult.value = results;
}).then(function () {
if((addToContactsJSJSResult.value.successOut)) {
// Set Values
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
// Success = AddToContactsJS.Success
outVars.value.successOut = addToContactsJSJSResult.value.successOut;
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
} else {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = AddToContactsJS.ErrorMessage
outVars.value.errorOut.errorMessageAttr = addToContactsJSJSResult.value.errorMessageOut;
// Error.ErrorCode = 3
outVars.value.errorOut.errorCodeAttr = "3";
}

});
} else {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = CheckContactsPlugin.Error.ErrorMessage
outVars.value.errorOut.errorMessageAttr = checkContactsPluginVar.value.errorOut.errorMessageAttr;
// Error.ErrorCode = CheckContactsPlugin.Error.ErrorCode
outVars.value.errorOut.errorCodeAttr = checkContactsPluginVar.value.errorOut.errorCodeAttr;
}

});
}).catch(function (ex) {
OS.Logger.trace("AddToContacts.AddToContacts", OS.Exceptions.getMessage(ex), ex.name);
// Handle Error: AllExceptions
if(!(OS.Exceptions.isSystem(ex))) {
OS.Logger.error(null, ex);
allExceptionsVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
return OS.Flow.executeAsyncFlow(function () {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = AllExceptions.ExceptionMessage
outVars.value.errorOut.errorMessageAttr = allExceptionsVar.value.exceptionMessageAttr;
// Error.ErrorCode = -1
outVars.value.errorOut.errorCodeAttr = (-1).toString();
return OS.Flow.returnAsync(outVars.value);

});
}

throw ex;
}).then(function () {
return outVars.value;
});
};
var controller = WUContactsPluginController.default;
WUContactsPluginController.default.constructor.registerVariableGroupType("WUContactsPlugin.AddToContacts$vars", [{
name: "FirstName",
attrName: "firstNameInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "LastName",
attrName: "lastNameInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "Phone",
attrName: "phoneInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "Email",
attrName: "emailInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUContactsPluginController.default.constructor.registerVariableGroupType("WUContactsPlugin.AddToContacts$addToContactsJSJSResult", [{
name: "Success",
attrName: "successOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "ErrorMessage",
attrName: "errorMessageOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUContactsPluginController.default.constructor.registerVariableGroupType("WUContactsPlugin.AddToContacts$outVars", [{
name: "Success",
attrName: "successOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}]);
WUContactsPluginController.default.clientActionProxies.addToContacts$Action = function (firstNameIn, lastNameIn, phoneIn, emailIn) {
firstNameIn = (firstNameIn === undefined) ? "" : firstNameIn;
lastNameIn = (lastNameIn === undefined) ? "" : lastNameIn;
phoneIn = (phoneIn === undefined) ? "" : phoneIn;
emailIn = (emailIn === undefined) ? "" : emailIn;
return controller.executeActionInsideJSNode(WUContactsPluginController.default.addToContacts$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(firstNameIn, OS.Types.Text), OS.DataConversion.JSNodeParamConverter.from(lastNameIn, OS.Types.Text), OS.DataConversion.JSNodeParamConverter.from(phoneIn, OS.Types.Text), OS.DataConversion.JSNodeParamConverter.from(emailIn, OS.Types.Text)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Success: OS.DataConversion.JSNodeParamConverter.to(actionResults.successOut, OS.Types.Boolean),
Error: actionResults.errorOut
};
});
};
});
define("WUContactsPlugin.controller$AddToContacts.AddToContactsJSJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
return new Promise(function ($resolve, $reject) {
function onSuccess(contact) {
    $parameters.Success = true;
    $parameters.ErrorMessage = "";
    $resolve(); 
}

function onError(contactError) {
    $parameters.Success = false;
    $parameters.ErrorMessage = "Could not save contact";
    $resolve();
}

var name = new ContactName();
name.givenName = $parameters.FirstName;
name.familyName = $parameters.LastName;

var phoneNumbers = [];
phoneNumbers[0] = new ContactField('mobile', $parameters.Phone, true);

var emails = [];
emails[0] = new ContactField('work', $parameters.Email, true);

var contact = navigator.contacts.create();
contact.name = name;
contact.phoneNumbers = phoneNumbers;
contact.emails = emails;

// save to device
contact.save(onSuccess, onError);
});
};
});

define("WUContactsPlugin.controller$CheckContactsPlugin", ["exports", "OutSystems/ClientRuntime/Main", "WUContactsPlugin.model", "WUContactsPlugin.controller", "CommonPlugin.controller", "CommonPlugin.model", "WUContactsPlugin.controller$CheckContactsPlugin.IsPluginAvailableJSJS", "CommonPlugin.controller$IsCordovaDefined", "WUContactsPlugin.referencesHealth", "WUContactsPlugin.referencesHealth$CommonPlugin", "CommonPlugin.model$ErrorRec"], function (exports, OutSystems, WUContactsPluginModel, WUContactsPluginController, CommonPluginController, CommonPluginModel, WUContactsPlugin_controller_CheckContactsPlugin_IsPluginAvailableJSJS) {
var OS = OutSystems.Internal;
WUContactsPluginController.default.checkContactsPlugin$Action = function (callContext) {
callContext = controller.callContext(callContext);
var allExceptionsVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var isCordovaDefinedVar = new OS.DataTypes.VariableHolder();
var isPluginAvailableJSJSResult = new OS.DataTypes.VariableHolder();
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUContactsPlugin.CheckContactsPlugin$outVars"))());
try {// Execute Action: IsCordovaDefined
isCordovaDefinedVar.value = CommonPluginController.default.isCordovaDefined$Action(callContext);

if((isCordovaDefinedVar.value.isLoadedOut)) {
// Validates if the plugin is currently available. Useful to verify if the current application has the plugin installed.
isPluginAvailableJSJSResult.value = controller.safeExecuteJSNode(WUContactsPlugin_controller_CheckContactsPlugin_IsPluginAvailableJSJS, "IsPluginAvailableJS", "CheckContactsPlugin", {
IsAvailable: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("WUContactsPlugin.CheckContactsPlugin$isPluginAvailableJSJSResult"))();
jsNodeResult.isAvailableOut = OS.DataConversion.JSNodeParamConverter.from($parameters.IsAvailable, OS.Types.Boolean);
return jsNodeResult;
}, {}, {});
if((isPluginAvailableJSJSResult.value.isAvailableOut)) {
// IsAvailable = IsPluginAvailableJS.IsAvailable
outVars.value.isAvailableOut = isPluginAvailableJSJSResult.value.isAvailableOut;
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
} else {
// Error.ErrorCode = 2
outVars.value.errorOut.errorCodeAttr = "2";
// Error.ErrorMessage = "Contacts Plugin is unavailable"
outVars.value.errorOut.errorMessageAttr = "Contacts Plugin is unavailable";
// IsAvailable = False
outVars.value.isAvailableOut = false;
}

} else {
// Error.ErrorCode = 1
outVars.value.errorOut.errorCodeAttr = "1";
// Error.ErrorMessage = "Cordova is not available"
outVars.value.errorOut.errorMessageAttr = "Cordova is not available";
// IsAvailable = False
outVars.value.isAvailableOut = false;
}

} catch (ex) {
(function () {
OS.Logger.trace("CheckContactsPlugin.CheckContactsPlugin", OS.Exceptions.getMessage(ex), ex.name);
// Handle Error: AllExceptions
if(!(OS.Exceptions.isSystem(ex))) {
OS.Logger.error(null, ex);
allExceptionsVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
// IsAvailable = False
outVars.value.isAvailableOut = false;
// Error.ErrorCode = -1
outVars.value.errorOut.errorCodeAttr = (-1).toString();
// Error.ErrorMessage = AllExceptions.ExceptionMessage
outVars.value.errorOut.errorMessageAttr = allExceptionsVar.value.exceptionMessageAttr;
return outVars.value;

}

throw ex;
})();
}

return outVars.value;
};
var controller = WUContactsPluginController.default;
WUContactsPluginController.default.constructor.registerVariableGroupType("WUContactsPlugin.CheckContactsPlugin$isPluginAvailableJSJSResult", [{
name: "IsAvailable",
attrName: "isAvailableOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
WUContactsPluginController.default.constructor.registerVariableGroupType("WUContactsPlugin.CheckContactsPlugin$outVars", [{
name: "IsAvailable",
attrName: "isAvailableOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}]);
WUContactsPluginController.default.clientActionProxies.checkContactsPlugin$Action = function () {
return controller.executeActionInsideJSNode(WUContactsPluginController.default.checkContactsPlugin$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
IsAvailable: OS.DataConversion.JSNodeParamConverter.to(actionResults.isAvailableOut, OS.Types.Boolean),
Error: actionResults.errorOut
};
});
};
});
define("WUContactsPlugin.controller$CheckContactsPlugin.IsPluginAvailableJSJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
$parameters.IsAvailable = !!window.cordova && !!navigator.contacts;
};
});

define("WUContactsPlugin.controller$FindContact", ["exports", "OutSystems/ClientRuntime/Main", "WUContactsPlugin.model", "WUContactsPlugin.controller", "CommonPlugin.model", "WUContactsPlugin.controller$FindContact.FindContactJSJS", "CommonPlugin.model$ErrorRec", "WUContactsPlugin.referencesHealth", "WUContactsPlugin.referencesHealth$CommonPlugin", "WUContactsPlugin.controller$CheckContactsPlugin", "WUContactsPlugin.model$ContactList"], function (exports, OutSystems, WUContactsPluginModel, WUContactsPluginController, CommonPluginModel, WUContactsPlugin_controller_FindContact_FindContactJSJS) {
var OS = OutSystems.Internal;
WUContactsPluginController.default.findContact$Action = function (searchParameterIn, multipleContactsIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUContactsPlugin.FindContact$vars"))());
vars.value.searchParameterInLocal = searchParameterIn;
vars.value.multipleContactsInLocal = multipleContactsIn;
var allExceptionsVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var checkContactsPluginVar = new OS.DataTypes.VariableHolder();
var findContactJSJSResult = new OS.DataTypes.VariableHolder();
var jSONDeserializeContactVar = new OS.DataTypes.VariableHolder(new (OS.Controller.BaseController.getJSONDeserializeOutputType(WUContactsPluginModel.ContactList))());
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUContactsPlugin.FindContact$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: CheckContactsPlugin
checkContactsPluginVar.value = WUContactsPluginController.default.checkContactsPlugin$Action(callContext);

// Is Contacts Plugin available?
return OS.Flow.executeSequence(function () {
if((checkContactsPluginVar.value.isAvailableOut)) {
// Use this action to add a contact to the device's address book.
return controller.safeExecuteAsyncJSNode(WUContactsPlugin_controller_FindContact_FindContactJSJS, "FindContactJS", "FindContact", {
SearchParameter: OS.DataConversion.JSNodeParamConverter.to(vars.value.searchParameterInLocal, OS.Types.Text),
MultipleContacts: OS.DataConversion.JSNodeParamConverter.to(vars.value.multipleContactsInLocal, OS.Types.Boolean),
ContactsJSON: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text),
Success: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean),
ErrorMessage: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("WUContactsPlugin.FindContact$findContactJSJSResult"))();
jsNodeResult.contactsJSONOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ContactsJSON, OS.Types.Text);
jsNodeResult.successOut = OS.DataConversion.JSNodeParamConverter.from($parameters.Success, OS.Types.Boolean);
jsNodeResult.errorMessageOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ErrorMessage, OS.Types.Text);
return jsNodeResult;
}, {}, {}).then(function (results) {
findContactJSJSResult.value = results;
}).then(function () {
if((findContactJSJSResult.value.successOut)) {
// JSON Deserialize: JSONDeserializeContact
jSONDeserializeContactVar.value.dataOut = OS.JSONUtils.deserializeFromJSON(findContactJSJSResult.value.contactsJSONOut, WUContactsPluginModel.ContactList, false);
// Set Values
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
// Success = FindContactJS.Success
outVars.value.successOut = findContactJSJSResult.value.successOut;
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
// Contacts = JSONDeserializeContact.Data
outVars.value.contactsOut = jSONDeserializeContactVar.value.dataOut;
} else {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = FindContactJS.ErrorMessage
outVars.value.errorOut.errorMessageAttr = findContactJSJSResult.value.errorMessageOut;
// Error.ErrorCode = 3
outVars.value.errorOut.errorCodeAttr = "3";
}

});
} else {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = CheckContactsPlugin.Error.ErrorMessage
outVars.value.errorOut.errorMessageAttr = checkContactsPluginVar.value.errorOut.errorMessageAttr;
// Error.ErrorCode = CheckContactsPlugin.Error.ErrorCode
outVars.value.errorOut.errorCodeAttr = checkContactsPluginVar.value.errorOut.errorCodeAttr;
}

});
}).catch(function (ex) {
OS.Logger.trace("FindContact.FindContact", OS.Exceptions.getMessage(ex), ex.name);
// Handle Error: AllExceptions
if(!(OS.Exceptions.isSystem(ex))) {
OS.Logger.error(null, ex);
allExceptionsVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
return OS.Flow.executeAsyncFlow(function () {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = AllExceptions.ExceptionMessage
outVars.value.errorOut.errorMessageAttr = allExceptionsVar.value.exceptionMessageAttr;
// Error.ErrorCode = -1
outVars.value.errorOut.errorCodeAttr = (-1).toString();
return OS.Flow.returnAsync(outVars.value);

});
}

throw ex;
}).then(function () {
return outVars.value;
});
};
var controller = WUContactsPluginController.default;
WUContactsPluginController.default.constructor.registerVariableGroupType("WUContactsPlugin.FindContact$vars", [{
name: "SearchParameter",
attrName: "searchParameterInLocal",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "MultipleContacts",
attrName: "multipleContactsInLocal",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}]);
WUContactsPluginController.default.constructor.registerVariableGroupType("WUContactsPlugin.FindContact$findContactJSJSResult", [{
name: "ContactsJSON",
attrName: "contactsJSONOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "Success",
attrName: "successOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "ErrorMessage",
attrName: "errorMessageOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUContactsPluginController.default.constructor.registerVariableGroupType("WUContactsPlugin.FindContact$outVars", [{
name: "Contacts",
attrName: "contactsOut",
mandatory: false,
dataType: OS.Types.RecordList,
defaultValue: function () {
return new WUContactsPluginModel.ContactList();
},
complexType: WUContactsPluginModel.ContactList
}, {
name: "Success",
attrName: "successOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}]);
WUContactsPluginController.default.clientActionProxies.findContact$Action = function (searchParameterIn, multipleContactsIn) {
searchParameterIn = (searchParameterIn === undefined) ? "" : searchParameterIn;
multipleContactsIn = (multipleContactsIn === undefined) ? false : multipleContactsIn;
return controller.executeActionInsideJSNode(WUContactsPluginController.default.findContact$Action.bind(controller, OS.DataConversion.JSNodeParamConverter.from(searchParameterIn, OS.Types.Text), OS.DataConversion.JSNodeParamConverter.from(multipleContactsIn, OS.Types.Boolean)), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Contacts: actionResults.contactsOut,
Success: OS.DataConversion.JSNodeParamConverter.to(actionResults.successOut, OS.Types.Boolean),
Error: actionResults.errorOut
};
});
};
});
define("WUContactsPlugin.controller$FindContact.FindContactJSJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
return new Promise(function ($resolve, $reject) {
function onSuccess(contacts) {
    $parameters.Success = true;
    $parameters.ErrorMessage = "";
    $parameters.ContactsJSON = JSON.stringify(contacts);
    $resolve(); 
}

function onError(contactError) {
    $parameters.Success = false;
    $parameters.ErrorMessage = "Could not save contact";
    $resolve();
}

var options = new ContactFindOptions();
options.filter = $parameters.SearchParameter;
options.multiple = $parameters.MultipleContacts;
options.hasPhoneNumber = true;
// Get only desired fields
options.desiredFields = [navigator.contacts.fieldType.name, navigator.contacts.fieldType.familyName, navigator.contacts.fieldType.middleName, navigator.contacts.fieldType.phoneNumbers, navigator.contacts.fieldType.photos, navigator.contacts.fieldType.emails]; // read only those you want to display

// Finds contacts
var fields = [navigator.contacts.fieldType.displayName, navigator.contacts.fieldType.name, navigator.contacts.fieldType.familyName, navigator.contacts.fieldType.nickname, navigator.contacts.fieldType.givenName];

navigator.contacts.find(fields, onSuccess, onError, options);

});
};
});

define("WUContactsPlugin.controller$PickContact", ["exports", "OutSystems/ClientRuntime/Main", "WUContactsPlugin.model", "WUContactsPlugin.controller", "CommonPlugin.model", "WUContactsPlugin.controller$PickContact.PickContactJS", "CommonPlugin.model$ErrorRec", "WUContactsPlugin.referencesHealth", "WUContactsPlugin.referencesHealth$CommonPlugin", "WUContactsPlugin.controller$CheckContactsPlugin", "WUContactsPlugin.model$ContactRec"], function (exports, OutSystems, WUContactsPluginModel, WUContactsPluginController, CommonPluginModel, WUContactsPlugin_controller_PickContact_PickContactJS) {
var OS = OutSystems.Internal;
WUContactsPluginController.default.pickContact$Action = function (callContext) {
callContext = controller.callContext(callContext);
var allExceptionsVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var checkContactsPluginVar = new OS.DataTypes.VariableHolder();
var pickContactJSResult = new OS.DataTypes.VariableHolder();
var jSONDeserializeContactVar = new OS.DataTypes.VariableHolder(new (OS.Controller.BaseController.getJSONDeserializeOutputType(WUContactsPluginModel.ContactRec))());
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUContactsPlugin.PickContact$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: CheckContactsPlugin
checkContactsPluginVar.value = WUContactsPluginController.default.checkContactsPlugin$Action(callContext);

// Is Contacts Plugin available?
return OS.Flow.executeSequence(function () {
if((checkContactsPluginVar.value.isAvailableOut)) {
return controller.safeExecuteAsyncJSNode(WUContactsPlugin_controller_PickContact_PickContactJS, "PickContact", "PickContact", {
Success: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean),
ErrorMessage: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text),
ContactJSON: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("WUContactsPlugin.PickContact$pickContactJSResult"))();
jsNodeResult.successOut = OS.DataConversion.JSNodeParamConverter.from($parameters.Success, OS.Types.Boolean);
jsNodeResult.errorMessageOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ErrorMessage, OS.Types.Text);
jsNodeResult.contactJSONOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ContactJSON, OS.Types.Text);
return jsNodeResult;
}, {}, {}).then(function (results) {
pickContactJSResult.value = results;
}).then(function () {
if((pickContactJSResult.value.successOut)) {
// JSON Deserialize: JSONDeserializeContact
jSONDeserializeContactVar.value.dataOut = OS.JSONUtils.deserializeFromJSON(pickContactJSResult.value.contactJSONOut, WUContactsPluginModel.ContactRec, false);
// Set Values
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
// Success = PickContact.Success
outVars.value.successOut = pickContactJSResult.value.successOut;
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
// Contact = JSONDeserializeContact.Data
outVars.value.contactOut = jSONDeserializeContactVar.value.dataOut;
} else {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = PickContact.ErrorMessage
outVars.value.errorOut.errorMessageAttr = pickContactJSResult.value.errorMessageOut;
// Error.ErrorCode = 3
outVars.value.errorOut.errorCodeAttr = "3";
}

});
} else {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = CheckContactsPlugin.Error.ErrorMessage
outVars.value.errorOut.errorMessageAttr = checkContactsPluginVar.value.errorOut.errorMessageAttr;
// Error.ErrorCode = CheckContactsPlugin.Error.ErrorCode
outVars.value.errorOut.errorCodeAttr = checkContactsPluginVar.value.errorOut.errorCodeAttr;
}

});
}).catch(function (ex) {
OS.Logger.trace("PickContact.PickContact", OS.Exceptions.getMessage(ex), ex.name);
// Handle Error: AllExceptions
if(!(OS.Exceptions.isSystem(ex))) {
OS.Logger.error(null, ex);
allExceptionsVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
return OS.Flow.executeAsyncFlow(function () {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = AllExceptions.ExceptionMessage
outVars.value.errorOut.errorMessageAttr = allExceptionsVar.value.exceptionMessageAttr;
// Error.ErrorCode = -1
outVars.value.errorOut.errorCodeAttr = (-1).toString();
return OS.Flow.returnAsync(outVars.value);

});
}

throw ex;
}).then(function () {
return outVars.value;
});
};
var controller = WUContactsPluginController.default;
WUContactsPluginController.default.constructor.registerVariableGroupType("WUContactsPlugin.PickContact$pickContactJSResult", [{
name: "Success",
attrName: "successOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "ErrorMessage",
attrName: "errorMessageOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}, {
name: "ContactJSON",
attrName: "contactJSONOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUContactsPluginController.default.constructor.registerVariableGroupType("WUContactsPlugin.PickContact$outVars", [{
name: "Contact",
attrName: "contactOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new WUContactsPluginModel.ContactRec();
},
complexType: WUContactsPluginModel.ContactRec
}, {
name: "Success",
attrName: "successOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}]);
WUContactsPluginController.default.clientActionProxies.pickContact$Action = function () {
return controller.executeActionInsideJSNode(WUContactsPluginController.default.pickContact$Action.bind(controller), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Contact: actionResults.contactOut,
Success: OS.DataConversion.JSNodeParamConverter.to(actionResults.successOut, OS.Types.Boolean),
Error: actionResults.errorOut
};
});
};
});
define("WUContactsPlugin.controller$PickContact.PickContactJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
return new Promise(function ($resolve, $reject) {
function onSuccess(contact) {
    // TODO: could store contact js option to perform further operations like 
    // delete, or update
    $parameters.ContactJSON = JSON.stringify(contact);
    $parameters.Success = true;
    $parameters.ErrorMessage = "";
    $resolve(); 
}

function onError(err) {
    $parameters.Success = false;
    $parameters.ErrorMessage = "Could not pick contact";
    $resolve();
}


if (!navigator.contacts) { 
    onError(""); 
}
else {
    // pick contact from device's contact picker
    navigator.contacts.pickContact(onSuccess, onError);
}
});
};
});

define("WUContactsPlugin.controller$RemoveFromContacts", ["exports", "OutSystems/ClientRuntime/Main", "WUContactsPlugin.model", "WUContactsPlugin.controller", "CommonPlugin.model", "WUContactsPlugin.controller$RemoveFromContacts.RemoveFromContactsJSJS", "CommonPlugin.model$ErrorRec", "WUContactsPlugin.referencesHealth", "WUContactsPlugin.referencesHealth$CommonPlugin", "WUContactsPlugin.controller$CheckContactsPlugin", "WUContactsPlugin.model$ContactRec"], function (exports, OutSystems, WUContactsPluginModel, WUContactsPluginController, CommonPluginModel, WUContactsPlugin_controller_RemoveFromContacts_RemoveFromContactsJSJS) {
var OS = OutSystems.Internal;
WUContactsPluginController.default.removeFromContacts$Action = function (contactIn, callContext) {
callContext = controller.callContext(callContext);
var vars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUContactsPlugin.RemoveFromContacts$vars"))());
vars.value.contactInLocal = contactIn.clone();
var allExceptionsVar = new OS.DataTypes.VariableHolder(new OS.DataTypes.ErrorHandlerOutputType());
var checkContactsPluginVar = new OS.DataTypes.VariableHolder();
var removeFromContactsJSJSResult = new OS.DataTypes.VariableHolder();
var jSONSerialize1Var = new OS.DataTypes.VariableHolder(new OS.DataTypes.JSONSerializeOutputType());
var outVars = new OS.DataTypes.VariableHolder(new (controller.constructor.getVariableGroupType("WUContactsPlugin.RemoveFromContacts$outVars"))());
return OS.Flow.executeAsyncFlow(function () {
// Execute Action: CheckContactsPlugin
checkContactsPluginVar.value = WUContactsPluginController.default.checkContactsPlugin$Action(callContext);

// Is Contacts Plugin available?
return OS.Flow.executeSequence(function () {
if((checkContactsPluginVar.value.isAvailableOut)) {
// JSON Serialize: JSONSerialize1
jSONSerialize1Var.value.jSONOut = OS.JSONUtils.serializeToJSON(vars.value.contactInLocal, false, false);
// Use this action to add a contact to the device's address book.
return controller.safeExecuteAsyncJSNode(WUContactsPlugin_controller_RemoveFromContacts_RemoveFromContactsJSJS, "RemoveFromContactsJS", "RemoveFromContacts", {
ContactJSON: OS.DataConversion.JSNodeParamConverter.to(jSONSerialize1Var.value.jSONOut, OS.Types.Text),
Success: OS.DataConversion.JSNodeParamConverter.to(false, OS.Types.Boolean),
ErrorMessage: OS.DataConversion.JSNodeParamConverter.to("", OS.Types.Text)
}, function ($parameters) {
var jsNodeResult = new (controller.constructor.getVariableGroupType("WUContactsPlugin.RemoveFromContacts$removeFromContactsJSJSResult"))();
jsNodeResult.successOut = OS.DataConversion.JSNodeParamConverter.from($parameters.Success, OS.Types.Boolean);
jsNodeResult.errorMessageOut = OS.DataConversion.JSNodeParamConverter.from($parameters.ErrorMessage, OS.Types.Text);
return jsNodeResult;
}, {}, {}).then(function (results) {
removeFromContactsJSJSResult.value = results;
}).then(function () {
if((removeFromContactsJSJSResult.value.successOut)) {
// Set Values
// Error.ErrorMessage = ""
outVars.value.errorOut.errorMessageAttr = "";
// Success = RemoveFromContactsJS.Success
outVars.value.successOut = removeFromContactsJSJSResult.value.successOut;
// Error.ErrorCode = 0
outVars.value.errorOut.errorCodeAttr = "0";
} else {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = RemoveFromContactsJS.ErrorMessage
outVars.value.errorOut.errorMessageAttr = removeFromContactsJSJSResult.value.errorMessageOut;
// Error.ErrorCode = 3
outVars.value.errorOut.errorCodeAttr = "3";
}

});
} else {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = CheckContactsPlugin.Error.ErrorMessage
outVars.value.errorOut.errorMessageAttr = checkContactsPluginVar.value.errorOut.errorMessageAttr;
// Error.ErrorCode = CheckContactsPlugin.Error.ErrorCode
outVars.value.errorOut.errorCodeAttr = checkContactsPluginVar.value.errorOut.errorCodeAttr;
}

});
}).catch(function (ex) {
OS.Logger.trace("RemoveFromContacts.RemoveFromContacts", OS.Exceptions.getMessage(ex), ex.name);
// Handle Error: AllExceptions
if(!(OS.Exceptions.isSystem(ex))) {
OS.Logger.error(null, ex);
allExceptionsVar.value.exceptionMessageAttr = OS.Exceptions.getMessage(ex);
return OS.Flow.executeAsyncFlow(function () {
// Set error
// Success = False
outVars.value.successOut = false;
// Error.ErrorMessage = AllExceptions.ExceptionMessage
outVars.value.errorOut.errorMessageAttr = allExceptionsVar.value.exceptionMessageAttr;
// Error.ErrorCode = -1
outVars.value.errorOut.errorCodeAttr = (-1).toString();
return OS.Flow.returnAsync(outVars.value);

});
}

throw ex;
}).then(function () {
return outVars.value;
});
};
var controller = WUContactsPluginController.default;
WUContactsPluginController.default.constructor.registerVariableGroupType("WUContactsPlugin.RemoveFromContacts$vars", [{
name: "Contact",
attrName: "contactInLocal",
mandatory: true,
dataType: OS.Types.Record,
defaultValue: function () {
return new WUContactsPluginModel.ContactRec();
},
complexType: WUContactsPluginModel.ContactRec
}]);
WUContactsPluginController.default.constructor.registerVariableGroupType("WUContactsPlugin.RemoveFromContacts$removeFromContactsJSJSResult", [{
name: "Success",
attrName: "successOut",
mandatory: true,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "ErrorMessage",
attrName: "errorMessageOut",
mandatory: true,
dataType: OS.Types.Text,
defaultValue: function () {
return "";
}
}]);
WUContactsPluginController.default.constructor.registerVariableGroupType("WUContactsPlugin.RemoveFromContacts$outVars", [{
name: "Success",
attrName: "successOut",
mandatory: false,
dataType: OS.Types.Boolean,
defaultValue: function () {
return false;
}
}, {
name: "Error",
attrName: "errorOut",
mandatory: false,
dataType: OS.Types.Record,
defaultValue: function () {
return new CommonPluginModel.ErrorRec();
},
complexType: CommonPluginModel.ErrorRec
}]);
WUContactsPluginController.default.clientActionProxies.removeFromContacts$Action = function (contactIn) {
contactIn = (contactIn === undefined) ? new WUContactsPluginModel.ContactRec() : contactIn;
return controller.executeActionInsideJSNode(WUContactsPluginController.default.removeFromContacts$Action.bind(controller, contactIn), OS.Controller.BaseViewController.activeScreen ? OS.Controller.BaseViewController.activeScreen.callContext() : undefined, function (actionResults) {
return {
Success: OS.DataConversion.JSNodeParamConverter.to(actionResults.successOut, OS.Types.Boolean),
Error: actionResults.errorOut
};
});
};
});
define("WUContactsPlugin.controller$RemoveFromContacts.RemoveFromContactsJSJS", [], function () {
return function ($parameters, $actions, $roles, $public) {
return new Promise(function ($resolve, $reject) {
function onSuccess() {
    $parameters.Success = true;
    $parameters.ErrorMessage = "";
    $resolve();
}

function onError(contactError) {
    $parameters.Success = false;
    $parameters.ErrorMessage = "Error deleting contact";
    $resolve();
}
var json = JSON.parse($parameters.ContactJSON);

var contact = navigator.contacts.create();
contact.id = json.id;

contact.remove(onSuccess, onError);
});
};
});

define("WUContactsPlugin.controller", ["exports", "OutSystems/ClientRuntime/Main", "WUContactsPlugin.model"], function (exports, OutSystems, WUContactsPluginModel) {
var OS = OutSystems.Internal;
var WUContactsPluginController = exports;
var Controller = (function (_super) {
__extends(Controller, _super);
function Controller() {
_super.apply(this, arguments);
}
Controller.prototype.clientActionProxies = {};
Controller.prototype.roles = {};
Controller.prototype.defaultTimeout = 10;
Controller.prototype.getDefaultTimeout = function () {
return WUContactsPluginController.default.defaultTimeout;
};
return Controller;
})(OS.Controller.BaseModuleController);
WUContactsPluginController.default = new Controller(null, "WUContactsPlugin");
});
