﻿function AnimatedLabelInputBox() {
    
    var inputValue;
    var animatedLabelEl;
    
    var onFocus = function (event) {
        animatedLabelEl = osui.GetClosest(event.target, '.animated-label');
        if(animatedLabelEl){
            animatedLabelEl.classList.add('active');  
        } 
    };
    
    var onBlur = function (event) {
        animatedLabelEl = osui.GetClosest(event.target, '.animated-label');
        if (this.value.length === 0 && animatedLabelEl) {
            animatedLabelEl.classList.remove('active');
        }
    };
    
    var addEventListeners = function(inputValue) {    
        
        if (inputValue !== null) {
            inputValue.addEventListener("focus", onFocus, true);
            inputValue.addEventListener("blur", onBlur, true);
            inputValue.addEventListener('animationstart', onAnimationStart, false);
        }
    };
    
    var updateLabel = function (inputValue) {
        
        animatedLabelEl = osui.GetClosest(inputValue, '.animated-label');

        if (inputValue!== null && animatedLabelEl) {
            if (inputValue.value === '' && inputValue !== document.activeElement ) {
                animatedLabelEl.classList.remove('active');
                if(event && event.animationName === "onAutoFillStart") {
                    animatedLabelEl.classList.add('active');
                }
            } else {
               animatedLabelEl.classList.add('active'); 
            }            
        }
    };
    
    var onAnimationStart = function() {
        updateLabel(this);
    };

    return {
      
    //wrapperId from animated label wrapper
    init: function(wrapperId) {
        
        var inputValue = document.getElementById(wrapperId);
        inputValue = inputValue.querySelector('input');
        var animatedLabelEl = osui.GetClosest(inputValue, '.animated-label');
        
        if(inputValue !== null && animatedLabelEl) {
            addEventListeners(inputValue);
        }
    },
    update: function(wrapperId) {
        
        var inputValue = document.getElementById(wrapperId);
        inputValue = inputValue.querySelector('input');

        updateLabel(inputValue);
        
    }
  };

}