﻿function InputMaskCurrency(widgetId, realInputWrapperId, value) {

    var widget = document.getElementById(widgetId);
    var maskedInput = widget.querySelector('input');

    var realInput = document.getElementById(realInputWrapperId).querySelector("input");

    var realInputClass = realInput.classList;
    realInputClass.forEach(function(e){
        maskedInput.classList.add(e);
    });

    var animatedLabel = realInput.closest('.animated-label');
    if(animatedLabel !== null) {
        animatedLabel.classList.add('active');
    }

    maskedInput.addEventListener('blur', function(){
        realInput.dispatchEvent(new Event('blur', { bubbles: true }));
    });

    maskedInput.addEventListener('focus', function(){
        if(this.value == '0,00') {
            setTimeout(function() {
                maskedInput.setSelectionRange(100,100);
            }, 50);
        }
    });

    var currentValue = value;

    var start = 0;
    
    function numberWithCommas(x) {
        return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
    }

    function getFormattedValue(temp) {
        var temp2 = parseInt(temp.replace(/\D/g,''))
        var finalVal = (temp2/100).toFixed(2) + "";
        finalVal = finalVal.replace(".",",");
        return finalVal;
    }

    var isRealInputNotValid = realInput.classList.contains('not-valid');
    var observer = new MutationObserver(function(mutations) {
        mutations.forEach(function(mutation) {
            if(mutation.attributeName == "class") {
                var currentIsRealInputNotValid = mutation.target.classList.contains('not-valid');
                if(isRealInputNotValid !== currentIsRealInputNotValid) {
                    isRealInputNotValid = currentIsRealInputNotValid;
                    currentIsRealInputNotValid ? maskedInput.classList.add('not-valid') : maskedInput.classList.remove('not-valid');  
                }
            }
        });
    });
    observer.observe(realInput, {attributes: true});

    function setNativeValue(element, value) {
        start = Date.now();
        var lastValue = element.value;
        element.value = value;
        var event = new Event("input", { target: element, bubbles: true });
        // React 15
        event.simulated = true;
        // React 16
        var tracker = element._valueTracker;
        if (tracker) {
            tracker.setValue(lastValue);
        }
        element.dispatchEvent(event); 
    }
    
    return {
        init: function() {
            if(maskedInput !== undefined && maskedInput !== null) {
                maskedInput.addEventListener("input", function() {
                    var pos = this.selectionStart;
                    if(this.value == "0,0" || this.value == "Na" || this.value == "NaN" || this.value == "") {
                        this.value = "0,00"
                    } else {
                        this.value = numberWithCommas(getFormattedValue(this.value, event.data));
                    }
                    setTimeout(function() {
                        var maskedInputVal = Number((""+maskedInput.value).replaceAll(".","").replace(",","."))
                        var currentValueVal = Number((""+currentValue).replaceAll(".","").replace(",","."));

                        if(maskedInputVal == currentValueVal) {
                            maskedInput.setSelectionRange(100,100);
                        } else {
                                if(maskedInput.value.length == 4 && this == 3) {
                                     if(maskedInputVal - currentValueVal > 0) {
                                        maskedInput.setSelectionRange(this-1,this-1);   
                                    } else {
                                         if(maskedInputVal < 1) {
                                             maskedInput.setSelectionRange(this+1,this+1);
                                         } else {
                                             maskedInput.setSelectionRange(this,this);
                                         }   
                                    }
                                } else if(maskedInput.value.length == 4 && this == 2) {
                                    if(maskedInputVal - currentValueVal > 0) {
                                        maskedInput.setSelectionRange(this-1,this-1);   
                                    } else {
                                        maskedInput.setSelectionRange(this+1,this+1);
                                    }
                                } else if(maskedInput.value.length == 4 && this == 0) {
                                    if((""+maskedInput.value).startsWith("0")) {
                                        maskedInput.setSelectionRange(this+1,this+1);
                                    } else {
                                        maskedInput.setSelectionRange(this,this);
                                    }
                                } else if(maskedInput.value.length == 4 && this == 4) {
                                    if(maskedInputVal - currentValueVal > 0) {
                                        maskedInput.setSelectionRange(this-1,this-1);   
                                    }        
                                } else {
        
                                    //aumentar
                                    if(maskedInputVal - currentValueVal > 0) {
                                        var thousandsCurrent = ((""+currentValue).match(/\./g)) == null ? 0 : ((""+currentValue).match(/\./g)).length;
                                        var thousandsNow = ((""+maskedInput.value).match(/\./g)) == null ? 0 : ((""+maskedInput.value).match(/\./g)).length;
                                        if(thousandsNow > thousandsCurrent) {
                                            if(this == 1) {
                                                maskedInput.setSelectionRange(this,this);
                                            } else {
                                                maskedInput.setSelectionRange(this+1,this+1);
                                            }
                                        } else {
                                            maskedInput.setSelectionRange(this,this);
                                        }
                                    //diminuir    
                                    } else if(maskedInputVal - currentValueVal < 0) {
                                        var thousandsCurrent = ((""+currentValue).match(/\./g)) == null ? 0 : ((""+currentValue).match(/\./g)).length;
                                        var thousandsNow = ((""+maskedInput.value).match(/\./g)) == null ? 0 : ((""+maskedInput.value).match(/\./g)).length;
                                        if(thousandsCurrent > thousandsNow) {
                                            if(this == 0) {
                                                maskedInput.setSelectionRange(this,this);
                                            } else {
                                                maskedInput.setSelectionRange(this-1,this-1);
                                            }
                                        } else {
                                            maskedInput.setSelectionRange(this,this);
                                        }
                                    } else {
                                        maskedInput.setSelectionRange(100,100);
                                    }
                                    
                                }
                        }

                        if(maskedInput.value.charAt(maskedInput.selectionStart-1) == ",") {
                            maskedInput.setSelectionRange(maskedInput.selectionStart-1,maskedInput.selectionStart-1);
                        }

                        currentValue = maskedInput.value;
                    }.bind(pos), 1);
                    setNativeValue(realInput, maskedInput.value.replaceAll(".","").replace(",","."));
                });
            }
        },
        render: function(value) {
            if(maskedInput.value != "") {
                var value = Number((""+value).replace(",",".")).toFixed(2);
                maskedInput.value = (""+value).replace(".",",").replace(/\B(?=(\d{3})+(?!\d))/g, ".");
                if(Date.now() - start > 50) {
                    currentValue = maskedInput.value;
                }
            }
        }
    };

}
